SystemOrganization addCategory: #'Qwaq-Video-Discovery'!
SystemOrganization addCategory: #'Qwaq-Video-LowLevel'!
SystemOrganization addCategory: #'Qwaq-Video-MP4'!
SystemOrganization addCategory: #'Qwaq-Video-NetVid'!
SystemOrganization addCategory: #'Qwaq-Video-NetVid-Client'!
SystemOrganization addCategory: #'Qwaq-Video-NetVid-Client-Output'!
SystemOrganization addCategory: #'Qwaq-Video-NetVid-Integration'!
SystemOrganization addCategory: #'Qwaq-Video-NetVid-Recorder'!
SystemOrganization addCategory: #'Qwaq-Video-NetVid-Server'!
SystemOrganization addCategory: #'Qwaq-Video-NetVid-Service'!
SystemOrganization addCategory: #'Qwaq-Video-PluginFeedback'!
SystemOrganization addCategory: #'Qwaq-Video-RTP'!
SystemOrganization addCategory: #'Qwaq-Video-RTP-Test'!
SystemOrganization addCategory: #'Qwaq-Video-RTSP'!
SystemOrganization addCategory: #'Qwaq-Video-Secure'!
SystemOrganization addCategory: #'Qwaq-Video-Session'!
SystemOrganization addCategory: #'Qwaq-Video-Streaming'!
SystemOrganization addCategory: #'Qwaq-Video-Texture'!
SystemOrganization addCategory: #'Qwaq-Video-Webcam'!

TTexture subclass: #QVideoTexture
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-Texture'!

!QVideoTexture commentStamp: 'crl 12/17/2009 11:58' prior: 0!
Abstract superclass for on-island 'thumbnail' textures!

!QVideoTexture class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QVideoTexture class methodsFor: 'accessing' stamp: 'jcg 8/7/2007 15:32'!
resourceType
	"Answer a symbol describing the type of resource this texture represents"
	^#videos! !

!QVideoTexture methodsFor: 'copying' stamp: 'jcg 1/12/2009 12:56'!
deepCopy
	"Hack to prevent QMaterialEditor from freezing when you try to open it on a video-panel."
	| savedProperties copy |
	savedProperties := myProperties.
	[
		myProperties := nil.
		copy := super deepCopy.
		copy initializeScripts
	] ensure: [myProperties := savedProperties].
	! !

!QVideoTexture methodsFor: 'initialize' stamp: 'crl 12/18/2009 16:23'!
description: desc "a QStreamingVideoDescription or QWebcamRecord"
	description ifNotNil: [self unregisterResource].
	description := desc.
	description ifNotNil: [
		"Session-ID is unique, so might as well use it as the SHA
		 (makes for easier texture-debugging, too)."
		sha := desc sessionID.
		self registerResource.
	].

! !

!QVideoTexture methodsFor: 'initialize' stamp: 'crl 12/17/2009 14:48'!
destroy
	"Clear sha before 'super destroy' so that we don't flush the texture from the TContentManager... other QVideoTextures might refer to the same texture."
	sha := nil.  
	super destroy. 

	self description: nil. "will cause #unregisterResource to be sent, if necessary"
! !

!QVideoTexture methodsFor: 'accessing' stamp: 'jcg 12/29/2009 17:25'!
exportVideoDescription
	^self videoDescription ifNotNilDo: [:desc | TIslandCopier new export: desc].! !

!QVideoTexture methodsFor: 'initialize' stamp: 'jcg 1/12/2009 12:47'!
initialize
	super initialize.
	bThumb := true.
	self initializeScripts.! !

!QVideoTexture methodsFor: 'initialize' stamp: 'crl 12/17/2009 14:50'!
initializeScripts
	"No-op.  We don't push it into subclasses because it's used by #deepCopy."! !

!QVideoTexture methodsFor: 'resources' stamp: 'jcg 8/9/2007 17:25'!
registerResource
	"Register this texture as a resource"
	self island registerResource: self type: self resourceType.
! !

!QVideoTexture methodsFor: 'resources' stamp: 'jcg 8/7/2007 15:32'!
resourceType
	"Answer a symbol describing the type of resource this texture represents"
	^self class resourceType! !

!QVideoTexture methodsFor: 'accessing' stamp: 'jcg 1/31/2008 23:20'!
sha: newSHA
	"sha is derived from video description"
	self shouldNotImplement
! !

!QVideoTexture methodsFor: 'resources' stamp: 'jcg 8/9/2007 17:25'!
unregisterResource
	"Unregister this texture as a resource"
	self island unregisterResource: self type: self resourceType.! !

!QVideoTexture methodsFor: 'accessing' stamp: 'crl 12/17/2009 14:37'!
videoDescription
	^description! !

!QVideoTexture methodsFor: 'accessing' stamp: 'jcg 1/31/2008 17:54'!
videoExtent
	"The width and height of the video being streamed to the texture."
	^description ifNotNil: [description videoExtent]! !

QVideoTexture subclass: #QWebcamTexture
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-Texture'!

!QWebcamTexture commentStamp: 'crl 12/17/2009 11:58' prior: 0!
The actual texture displayed is managed by a QStreamingVideoDecoder (see the classes in Qwaq-Video-Session).

Instance variables:
	description <QStreamingVideoV1FileCardContents>!

!QWebcamTexture class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QWebcamTexture methodsFor: 'initialize' stamp: 'crl 12/17/2009 14:44'!
description: desc "a QStreamingVideoDescription"
	| mungedDesc |
	"We munge the description to zero-out the 'streamID'.  We do this because the streamID is not used here (we always use the streamID indicated by the QVideoRegistry)... this way, it is evident that the streamID is not to be used."
	mungedDesc := desc copy.
	mungedDesc ifNotNil: [mungedDesc streamID: TObjectID nilObjectID].

	mungedDesc = description ifTrue: [^self "no change"].
	description ifNotNil: [self unregisterResource].
	description := mungedDesc.
	description ifNotNil: [
		"Don't compute SHA from our description... only trust the registered description."
		| regDesc |
		regDesc := self videoDescription.
		sha := regDesc ifNotNil: [regDesc computeSHA].
		self registerResource.
	].

! !

!QWebcamTexture methodsFor: 'initialize' stamp: 'crl 12/17/2009 14:48'!
destroy
	super destroy. 
	self stopScript: #updateUser:withStreamDescription:.! !

!QWebcamTexture methodsFor: 'initialize' stamp: 'crl 12/17/2009 14:49'!
initializeScripts
	self 
		runScript: #updateUser:withStreamDescription: 
		when: {self forumVideoStreamRegistry. #streamDescriptionChanged}! !

!QWebcamTexture methodsFor: 'private' stamp: 'crl 12/17/2009 14:51'!
updateUser: userName withStreamDescription: desc
	"If this update applies to us, then signal observers (in particular, our QClientVideoTexture)."
	description ifNil: [^self].
	description userName = userName ifFalse: [^self].
	sha := desc ifNotNil: [desc computeSHA].
	self signal: #streamDescriptionChanged with: desc.
	
! !

!QWebcamTexture methodsFor: 'accessing' stamp: 'crl 12/17/2009 14:38'!
videoDescription
	"The only thing that we know is right about our stream-description is the userName...  ask the forum's registry for the real deal."
	description ifNil: [^nil].
	^self forumVideoStreamRegistry streamDescriptionForUser: description userName! !

QVideoTexture subclass: #QWebcastTexture
	instanceVariableNames: 'speaker'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-Texture'!

!QWebcastTexture class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QWebcastTexture methodsFor: 'accessing' stamp: 'crl 1/11/2010 12:18'!
speaker
	^speaker! !

!QWebcastTexture methodsFor: 'initialize' stamp: 'crl 1/8/2010 18:08'!
speaker: aQSpeaker
	speaker := aQSpeaker! !

QControlStreamInput subclass: #QVideoStreamInput
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-Streaming'!

!QVideoStreamInput commentStamp: '<historical>' prior: 0!
(c) 2007 Qwaq Inc.  This subclass is only to distinguish video streams from other stream types.!

!QVideoStreamInput class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QVideoStreamInput methodsFor: 'accessing' stamp: 'bgf 10/27/2007 14:15'!
trafficTag
	"Default categorization for traffic through the channel"
	^ VideoTag! !

Stream subclass: #QBigEndianBitStream
	instanceVariableNames: 'position collection readLimit writeLimit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-MP4'!

!QBigEndianBitStream commentStamp: '<historical>' prior: 0!
Really quick hack to read/write n-bit integers from a bitstream.!

!QBigEndianBitStream class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QBigEndianBitStream class methodsFor: 'instance creation' stamp: 'jcg 7/30/2009 16:18'!
forWriting
	^ (self on: (ByteArray new: 100))
							initializeReadLimit: 0;
							yourself! !

!QBigEndianBitStream class methodsFor: 'instance creation' stamp: 'jcg 7/31/2009 11:20'!
on: aByteArray
	(aByteArray isKindOf: ByteArray) 
		ifFalse: [self error: 'QBigEndianBitStream requires a ByteArray'].
	^self basicNew on: aByteArray! !

!QBigEndianBitStream methodsFor: 'testing' stamp: 'jcg 7/31/2009 17:18'!
atEnd
	^position >= readLimit! !

!QBigEndianBitStream methodsFor: 'accessing-h264' stamp: 'jcg 7/31/2009 17:02'!
burnRbspTrailingBits
	| remainingBits |

	remainingBits := 8 - (position \\ 8).
	remainingBits = 0 ifTrue: [remainingBits := 8].
	self next = 1 ifFalse: [self error: 'expected rbsp_stop_one_bit'].
	remainingBits-1 > 0 ifTrue: [
		(self next: remainingBits-1) = 0 ifFalse: [
			self error: 'expected several rbsp_alignment_zero_bit'		
		].
	].
	"Sanity check."
	(position \\ 8) = 0 ifFalse: [self error: 'internal error in #putRbspTrailingBits']
	! !

!QBigEndianBitStream methodsFor: 'accessing-h264' stamp: 'jcg 7/31/2009 17:07'!
burnStartCode
	(self remaining < 24) ifTrue: [self error: 'not enough data left for start code'].
	(self peek: 24) = 1 ifTrue: [position := position + 24. ^self].
	(self remaining < 32) ifTrue: [self error: 'not enough data left for start code'].
	(self peek: 32) = 1 ifTrue: [position := position + 32. ^self].
	self error: 'not at a start code'
	

! !

!QBigEndianBitStream methodsFor: 'accessing' stamp: 'jcg 9/9/2009 23:44'!
burnUpToByteBoundary
	"If already at a byte-boundary, do nothing.  Otherwise, discard bits up to the next byte-boundary."
	(position \\ 8) = 0 ifFalse: [
		self position: (((position // 8) + 1) * 8)
	].! !

!QBigEndianBitStream methodsFor: 'accessing-h264' stamp: 'jcg 7/31/2009 17:10'!
burnUpToStartCode
	[self remaining >= 24] whileTrue: [
		(((self peek: 24) == 1) or: [(self peek: 32) == 1])
			ifFalse: [self next: 8 "burn a byte"]
			ifTrue: [^self]
	].
	"If we reach here, we didn't find a start-code."
	position := readLimit
! !

!QBigEndianBitStream methodsFor: 'accessing' stamp: 'jcg 6/15/2009 14:56'!
contents
	^collection copyFrom: 1 to: (readLimit roundUpTo: 8) / 8! !

!QBigEndianBitStream methodsFor: 'initialize' stamp: 'jcg 7/30/2009 16:19'!
initializeReadLimit: initialReadLimit
	readLimit := initialReadLimit! !

!QBigEndianBitStream methodsFor: 'accessing' stamp: 'jcg 6/15/2009 13:01'!
next
	| byteIndex bitIndex |
	position >= readLimit ifTrue: [^nil].
	byteIndex := position // 8 + 1.
	bitIndex := position \\ 8 + 1.
	position := position + 1.
	^ ((collection at: byteIndex) bitShift: (bitIndex - 8)) bitAnd: 1
! !

!QBigEndianBitStream methodsFor: 'accessing' stamp: 'jcg 6/15/2009 13:55'!
next: nbits
	| accum |
	accum := 0.
	nbits timesRepeat: [accum := (accum bitShift: 1) + (self next ifNil: [^nil])].
	^accum
! !

!QBigEndianBitStream methodsFor: 'accessing' stamp: 'jcg 7/2/2009 12:53'!
nextBytes: nBytes
	| start bytes |
	(position \\ 8) = 0 ifFalse: [self error: 'can only ask for bytes at byte-aligned boundary'].
	start := position // 8 + 1.
	bytes := collection copyFrom: start to: start + nBytes - 1.
	position := position + (nBytes*8).
	^bytes
	! !

!QBigEndianBitStream methodsFor: 'accessing' stamp: 'jcg 6/15/2009 13:54'!
nextPut: bit "1 or 0"
	| byteIndex bitIndex byte mask |
	(bit between: 0 and: 1) ifFalse: [self error: bit printString, ' is not a bit'].
	position >= writeLimit ifTrue: [
		| grown |
		grown := ByteArray new: collection size * 2.
		grown replaceFrom: 1 to: collection size with: collection.
		collection := grown.
		writeLimit := collection size * 8.
	].
	byteIndex := position // 8 + 1.
	bitIndex := position \\ 8 + 1.
	position := position + 1.
	position > readLimit ifTrue: [readLimit := position].
	byte := collection at: byteIndex.
	mask := 1 bitShift: (8 - bitIndex).
	byte := bit isZero ifTrue: [byte bitClear: mask] ifFalse: [byte bitOr: mask].
	collection at: byteIndex put: byte.
	^bit! !

!QBigEndianBitStream methodsFor: 'accessing' stamp: 'jcg 6/16/2009 18:04'!
nextPut: number nbits: nbits
	number < (2 raisedTo: nbits) ifFalse: [self error: 'number is too big'].
	nbits > 8
		ifTrue: [
			self nextPut: (number bitShift: 8-nbits) nbits: 8.
			self nextPut: (number bitClear: (255 bitShift: nbits-8)) nbits: nbits-8.
		]
		ifFalse: [
			nbits to: 1 by: -1 do: [:i |
				self nextPut: ((number bitShift: 1-i) bitAnd: 1).
			].
		].! !

!QBigEndianBitStream methodsFor: 'accessing' stamp: 'jcg 7/21/2009 13:35'!
nextPutBytes: aByteArray
	"Nice'n'slow... a bit at a time."
	aByteArray do: [:byte | self nextPut: byte nbits: 8]
! !

!QBigEndianBitStream methodsFor: 'initialize' stamp: 'jcg 6/15/2009 13:32'!
on: aByteArray
	collection := aByteArray.
	position := 0.
	writeLimit := readLimit := collection size * 8.
! !

!QBigEndianBitStream methodsFor: 'accessing' stamp: 'jcg 7/31/2009 17:19'!
peek: anInteger 
	"Answer the next 'anInteger' bits.  Stream position does not change."
	| oldPosition result |
	oldPosition := position.
	result := self next: anInteger.
	position := oldPosition.
	^result
! !

!QBigEndianBitStream methodsFor: 'accessing' stamp: 'jcg 7/31/2009 17:19'!
position
	^position! !

!QBigEndianBitStream methodsFor: 'accessing' stamp: 'jcg 7/31/2009 17:20'!
position: newPosition
	(position between: 0 and: readLimit) ifFalse: [self error: 'invalid position'].
	position := newPosition! !

!QBigEndianBitStream methodsFor: 'accessing-h264' stamp: 'jcg 7/30/2009 14:06'!
putRbspTrailingBits
	| remainingBits |
	remainingBits := 8 - (position \\ 8).
	remainingBits = 0 ifTrue: [remainingBits := 8].
	self nextPut: 1.
	remainingBits-1 > 0 ifTrue: [self nextPut: 0 nbits: remainingBits-1].
! !

!QBigEndianBitStream methodsFor: 'accessing' stamp: 'jcg 7/31/2009 17:19'!
remaining
	"Answer the number of bits available to be read."
	^ readLimit - position
! !

!QBigEndianBitStream methodsFor: 'accessing' stamp: 'jcg 7/29/2009 01:37'!
signedExpGolomb
	"See 14496-10, Section 9.1"
	| codeNum |
	codeNum := self unsignedExpGolomb.
	^(-1 raisedTo: codeNum + 1) * (codeNum / 2) ceiling
! !

!QBigEndianBitStream methodsFor: 'accessing' stamp: 'jcg 7/29/2009 17:35'!
signedExpGolombPut: num
	"See 14496-10, Section 9.1"
	| n |
	num = 0 ifTrue: [n := 0].
	num < 0 ifTrue: [n := num * -2].
	num > 0 ifTrue: [n := num * 2 - 1].
	^self unsignedExpGolombPut: n
! !

!QBigEndianBitStream methodsFor: 'accessing' stamp: 'jcg 7/29/2009 01:24'!
unsignedExpGolomb
	"See 14496-10, Section 9.1"
	| zeroCount codeNum |

	zeroCount := 0.
	[self next = 0] whileTrue: [zeroCount := zeroCount + 1].
	codeNum := (2 raisedTo: zeroCount) - 1 + (self next: zeroCount).
	^codeNum! !

!QBigEndianBitStream methodsFor: 'accessing' stamp: 'jcg 7/29/2009 17:35'!
unsignedExpGolombPut: num
	"See 14496-10, Section 9.1.  Answers the order 'k' of the Exp-Golomb code used for encoding."
	| k n |

	num < 0 ifTrue: [self error: 'argument must be positive'].

	"I couldn't find a good explanation of how to encode numbers (Wikipedia describes how to encode using an Exp-Golomb code of order-k, but doesn't tell you how to determine what k to use for a particular number).  The following algorithm is based on the observation that the encodable range for an order-k code is between ((2 raisedTo: k)-1) to (2 raisedTo: k+1)-2)."
	k := 0.
	[num < ((2 raisedTo: k+1) - 1)] whileFalse: [k := k + 1].
	n := num - ((2 raisedTo: k) - 1).
	self nextPut: 1 nbits: k+1.
	k = 0 ifFalse: [self nextPut: n nbits: k].
	^k
	
! !

Object subclass: #AACAudioSpecificConfig
	instanceVariableNames: 'audioObjectType samplingFrequency channelConfiguration frameLengthFlag dependsOnCoreCoder coreCoderDelay extensionFlag'
	classVariableNames: 'AudioObjectTypes ChannelConfigurations SamplingFrequencies'
	poolDictionaries: ''
	category: 'Qwaq-Video-MP4'!

!AACAudioSpecificConfig commentStamp: '<historical>' prior: 0!
Deals with the AudioSpecificConfig() defined in ISO-14496-3 sections 1.6 and 4.5 
!

!AACAudioSpecificConfig class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!AACAudioSpecificConfig class methodsFor: 'class initialization' stamp: 'jcg 6/15/2009 16:18'!
initialize

	"See ISO-14496-3 subpart 1, Table 1.1"
	AudioObjectTypes := Dictionary newFromPairs: {
		0.		'Null'.
		1.		'AAC main'.
		2.		'AAC LC'.
		3.		'AAC SSR'.
		4.		'AAC LTP'.
		5.		'(Reserved)'.
		6.		'AAC Scalable'.
		7.		'TwinVQ'.
		8.		'CELP'.
		9.		'HVXC'.
		10.		'(Reserved)'.
		11.		'(Reserved)'.
		12.		'TTSI'.
		13.		'Main synthetic'.
		14.		'Wavetable synthesis'.
		15.		'General MIDI'.
		16.		'Algorithmic Synthesis and Audio FX'.
		17.		'ER AAC LC'.
		18.		'(Reserved)'.
		19.		'ER AAC LTP'.
		20.		'ER AAC scalable'.
		21.		'ER TwinVQ'.
		22.		'ER BSAC'.
		23.		'ER AAC LD'.
		24.		'ER CELP'.
		25.		'ER HVXC'.
		26.		'ER HILN'.
		27.		'ER Parametric'.
		28.		'(Reserved)'.
		29.		'(Reserved)'.
		30.		'(Reserved)'.
		31.		'(Reserved)'.
	}.

	"See ISO-14496-3 subpart 1, Table 1.10"
	SamplingFrequencies := Dictionary newFromPairs: {
		0.		96000.
		1.		88200.
		2.		64000.
		3.		48000.
		4.		44100.
		5.		32000.
		6.		24000.
		7.		22050.
		8.		16000.
		9.		12000.
		10.		11025.
		11.		8000.
		12.		7350.
		13.		'reserved'.
		14.		'reserved'.
		15.		'escape value'.
	}.

	"See ISO-14496-3 subpart 1, Table 1.11"
	ChannelConfigurations := Dictionary newFromPairs: {
		0.		'GASpecificConfig()'.
		1.		1.
		2.		2.
		3.		3.
		4.		4.
		5.		5.
		6.		5.1.
		7.		7.1.
		8.		'reserved'.
		9.		'reserved'.
		10.		'reserved'.
		11.		'reserved'.
		12.		'reserved'.
		13.		'reserved'.
		14.		'reserved'.
		15.		'escape value'.
	}.! !

!AACAudioSpecificConfig methodsFor: 'comparing' stamp: 'jcg 8/12/2009 12:11'!
= aacConfig
	"Quicker (for me to type) and less error-prone than typing in inst-var accessors."
	self class == aacConfig class ifFalse: [^false].
	1 to: self class instSize do: [:i |
		(self instVarAt: i) = (aacConfig instVarAt: i) ifFalse: [^false]
	].
	^true! !

!AACAudioSpecificConfig methodsFor: 'accessing' stamp: 'jcg 6/15/2009 15:01'!
audioObjectType: type
	audioObjectType := type "see 14496-3 Table 1.1"! !

!AACAudioSpecificConfig methodsFor: 'accessing' stamp: 'jcg 8/12/2009 11:56'!
bytes
	"Answer the AudioSpecificConfig (as defined by 14496-3, sections 1.6.2 and 1.6.3), a ByteArray."
	| stream samplingFrequencyIndex |
	stream := QBigEndianBitStream on: (ByteArray new: 1).
	stream nextPut: audioObjectType nbits: 5.
	samplingFrequencyIndex := SamplingFrequencies keyAtValue: samplingFrequency.
	stream nextPut: samplingFrequencyIndex nbits: 4.
	samplingFrequencyIndex == 15 ifTrue: [
		"Explicitly specifying a non-standard sampling frequency (in Hz)."
		stream nextPut: samplingFrequency nbits: 24.
	].
	stream nextPut: channelConfiguration nbits: 4.

	"Verify that we're using an audio type which uses GASpecificConfig()."
	(#(1 2 3 4 6 7) includes: audioObjectType) ifFalse: [
		self error: 'unsupported audioObjectType: ', audioObjectType.
	].
	stream nextPut: (frameLengthFlag ifTrue: [1] ifFalse: [0]).
	stream nextPut: (dependsOnCoreCoder ifTrue: [1] ifFalse: [0]).
	dependsOnCoreCoder ifTrue: [stream nextPut: coreCoderDelay nbits: 14].
	stream nextPut: (extensionFlag ifTrue: [1] ifFalse: [0]).
	extensionFlag ifTrue: [self error: 'extension flag is not yet implemented'].
	^ stream contents! !

!AACAudioSpecificConfig methodsFor: 'accessing' stamp: 'jcg 6/15/2009 15:03'!
channelConfiguration: configIndex
	channelConfiguration := configIndex "see 14496-3 Table 1.11"! !

!AACAudioSpecificConfig methodsFor: 'initialize' stamp: 'jcg 6/15/2009 16:57'!
initialize
	super initialize.
	"Initialize defaults."
	frameLengthFlag := false.
	dependsOnCoreCoder  := false.
	coreCoderDelay := 0.
	extensionFlag := false.! !

!AACAudioSpecificConfig methodsFor: 'initialize' stamp: 'jcg 8/29/2009 16:52'!
initializeFromBytes: bytes
	"AudioSpecificConfig() is discussed in 14496-3 section 1.6"
	| stream frequencyIndex |
	stream := QBigEndianBitStream on: bytes.
	audioObjectType := stream next: 5.
	(#(1 2 3 4 6 7) includes: audioObjectType) ifFalse: [
		"We expect a type that indicates that GASpecificConfig() is to be used."
		self error: 'unsupported audioObjectType: ', audioObjectType.
	].
	frequencyIndex := stream next: 4.
	samplingFrequency := SamplingFrequencies at: frequencyIndex ifAbsent: [nil].
	samplingFrequency isNumber ifFalse: [
		"If the index is 15 ('escape value'), then the frequency is explicitly specified
		 ... but we don't handle this."
		self error: 'invalid sampling frequency:  ', samplingFrequency.
	].
	channelConfiguration := stream next: 4.
	frameLengthFlag := stream next 	~~ 0.
	dependsOnCoreCoder := stream next ~~ 0.
	coreCoderDelay := dependsOnCoreCoder ifTrue: [stream next: 14] ifFalse: [nil].
	extensionFlag := stream next ~~ 0.
	extensionFlag ifTrue: [self error: 'extension flag is not yet implemented'].
	
! !

!AACAudioSpecificConfig methodsFor: 'initialize' stamp: 'jcg 8/29/2009 16:52'!
initializeFromFMTP: aString
	"Initializes the config from the SDP 'fmtp' attribute as defined by RFC3016: 'RTP Payload Format for MPEG-4 Audio/Visual'."
	| params |
	params := Dictionary new.
	(aString findTokens: '; ') do: [:p |
		params at: (p copyUpTo: $=) put: (p copyAfter: $=).
	].
	self initializeFromBytes: 
		(ByteArray readHexFrom: (params at: 'config') asLowercase)
	! !

!AACAudioSpecificConfig methodsFor: 'accessing' stamp: 'jcg 8/12/2009 14:30'!
numChannels

	"No reason to necessarily exclude other values, but I'd rather revisit this when they occur rather than assume they're OK now (while I'm in a rush)."
	(channelConfiguration between: 1 and: 5) ifFalse: [
		self error: 'channel-configuration is not (yet) supported'
	].
	^ChannelConfigurations at: channelConfiguration! !

!AACAudioSpecificConfig methodsFor: 'accessing' stamp: 'jcg 6/15/2009 16:46'!
samplingFrequency
	"See 14496-3 Table 1.10"
	^samplingFrequency! !

!AACAudioSpecificConfig methodsFor: 'accessing' stamp: 'jcg 6/15/2009 16:46'!
samplingFrequency: hertz
	"See 14496-3 Table 1.10"
	samplingFrequency := hertz ! !

!AACAudioSpecificConfig methodsFor: 'accessing' stamp: 'jcg 7/21/2009 14:09'!
sdpRtpmapDescription
	"Answer a media-description in the format required for the SDP rtpmap attribute.  Eg: in 'a=rtpmap:96 mpeg4-generic/44100/1', this method answers 'mpeg4-generic/44100/1'."
	^String streamContents: [:s |
		s nextPutAll: 'mpeg4-generic'.
		samplingFrequency ifNotNil: [
			s nextPut: $/; nextPutAll: samplingFrequency printString.
			
			"XXXXX: Although this isn't documented in any of the RFCs, I found 
			 a hint in 'draft-ietf-avt-rtp-mps-02' that suggests that this is the
			 correct way to specify the number of sound channels."
			channelConfiguration ifNotNil: [
				s nextPut: $/; nextPutAll: channelConfiguration printString.
			].
		].
	].! !

Object subclass: #AVCHackingUtilities
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-MP4'!

!AVCHackingUtilities commentStamp: '<historical>' prior: 0!
Miscellaneous stuff.!

!AVCHackingUtilities class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!AVCHackingUtilities class methodsFor: 'as yet unclassified' stamp: 'jcg 7/31/2009 18:40'!
extractNALUs: aByteArray
	"Assume that aByteArray has nalu-sizes, not start-codes."
	| stream nalus length |
	stream := ReadStream on: aByteArray.
	nalus := OrderedCollection new.
	[stream atEnd] whileFalse: [
		length := (stream next: 4) networkUnsignedLongAt: 1.
		nalus add: (stream next: length).
		nalus last size = length ifFalse: [self error: 'unexpected NALU length'].
	].
	^nalus! !

!AVCHackingUtilities class methodsFor: 'as yet unclassified' stamp: 'jcg 11/29/2009 01:28'!
replaceNaluSizes: naluSizeSize withStartCodeIn: input startingAt: initialIndex
	"The NHML .media file contains NALU sizes at the beginning of each NALU... replace these with a start code.  We attempt to do this in place (can only do this if 'naluSizeSize' is 4)."
	"NOTE: eventually, we'll want to do this in (the equivalent of) the .media file.  However, we don't currently have the necessary level of metadata to record whether this type of processing has already taken place."
	| readStream writeStream buf  startCode |

	naluSizeSize = 4 ifTrue: [
		| index |
		index := initialIndex.
		[index <= input size] whileTrue: [
			| naluSize |
			naluSize := input networkUnsignedLongAt: index.
			input networkUnsignedLongAt: index put: 1. "0x00000001"
			index := index + naluSize + 4 
		].
		index == (input size + 1) ifFalse: [self error: 'error while replacing NALU sizes'].
		^input
	].

	"We can't do the replacement in-place, because the sizes aren't the same size as an AVC start code."
	readStream := ReadStream on: input.
	writeStream := WriteStream on: (ByteArray new: input size + 100).
	writeStream nextPutAll: (readStream next: initialIndex-1). "copy the header as-is"
	buf := ByteArray new: 4.
	startCode := #(0 0 0 1) asByteArray.
	[readStream atEnd] whileFalse: [
		| naluSize nalu |
		(readStream next: naluSizeSize into: buf startingAt: 5-naluSizeSize) = buf
			ifFalse: [self error: 'ran out of data while replacing NALU sizes'].
		naluSize := buf networkUnsignedLongAt: 1.
		nalu := readStream next: naluSize.
		nalu size = naluSize ifFalse: [self error: 'ran out of data while replacing NALU sizes'].
		writeStream nextPutAll: startCode.
		writeStream nextPutAll: nalu.
	].
	^writeStream contents! !

!AVCHackingUtilities class methodsFor: 'as yet unclassified' stamp: 'jcg 1/31/2012 02:00'!
replaceStartCodesWithNaluSizes: aByteArray
	"Answer a ByteArray where all 3- or 4-byte start-codes have been replaced
	 with a 4-byte NALU length.  When possible, we write directly into aByteArray
	 (i.e. this method is often destructive)."
	| starts ends startCode threeStarts inputSize pos |
	(aByteArray isKindOf: ByteArray) ifFalse: [self error: 'expect a ByteArray'].

	"Get start-code as SmallInteger using platform endianness."
	startCode := #(0 0 0 1) asByteArray networkUnsignedLongAt: 1.
	
	threeStarts := Set new.
	
	starts := OrderedCollection new.
	ends := OrderedCollection new.
	pos := 1.
	inputSize := aByteArray size.
	[pos < (inputSize - 3)] whileTrue: [
		| next4 |
		"Fast identity comparison between integers, instead of byte-by-byte equality."
		next4 := aByteArray networkUnsignedLongAt: pos.
		startCode == next4
			ifTrue: [
				"matched 0001"
				starts add: pos.
				pos := pos + 4.
			]
			ifFalse: [
				| next3 |
				next3 := next4 bitShift: -8.
				startCode == next3
					ifTrue: [
						"matched 001"
						starts add: pos.
						threeStarts add: pos.
						pos := pos + 3.
					]
					ifFalse: [
						"no match"
						pos := pos+1
					]
			]
			
	].
	ends := starts collect: [:v | v-1].
	ends removeFirst.
	ends add: inputSize.

	"We used to only deal with 4-byte start-codes, which we replaced in-place with
	 4-byte integers containing the NALU length.  However, when we switched over
	 to x264, the encoder started to sometimes give us 3-byte start-codes, which 
	 we can no longer replace in-place.  When we detect any 3-byte start-codes,
	 we instead write everything to a new ByteArray."
	threeStarts 
		ifEmpty: [
			"In-place replacement of 4-byte start-code with NALU lengths."
			starts with: ends do: [:start :end |
				| length |
				length := end - start - 3.
				aByteArray networkUnsignedLongAt: start put: length
			].
			^aByteArray.
		]
		ifNotEmpty: [
			"Since we have some 3-byte start-codes which are smaller than the 4 bytes
			 that we use for NALU length, we have to rewrite the stream."
			| stream lengthBytes | 
			stream := RWBinaryOrTextStream on: (ByteArray new: aByteArray size + starts size).
			stream binary.
			lengthBytes := ByteArray new: 4.
			starts with: ends do: [:start :end |
				| length dataStart |
				
				(threeStarts includes: start) 
					ifTrue: [dataStart := start + 3]
					ifFalse: [dataStart := start + 4].
				length := end - dataStart + 1.
				lengthBytes networkUnsignedLongAt: 1 put: length.
				stream nextPutAll: lengthBytes.
				stream next: length putAll: aByteArray startingAt: dataStart.
			].
			^stream contents
		]


	



	! !

Object subclass: #AVCStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-MP4'!

!AVCStructure commentStamp: '<historical>' prior: 0!
Superclass for syntax-structures defined in ISO-14496-10 and ISO-14496-15.!

AVCStructure subclass: #AVCDecoderConfigurationRecord
	instanceVariableNames: 'configurationVersion profileIndication profileCompatibility levelIndication nalUnitSize sequenceParameterSets pictureParameterSets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-MP4'!

!AVCDecoderConfigurationRecord commentStamp: '<historical>' prior: 0!
Represents an AVCDecoderConfigurationRecord as defined in ISO-14496-15 Section 5.2.4.1

NOTE: not quite a well-behaved AVCStructure like the other (newer) ones.  In particular, doesn't read/write bitstreams as nicely.

Contains information about an elementary AVC/H.264 stream.  The sequence/picture parameter-sets MUST be pushed into the decoder before any encoded frames (it would be possible for the server to periodically intersperse parameter-sets in the encoded stream, but we don't do it that way).!

!AVCDecoderConfigurationRecord class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!AVCDecoderConfigurationRecord class methodsFor: 'utilities' stamp: 'jcg 7/29/2009 14:29'!
debugPrintSequenceParameterSet: sps "a ByteArray or QBigEndianBitStream"
	| bits refIDC naluType picOrderCntType frameMbsOnlyFlag frameCroppingFlag vuiParametersPresentFlag |

	(sps isKindOf: ByteArray) 
		ifTrue: [bits := QBigEndianBitStream on: sps]
		ifFalse: [bits := sps].

	"Skip start-code, if present."
	(sps first: 4) = #(0 0 0 1) asByteArray ifTrue: [bits nextBytes: 4].

	Transcript show: '/// sequence_parameter_set START'; cr.

	"Verify NAL header."
	bits next == 0 ifFalse: [self error: 'nal_unit forbidden_zero_bit is not zero'].
	refIDC := bits next: 2.
	refIDC == 0 ifTrue: [self error: 'nal_ref_idc must be non-zero'].
	naluType := bits next: 5.
	naluType == 7 ifFalse: [self error: 'nal is not a sequence-parameter-set'].

	Transcript show: 'profile_idc: ', (bits next: 8); cr.
	Transcript show: 'constraint_set0_flag: ', bits next; cr.
	Transcript show: 'constraint_set1_flag: ', bits next; cr.
	Transcript show: 'constraint_set2_flag: ', bits next; cr.
	(bits next: 5) == 0 ifFalse: [self error: 'reserved_zero_5bits is not zero'].
	Transcript show: 'level_idc: ', (bits next: 8); cr.
	Transcript show: 'seq_parameter_set_id: ', bits unsignedExpGolomb; cr.
	Transcript show: 'log2_max_frame_num_minus4: ', bits unsignedExpGolomb; cr.
	picOrderCntType := bits unsignedExpGolomb.
	Transcript show: 'pic_order_cnt_type: ', picOrderCntType; cr.
	picOrderCntType = 0 ifTrue: [
		Transcript 
			show: 'log2_max_pic_order_cnt_lsb_minus4: ', bits unsignedExpGolomb; 
			cr.
	].
	picOrderCntType = 1 ifTrue: [
		| numRefFrames |
		Transcript 
			show: 'delta_pic_order_always_zero_flag: ', bits next; cr;
			show: 'offset_for_non_ref_pic: ', bits signedExpGolomb; cr;
			show: 'offset_for_top_to_bottom_field: ', bits signedExpGolomb; cr.
		numRefFrames := bits unsignedExpGolomb.
		Transcript show: 'num_ref_frames_in_pic_order_cnt_cycle', numRefFrames; cr.
		numRefFrames timesRepeat: [
			Transcript show: '    offset_for_ref_frame:', bits signedExpGolomb; cr.
		].
	].
	Transcript show: 'num_ref_frames: ', bits unsignedExpGolomb; cr.
	Transcript show: 'gaps_in_frame_num_value_allowed_flag: ', bits next; cr.
	Transcript show: 'pic_width_in_mbs_minus1: ', bits unsignedExpGolomb; cr.
	Transcript show: 'pic_height_in_map_units_minus1: ', bits unsignedExpGolomb; cr.

	frameMbsOnlyFlag := bits next.
	Transcript show: 'frame_mbs_only_flag: ', frameMbsOnlyFlag; cr.
	frameMbsOnlyFlag = 1 ifFalse: [
		Transcript show: 'mb_adaptive_frame_field_flag: ', bits next; cr.
	].
	Transcript show: 'direct_8x8_inference_flag: ', bits next; cr.
	frameCroppingFlag := bits next.
	Transcript show: 'frame_cropping_flag: ', frameCroppingFlag; cr.
	frameCroppingFlag = 1 ifTrue: [
		Transcript show: 'frame_crop_left_offset: ', bits unsignedExpGolomb; cr.
		Transcript show: 'frame_crop_right_offset: ', bits unsignedExpGolomb; cr.
		Transcript show: 'frame_crop_top_offset: ', bits unsignedExpGolomb; cr.
		Transcript show: 'frame_crop_bottom_offset: ', bits unsignedExpGolomb; cr.
	].
	vuiParametersPresentFlag := bits next.
	Transcript show: 'vui_parameters_present_flag: ', vuiParametersPresentFlag; cr.
	vuiParametersPresentFlag = 1 ifTrue: [
		self debugPrintVuiParameters: bits.
	].


	Transcript show: '/// sequence_parameter_set END (unfinished)'; cr.
! !

!AVCDecoderConfigurationRecord class methodsFor: 'utilities' stamp: 'jcg 7/29/2009 09:50'!
debugPrintVuiParameters: sps "a ByteArray or QBigEndianBitStream"
	| bits aspectRatioInfoPresentFlag overscanInfoPresentFlag videoSignalTypePresentFlag chromaLocInfoPresentFlag timingInfoPresentFlag |

	(sps isKindOf: ByteArray) 
		ifTrue: [bits := QBigEndianBitStream on: sps]
		ifFalse: [bits := sps].

	Transcript show: '/// vui_parameters START'; cr.

	aspectRatioInfoPresentFlag := bits next.
	Transcript show: 'aspect_ratio_info_present_flag: ', aspectRatioInfoPresentFlag; cr.
	aspectRatioInfoPresentFlag = 1 ifTrue: [
		| aspectRatioIDC |
		aspectRatioIDC := bits next: 8.
		Transcript show: 'aspect_ratio_idc: ', aspectRatioIDC; cr.
		(aspectRatioIDC = 255 "Extended_SAR") ifTrue: [
			Transcript show: 'sar_width: ', (bits next: 16); cr.
			Transcript show: 'sar_height: ', (bits next: 16); cr.
		].
	].

	overscanInfoPresentFlag := bits next.
	Transcript show: 'overscan_info_present_flag: ', overscanInfoPresentFlag; cr.
	overscanInfoPresentFlag = 1 ifTrue: [
		Transcript show: 'overscan_appropriate_flag: ', bits next; cr.
	].

	videoSignalTypePresentFlag := bits next.
	Transcript show: 'video_signal_type_present_flag: ', videoSignalTypePresentFlag; cr.
	videoSignalTypePresentFlag = 1 ifTrue: [
		| colorDescPresentFlag |
		Transcript show: 'video_format: ', (bits next: 3); cr.
		Transcript show: 'video_full_range_flag ', bits next; cr.

		colorDescPresentFlag := bits next.
		Transcript show: 'colour_description_present_flag: ', colorDescPresentFlag; cr.
		colorDescPresentFlag = 1 ifTrue: [
			Transcript show: 'colour_primaries: ', (bits next: 8); cr.
			Transcript show: 'transfer_characteristics: ', (bits next: 8); cr.
			Transcript show: 'matrix_coefficients: ', (bits next: 8); cr.
		].
	].

	chromaLocInfoPresentFlag := bits next.
	Transcript show: 'chroma_loc_info_present_flag: ', chromaLocInfoPresentFlag; cr.
	chromaLocInfoPresentFlag = 1 ifTrue: [
		Transcript 
			show: 'chroma_sample_loc_type_top_field: ', bits unsignedExpGolomb; cr;
			show: 'chroma_sample_loc_type_bottom_field: ', bits unsignedExpGolomb; cr.
	].

	timingInfoPresentFlag := bits next.
	Transcript show: 'timing_info_present_flag: ', timingInfoPresentFlag; cr.
	timingInfoPresentFlag = 1 ifTrue: [
		Transcript show: 'num_units_in_tick: ', (bits next: 32); cr.
		Transcript show: 'time_scale: ', (bits next: 32); cr.
		Transcript show: 'fixed_frame_rate_flag: ', bits next; cr.
	].

	Transcript show: '/// vui_parameters END (unfinished)'; cr.
	! !

!AVCDecoderConfigurationRecord class methodsFor: 'instance creation' stamp: 'jcg 7/31/2009 11:14'!
fromBytes: aByteArray
	^self new initializeFromDecoderSpecificInfo: aByteArray; yourself
! !

!AVCDecoderConfigurationRecord class methodsFor: 'instance creation' stamp: 'jcg 7/31/2009 11:15'!
fromFileNamed: filePath
	| file |
	file := FileStream readOnlyFileNamed: filePath.
	file binary.
	^[self fromBytes: file contents] ensure: [file close]! !

!AVCDecoderConfigurationRecord methodsFor: 'initialize' stamp: 'jcg 7/21/2009 14:31'!
addPictureParameterSet: aByteArray
	"Prepend a start-code to the parameter-set data before adding it to the list (as is done in #initializeFromDecoderSpecificInfo: and #initializeFromFMTP:."
	pictureParameterSets ifNil: [pictureParameterSets := OrderedCollection new].
	pictureParameterSets add: #(0 0 0 1) asByteArray, aByteArray! !

!AVCDecoderConfigurationRecord methodsFor: 'initialize' stamp: 'jcg 7/31/2009 11:49'!
addSequenceParameterSet: aByteArray
	"Prepend a start-code to the parameter-set data before adding it to the list (as is done in #initializeFromDecoderSpecificInfo: and #initializeFromFMTP:."
	sequenceParameterSets add: #(0 0 0 1) asByteArray, aByteArray! !

!AVCDecoderConfigurationRecord methodsFor: 'converting' stamp: 'jcg 7/6/2009 17:14'!
asAVCDecoderConfigurationRecord
	"Answer a ByteArray containing a AVCDecoderConfigurationRecord (as defined in ISO-14496-15 Section 5.2.4.1)."
	| bits |

	bits := QBigEndianBitStream on: (ByteArray new: 8).
	bits nextPut: configurationVersion nbits: 8.
	bits nextPut: profileIndication nbits: 8.
	bits nextPut: profileCompatibility nbits: 8.
	bits nextPut: levelIndication nbits: 8.

	"High 6 bits must be 0x3F, NALU size stored in the low 2 bits."
	bits nextPut: 16r3F nbits: 6.
	bits nextPut: nalUnitSize - 1 nbits: 2.
	
	"Sequence parameter sets."
	bits nextPut: 7 nbits: 3.
	bits nextPut: sequenceParameterSets size nbits: 5.
	sequenceParameterSets do: [:sps |
		bits nextPut: sps size - 4 nbits: 16.
		bits nextPutBytes: (sps copyFrom: 5 to: sps size)
	].

	"Picture parameter sets."
	bits nextPut: pictureParameterSets size nbits: 8.
	pictureParameterSets do: [:pps |
		bits nextPut: pps size - 4 nbits: 16.
		bits nextPutBytes: (pps copyFrom: 5 to: pps size)
	].

	^bits contents! !

!AVCDecoderConfigurationRecord methodsFor: 'accessing' stamp: 'jcg 1/6/2009 09:43'!
configurationVersion
	^configurationVersion! !

!AVCDecoderConfigurationRecord methodsFor: 'initialize' stamp: 'jcg 7/6/2009 17:45'!
configurationVersion: aNumber
	configurationVersion := aNumber.! !

!AVCDecoderConfigurationRecord methodsFor: 'initialize' stamp: 'jcg 7/31/2009 11:49'!
initialize
	self initializeParameterSets ! !

!AVCDecoderConfigurationRecord methodsFor: 'initialize' stamp: 'jcg 9/29/2009 11:01'!
initializeFromDecoderSpecificInfo: decoderSpecificInfo
	"I originally learned how to do this from GPAC's gf_odf_avc_cfg_write() function, but later found out that this corresponds to the AVCDecoderConfigurationRecord defined in ISO-14496-15 Section 5.2.4.1."
	| str count startCode |

	self initializeParameterSets.

	str := QBigEndianBitStream on: decoderSpecificInfo.
	configurationVersion := str next: 8.

	"profile_idc as defined in 14496-10 Annex A.  Values:
		66	-	Baseline Profile
		77	-	Main Profile
		88	-	Extended Profile"
	profileIndication := str next: 8.

	"I *believe* that this corresponds to the byte between the 'profile_idc' and the 'level_idc' in seq_parameter_set_rbsp() in 14496-10; my evidence is that I see a match in the output produced by MP4Box for some real videos.  If this is correct, then the first 3 bits are:
	- constraint_set0_flag
	- constraint_set1_flag
	- constraint_set2_flag
... and the next 5 bits are reserved, and must be zero."
	profileCompatibility := str next: 8.

	"level_idc as defined in 14496-10 Annex A.  See Table A-1.  The level_idc must be divided by 10 to find the corresponding entry in the table.  Each level specifies the following limits on the corresponding video:
		- Max macroblock processing rate (MaxMBPS - MB/s)
		- Max macroblock processing rate (MaxMBPS - MB/s)
		- Max decoded picture buffer size (MaxDPB - 1024 bytes)
		- Max video bit rate (MaxBR - 1000 bits/s or 1200 bits/s)
		- Max CPB size (MaxCPB - 1000 bits or 1200 bits)
		- Vertical MV component range (MaxVmvR - luma frame samples)
		- Min compression ratio (MinCR)
		- Max number of motion vectors per two consecutive MBs (MaxMvsPer2Mb)
	There are also profile_idc-specific level limits (see Tables A-2,3,4), which I won't discuss further."
	levelIndication := str next: 8.

	"High 6 bits must be 0x3F, NALU size stored in the low 2 bits."
	nalUnitSize := str next: 6.
	nalUnitSize == 16r3F
		ifFalse: [self error: '6 high bits of NALU-size byte must be 0x3F'].
	nalUnitSize := (str next: 2) + 1. "ranges between 1 and 4"

	"Start code: we prepend this to each sequence/picture parameter set...
	 this is what the H.264 decoder expects."
	startCode := ByteArray new: 4.
	startCode networkUnsignedLongAt: 1 put: 1. "0x00000001"

	"Read sequence parameter sets."
	"High 3 bits must be 0x7, Param-set count is in the low 5 bytes."
	count := str next: 3.
	count == 7
		ifFalse: [self error: '3 high bits of seq-param-set count must be 0x7'].
	count := str next: 5.
	count timesRepeat: [
		| sz |
		"2 bytes for the size of the parameter set, including the NAL header.  For files I've seen, the first byte after the size is 39, which jives with the NAL unit syntax in 14496-10 7.3.1 (including a nal_unit_type of 7, which corresponds to a sequence parameter set."
		sz := str next: 16.
		sz ifNil: [self error: 'cannot read size of sequence parameter set (count: ', sz, ')'].
		sequenceParameterSets add: startCode, (str nextBytes: sz).
	].

	"Read picture parameter sets."
	count := str next: 8.
	count timesRepeat: [
		| sz |
		"2 bytes for the size of the parameter set, including the NAL header.  For files I've seen, the first byte after the size is 40, which jives with the NAL unit syntax in 14496-10 7.3.1 (including a nal_unit_type of 8, which corresponds to a picture parameter set."
		sz := str next: 16.
		sz ifNil: [self error: 'cannot read size of picture parameter set (count: ', count, ')'].
		pictureParameterSets add: startCode, (str nextBytes: sz).
	].! !

!AVCDecoderConfigurationRecord methodsFor: 'initialize' stamp: 'jcg 7/21/2009 14:28'!
initializeFromFMTP: aString
	"Initializes the config from the SDP 'fmtp' attribute as defined by RFC3016: 'RTP Payload Format for MPEG-4 Audio/Visual'."
	| params bits paramSets sequenceParams pictureParams |
	params := Dictionary new.
	(aString findTokens: '; ') do: [:p |
		params at: (p copyUpTo: $=) put: (p copyAfter: $=).
	].

	"Create an AVCDecoderConfigurationRecord (see ISO-14496-15 Section 5.2.4.1)."
	bits := QBigEndianBitStream on: (ByteArray new: 20).
	bits nextPut: 1 nbits: 8.  "configuration version"
	"The profile_idc, costraint_set flags, and level_idc."
	(ByteArray readHexFrom: (params at: 'profile-level-id') asLowercase) do: [:byte |
		bits nextPut: byte nbits: 8
	].
	"Number of bytes used to specify NALU size, less 1.  Top bits must be 0x3F."
	bits nextPut: 16r3F nbits: 6.
	bits nextPut: 4-1 nbits: 2.  "NALU sizes are 4 bytes long, but the value stored is 3."
	"Finally, the picture and sequence parameter sets."
	paramSets := (params at: 'sprop-parameter-sets') findTokens: ',= '.
	paramSets := paramSets collect: [:p | 
		(Base64MimeConverter mimeDecodeToBytes: p readStream) contents
	].
	sequenceParams := paramSets select: [:p | p first = 39].
	pictureParams := paramSets select: [:p | p first = 40].
	(sequenceParams size + pictureParams size) = paramSets size ifFalse: [
		self error: 'error parsing param-sets... must be either picture or sequence params'.
	].
	"Store the sequence parameter sets.  First store the number of sets.  1 byte... first 3 bits must be 0x7; actual value is stores in last 5 bits."
	bits nextPut: 7 nbits: 3.
	bits nextPut: sequenceParams size nbits: 5.  "store # of parameter sets"
	sequenceParams do: [:p |
		bits nextPut: p size nbits: 16. "2 bytes to store size of each parameter set"
		p do: [:byte | bits nextPut: byte nbits: 8].
	].
	"Store the picture parameter sets.  First store the number of sets."
	bits nextPut: pictureParams size nbits: 8.  "store # of parameter sets"
	pictureParams do: [:p |
		bits nextPut: p size nbits: 16. "2 bytes to store size of each parameter set"
		p do: [:byte | bits nextPut: byte nbits: 8].
	].
	
	self initializeFromDecoderSpecificInfo: bits contents.! !

!AVCDecoderConfigurationRecord methodsFor: 'initialize' stamp: 'jcg 1/30/2012 00:16'!
initializeFromNalu: naluBytes
	"If the NALU is a parameter set, remember it.  Otherwise, skip it."
	| bits refIDC naluType |

	naluBytes ifEmpty: [^self].

	bits := QBigEndianBitStream on: naluBytes.
	
	bits next == 0 ifFalse: [self error: 'nal_unit forbidden_zero_bit is not zero'].
	refIDC := bits next: 2.
	refIDC == 0 ifTrue: [^QLogger log: 'skipping NALU with nal_ref_idc == 0'].
	
	naluType := bits next: 5.
	(naluType between: 7 and: 8) 
		ifFalse: [^QLogger log: 'skipping non-parameter-set NALU of type: ', naluType].
		
	naluType == 7
				ifTrue: [self addSequenceParameterSet: naluBytes]
				ifFalse: [self addPictureParameterSet: naluBytes].
	! !

!AVCDecoderConfigurationRecord methodsFor: 'initialize' stamp: 'jcg 1/30/2012 00:18'!
initializeFromParameterSets: paramSets
	"Initialize from parameter-sets as obtained by QVideoEncoderMC#parameterSets."
	| stream set bits |

	self initializeParameterSets.

	stream := ReadStream on: paramSets.

	[stream atEnd] whileFalse: [
		"Hacky way to handle both #(0 0 0 1) and #(0 0 1)."
		set := stream upToAll: #(0 0 1).
		set last = 0 ifTrue: [set := set allButLast].
		
		self initializeFromNalu: set.	
	].
	sequenceParameterSets ifEmpty: [self error: 'no sequence parameter-sets'].
	pictureParameterSets ifEmpty: [self error: 'no picture parameter-sets'].

	"Need to initialize the profile, level, etc.  Use the first sequence-parameter-set to obtain these values."
	set := sequenceParameterSets first.
	bits := QBigEndianBitStream on: set.
	bits nextBytes: 5.  "burn through start-code and first byte."
	configurationVersion := 1. "always"
	profileIndication := bits next: 8.
	profileCompatibility := bits next: 8.
	levelIndication := bits next: 8.
! !

!AVCDecoderConfigurationRecord methodsFor: 'initialize' stamp: 'jcg 7/31/2009 11:48'!
initializeParameterSets
	sequenceParameterSets := OrderedCollection new.
	pictureParameterSets := OrderedCollection new.! !

!AVCDecoderConfigurationRecord methodsFor: 'accessing' stamp: 'jcg 1/6/2009 09:43'!
levelIndication
	^levelIndication! !

!AVCDecoderConfigurationRecord methodsFor: 'initialize' stamp: 'jcg 7/6/2009 17:46'!
levelIndication: aNumber
	levelIndication := aNumber.! !

!AVCDecoderConfigurationRecord methodsFor: 'accessing' stamp: 'jcg 1/6/2009 09:43'!
nalUnitSize
	^nalUnitSize! !

!AVCDecoderConfigurationRecord methodsFor: 'initialize' stamp: 'jcg 7/21/2009 14:33'!
nalUnitSize: aNumber
	"Set the size, in bytes, of a NALU size descriptor.  Can be 2, 3, or 4."
	(aNumber between: 2 and: 4) ifFalse: [
		self error: 'NALU size descriptor can be 2, 3, or 4 bytes'.
	].
	nalUnitSize := aNumber.! !

!AVCDecoderConfigurationRecord methodsFor: 'accessing' stamp: 'jcg 1/6/2009 09:43'!
pictureParameterSets
	^pictureParameterSets! !

!AVCDecoderConfigurationRecord methodsFor: 'accessing' stamp: 'jcg 1/6/2009 09:43'!
profileCompatibility
	^profileCompatibility! !

!AVCDecoderConfigurationRecord methodsFor: 'initialize' stamp: 'jcg 7/6/2009 17:46'!
profileCompatibility: aNumber
	profileCompatibility := aNumber.! !

!AVCDecoderConfigurationRecord methodsFor: 'accessing' stamp: 'jcg 1/6/2009 09:43'!
profileIndication
	^profileIndication! !

!AVCDecoderConfigurationRecord methodsFor: 'initialize' stamp: 'jcg 7/6/2009 17:46'!
profileIndication: aNumber
	profileIndication := aNumber.! !

!AVCDecoderConfigurationRecord methodsFor: 'reading/writing' stamp: 'jcg 7/30/2009 15:42'!
readBitsFrom: bits
	self error: 'unsupported for this class (just not done)'! !

!AVCDecoderConfigurationRecord methodsFor: 'accessing' stamp: 'jcg 7/30/2009 15:38'!
sequenceParameterSetObjects
	"Answer a collection of AVCSequenceParameterSets intead of ByteArrays."
	^sequenceParameterSets collect: [:bytes |
		| bits |
		bits := QBigEndianBitStream on: bytes.
		bits nextBytes: 5.  "burn start-code and nal-header"
		AVCSequenceParameterSet readBitsFrom: bits.
	]! !

!AVCDecoderConfigurationRecord methodsFor: 'accessing' stamp: 'jcg 1/6/2009 09:43'!
sequenceParameterSets
	^sequenceParameterSets! !

!AVCDecoderConfigurationRecord methodsFor: 'reading/writing' stamp: 'jcg 8/25/2009 17:08'!
writeBitsOn: bits

	bits nextPut: configurationVersion nbits: 8.  "configuration version"

	"AVCProfileIndication, profile_compatibility, AVCLevelIndication."
	bits nextPut: profileIndication nbits: 8.
	bits nextPut: profileCompatibility nbits: 8.
	bits nextPut: levelIndication nbits: 8.

	"2 bits for NAL 'lengthSizeMinusOne'."
	bits nextPut: 2r111111 nbits: 6.
	bits nextPut: nalUnitSize-1 nbits: 2.

	"Write the sequence-parameter sets."
	bits nextPut: 2r111 nbits: 3.
	sequenceParameterSets size > 2r11111 ifTrue: [self error: 'too many SPSes'].
	bits nextPut: sequenceParameterSets size nbits: 5.
	sequenceParameterSets do: [:sps |
		"Strip off 4-byte start-code."
		bits nextPut: sps size - 4 nbits: 16.
		bits nextPutBytes: (sps last: sps size - 4).
	].

	"Write the picture-parameter sets."
	pictureParameterSets size > 255 ifTrue: [self error: 'too many PPSes'].
	bits nextPut: pictureParameterSets size nbits: 8.
	pictureParameterSets do: [:pps |
		"Strip off 4-byte start-code."
		bits nextPut: pps size - 4 nbits: 16.
		bits nextPutBytes: (pps last: pps size - 4).
	].! !

AVCStructure subclass: #AVCHrdParameters
	instanceVariableNames: 'cpbCntMinus1 bitRateScale cpbSizeScale bitRateValueMinus1 cpbSizeValueMinus1 cbrFlag initialCpbRemovalDelayLengthMinus1 cpbRemovalDelayLengthMinus1 dpbOutputDelayLengthMinus1 timeOffsetLength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-MP4'!

!AVCHrdParameters commentStamp: '<historical>' prior: 0!
hrd_parameters() as defined in ISO-14496-10 E.1.2!

!AVCHrdParameters class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!AVCHrdParameters class methodsFor: 'specification' stamp: 'jcg 7/30/2009 09:42'!
specFrom14496
	"14496-10 E.1.1"
^'
hrd_parameters( ) { 								C Descriptor
	cpb_cnt_minus1 								0 ue(v)
	bit_rate_scale 								0 u(4)
	cpb_size_scale 								0 u(4)
	for( SchedSelIdx = 0; SchedSelIdx <= cpb_cnt_minus1; SchedSelIdx++ ) {
		bit_rate_value_minus1[ SchedSelIdx ] 		0 ue(v)
		cpb_size_value_minus1[ SchedSelIdx ] 		0 ue(v)
		cbr_flag[ SchedSelIdx ] 					0 u(1)
	}
	initial_cpb_removal_delay_length_minus1 		0 u(5)
	cpb_removal_delay_length_minus1 			0 u(5)
	dpb_output_delay_length_minus1 				0 u(5)
	time_offset_length 							0 u(5)
}
'! !

!AVCHrdParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 09:48'!
bitRateScale
	^bitRateScale! !

!AVCHrdParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:01'!
bitRateScale: aNumber
	(aNumber between: 0 and: 15) ifFalse: [self invalidParameter: aNumber].
	bitRateScale := aNumber! !

!AVCHrdParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 09:49'!
bitRateValueMinus1
	^bitRateValueMinus1 "an array of size cpbCntMinus1+1"! !

!AVCHrdParameters methodsFor: 'accessing-helpers' stamp: 'jcg 7/30/2009 11:12'!
bitRateValueMinus1: brArray cpbSizeValueMinus1: cpbArray cbrFlag: cbrArray
	cpbCntMinus1 := brArray size - 1.
	((cpbArray size-1 = cpbCntMinus1) and: [cbrArray size-1 = cpbCntMinus1]) 
		ifFalse: [self invalidParameter: 'array size mismatch'].
	bitRateValueMinus1 := brArray.
	cpbSizeValueMinus1 := cpbArray.
	cbrFlag := cbrArray.

	bitRateValueMinus1 do: [:v | 
		v > 0 ifFalse: [self invalidParameter: 'bit_rate_value_minus1 must be >= 0']
	].
	cpbSizeValueMinus1 do: [:v | 
		v > 0 ifFalse: [self invalidParameter: 'cpb_size_value_minus1 must be >= 0']
	].
	cbrFlag do: [:v | 
		(v between: 0 and: 1) ifFalse: [self invalidParameter: 'cpb_flag must be 0 or 1']
	].

	! !

!AVCHrdParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 09:49'!
cbrFlag
	^cbrFlag "an array of size cpbCntMinus1+1"! !

!AVCHrdParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 09:48'!
cpbCntMinus1
	^cpbCntMinus1! !

!AVCHrdParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:03'!
cpbCntMinus1: aNumber
	"Set arrays directly via #bitRateValueMinus1:cpbSizeValueMinus1:cbrFlag:."
	self shouldNotImplement
! !

!AVCHrdParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 09:49'!
cpbRemovalDelayLengthMinus1
	^cpbRemovalDelayLengthMinus1! !

!AVCHrdParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:13'!
cpbRemovalDelayLengthMinus1: aNumber
	(aNumber between: 0 and: 31) ifFalse: [self invalidParameter: aNumber].
	cpbRemovalDelayLengthMinus1 := aNumber! !

!AVCHrdParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 09:48'!
cpbSizeScale
	^cpbSizeScale! !

!AVCHrdParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:01'!
cpbSizeScale: aNumber
	(aNumber between: 0 and: 15) ifFalse: [self invalidParameter: aNumber].
	cpbSizeScale := aNumber! !

!AVCHrdParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 09:49'!
cpbSizeValueMinus1
	^cpbSizeValueMinus1 "an array of size cpbCntMinus1+1"! !

!AVCHrdParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 09:50'!
dpbOutputDelayLengthMinus1
	^dpbOutputDelayLengthMinus1! !

!AVCHrdParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:13'!
dpbOutputDelayLengthMinus1: aNumber
	(aNumber between: 0 and: 31) ifFalse: [self invalidParameter: aNumber].
	dpbOutputDelayLengthMinus1 := aNumber! !

!AVCHrdParameters methodsFor: 'reading/writing' stamp: 'jcg 7/30/2009 12:22'!
fullPrintOn: aStream
	aStream nextPutAll: '/// hrd_parameters START'; cr.
	aStream nextPutAll: 'cpb_cnt_minus1: ', cpbCntMinus1; cr.
	aStream nextPutAll: 'bit_rate_scale: ', bitRateScale; cr.
	aStream nextPutAll: 'cpb_size_scale: ', cpbSizeScale; cr.
	((bitRateValueMinus1 size = (cpbCntMinus1+1)) and:
	[cpbSizeValueMinus1 size = (cpbCntMinus1+1)] and:
	[cbrFlag size = (cpbCntMinus1+1)]) ifFalse: [
		self error: 'array sizes do not match cpb_cnt_minus1'.
	].
	1 to: cpbCntMinus1 do: [:i |
		aStream nextPutAll: 'bit_rate_value_minus1[', i, ']: ', (bitRateValueMinus1 at: i).	
		aStream nextPutAll: 'cpb_size_value_minus1[', i, ']: ', (cpbSizeValueMinus1 at: i).	
		aStream nextPutAll: 'cbr_flag[', i, ']: ', (cbrFlag at: i).	
	].
	aStream nextPutAll: 'initial_cpb_removal_delay_length_minus1 : ', 
							initialCpbRemovalDelayLengthMinus1; cr.	
	aStream nextPutAll: 'cpb_removal_delay_length_minus1: ',
							cpbRemovalDelayLengthMinus1; cr.	
	aStream nextPutAll: 'dpb_output_delay_length_minus1: ',
							dpbOutputDelayLengthMinus1; cr.	
	aStream nextPutAll: 'time_offset_length: ', timeOffsetLength; cr.	
	aStream nextPutAll: '/// hrd_parameters END'; cr.! !

!AVCHrdParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 09:49'!
initialCpbRemovalDelayLengthMinus1
	^initialCpbRemovalDelayLengthMinus1! !

!AVCHrdParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:13'!
initialCpbRemovalDelayLengthMinus1: aNumber
	(aNumber between: 0 and: 31) ifFalse: [self invalidParameter: aNumber].
	initialCpbRemovalDelayLengthMinus1 := aNumber! !

!AVCHrdParameters methodsFor: 'reading/writing' stamp: 'jcg 7/30/2009 10:10'!
readBitsFrom: bits "a QBigEndianBitStream"
	cpbCntMinus1 := bits unsignedExpGolomb.
	bitRateScale := bits next: 4.
	cpbSizeScale := bits next: 4.
	bitRateValueMinus1 := Array new: cpbCntMinus1+1.
	cpbSizeValueMinus1 := Array new: cpbCntMinus1+1.
	cbrFlag := Array new: cpbCntMinus1+1.
	1 to: cpbCntMinus1+1 do: [:i |
		bitRateValueMinus1 at: i put: bits unsignedExpGolomb.
		cpbSizeValueMinus1 at: i put: bits unsignedExpGolomb.
		cbrFlag at: i put: bits next.	
	].
	initialCpbRemovalDelayLengthMinus1 := bits next: 5.	
	cpbRemovalDelayLengthMinus1 := bits next: 5.	
	dpbOutputDelayLengthMinus1 := bits next: 5.	
	timeOffsetLength := bits next: 5.	
	! !

!AVCHrdParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 09:50'!
timeOffsetLength
	^timeOffsetLength! !

!AVCHrdParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:14'!
timeOffsetLength: aNumber
	(aNumber between: 0 and: 31) ifFalse: [self invalidParameter: aNumber].
	timeOffsetLength := aNumber! !

!AVCHrdParameters methodsFor: 'reading/writing' stamp: 'jcg 7/30/2009 09:56'!
writeBitsOn: bits "a QBigEndianBitStream"
	bits unsignedExpGolombPut: cpbCntMinus1.
	bits nextPut: bitRateScale nbits: 4.
	bits nextPut: cpbSizeScale nbits: 4.
	((bitRateValueMinus1 size = (cpbCntMinus1+1)) and:
	[cpbSizeValueMinus1 size = (cpbCntMinus1+1)] and:
	[cbrFlag size = (cpbCntMinus1+1)]) ifFalse: [
		self error: 'array sizes do not match cpb_cnt_minus1'.
	].
	1 to: cpbCntMinus1 do: [:i |
		bits unsignedExpGolombPut: (bitRateValueMinus1 at: i).	
		bits unsignedExpGolombPut: (cpbSizeValueMinus1 at: i).	
		bits nextPut: (cbrFlag at: i).	
	].
	bits nextPut: initialCpbRemovalDelayLengthMinus1 nbits: 5.	
	bits nextPut: cpbRemovalDelayLengthMinus1 nbits: 5.	
	bits nextPut: dpbOutputDelayLengthMinus1 nbits: 5.	
	bits nextPut: timeOffsetLength nbits: 5.	! !

AVCStructure subclass: #AVCSequenceParameterSet
	instanceVariableNames: 'profileIDC constraintSet0Flag constraintSet1Flag constraintSet2Flag levelIDC seqParameterSetID log2MaxFrameNumMinus4 picOrderCntType log2MaxPicOrderCntLsbMinus4 deltaPicOrderAlwaysZeroFlag offsetForNonRefPic offsetForTopToBottomField numRefFramesInPicOrderCntCycle numRefFrames gapsInFrameNumValueAllowedFlag picWidthInMbsMinus1 picHeightInMapUnitsMinus1 frameMbsOnlyFlag mbAdaptiveFrameFieldFlag direct8x8InferenceFlag frameCroppingFlag frameCropLeftOffset frameCropRightOffset frameCropTopOffset frameCropBottomOffset vuiParametersPresentFlag vuiParameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-MP4'!

!AVCSequenceParameterSet commentStamp: '<historical>' prior: 0!
seq_parameter_set_rbsp() as defined in ISO-14496-10 7.3.2.1!

!AVCSequenceParameterSet class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!AVCSequenceParameterSet class methodsFor: 'specification' stamp: 'jcg 7/30/2009 09:43'!
specFrom14496
	"14496-10 7.3.2.1"
^'
seq_parameter_set_rbsp( ) {						C Descriptor
	profile_idc 									0 u(8)
	constraint_set0_flag 							0 u(1)
	constraint_set1_flag 							0 u(1)
	constraint_set2_flag 							0 u(1)
	reserved_zero_5bits /* equal to 0 */ 			0 u(5)
	level_idc 									0 u(8)
	seq_parameter_set_id 						0 ue(v)
	log2_max_frame_num_minus4 				0 ue(v)
	pic_order_cnt_type 							0 ue(v)
	if( pic_order_cnt_type = = 0 )
		log2_max_pic_order_cnt_lsb_minus4 		0 ue(v)
	else if( pic_order_cnt_type = = 1 ) {
		delta_pic_order_always_zero_flag 			0 u(1)
		offset_for_non_ref_pic 					0 se(v)
		offset_for_top_to_bottom_field 			0 se(v)
		num_ref_frames_in_pic_order_cnt_cycle 	0 ue(v)
		for( i = 0; i < num_ref_frames_in_pic_order_cnt_cycle; i++ )
			offset_for_ref_frame[ i ] 				0 se(v)
	}
	num_ref_frames 								0 ue(v)
	gaps_in_frame_num_value_allowed_flag 		0 u(1)
	pic_width_in_mbs_minus1 					0 ue(v)
	pic_height_in_map_units_minus1 				0 ue(v)
	frame_mbs_only_flag 							0 u(1)
	if( !!frame_mbs_only_flag )
		mb_adaptive_frame_field_flag 				0 u(1)
	direct_8x8_inference_flag 						0 u(1)
	frame_cropping_flag 							0 u(1)
	if( frame_cropping_flag ) {
		frame_crop_left_offset 					0 ue(v)
		frame_crop_right_offset 					0 ue(v)
		frame_crop_top_offset 					0 ue(v)
		frame_crop_bottom_offset 				0 ue(v)
	}
	vui_parameters_present_flag 					0 u(1)
	if( vui_parameters_present_flag )
		vui_parameters( ) 						*
	rbsp_trailing_bits( ) 							*
}
'! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 7/29/2009 15:22'!
constraintSet0Flag: bit
	(bit between: 0 and: 1) ifFalse: [self invalidParameter: bit].
	constraintSet0Flag := bit.! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 7/29/2009 15:22'!
constraintSet1Flag: bit
	(bit between: 0 and: 1) ifFalse: [self invalidParameter: bit].
	constraintSet1Flag := bit.! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 7/29/2009 15:22'!
constraintSet2Flag: bit
	(bit between: 0 and: 1) ifFalse: [self invalidParameter: bit].
	constraintSet2Flag := bit.! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 7/29/2009 15:30'!
deltaPicOrderAlwaysZeroFlag: bit
	(bit between: 0 and: 1) ifFalse: [self invalidParameter: bit].
	deltaPicOrderAlwaysZeroFlag := bit.! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 7/29/2009 15:44'!
direct8x8InferenceFlag: bit
	(bit between: 0 and: 1) ifFalse: [self invalidParameter: bit].
	direct8x8InferenceFlag := bit.! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 7/29/2009 15:45'!
frameCropBottomOffset: num
	(num >= 0) ifFalse: [self invalidParameter: num].
	frameCropBottomOffset := num.! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 7/29/2009 15:45'!
frameCropLeftOffset: num
	(num >= 0) ifFalse: [self invalidParameter: num].
	frameCropLeftOffset := num.! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 7/29/2009 15:45'!
frameCropRightOffset: num
	(num >= 0) ifFalse: [self invalidParameter: num].
	frameCropRightOffset := num.! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 7/29/2009 15:45'!
frameCropTopOffset: num
	(num >= 0) ifFalse: [self invalidParameter: num].
	frameCropTopOffset := num.! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 7/29/2009 15:45'!
frameCroppingFlag: bit
	(bit between: 0 and: 1) ifFalse: [self invalidParameter: bit].
	frameCroppingFlag := bit.! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 7/29/2009 15:41'!
frameMbsOnlyFlag: bit
	(bit between: 0 and: 1) ifFalse: [self invalidParameter: bit].
	frameMbsOnlyFlag := bit.! !

!AVCSequenceParameterSet methodsFor: 'reading/writing' stamp: 'jcg 7/30/2009 16:06'!
fullPrintOn: aStream
	aStream nextPutAll: '/// seq_parameter_set_rbsp START'; cr.
	aStream nextPutAll: 'profile_idc: ', profileIDC; cr.
	aStream nextPutAll: 'constraint_set0_flag: ', constraintSet0Flag; cr.
	aStream nextPutAll: 'constraint_set1_flag: ', constraintSet1Flag; cr.
	aStream nextPutAll: 'constraint_set2_flag: ', constraintSet2Flag; cr.

	aStream nextPutAll: 'level_idc: ', levelIDC; cr.
	aStream nextPutAll: 'seq_parameter_set_id: ', seqParameterSetID; cr.
	aStream nextPutAll: 'log2_max_frame_num_minus4: ', log2MaxFrameNumMinus4; cr.
	aStream nextPutAll: 'pic_order_cnt_type: ', picOrderCntType; cr.
	(picOrderCntType = 0) ifTrue: [
		aStream nextPutAll: 'log2_max_pic_order_cnt_lsb_minus4: ', 
										log2MaxPicOrderCntLsbMinus4; cr.
	].
	(picOrderCntType = 1) ifTrue: [
		aStream nextPutAll: 'delta_pic_order_always_zero_flag: ', 
										deltaPicOrderAlwaysZeroFlag; cr.
		aStream nextPutAll: 'offset_for_non_ref_pic: ', offsetForNonRefPic; cr.
		aStream nextPutAll: 'offset_for_top_to_bottom_field: ', 
										offsetForTopToBottomField; cr.
		aStream nextPutAll: 'num_ref_frames_in_pic_order_cnt_cycle: ',
										numRefFramesInPicOrderCntCycle; cr. 
		numRefFramesInPicOrderCntCycle = 0 ifFalse: [
			self error: 'sorry, "numRefFramesInPicOrderCntCycle" must be zero'.
		].
	].
	aStream nextPutAll: 'num_ref_frames: ', numRefFrames; cr.
	aStream nextPutAll: 'gaps_in_frame_num_value_allowed_flag: ',
										gapsInFrameNumValueAllowedFlag; cr.
	aStream nextPutAll: 'pic_width_in_mbs_minus1: ', picWidthInMbsMinus1; cr.
	aStream nextPutAll: 'pic_height_in_map_units_minus1: ', 
										picHeightInMapUnitsMinus1; cr.
	aStream nextPutAll: 'frame_mbs_only_flag: ', frameMbsOnlyFlag; cr.
	(frameMbsOnlyFlag = 0) ifTrue: [
		aStream nextPutAll: 'mb_adaptive_frame_field_flag: ', 
										mbAdaptiveFrameFieldFlag; cr.
	].
	aStream nextPutAll: 'direct_8x8_inference_flag: ', direct8x8InferenceFlag; cr.
	aStream nextPutAll: 'frame_cropping_flag: ', frameCroppingFlag; cr.
	(frameCroppingFlag = 1) ifTrue: [
		aStream nextPutAll: 'frame_crop_left_offset: ', frameCropLeftOffset; cr.
		aStream nextPutAll: 'frame_crop_right_offset: ', frameCropRightOffset; cr.
		aStream nextPutAll: 'frame_crop_top_offset: ', frameCropTopOffset; cr.
		aStream nextPutAll: 'frame_crop_bottom_offset: ', frameCropBottomOffset; cr.
	].
	aStream nextPutAll: 'vui_parameters_present_flag: ', vuiParametersPresentFlag.
	(vuiParametersPresentFlag = 1) ifTrue: [
		vuiParameters fullPrintOn: aStream.
	].
	aStream nextPutAll: '/// seq_parameter_set_rbsp END'; cr.
! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 7/29/2009 15:40'!
gapsInFrameNumValueAllowedFlag: bit
	(bit between: 0 and: 1) ifFalse: [self invalidParameter: bit].
	gapsInFrameNumValueAllowedFlag := bit.! !

!AVCSequenceParameterSet methodsFor: 'initialize' stamp: 'jcg 7/29/2009 15:59'!
initialize
	"Parameters that are nil must be explicitly specified (usually, it's because I don't know what a sensible default is, but sometimes because you had to set a flag to a non-default value to bring those parameters into play)."
	super initialize.
	profileIDC := 66.  						"Baseline profile by default"
	constraintSet0Flag := 0.
	constraintSet1Flag := 0.
	constraintSet2Flag := 0.
	levelIDC := nil.							
	seqParameterSetID := 0.
	log2MaxFrameNumMinus4 := nil.
	picOrderCntType := 0.
	log2MaxPicOrderCntLsbMinus4 := nil.	
	deltaPicOrderAlwaysZeroFlag := nil.
	offsetForNonRefPic := nil.
	offsetForTopToBottomField := nil.
	numRefFramesInPicOrderCntCycle := 0.
	numRefFrames := nil.
	gapsInFrameNumValueAllowedFlag := 0.
	picWidthInMbsMinus1 := nil.
	picHeightInMapUnitsMinus1 := nil.
	frameMbsOnlyFlag := 1.
	mbAdaptiveFrameFieldFlag := 0.
	direct8x8InferenceFlag := 1.
	frameCroppingFlag := 0.
	frameCropLeftOffset := 0.
	frameCropRightOffset := 0.
	frameCropTopOffset := 0.
	frameCropBottomOffset := 0.
	vuiParametersPresentFlag := 1.! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 7/31/2009 11:45'!
levelIDC
	^levelIDC! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 7/29/2009 15:24'!
levelIDC: num
	(num between: 0 and: 255) ifFalse: [self invalidParameter: num].
	levelIDC := num.! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 7/29/2009 15:25'!
log2MaxFrameNumMinus4: num
	(num >= 0) ifFalse: [self invalidParameter: num].
	log2MaxFrameNumMinus4 := num.! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 7/29/2009 15:29'!
log2MaxPicOrderCntLsbMinus4: num
	(num >= 0) ifFalse: [self invalidParameter: num].
	log2MaxPicOrderCntLsbMinus4 := num.! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 7/29/2009 15:41'!
mbAdaptiveFrameFieldFlag: bit
	(bit between: 0 and: 1) ifFalse: [self invalidParameter: bit].
	mbAdaptiveFrameFieldFlag := bit.! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 7/29/2009 15:39'!
numRefFrames: num
	(num >= 0) ifFalse: [self invalidParameter: num].
	numRefFrames := num.! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 7/29/2009 15:33'!
numRefFramesInPicOrderCntCycle: num
	(num = 0) ifFalse: [
		self error: 'sorry, we do not support non-zero ', 						'num_ref_frames_in_pic_order_cnt_cycle'
	].
	numRefFramesInPicOrderCntCycle := num.! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 7/29/2009 15:31'!
offsetForNonRefPic: num
	(num isNumber) ifFalse: [self invalidParameter: num].
	offsetForNonRefPic := num.! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 7/29/2009 15:31'!
offsetForTopToBottomField: num
	(num isNumber) ifFalse: [self invalidParameter: num].
	offsetForTopToBottomField := num.! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 7/29/2009 15:41'!
picHeightInMapUnitsMinus1: num
	(num >= 0) ifFalse: [self invalidParameter: num].
	picHeightInMapUnitsMinus1 := num.! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 7/29/2009 15:28'!
picOrderCntType: num
	(num >= 0) ifFalse: [self invalidParameter: num].
	picOrderCntType := num.! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 7/29/2009 15:40'!
picWidthInMbsMinus1: num
	(num >= 0) ifFalse: [self invalidParameter: num].
	picWidthInMbsMinus1 := num.! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 8/25/2009 17:17'!
pictureHeight
	| height |
	height := (picHeightInMapUnitsMinus1+1) * 16.
	(frameCroppingFlag > 0) ifTrue: [
		height := height - frameCropBottomOffset.
		height := height - frameCropTopOffset.
	].
	^height
		! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 8/25/2009 17:18'!
pictureWidth
	| width |
	width := (picWidthInMbsMinus1+1) * 16.
	(frameCroppingFlag > 0) ifTrue: [
		width := width - frameCropLeftOffset.
		width := width - frameCropRightOffset.
	].
	^width
		! !

!AVCSequenceParameterSet methodsFor: 'accessing-helpers' stamp: 'jcg 7/31/2009 11:39'!
profileCompatibilityByte
	"Answers the 'profile_compatibility' byte for an AVCDecoderConfigurationRecord (as defined in 14496-15)."
	| result |
	result := constraintSet0Flag.
	result := result bitShift: 1.
	result := result bitOr: constraintSet1Flag.
	result := result bitShift: 1.
	result := result bitOr: constraintSet2Flag.
	result := result bitShift: 5.
	^result! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 7/31/2009 11:45'!
profileIDC
	^profileIDC! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 7/29/2009 15:22'!
profileIDC: num
	(num between: 0 and: 255) ifFalse: [self invalidParameter: num].
	profileIDC := num.! !

!AVCSequenceParameterSet methodsFor: 'reading/writing' stamp: 'jcg 7/31/2009 17:01'!
readBitsFrom: bits "a QBigEndianBitStream"
	profileIDC := bits next: 8.
	constraintSet0Flag := bits next.
	constraintSet1Flag := bits next.
	constraintSet2Flag := bits next.
	(bits next: 5) = 0 ifFalse: [self error: 'reserved_zero_5bits should be zero'].
	levelIDC := bits next: 8.
	seqParameterSetID := bits unsignedExpGolomb.
	log2MaxFrameNumMinus4 := bits unsignedExpGolomb.
	picOrderCntType := bits unsignedExpGolomb.
	(picOrderCntType = 0) ifTrue: [
		log2MaxPicOrderCntLsbMinus4 := bits unsignedExpGolomb.
	].
	(picOrderCntType = 1) ifTrue: [
		deltaPicOrderAlwaysZeroFlag := bits next.
		offsetForNonRefPic := bits signedExpGolomb.
		offsetForTopToBottomField := bits signedExpGolomb.
		numRefFramesInPicOrderCntCycle := bits unsignedExpGolomb.
		numRefFramesInPicOrderCntCycle = 0 ifFalse: [
			self error: 'sorry, "numRefFramesInPicOrderCntCycle" must be zero'.
		].
	].
	numRefFrames := bits unsignedExpGolomb.
	gapsInFrameNumValueAllowedFlag := bits next.
	picWidthInMbsMinus1 := bits unsignedExpGolomb.
	picHeightInMapUnitsMinus1 := bits unsignedExpGolomb.
	frameMbsOnlyFlag := bits next.
	(frameMbsOnlyFlag = 0) ifTrue: [
		mbAdaptiveFrameFieldFlag := bits next
	].
	direct8x8InferenceFlag := bits next.
	frameCroppingFlag := bits next.
	(frameCroppingFlag = 1) ifTrue: [
		frameCropLeftOffset := bits unsignedExpGolomb.
		frameCropRightOffset := bits unsignedExpGolomb.
		frameCropTopOffset := bits unsignedExpGolomb.
		frameCropBottomOffset := bits unsignedExpGolomb.
	].
	vuiParametersPresentFlag := bits next.
	(vuiParametersPresentFlag = 1) ifTrue: [
		vuiParameters := AVCVuiParameters readBitsFrom: bits.
	].
	bits burnRbspTrailingBits.! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 7/29/2009 15:25'!
seqParameterSetID: num
	(num >= 0) ifFalse: [self invalidParameter: num].
	seqParameterSetID := num.! !

!AVCSequenceParameterSet methodsFor: 'accessing' stamp: 'jcg 7/29/2009 15:46'!
vuiParametersPresentFlag: bit
	(bit between: 0 and: 1) ifFalse: [self invalidParameter: bit].
	vuiParametersPresentFlag := bit.! !

!AVCSequenceParameterSet methodsFor: 'reading/writing' stamp: 'jcg 7/30/2009 16:09'!
writeBitsOn: bits "a QBigEndianBitStream"
	bits nextPut: profileIDC nbits: 8.
	bits nextPut: constraintSet0Flag.
	bits nextPut: constraintSet1Flag.
	bits nextPut: constraintSet2Flag.
	bits nextPut: 0 nbits: 5.
	bits nextPut: levelIDC nbits: 8.
	bits unsignedExpGolombPut: seqParameterSetID.
	bits unsignedExpGolombPut: log2MaxFrameNumMinus4.
	bits unsignedExpGolombPut: picOrderCntType.
	(picOrderCntType = 0) ifTrue: [
		bits unsignedExpGolombPut: log2MaxPicOrderCntLsbMinus4.
	].
	(picOrderCntType = 1) ifTrue: [
		bits nextPut: deltaPicOrderAlwaysZeroFlag.
		bits signedExpGolombPut: offsetForNonRefPic.
		bits signedExpGolombPut: offsetForTopToBottomField.
		bits unsignedExpGolombPut: numRefFramesInPicOrderCntCycle. 
		numRefFramesInPicOrderCntCycle = 0 ifFalse: [
			self error: 'sorry, "numRefFramesInPicOrderCntCycle" must be zero'.
		].
	].
	bits unsignedExpGolombPut: numRefFrames.
	bits nextPut: gapsInFrameNumValueAllowedFlag.
	bits unsignedExpGolombPut: picWidthInMbsMinus1.
	bits unsignedExpGolombPut: picHeightInMapUnitsMinus1.
	bits nextPut: frameMbsOnlyFlag.
	(frameMbsOnlyFlag = 0) ifTrue: [
		bits nextPut: mbAdaptiveFrameFieldFlag.
	].
	bits nextPut: direct8x8InferenceFlag.
	bits nextPut: frameCroppingFlag.
	(frameCroppingFlag = 1) ifTrue: [
		bits unsignedExpGolombPut: frameCropLeftOffset.
		bits unsignedExpGolombPut: frameCropRightOffset.
		bits unsignedExpGolombPut: frameCropTopOffset.
		bits unsignedExpGolombPut: frameCropBottomOffset.
	].
	bits nextPut: vuiParametersPresentFlag.
	(vuiParametersPresentFlag = 1) ifTrue: [
		vuiParameters writeBitsOn: bits.
	].
	bits putRbspTrailingBits.! !

!AVCStructure class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!AVCStructure class methodsFor: 'instance creation' stamp: 'jcg 7/31/2009 11:18'!
readBitsFrom: source "a ByteArray or QBigEndianBitStream"
	| bits |
	(source isKindOf: ByteArray)
		ifFalse: [bits := source]
		ifTrue: [bits := QBigEndianBitStream on: source].
	^self new 
			readBitsFrom: bits; 
			yourself! !

!AVCStructure methodsFor: 'comparing' stamp: 'jcg 8/12/2009 12:11'!
= anAVCStructure
	"Quicker (for me to type) and less error-prone than typing in inst-var accessors."
	self class == anAVCStructure class ifFalse: [^false].
	1 to: self class instSize do: [:i |
		(self instVarAt: i) = (anAVCStructure instVarAt: i) ifFalse: [^false]
	].
	^true! !

!AVCStructure methodsFor: 'converting' stamp: 'jcg 7/30/2009 16:19'!
asByteArray
	| bits |
	bits := QBigEndianBitStream forWriting.
	self writeBitsOn: bits.
	^bits contents
! !

!AVCStructure methodsFor: 'printing' stamp: 'jcg 7/30/2009 10:11'!
fullPrintString
	^String streamContents: [:s | self fullPrintOn: s]! !

!AVCStructure methodsFor: 'private' stamp: 'jcg 7/30/2009 10:58'!
invalidParameter: param
	self error: 'invalid parameter: ', param, ' in: ', thisContext sender selector printString! !

AVCStructure subclass: #AVCVuiParameters
	instanceVariableNames: 'aspectRatioInfoPresentFlag aspectRatioIDC sarWidth sarHeight overscanInfoPresentFlag overscanAppropriateFlag videoSignalTypePresentFlag videoFormat videoFullRangeFlag colourDescriptionPresentFlag colourPrimaries transferCharacteristics matrixCoefficients chromaLocInfoPresentFlag chromaSampleLocTypeTopField chromaSampleLocTypeBottomField timingInfoPresentFlag numUnitsInTick timeScale fixedFrameRateFlag nalHrdParametersPresentFlag nalHrdParameters vclHrdParametersPresentFlag vclHrdParameters lowDelayHrdFlag picStructPresentFlag bitstreamRestrictionFlag motionVectorsOverPicBoundariesFlag maxBytesPerPicDenom maxBitsPerMbDenom log2MaxMvLengthHorizontal log2MaxMvLengthVertical numReorderFrames maxDecFrameBuffering'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-MP4'!

!AVCVuiParameters commentStamp: 'jcg 7/30/2009 11:53' prior: 0!
vui_parameters() as defined in ISO-14496-10 E.1.1

TO-DO
- In some cases (eg: #nalHrdParameters: and #sarWidth:sarHeight:) we set a flag/indicator depending on the value of a parameter, rather than setting the flag directly.  Eg: you're not allowed to directly set nal_hrd_parameters_present_flag... it is automatically set when you provide the corresponding parameters, and automatically cleared when you clear the parameter.  We should do this in more places.!

!AVCVuiParameters class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!AVCVuiParameters class methodsFor: 'specification' stamp: 'jcg 7/30/2009 09:41'!
specFrom14496
	"14496-10 E.1.1"
^'
vui_parameters( ) { 								C Descriptor
	aspect_ratio_info_present_flag 				0 u(1)
	if( aspect_ratio_info_present_flag ) {
		aspect_ratio_idc 							0 u(8)
		if( aspect_ratio_idc = = Extended_SAR ) {
			sar_width 							0 u(16)
			sar_height 							0 u(16)
		}
	}
	overscan_info_present_flag 					0 u(1)
	if( overscan_info_present_flag )
		overscan_appropriate_flag				0 u(1)
	video_signal_type_present_flag 				0 u(1)
	if( video_signal_type_present_flag ) {
		video_format 							0 u(3)
		video_full_range_flag 						0 u(1)
		colour_description_present_flag			0 u(1)
		if( colour_description_present_flag ) {
			colour_primaries 						0 u(8)
			transfer_characteristics 				0 u(8)
			matrix_coefficients 					0 u(8)
		}
	}
	chroma_loc_info_present_flag					0 u(1)
	if( chroma_loc_info_present_flag ) {
		chroma_sample_loc_type_top_field			0 ue(v)
		chroma_sample_loc_type_bottom_field		0 ue(v)
	}
	timing_info_present_flag						0 u(1)
	if( timing_info_present_flag ) {
		num_units_in_tick 						0 u(32)
		time_scale 								0 u(32)
		fixed_frame_rate_flag 					0 u(1)
	}
	nal_hrd_parameters_present_flag 				0 u(1)
	if( nal_hrd_parameters_present_flag )
		hrd_parameters( )						*
	vcl_hrd_parameters_present_flag 				0 u(1)
	if( vcl_hrd_parameters_present_flag )
		hrd_parameters( )						*
	if( nal_hrd_parameters_present_flag | | vcl_hrd_parameters_present_flag )
		low_delay_hrd_flag 						0 u(1)
	pic_struct_present_flag 						0 u(1)
	bitstream_restriction_flag 						0 u(1)
	if( bitstream_restriction_flag ) {
		motion_vectors_over_pic_boundaries_flag 	0 u(1)
		max_bytes_per_pic_denom 				0 ue(v)
		max_bits_per_mb_denom 					0 ue(v)
		log2_max_mv_length_horizontal 			0 ue(v)
		log2_max_mv_length_vertical 				0 ue(v)
		num_reorder_frames 						0 ue(v)
		max_dec_frame_buffering 				0 ue(v)
	}
}
'! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 18:59'!
aspectRatioIDC
	^aspectRatioIDC! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:32'!
aspectRatioIDC: aNumber
	"255 is also an allowable value, but we set this when we explicitly specify sarWidth/sarHeight."
	(aNumber between: 0 and: 254) ifFalse: [self invalidParameter: aNumber].
	aspectRatioIDC := aNumber.
	sarWidth := sarHeight := nil.! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 18:59'!
aspectRatioInfoPresentFlag
	^aspectRatioInfoPresentFlag! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:31'!
aspectRatioInfoPresentFlag: aNumber
	(aNumber between: 0 and: 1) ifFalse: [self invalidParameter: aNumber].
	aspectRatioInfoPresentFlag := aNumber.! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 19:01'!
bitstreamRestrictionFlag
	^bitstreamRestrictionFlag! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:47'!
bitstreamRestrictionFlag: aNumber
	(aNumber between: 0 and: 1) ifFalse: [self invalidParameter: aNumber].
	bitstreamRestrictionFlag := aNumber.! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 19:00'!
chromaLocInfoPresentFlag
	^chromaLocInfoPresentFlag! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:40'!
chromaLocInfoPresentFlag: aNumber
	(aNumber between: 0 and: 1) ifFalse: [self invalidParameter: aNumber].
	chromaLocInfoPresentFlag := aNumber.! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 19:00'!
chromaSampleLocTypeBottomField
	^chromaSampleLocTypeBottomField! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:41'!
chromaSampleLocTypeBottomField: aNumber
	(aNumber >= 0) ifFalse: [self invalidParameter: aNumber].
	chromaSampleLocTypeBottomField := aNumber.! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 19:00'!
chromaSampleLocTypeTopField
	^chromaSampleLocTypeTopField! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:41'!
chromaSampleLocTypeTopField: aNumber
	(aNumber >= 0) ifFalse: [self invalidParameter: aNumber].
	chromaSampleLocTypeTopField := aNumber.! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 18:59'!
colourDescriptionPresentFlag
	^colourDescriptionPresentFlag! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:39'!
colourDescriptionPresentFlag: aNumber
	(aNumber between: 0 and: 1) ifFalse: [self invalidParameter: aNumber].
	colourDescriptionPresentFlag := aNumber.! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 18:59'!
colourPrimaries
	^colourPrimaries! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:39'!
colourPrimaries: aNumber
	(aNumber between: 0 and: 255) ifFalse: [self invalidParameter: aNumber].
	colourPrimaries := aNumber.! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 19:00'!
fixedFrameRateFlag
	^fixedFrameRateFlag! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:42'!
fixedFrameRateFlag: aNumber
	(aNumber between: 0 and: 1) ifFalse: [self invalidParameter: aNumber].
	fixedFrameRateFlag := aNumber.! !

!AVCVuiParameters methodsFor: 'reading/writing' stamp: 'jcg 7/30/2009 16:07'!
fullPrintOn: aStream
	aStream nextPutAll: '/// vui_parameters START'; cr.
	aStream nextPutAll: 'aspect_ratio_info_present_flag: ', aspectRatioInfoPresentFlag; cr.
	(aspectRatioInfoPresentFlag = 1) ifTrue: [
		aStream nextPutAll: 'aspect_ratio_idc: ', aspectRatioIDC; cr.
		(aspectRatioIDC = 255 "extended") ifTrue: [
			aStream nextPutAll: 'sar_width: ', sarWidth; cr.
			aStream nextPutAll: 'sar_height ', sarHeight; cr.
		].
	].
	aStream nextPutAll: 'overscan_info_present_flag: ', overscanInfoPresentFlag; cr.
	(overscanInfoPresentFlag = 1) ifTrue: [
		aStream nextPutAll: 'overscan_appropriate_flag: ', overscanAppropriateFlag; cr
	].
	aStream nextPutAll: 'video_signal_type_present_flag: ', videoSignalTypePresentFlag; cr.
	(videoSignalTypePresentFlag = 1) ifTrue: [
		aStream nextPutAll: 'video_format: ', videoFormat; cr.
		aStream nextPutAll: 'video_full_range_flag: ', videoFullRangeFlag; cr.
		aStream nextPutAll: 'colour_description_present_flag', colourDescriptionPresentFlag; cr.
		(colourDescriptionPresentFlag = 1) ifTrue: [
			aStream nextPutAll: 'colour_primaries: ', colourPrimaries; cr.
			aStream nextPutAll: 'transfer_characteristics: ', transferCharacteristics; cr.
			aStream nextPutAll: 'matrix_coefficients: ', matrixCoefficients; cr.
		].
	].
	aStream nextPutAll: 'chroma_loc_info_present_flag: ', chromaLocInfoPresentFlag; cr.
	(chromaLocInfoPresentFlag = 1) ifTrue: [
		aStream nextPutAll: 'chroma_sample_loc_type_top_field: ', chromaSampleLocTypeTopField; cr.
		aStream nextPutAll: 'chroma_sample_loc_type_bottom_field: ', 
										chromaSampleLocTypeBottomField; cr.
	].
	aStream nextPutAll: 'timing_info_present_flag: ', timingInfoPresentFlag; cr.
	(timingInfoPresentFlag = 1) ifTrue: [
		aStream nextPutAll: 'num_units_in_tick : ', numUnitsInTick; cr.
		aStream nextPutAll: 'time_scale: ', timeScale; cr.
		aStream nextPutAll: 'fixed_frame_rate_flag: ', fixedFrameRateFlag; cr.
	].
	aStream nextPutAll: 'nal_hrd_parameters_present_flag: ', nalHrdParametersPresentFlag; cr.
	(nalHrdParametersPresentFlag = 1) ifTrue: [nalHrdParameters fullPrintOn: aStream].
	aStream nextPutAll: 'vcl_hrd_parameters_present_flag: ', vclHrdParametersPresentFlag; cr.
	(vclHrdParametersPresentFlag = 1) ifTrue: [vclHrdParameters fullPrintOn: aStream].
	((nalHrdParametersPresentFlag + vclHrdParametersPresentFlag) > 0) ifTrue: [
		aStream nextPutAll: 'low_delay_hrd_flag : ', lowDelayHrdFlag; cr.
	].
	aStream nextPutAll: 'pic_struct_present_flag: ', picStructPresentFlag; cr.
	aStream nextPutAll: 'bitstream_restriction_flag: ', bitstreamRestrictionFlag; cr.
	(bitstreamRestrictionFlag = 1) ifTrue: [
		aStream nextPutAll: 'motion_vectors_over_pic_boundaries_flag: ', 
											motionVectorsOverPicBoundariesFlag; cr.
		aStream nextPutAll: 'max_bytes_per_pic_denom: ', maxBytesPerPicDenom; cr.
		aStream nextPutAll: 'max_bits_per_mb_denom: ', maxBitsPerMbDenom; cr.
		aStream nextPutAll: 'log2_max_mv_length_horizontal: ', log2MaxMvLengthHorizontal; cr.
		aStream nextPutAll: 'log2_max_mv_length_vertical: ', log2MaxMvLengthVertical; cr.
		aStream nextPutAll: 'num_reorder_frames: ', numReorderFrames; cr.
		aStream nextPutAll: 'max_dec_frame_buffering: ', maxDecFrameBuffering; cr.
	].
	aStream nextPutAll: '/// vui_parameters END'; cr.! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 19:01'!
log2MaxMvLengthHorizontal
	^log2MaxMvLengthHorizontal! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:49'!
log2MaxMvLengthHorizontal: aNumber
	(aNumber >= 0) ifFalse: [self invalidParameter: aNumber].
	log2MaxMvLengthHorizontal := aNumber.! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 19:01'!
log2MaxMvLengthVertical
	^log2MaxMvLengthVertical! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:49'!
log2MaxMvLengthVertical: aNumber
	(aNumber >= 0) ifFalse: [self invalidParameter: aNumber].
	log2MaxMvLengthVertical := aNumber.! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 19:01'!
lowDelayHrdFlag
	^lowDelayHrdFlag! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:47'!
lowDelayHrdFlag: aNumber
	(aNumber between: 0 and: 1) ifFalse: [self invalidParameter: aNumber].
	lowDelayHrdFlag := aNumber.! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 19:00'!
matrixCoefficients
	^matrixCoefficients! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:40'!
matrixCoefficients: aNumber
	(aNumber between: 0 and: 255) ifFalse: [self invalidParameter: aNumber].
	matrixCoefficients := aNumber.! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 19:01'!
maxBitsPerMbDenom
	^maxBitsPerMbDenom! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:49'!
maxBitsPerMbDenom: aNumber
	(aNumber >= 0) ifFalse: [self invalidParameter: aNumber].
	maxBitsPerMbDenom := aNumber.! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 19:01'!
maxBytesPerPicDenom
	^maxBytesPerPicDenom! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:48'!
maxBytesPerPicDenom: aNumber
	(aNumber >= 0) ifFalse: [self invalidParameter: aNumber].
	maxBytesPerPicDenom := aNumber.! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 19:01'!
maxDecFrameBuffering
	^maxDecFrameBuffering! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:49'!
maxDecFrameBuffering: aNumber
	(aNumber >= 0) ifFalse: [self invalidParameter: aNumber].
	maxDecFrameBuffering := aNumber.! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 19:01'!
motionVectorsOverPicBoundariesFlag
	^motionVectorsOverPicBoundariesFlag! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:48'!
motionVectorsOverPicBoundariesFlag: aNumber
	(aNumber between: 0 and: 1) ifFalse: [self invalidParameter: aNumber].
	motionVectorsOverPicBoundariesFlag := aNumber.! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 19:00'!
nalHrdParameters
	^nalHrdParameters! !

!AVCVuiParameters methodsFor: 'accessing-helpers' stamp: 'jcg 7/30/2009 11:45'!
nalHrdParameters: params "an AVCHrdParameters"
	nalHrdParameters := params.
	nalHrdParametersPresentFlag := nalHrdParameters ifNil: [0] ifNotNil: [1].! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 19:00'!
nalHrdParametersPresentFlag
	^nalHrdParametersPresentFlag! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:43'!
nalHrdParametersPresentFlag: aNumber
	self error: 'use #nalHrdParameters: instead'.! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 19:01'!
numReorderFrames
	^numReorderFrames! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:49'!
numReorderFrames: aNumber
	(aNumber >= 0) ifFalse: [self invalidParameter: aNumber].
	numReorderFrames := aNumber.! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 19:00'!
numUnitsInTick
	^numUnitsInTick! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:42'!
numUnitsInTick: aNumber
	(aNumber between: 0 and: 4294967295 "uint32") ifFalse: [self invalidParameter: aNumber].
	numUnitsInTick := aNumber.
! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 18:59'!
overscanAppropriateFlag
	^overscanAppropriateFlag! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:37'!
overscanAppropriateFlag: aNumber
	(aNumber between: 0 and: 1) ifFalse: [self invalidParameter: aNumber].
	overscanAppropriateFlag := aNumber.! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 18:59'!
overscanInfoPresentFlag
	^overscanInfoPresentFlag! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:37'!
overscanInfoPresentFlag: aNumber
	(aNumber between: 0 and: 1) ifFalse: [self invalidParameter: aNumber].
	overscanInfoPresentFlag := aNumber.! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 19:01'!
picStructPresentFlag
	^picStructPresentFlag! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:47'!
picStructPresentFlag: aNumber
	(aNumber between: 0 and: 1) ifFalse: [self invalidParameter: aNumber].
	picStructPresentFlag := aNumber.! !

!AVCVuiParameters methodsFor: 'reading/writing' stamp: 'jcg 7/30/2009 12:21'!
readBitsFrom: bits "a QBigEndianBitStream"
	aspectRatioInfoPresentFlag := bits next.
	(aspectRatioInfoPresentFlag = 1) 
		ifFalse: [aspectRatioIDC := sarWidth := sarHeight := nil]
		ifTrue: [
			aspectRatioIDC := bits next: 8.
			(aspectRatioIDC = 255 "extended") 
				ifFalse: [sarWidth := sarHeight := nil]
				ifTrue: [
					sarWidth := bits next: 16.
					sarHeight := bits next: 16.
				].
		].
	overscanInfoPresentFlag := bits next.
	(overscanInfoPresentFlag = 1) 
		ifFalse: [overscanAppropriateFlag := nil]
		ifTrue: [overscanAppropriateFlag := bits next].
	videoSignalTypePresentFlag := bits next.
	(videoSignalTypePresentFlag = 1) 
		ifFalse: [
			videoFormat := videoFullRangeFlag := colourDescriptionPresentFlag := nil.
			colourPrimaries := transferCharacteristics := matrixCoefficients := nil
		]
		ifTrue: [
			videoFormat := bits next: 3.
			videoFullRangeFlag := bits next.
			colourDescriptionPresentFlag := bits next.
			(colourDescriptionPresentFlag = 1) 
				ifFalse: [colourPrimaries := transferCharacteristics := matrixCoefficients := nil]
				ifTrue: [
					colourPrimaries := bits next: 8.
					transferCharacteristics := bits next: 8.
					matrixCoefficients := bits next: 8.
				].
		].
	chromaLocInfoPresentFlag := bits next.
	(chromaLocInfoPresentFlag = 1)
		ifFalse: [ chromaSampleLocTypeTopField := chromaSampleLocTypeBottomField := nil]
		ifTrue: [
			chromaSampleLocTypeTopField := bits unsignedExpGolomb.
			chromaSampleLocTypeBottomField := bits unsignedExpGolomb.
		].
	timingInfoPresentFlag := bits next.
	(timingInfoPresentFlag = 1)
		ifFalse: [numUnitsInTick := timeScale := fixedFrameRateFlag := nil]
		ifTrue: [
			numUnitsInTick := bits next: 32.
			timeScale := bits next: 32.
			fixedFrameRateFlag := bits next.
		].
	nalHrdParametersPresentFlag := bits next.
	(nalHrdParametersPresentFlag = 1) 
		ifFalse: [nalHrdParameters := nil]
		ifTrue: [nalHrdParameters := AVCHrdParameters readBitsFrom: bits].
	vclHrdParametersPresentFlag := bits next.
	(vclHrdParametersPresentFlag = 1) 
		ifFalse: [vclHrdParameters := nil]
		ifTrue: [vclHrdParameters := AVCHrdParameters readBitsFrom: bits].
	((nalHrdParametersPresentFlag + vclHrdParametersPresentFlag) > 0) 
		ifFalse: [lowDelayHrdFlag := nil]
		ifTrue: [lowDelayHrdFlag := bits next].
	picStructPresentFlag := bits next.
	bitstreamRestrictionFlag := bits next.
	(bitstreamRestrictionFlag = 1) 
		ifFalse: [
			motionVectorsOverPicBoundariesFlag := 
			maxBytesPerPicDenom :=
			maxBitsPerMbDenom :=
			log2MaxMvLengthHorizontal :=
			log2MaxMvLengthVertical :=
			numReorderFrames :=
			maxDecFrameBuffering :=
			nil
		]
		ifTrue: [
			motionVectorsOverPicBoundariesFlag := bits next.
			maxBytesPerPicDenom := bits unsignedExpGolomb.
			maxBitsPerMbDenom := bits unsignedExpGolomb.
			log2MaxMvLengthHorizontal := bits unsignedExpGolomb.
			log2MaxMvLengthVertical := bits unsignedExpGolomb.
			numReorderFrames := bits unsignedExpGolomb.
			maxDecFrameBuffering := bits unsignedExpGolomb.
		].! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 18:59'!
sarHeight
	^sarHeight! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:36'!
sarHeight: aNumber
	"Use #sarWidth:sarHeight instead."
	self shouldNotImplement! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 18:59'!
sarWidth
	^sarWidth! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:36'!
sarWidth: aNumber
	"Use #sarWidth:sarHeight instead."
	self shouldNotImplement! !

!AVCVuiParameters methodsFor: 'accessing-helpers' stamp: 'jcg 7/30/2009 11:50'!
sarWidth: width sarHeight: height
	(width between: 0 and: 65535) ifFalse: [self invalidParameter: width].
	(height between: 0 and: 65535) ifFalse: [self invalidParameter: height].
	sarWidth := width.
	sarHeight := height.
	aspectRatioIDC := 255.  "Extended_SAR: use sar_width and sar_height"
! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 19:00'!
timeScale
	^timeScale! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:42'!
timeScale: aNumber
	(aNumber between: 0 and: 4294967295 "uint32") ifFalse: [self invalidParameter: aNumber].
	timeScale := aNumber.
! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 19:00'!
timingInfoPresentFlag
	^timingInfoPresentFlag! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:41'!
timingInfoPresentFlag: aNumber
	(aNumber between: 0 and: 1) ifFalse: [self invalidParameter: aNumber].
	timingInfoPresentFlag := aNumber.! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 18:59'!
transferCharacteristics
	^transferCharacteristics! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:40'!
transferCharacteristics: aNumber
	(aNumber between: 0 and: 255) ifFalse: [self invalidParameter: aNumber].
	transferCharacteristics := aNumber.! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 19:01'!
vclHrdParameters
	^vclHrdParameters! !

!AVCVuiParameters methodsFor: 'accessing-helpers' stamp: 'jcg 7/30/2009 11:45'!
vclHrdParameters: params "an AVCHrdParameters"
	vclHrdParameters := params.
	vclHrdParametersPresentFlag := vclHrdParameters ifNil: [0] ifNotNil: [1].! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 19:01'!
vclHrdParametersPresentFlag
	^vclHrdParametersPresentFlag! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:46'!
vclHrdParametersPresentFlag: aNumber
	self error: 'use #vclHrdParameters: instead'.! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 18:59'!
videoFormat
	^videoFormat! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:39'!
videoFormat: aNumber
	(aNumber between: 0 and: 7) ifFalse: [self invalidParameter: aNumber].
	videoFormat := aNumber.! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 18:59'!
videoFullRangeFlag
	^videoFullRangeFlag! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:38'!
videoFullRangeFlag: aNumber
	(aNumber between: 0 and: 1) ifFalse: [self invalidParameter: aNumber].
	videoFullRangeFlag := aNumber.! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/29/2009 18:59'!
videoSignalTypePresentFlag
	^videoSignalTypePresentFlag! !

!AVCVuiParameters methodsFor: 'accessing' stamp: 'jcg 7/30/2009 11:37'!
videoSignalTypePresentFlag: aNumber
	(aNumber between: 0 and: 1) ifFalse: [self invalidParameter: aNumber].
	videoSignalTypePresentFlag := aNumber.! !

!AVCVuiParameters methodsFor: 'reading/writing' stamp: 'jcg 7/30/2009 09:34'!
writeBitsOn: bits "a QBigEndianBitStream"
	bits nextPut: aspectRatioInfoPresentFlag.
	(aspectRatioInfoPresentFlag = 1) ifTrue: [
		bits nextPut: aspectRatioIDC nbits: 8.
		(aspectRatioIDC = 255 "extended") ifTrue: [
			bits nextPut: sarWidth nbits: 16.
			bits nextPut: sarHeight nbits: 16.
		].
	].
	bits nextPut: overscanInfoPresentFlag.
	(overscanInfoPresentFlag = 1) ifTrue: [bits nextPut: overscanAppropriateFlag].
	bits nextPut: videoSignalTypePresentFlag.
	(videoSignalTypePresentFlag = 1) ifTrue: [
		bits nextPut: videoFormat nbits: 3.
		bits nextPut: videoFullRangeFlag.
		bits nextPut: colourDescriptionPresentFlag.
		(colourDescriptionPresentFlag = 1) ifTrue: [
			bits nextPut: colourPrimaries nbits: 8.
			bits nextPut: transferCharacteristics nbits: 8.
			bits nextPut: matrixCoefficients nbits: 8.
		].
	].
	bits nextPut: chromaLocInfoPresentFlag.
	(chromaLocInfoPresentFlag = 1) ifTrue: [
		bits unsignedExpGolombPut: chromaSampleLocTypeTopField.
		bits unsignedExpGolombPut: chromaSampleLocTypeBottomField.
	].
	bits nextPut: timingInfoPresentFlag.
	(timingInfoPresentFlag = 1) ifTrue: [
		bits nextPut: numUnitsInTick nbits: 32.
		bits nextPut: timeScale nbits: 32.
		bits nextPut: fixedFrameRateFlag.
	].
	bits nextPut: nalHrdParametersPresentFlag.
	(nalHrdParametersPresentFlag = 1) ifTrue: [nalHrdParameters writeBitsOn: bits].
	bits nextPut: vclHrdParametersPresentFlag.
	(vclHrdParametersPresentFlag = 1) ifTrue: [vclHrdParameters writeBitsOn: bits].
	((nalHrdParametersPresentFlag + vclHrdParametersPresentFlag) > 0) ifTrue: [
		bits nextPut: lowDelayHrdFlag.
	].
	bits nextPut: picStructPresentFlag.
	bits nextPut: bitstreamRestrictionFlag.
	(bitstreamRestrictionFlag = 1) ifTrue: [
		bits nextPut: motionVectorsOverPicBoundariesFlag.
		bits unsignedExpGolombPut: maxBytesPerPicDenom.
		bits unsignedExpGolombPut: maxBitsPerMbDenom.
		bits unsignedExpGolombPut: log2MaxMvLengthHorizontal.
		bits unsignedExpGolombPut: log2MaxMvLengthVertical.
		bits unsignedExpGolombPut: numReorderFrames.
		bits unsignedExpGolombPut: maxDecFrameBuffering.
	].! !

Object subclass: #MP4Box
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-MP4'!

!MP4Box commentStamp: '<historical>' prior: 0!
Interface to external MP4Box program.!

!MP4Box class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!MP4Box class methodsFor: 'invocation' stamp: 'jcg 12/9/2009 14:45'!
add: nhmlFilePath to: outputFilePath
	| workingDirPath nhmlFileSize warningLimit hardTimeout runTime result |
	workingDirPath := (nhmlFilePath copyUpToLast: FileDirectory pathNameDelimiter), '/'.
	
	"Determine how long we should wait for MP4Box.  I previously observed that we could crunch 1500KB/s on apps04, but on Dec 9, 2009, I measured much worse performance: 210KB/s to 330KB/s on apps03 (for the audio and video tracks, respectively), and 300KB/s to 400KB/s on my MacBook Pro.  It's pretty sad if we can't do 300KB/s, so log a warning (but continue processing).  If we can't even manage 30KB/s, that's worthy of mailing an error and timing out.  Under no circumstances do we wait less than 15 seconds."
	"XXXXX: we should probably watch stdout, and not give up as long as some progress is being made."

	nhmlFileSize := (FileDirectory default directoryEntryFor: nhmlFilePath) fileSize.
	warningLimit := (nhmlFileSize / 300) roundUpTo: 1000.
	hardTimeout := (warningLimit * 10 max: 15000) roundUpTo: 1000.
	warningLimit := warningLimit max: 5000.

	runTime := [result := self 
							execWithCommandLine: '-mpeg4 -add ''', nhmlFilePath, ''' ''', outputFilePath, ''''
							workingDir: workingDirPath
							timeLimit: hardTimeout.
	] timeToRun.
	runTime >= hardTimeout ifTrue: [
		QLogger logError: '#add:to: exceeded hard-timeout of ', (hardTimeout / 1000), ' seconds' details: '' from: self.
		^result
	].
	runTime >= warningLimit ifTrue: [
		QLogger logWarning: '#add:to: exceeded warning-limit of ', (warningLimit / 1000), ' seconds'.
		^result
	].
	^result! !

!MP4Box class methodsFor: 'invocation' stamp: 'jcg 8/7/2009 14:28'!
execWithCommandLine: cmdLineArgs timeLimit: msecs
	"Answers the standard-output of the program execution.  Signals TimedOut if the timelimit is exceeded."
	^self execWithCommandLine: cmdLineArgs workingDir: nil timeLimit: msecs
! !

!MP4Box class methodsFor: 'invocation' stamp: 'jcg 12/14/2009 02:50'!
execWithCommandLine: cmdLineArgs workingDir: workingDirPath timeLimit: msecs 
	"Answers the standard-output of the program execution.  Signals TimedOut if the timelimit is exceeded."
	| cmdLine cmd seconds timedOut |

	cmdLine := self executablePath ifNil: [self error: 'could not find MP4Box executable'].
	cmdLine := cmdLine, ' ', cmdLineArgs.
	"We don't trust OSProcess to set the working dir properly (we believe that
	 we observed this in a QFES 3.0.2 install, but might have been confused)."
	workingDirPath ifNotNil: [cmdLine := '(cd ', workingDirPath, '; ', cmdLine, ')'].
	QLogger logInfo: 'executing: ', cmdLine.
	cmd := PipeableOSProcess 
				command: cmdLine
				environment: nil
				workingDir: nil
				input: nil
				output: nil
				error: nil
				errorPipelineStream: nil.
	^[
		seconds := (msecs roundUpTo: 1000) / 1000.
		timedOut := cmd waitForCompletionTimeoutInSeconds: seconds.
		timedOut
			ifFalse: [cmd output]
			ifTrue: [
				QLogger logWarning: 'took > ', seconds, 'secs to execute:  ', cmdLine.
				nil
			].
	] ensure: [cmd closePipes]! !

!MP4Box class methodsFor: 'accessing' stamp: 'sn 10/1/2011 21:53'!
executablePath
	"Answer the path to the MP4Box executable, and nil if we can't find it."
	| path platform|
	platform := SmalltalkImage current platformName.
	platform = 'Mac OS' ifTrue:[path := FileDirectory pathFromURI: 'MP4Box'].
	platform = 'Linux' ifTrue:[path := FileDirectory pathFromURI: '../../third-party/bin/MP4Box'].
	platform = 'Win32' ifTrue:[path := FileDirectory pathFromURI: 'MP4Box'].
	
	(FileDirectory default fileExists: path) ifTrue: [^path].
	path := '/usr/local/bin/MP4Box'.
	(FileDirectory default fileExists: path) ifTrue: [^path].
	^nil "well, we tried"
! !

!MP4Box class methodsFor: 'invocation' stamp: 'jcg 12/14/2009 10:12'!
infoFor: filePath
	| escapedPath |
	escapedPath := filePath copyReplaceAll: '"' with: '\"'.
	^ self execWithCommandLine: '-info "', escapedPath, '"' timeLimit: 5000! !

!MP4Box class methodsFor: 'accessing' stamp: 'jcg 12/14/2009 02:14'!
smokeTest
	"Log whether or not MP4Box is at least minimally working."
	"MP4Box smokeTest."
	| path cmd stdErr |
	
	"Ensure that that the executable exists."
	path := self executablePath ifNil: [
		QLogger logWarning: 'MP4Box executable is missing'.
		^self
	].

	"Ensure that the executable runs without printing anything on stderr."
	cmd := PipeableOSProcess command: path, ' -version'.
	[
		stdErr := cmd errorUpToEndOfFile.
		stdErr 
			ifEmpty: [QLogger logInfo: 'MP4Box passed smoke test']
			ifNotEmpty: [
				QLogger logWarning: 
					'MP4Box failed smoke test because:  ', String crlf, '                ', stdErr
			].
	] ensure: [cmd closePipes]

! !

Object subclass: #MP4BoxInfoParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-MP4'!

!MP4BoxInfoParser commentStamp: '<historical>' prior: 0!
Parses output of 'MP4Box -info' for the following MP4Box version:

MP4Box - GPAC version 0.4.5 (build 33)
GPAC Copyright: (c) Jean Le Feuvre 2000-2005
		(c) ENST 2005-200X
!

!MP4BoxInfoParser class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!MP4BoxInfoParser methodsFor: 'private' stamp: 'jcg 2/20/2009 14:13'!
parseDuration: stream
	| next duration |
	stream skipSeparators.
	(next := stream next: 11) = '- Duration ' 
		ifFalse: [self error: 'unexpected data while reading duration: ', next].
	duration := stream upTo: Character lf.
	duration := ('0:', duration) asDuration.
	^duration! !

!MP4BoxInfoParser methodsFor: 'parse' stamp: 'jcg 2/27/2009 14:25'!
parseMP4BoxOutput: stringOrStream
	| stream next timeScale duration isFragmented numTracks brand version date tracks |

	stream := stringOrStream readStream.
	(next := stream next: 14) = '* Movie Info *' ifFalse: [self error: 'unexpected data (: ', next].
	timeScale := self parseTimeScale: stream.
	duration := self parseDuration: stream.
	stream skipSeparators.
	(next := stream next: 16) = 'Fragmented File ' ifFalse: [self error: 'unexpected data: ', next].
	isFragmented := stream upTo: Character space.
	isFragmented := (isFragmented = 'yes').
	stream skipSeparators; next; skipSeparators.
	numTracks := Number readFrom: stream.
	stream upTo: Character lf; skipSeparators.
	(next := stream next: 11) = 'File Brand ' ifFalse: [self error: 'unexpected data: ', next].
	brand := (stream upTo: $-) withoutTrailingBlanks.
	(next := stream next: 9) = ' version ' ifFalse: [self error: 'unexpected data: ', next].
	version := Number readFrom: stream.
	stream skipSeparators.
	(next := stream next: 9) = 'Created: ' ifFalse: [self error: 'unexpected data: ', next].
	date := stream upTo: Character lf.

	tracks := OrderedCollection new.
	[
		1 to: numTracks do: [:i |
			| tr | 
			tr := self parseTrack: stream.
			tr ifNotNil: [tracks add: tr].
		].
	] on: Error do: [:err |
		QLogger logWarning: 'failed to parse all tracks'.
		QLogger logError: err.
	].

	^{'PARSED INFO'. timeScale. duration. isFragmented. numTracks. brand. version. date. tracks}
	! !

!MP4BoxInfoParser methodsFor: 'private' stamp: 'jcg 2/20/2009 12:27'!
parseTimeScale: stream
	| next |
	stream skipSeparators.
	(next := stream next: 10) asLowercase = 'timescale ' 
		ifFalse: [self error: 'unexpected data while reading timescale: ', next].
	^Number readFrom: stream! !

!MP4BoxInfoParser methodsFor: 'parse' stamp: 'jcg 2/27/2009 14:26'!
parseTrack: stringOrStream
	| stream trackNumber trackID timeScale duration type |

	stream := stringOrStream readStream.
	stream upToAll: 'Track # '.
	stream atEnd ifTrue: [^nil].
	trackNumber := Number readFrom: stream.
	stream upToAll: 'TrackID '.
	trackID := Number readFrom: stream.
	stream next; next; next.
	timeScale := self parseTimeScale: stream.
	stream next.
	duration := self parseDuration: stream.
	stream upToAll: 'Media Info:'.
	stream upToAll: 'Type "'.
	type := (stream upTo: $:) -> (stream upTo: $").


	^{'TRACK INFO'. trackNumber . trackID . timeScale . duration. type}! !

Object subclass: #MP4BoxNHMLParser
	instanceVariableNames: 'xml tracks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-MP4'!

!MP4BoxNHMLParser commentStamp: '<historical>' prior: 0!
Parse an NHML file into a list of tracks (MP4BoxNHMLTrack), each containing a list of samples (MP4BoxNHMLSample) describing the size and location of each sample in the raw media file.

FYI: The NHML files produced by MP4Box have only one track each.!

!MP4BoxNHMLParser class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!MP4BoxNHMLParser class methodsFor: 'instance creation' stamp: 'jcg 4/1/2009 17:49'!
parseFileNamed: fileName
	| file |
	file := FileStream readOnlyFileNamed: fileName.
	[^self parseStream: file] ensure: [file close].! !

!MP4BoxNHMLParser class methodsFor: 'instance creation' stamp: 'jcg 1/4/2009 13:45'!
parseStream: aStream
	^self new parseStream: aStream; yourself! !

!MP4BoxNHMLParser methodsFor: 'parsing' stamp: 'jcg 4/2/2009 10:06'!
parseBinaryStream: fileStream
	| track readStream |
	[
		track := MP4BoxNHMLTrack new.
		readStream := ReadStream on: fileStream binary contents.
		track initializeFromBinaryStream: readStream.
		tracks at: track trackID put: track.
	] on: Error do: [:err | 
		QLogger logError: 'failed to read binary .qtrack file: ', fileStream name.
		QLogger logError: err.
	].
! !

!MP4BoxNHMLParser methodsFor: 'parsing' stamp: 'jcg 4/3/2009 13:59'!
parseNHMLStream: fileStream
	| readStream |

	"Faster to read into memory first (MultiByteFileStream sux)."
	fileStream binary.
	readStream := ReadStream on: fileStream contents asString.
		
	[xml := XMLDOMParser parseDocumentFrom: readStream]
		on: Error
		do: [:err |
			QLogger logError: 'error while parsing XML (detailed listing follows...)'.
			QLogger logError: err.
			err pass.
		].

	xml elementsDo: [:elem |
		| tr |
		tr := MP4BoxNHMLTrack new.
		tr initializeFromXmlElement: elem baseDirectoryPath: fileStream directory pathName.
		tracks at: tr trackID put: tr
	].! !

!MP4BoxNHMLParser methodsFor: 'parsing' stamp: 'jcg 4/2/2009 02:46'!
parseStream: fileStream

	tracks := Dictionary new.

	"Figure out from the file-extension how we should parse this stream."
	(fileStream name endsWith: '.nhml') ifTrue: [^self parseNHMLStream: fileStream].
	(fileStream name endsWith: '.qtrack') ifTrue: [^self parseBinaryStream: fileStream].

	self error: 'unknown track file format'! !

!MP4BoxNHMLParser methodsFor: 'accessing' stamp: 'jcg 1/22/2009 16:55'!
tracks
	^tracks! !

!MP4BoxNHMLParser methodsFor: 'testing' stamp: 'jcg 9/22/2009 23:07'!
tracksHaveValidMediaFilePaths
	^tracks allSatisfy: [:tr | FileDirectory default fileExists: tr mediaFilePath]! !

Object subclass: #MP4BoxNHNTSample
	instanceVariableNames: 'filePos dts ctsOffset dtsDelta dataLength isRAP'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-MP4'!

!MP4BoxNHNTSample class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!MP4BoxNHNTSample methodsFor: 'accessing' stamp: 'jcg 1/23/2009 15:58'!
cts
	^dts + ctsOffset! !

!MP4BoxNHNTSample methodsFor: 'accessing' stamp: 'jcg 1/27/2009 17:45'!
ctsOffset
	^ctsOffset! !

!MP4BoxNHNTSample methodsFor: 'accessing' stamp: 'jcg 1/4/2009 13:56'!
dataLength
	^dataLength! !

!MP4BoxNHNTSample methodsFor: 'accessing' stamp: 'jcg 1/23/2009 15:58'!
dts
	^dts! !

!MP4BoxNHNTSample methodsFor: 'accessing' stamp: 'jcg 3/27/2009 23:50'!
dtsDelta
	"Answer the delta until the DTS of the next sample."
	^dtsDelta! !

!MP4BoxNHNTSample methodsFor: 'initialize' stamp: 'jcg 3/27/2009 23:49'!
dtsDelta: computedDelta
	dtsDelta := computedDelta.! !

!MP4BoxNHNTSample methodsFor: 'accessing' stamp: 'jcg 1/24/2009 17:24'!
filePosition
	^filePos! !

!MP4BoxNHNTSample methodsFor: 'initialize' stamp: 'jcg 1/4/2009 10:53'!
initialize
	super initialize.
	ctsOffset := 0.
	isRAP := false.
! !

!MP4BoxNHNTSample methodsFor: 'initialize' stamp: 'jcg 4/2/2009 01:03'!
initializeFromFilePos: dStart length: dLength dts: dtsVal ctsOffset: ctsOffsetVal isRAP: aBool
	filePos := dStart.
	dataLength := dLength.
	dts := dtsVal.
	ctsOffset := ctsOffsetVal.
	isRAP := aBool.! !

!MP4BoxNHNTSample methodsFor: 'initialize' stamp: 'jcg 1/6/2009 00:59'!
initializeFromXmlElement: xmlSample filePosition: pos "start location of data in file"
	filePos := pos.
	xmlSample name == #NHNTSample ifFalse: [self error: 'expected #NHNTSample'].
	xmlSample attributes keysAndValuesDo: [:key :value |
		key caseOf: {
			['DTS']		->		[dts := Number readFrom: value].
			['CTSOffset']		->	[ctsOffset := Number readFrom: value].
			['dataLength']	->	[dataLength := Number readFrom: value].
			['isRAP']		-> 	[isRAP := value = 'yes'].
		} otherwise: [self error: 'unexpected attribute: ', (key->value)].
	].! !

!MP4BoxNHNTSample methodsFor: 'accessing' stamp: 'jcg 1/24/2009 18:02'!
isRAP "is a random-access point?"
	^isRAP! !

Object subclass: #MP4BoxRtpDumpParser
	instanceVariableNames: 'tracks xml'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-MP4'!

!MP4BoxRtpDumpParser class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!MP4BoxRtpDumpParser class methodsFor: 'instance creation' stamp: 'jcg 1/4/2009 00:05'!
parseStream: aStream
	^self new parseStream: aStream; yourself! !

!MP4BoxRtpDumpParser methodsFor: 'initialize' stamp: 'jcg 1/4/2009 00:06'!
initialize
	tracks := Dictionary new.! !

!MP4BoxRtpDumpParser methodsFor: 'parsing' stamp: 'jcg 1/4/2009 00:46'!
parseHintTrack: xmlTrack
	| trackID track |

	"Create a new track (ensure that no track with that ID already exists)."
	trackID := Number readFrom: (xmlTrack attributeAt: #trackID).
	tracks at: trackID ifPresent: [:ignore | self error: 'track already exists with ID: ', trackID].
	tracks at: trackID put: (track := OrderedCollection new).

	xmlTrack elementsDo: [:xmlSample |
		| sample |
		sample := MP4BoxRtpHintSample new.
		sample initializeFromXmlElement: xmlSample.
		track addLast: sample
	].
	! !

!MP4BoxRtpDumpParser methodsFor: 'parsing' stamp: 'jcg 1/4/2009 00:52'!
parseStream: aStream
	xml := XMLDOMParser parseDocumentFrom: aStream.
	self parseXmlDocument.
! !

!MP4BoxRtpDumpParser methodsFor: 'parsing' stamp: 'jcg 1/4/2009 13:22'!
parseXmlDocument
	"Assumes that the 'xml' iVar has been initialized with a suitable XMLDocument."

	"Ensure we're starting with a clean slate."
	tracks := Dictionary new.

	"Parse the hint tracks.  
       We don't expect elements that aren't hint-tracks; raise an error if we see one."
	((xml elements size = 1) and: [xml elements first name == #RTPFile]) 
		ifFalse: [self error: 'expected single <RTPFile> element'].
	xml elements first elementsDo: [:elem |
		elem name == #RTPHintTrack 
			ifTrue: [self parseHintTrack: elem]
			ifFalse: [self error: 'expected <RTPHintTrack> element']
	].! !

!MP4BoxRtpDumpParser methodsFor: 'accessing' stamp: 'jcg 1/4/2009 01:02'!
tracks
	^tracks! !

Object subclass: #MP4BoxRtpHintPacket
	instanceVariableNames: 'packetNumber payloadType sequenceNumber repeated dropable relativeTransmissionTime fullPacketSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-MP4'!

!MP4BoxRtpHintPacket class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!MP4BoxRtpHintPacket methodsFor: 'initialize' stamp: 'jcg 1/4/2009 01:25'!
initializeFromXmlElement: xmlPacket
	xmlPacket name == #RTPHintPacket ifFalse: [self error: 'expected #RTPHintPacket'].
	xmlPacket attributes keysAndValuesDo: [:key :value |
		| number |
		number := Number readFrom: value. "the value is always a number"
		key caseOf: {
			['PacketNumber'] ->				[packetNumber := number].
			['PayloadType'] ->				[payloadType := number].
			['SequenceNumber'] -> 			[sequenceNumber := number].
			['RepeatedPacket'] ->			[repeated := number > 0].
			['DropablePacket'] ->			[dropable := number > 0].
			['RelativeTransmissionTime'] ->	[relativeTransmissionTime := number].
			['FullPacketSize'] ->				[fullPacketSize := number].
			['P'] ->							["ignore"].
			['X'] ->							["ignore"].
			['M'] ->							["ignore"].
		} otherwise: [self error: 'unexpected attribute: ', (key->value)]
	].

	

! !

!MP4BoxRtpHintPacket methodsFor: 'accessing' stamp: 'jcg 1/4/2009 01:37'!
packetSize
	^fullPacketSize ! !

Object subclass: #MP4BoxRtpHintSample
	instanceVariableNames: 'decodingTime packetCount randomAccessPoint sampleNumber packets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-MP4'!

!MP4BoxRtpHintSample class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!MP4BoxRtpHintSample methodsFor: 'initialize' stamp: 'jcg 1/4/2009 01:27'!
initializeFromXmlElement: xmlSample
	xmlSample name == #RTPHintSample ifFalse: [self error: 'expected #RTPHintSample'].
	xmlSample attributes keysAndValuesDo: [:key :value |
		| number |
		number := Number readFrom: value. "the value is always a number"
		key caseOf: {
			['DecodingTime'] ->			[decodingTime := number].
			['PacketCount'] ->			[packetCount := number].
			['RandomAccessPoint'] ->	[randomAccessPoint := number].
			['SampleNumber'] -> 		[sampleNumber := number].
		} otherwise: [self error: 'unexpected attribute: ', (key->value)]
	].

	packets := OrderedCollection new.
	xmlSample elementsDo: [:elem |
		| packet |
		packet := MP4BoxRtpHintPacket new.
		packet initializeFromXmlElement: elem.
		packets addLast: packet
	].
	packets size == packetCount ifFalse: [
		self error: 'expected ', packetCount, ' packets, but found ', packets size
	].
	

! !

!MP4BoxRtpHintSample methodsFor: 'accessing' stamp: 'jcg 1/4/2009 13:28'!
packets
	^packets! !

!MP4BoxRtpHintSample methodsFor: 'accessing' stamp: 'jcg 1/4/2009 01:28'!
sampleSize
	^(packets collect: [:p | p packetSize]) sum! !

Object subclass: #QNetVidAsset
	instanceVariableNames: 'mutex assetName state errorDescription readyPromise tracks duration users lastUse'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Server'!

!QNetVidAsset commentStamp: 'jcg 7/25/2009 00:36' prior: 0!
QNetVidAsset describes a video source.  Formerly, it used to contain the information required to stream a video from files on disk.  Now that we intend to support live video, no files are necessary, so file-related behavior has been pushed in to the subclass QNetVidFileAsset.!

!QNetVidAsset class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QNetVidAsset methodsFor: 'usage-tracking' stamp: 'jcg 8/20/2009 18:29'!
addUser: aQNetVidServer
	mutex critical: [users add: aQNetVidServer].
! !

!QNetVidAsset methodsFor: 'accessing' stamp: 'jcg 6/22/2009 14:46'!
assetName
	"Human-readable name for the asset"
	^assetName ifNil:['(unnamed)']! !

!QNetVidAsset methodsFor: 'accessing' stamp: 'ar 3/26/2009 17:20'!
assetName: aString
	"Human-readable name for the asset"
	assetName := aString! !

!QNetVidAsset methodsFor: 'initialize' stamp: 'jcg 5/7/2010 12:00'!
beReady: ok
	ok 
		ifTrue: [state := #ready]
		ifFalse: [ 
			"At the time of writing, this branch is never taken."
			state := #error.
			errorDescription := 'asset could not be made ready'.
		].
	readyPromise fulfill: ok.! !

!QNetVidAsset methodsFor: 'accessing' stamp: 'jcg 2/18/2009 19:12'!
duration
	^duration! !

!QNetVidAsset methodsFor: 'accessing' stamp: 'jcg 3/30/2009 19:06'!
errorDescription
	"Text description of what went wrong (when status == #error)."
	^errorDescription! !

!QNetVidAsset methodsFor: 'initialize' stamp: 'jcg 8/20/2009 18:28'!
initialize
	super initialize.
	mutex := Mutex new.
	readyPromise := TPromise new.
	tracks := Dictionary new.
	duration := 0.0.
	state := #new.
	users := IdentitySet new.
	lastUse := Time coarseClockValue.! !

!QNetVidAsset methodsFor: 'testing' stamp: 'jcg 7/27/2009 23:07'!
isLive
	"Is this video pre-recorded, or from a live source?"
	self subclassResponsibility.! !

!QNetVidAsset methodsFor: 'usage-tracking' stamp: 'jcg 8/20/2009 18:29'!
lengthOfDisuse
	mutex critical: [
		users ifNotEmpty: [^0].
		^Time coarseMillisecondsSince: lastUse.
	]! !

!QNetVidAsset methodsFor: 'printing' stamp: 'jcg 7/25/2009 00:11'!
logName
	^self class name, '(', self printDescription, ')'! !

!QNetVidAsset methodsFor: 'printing' stamp: 'jcg 7/24/2009 16:30'!
printDescription
	^assetName ifNil: ['no name']
! !

!QNetVidAsset methodsFor: 'printing' stamp: 'jcg 7/24/2009 16:32'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	aStream nextPutAll: self printDescription.
	aStream nextPut: $).! !

!QNetVidAsset methodsFor: 'initialize' stamp: 'jcg 5/7/2010 12:00'!
readSessionRecorderTracks: fullFileNames
	"Parse the NHML files into tracks."

	"It might take a while to process the asset before it is ready to stream.  Fork this off in a separate process and resolve the promise when we're done."
	[
		[
			state := #processing.
			self readTracks: fullFileNames.
			state := #ready.
			readyPromise fulfill: true.
		] on: Error do: [:err |
			QLogger logWarning: 'asset initialization failed: ', err description.
			"If the state was already #error, leave the error description alone."
			state == #error ifFalse: [
				QLogger logError: err.  "only report the error once"
				state := #error.
				errorDescription := 'unknown error while preparing asset for streaming'.
			].
			readyPromise fulfill: false.
		].
	] forkAt: Processor activePriority - 5 "give priority to processes that are actually streaming".! !

!QNetVidAsset methodsFor: 'accessing' stamp: 'jcg 3/27/2009 16:45'!
readyPromise
	"Answer promise that will be resolved when the asset is finished any necessary pre-processing."
	^readyPromise! !

!QNetVidAsset methodsFor: 'usage-tracking' stamp: 'jcg 8/20/2009 18:56'!
removeUser: aQNetVidServer
	mutex critical: [
		users remove: aQNetVidServer ifAbsent: [].
		self resetLastUse.
	]! !

!QNetVidAsset methodsFor: 'usage-tracking' stamp: 'jcg 8/20/2009 19:00'!
resetLastUse
	"We call this whereever the asset is 'obtained' to avoid possible race conditions."
	lastUse :=Time coarseClockValue.! !

!QNetVidAsset methodsFor: 'accessing' stamp: 'jcg 3/30/2009 19:17'!
state
	^state! !

!QNetVidAsset methodsFor: 'accessing' stamp: 'jcg 2/18/2009 19:12'!
tracks
	^tracks! !

!QNetVidAsset methodsFor: 'initialize' stamp: 'jcg 3/14/2009 00:14'!
waitUntilReady
	"The promise is resolved once all necessary pre-processing has been completed."
	^readyPromise wait! !

QNetVidAsset subclass: #QNetVidFileAsset
	instanceVariableNames: 'sha fileSize paths cacheDir'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Server'!

!QNetVidFileAsset commentStamp: '<historical>' prior: 0!
Provides a handle to on-disk data resulting from the processing of a user-uploaded media file.

Status values:
#new 
#processing
#error
#ready

XML Representation (not implemented yet):
<asset>
	<hash>DFDFJLWERJF3543JFDS</hash>
	<size>43225234</size>
	<path modified="2009-02-18T01:36:33-08:00">/full/path/to/original/file.mp4"</path>
	<path modified=" 2009-02-18T01:45:24-08:00">/full/path/to/another/file.mp4"</path>
</asset>!

!QNetVidFileAsset class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QNetVidFileAsset class methodsFor: 'instance creation' stamp: 'jcg 7/24/2009 16:34'!
forSHA: sha filePath: fullPath cachePath: cacheDirPath
	^self new 
			initializeForSHA: sha filePath: fullPath cachePath: cacheDirPath
			yourself! !

!QNetVidFileAsset methodsFor: 'initialize' stamp: 'jcg 7/24/2009 16:26'!
addPath: fullPath modificationTime: modTime
	paths at: fullPath put: modTime! !

!QNetVidFileAsset methodsFor: 'accessing' stamp: 'jcg 11/6/2009 12:53'!
fileSize
	^fileSize! !

!QNetVidFileAsset methodsFor: 'initialize' stamp: 'jcg 7/24/2009 16:28'!
fileSize: newFileSize
	fileSize := newFileSize! !

!QNetVidFileAsset methodsFor: 'initialize' stamp: 'jcg 7/24/2009 16:29'!
initialize
	super initialize.
	paths := Dictionary new.! !

!QNetVidFileAsset methodsFor: 'initialize' stamp: 'jcg 5/7/2010 12:00'!
initializeForSHA: fileSHA filePath: originalFilePath cachePath: cacheDirPath
	| assetDir |

	sha := fileSHA.
	cacheDir := FileDirectory on: cacheDirPath.
	cacheDir assureExistence.
	assetDir := cacheDir directoryNamed: sha.

	"It might take a while to process the asset before it is ready to stream.  Fork this off in a separate process, and resolve the promise when we're done."
	[
		[
			(FileDirectory directoryEntryFor: originalFilePath)
				ifNil: [FileDoesNotExistException fileName: originalFilePath]
				ifNotNilDo: [:dirEntry | fileSize := dirEntry fileSize].

			assetDir exists ifFalse: [
				assetDir assureExistence.
				self processWithMP4Box: originalFilePath
			].
			state := #processing.
			self readTracks.
			state == #processing
				ifTrue: [
					"Hooray, we succeeded."
					state := #ready.
					readyPromise fulfill: true.
				]
				ifFalse: [
					"Oops, something went wrong."					
					state == #error ifFalse: [
						self error: 'expected state to be #processing/#error, not #', state.
					].
					"We're in #error state, and the 'errorDescription'
					 should already be set."
					readyPromise fulfill: false. 
				].
		] on: Error do: [:err |
			QLogger logWarning: 'asset initialization failed: ', err description.
			"If the state was already #error, leave the error description alone."
			state == #error ifFalse: [
				QLogger logError: err.  "only report the error once"
				state := #error.
				errorDescription := 'unknown error while preparing asset for streaming'.
			].
			readyPromise fulfill: false.
			[assetDir recursiveDelete] on: Error do: [:err2 | 
				QLogger logWarning: 'failed to delete directory for asset: ', sha.
			].
		].
	] forkAt: Processor activePriority - 5 "give priority to processes that are actually streaming".! !

!QNetVidFileAsset methodsFor: 'testing' stamp: 'jcg 7/27/2009 23:07'!
isLive
	"Is this video pre-recorded, or from a live source?"
	^false! !

!QNetVidFileAsset methodsFor: 'private' stamp: 'jcg 12/14/2009 03:16'!
mp4InfoFor: filePath
	"Use MP4Box to get info about the specified file."
	| output |
	output := MP4Box infoFor: filePath.
	output ifNil: [self error: 'took too long to get MP4 info'].
	^MP4BoxInfoParser new parseMP4BoxOutput: output.
	! !

!QNetVidFileAsset methodsFor: 'private' stamp: 'jcg 7/25/2009 00:10'!
pathToMP4Box
	"Answer the path to the MP4Box executable, and nil if we can't find it."
	| path |
	path := FileDirectory pathFromURI: '../../third-party/bin/MP4Box'.
	(FileDirectory default fileExists: path) ifTrue: [^path].
	path := '/usr/local/bin/MP4Box'.
	(FileDirectory default fileExists: path) ifTrue: [^path].
	^nil "well, we tried"
! !

!QNetVidFileAsset methodsFor: 'printing' stamp: 'jcg 7/24/2009 16:32'!
printDescription
	^super printDescription, ', ', (sha ifNil: ['no SHA'])! !

!QNetVidFileAsset methodsFor: 'private' stamp: 'jcg 8/3/2010 16:56'!
processTrack: trackInfo "from #mp4InfoFor:" originalFile: originalFilePath
	| trackNum trackID trackType description shouldProcess cmdLine timeLimit outFile elapsed escapedPath |

	"Extract track-info."
	trackNum := trackInfo at: 2.
	trackID := trackInfo at: 3.
	trackType := trackInfo at: 6.

	"Create a description for logging that will be used whether we decide to process the file/track, or to skip it."
	description := 'TRACK #', trackNum, ' (ID: ', trackID, ') of TYPE: ', trackType, ' for FILE: ', originalFilePath.

	"Decide whether to skip the track.  We currently handle only H.264 and AAC tracks."
	shouldProcess := false.
	(trackType key = 'vide' and: [trackType value = 'avc1']) ifTrue: [shouldProcess := true].
	(trackType key = 'soun' and: [trackType value = 'mp4a']) ifTrue: [shouldProcess := true].
	shouldProcess ifFalse: [
		"If it's an audio/video track, we care a bit more.  There are tons of other track types,
		 such as sub-titles, that we don't care about."
		(#('vide' 'sound') includes: trackType key) 
			ifTrue: [QLogger logWarning: 'skipping audio/video ', description]
			ifFalse: [QLogger logInfo: 'skipping ', description].
		^self
	].

	"Process the file..."
	timeLimit := duration asMilliSeconds // 60.  "1 second per minute seems safe"
	outFile := cacheDir fullName, '/', sha, '/track', trackNum.
	QLogger logInfo: 'generating NHML for ', description.
	escapedPath := originalFilePath copyReplaceAll: '"' with: '\"'.
	cmdLine := ' -nhml ', trackID, ' -out ', '"', outFile, '"  "', escapedPath, '"'.
	elapsed := [MP4Box execWithCommandLine: cmdLine timeLimit: timeLimit] timeToRun.
	elapsed > timeLimit ifTrue: [
		"XXXX: We just log a warning instead of raising an error, in case it's just taking longer than expected to finish.  But, perhaps the right thing is to assume failure."  
		^QLogger logWarning: 'took longer than ', timeLimit, 'ms to process ', description
	].

	"The MP4Box finished in time... let's verify the result."
	QLogger logInfo: 'processed in ', elapsed, 'ms... about to verify ', description.
	((FileDirectory forFileName: outFile) fileExists: 'track', trackNum, '.nhml')
		ifFalse: [
			"We evidently didn't succeed in creating the .nhml/.media/.info files."
			self error: 'failed to process ', description
		].! !

!QNetVidFileAsset methodsFor: 'private' stamp: 'jcg 7/25/2009 00:13'!
processWithMP4Box: originalFilePath
	| parsedInfo parsedTracks |
	
	QLogger logInfo: 'processing original file with MP4Box: ', originalFilePath.

	"Use MP4Box to get info about the whole file, and then parse it."
	parsedInfo := self mp4InfoFor: originalFilePath.

	"This will get stomped later (in #readTracks), but we use it while processing tracks."
	duration := parsedInfo at: 3.

	"Process each track with MP4Box (we'll skip some, if they're not the right type)."
	parsedTracks := parsedInfo last.
	parsedTracks do: [:array |
		self processTrack: array originalFile: originalFilePath.
	].! !

!QNetVidFileAsset methodsFor: 'private' stamp: 'jcg 7/25/2009 00:13'!
readTracks
	"Parse the NHML files into tracks."
	| dir files |
	dir := cacheDir directoryNamed: sha.
	files := dir fileNamesMatching: '*.nhml'.
	^self readTracks: (files collect:[:f| dir fullNameFor: f])! !

!QNetVidFileAsset methodsFor: 'private' stamp: 'jcg 8/3/2010 16:50'!
readTracks: fullFileNames
	"Parse the NHML files into tracks."

	fullFileNames ifEmpty: [
		state := #error.
		errorDescription := String streamContents: [:s |
			s nextPutAll: 'video file has no valid tracks'; cr.
			s nextPutAll: '(ensure that video track is H.264/AVC'; cr.
			s nextPutAll: ' and audio track is AAC)'.
		].
		self error: 'empty list of track file-names'
	].	

	fullFileNames do: [:fileName |
		| qtrackFileName short parser |
		[ "wrap in error handler..."
			"Try to load from a binary .qtrack file... it's faster."
			qtrackFileName := fileName copyReplaceAll: '.nhml' with: '.qtrack'.
			(FileDirectory default fileExists: qtrackFileName) ifTrue: [
				short := qtrackFileName copyAfterLast: FileDirectory pathNameDelimiter.
				QLogger logInfo: 'parsing track info from file: ', short.
				parser := MP4BoxNHMLParser parseFileNamed: qtrackFileName.
				parser tracksHaveValidMediaFilePaths ifFalse: [
					"Uh-oh, the .qtrack file is dodgy.  Let's start fresh from the .nhml"
					QLogger logWarning: 'bad file-paths in .qtrack... retrying'.
					FileDirectory default deleteFileNamed: qtrackFileName.
					parser := nil.
				].
			].
			"If we reach here without a valid parser, something went wrong with
			 parsing the .qtrack file, so try with the .nhml file." 
			parser ifNil: [
				short := fileName copyAfterLast: FileDirectory pathNameDelimiter.
				QLogger logInfo: 'parsing track info from file: ', short.
				parser := MP4BoxNHMLParser parseFileNamed: fileName.
			].
			"Finally read the 'tracks' (we know there will be only one)."
			parser tracks keysAndValuesDo: [:k :v | tracks at: k put: v].
		] on: Error do:[:err | 
			QLogger logWarning: 
				'failed to read track: ', short, '   because: ', err description.
		]
	].
	
	"The longest track is used as the duration of the asset
	 (we assume that there is no track with non-zero start-offset)."
	duration := (tracks collect: [:tr | tr duration]) max.! !

!QNetVidFileAsset methodsFor: 'initialize' stamp: 'jcg 7/24/2009 16:27'!
sha
	^sha! !

!QNetVidFileAsset methodsFor: 'initialize' stamp: 'jcg 7/24/2009 16:27'!
sha: newSHA
	sha := newSHA! !

QNetVidAsset subclass: #QNetVidLiveAsset
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Server'!

!QNetVidLiveAsset class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QNetVidLiveAsset methodsFor: 'initialize' stamp: 'jcg 10/7/2009 10:08'!
addTrack: track "a QSessionRecorderTrackUploader"
	track ifNil: [^self "no harm in it, and makes some development-hacks easier"].
	tracks at: track trackID put: track! !

!QNetVidLiveAsset methodsFor: 'initialize' stamp: 'jcg 5/7/2010 12:01'!
initialize
	super initialize.

	"Maybe we can change this once recording stops, but that would open a can of worms about how to deal with seeking, since we don't keep the samples that we have already captured/streamed (remember that when the player plays past the asset's duration, it pauses and seeks to the beginning)."	
	duration := Float infinity.

	readyPromise fulfill: true.  "ready right out of the gate."! !

!QNetVidLiveAsset methodsFor: 'testing' stamp: 'jcg 7/27/2009 23:07'!
isLive
	"Is this video pre-recorded, or from a live source?"
	^true! !

Object subclass: #QNetVidAssetLimits
	instanceVariableNames: 'maxBitrate maxExtent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Server'!

!QNetVidAssetLimits commentStamp: 'jcg 4/4/2009 12:32' prior: 0!
Used to establish limits on resource consumption by a particular stream.

Very rudimentary, will be completely revamped when we have variable-quality video.!

!QNetVidAssetLimits class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QNetVidAssetLimits methodsFor: 'initialize' stamp: 'jcg 4/4/2009 12:22'!
bitrate: br
	maxBitrate := br! !

!QNetVidAssetLimits methodsFor: 'initialize' stamp: 'jcg 4/4/2009 12:23'!
extent: ext
	maxExtent := ext! !

!QNetVidAssetLimits methodsFor: 'testing' stamp: 'jcg 4/5/2009 12:44'!
isBitrateOK: bitrate
	maxBitrate ifNil: [^true "no limit in place"].
	^bitrate <= (maxBitrate * 1.05 "add some wiggle room")! !

!QNetVidAssetLimits methodsFor: 'testing' stamp: 'jcg 4/4/2009 11:26'!
isVideoExtentOK: videoExtent
	"Both width and height of video must be within the specified limits."
	maxExtent ifNil: [^true "no limit in place"].
	videoExtent x > maxExtent x ifTrue: [^false].
	videoExtent y > maxExtent y ifTrue: [^false].
	^true! !

!QNetVidAssetLimits methodsFor: 'testing' stamp: 'jcg 4/4/2009 12:27'!
validateBitrate: bitrate
	"Both width and height of video must be within the specified limits."
	(self isBitrateOK: bitrate) ifFalse: [
		self error: ('Cannot launch video:\bitrate of: ', bitrate, '\exceeds limit of: ', maxBitrate) withCRs
	]! !

!QNetVidAssetLimits methodsFor: 'testing' stamp: 'jcg 4/4/2009 12:27'!
validateVideoExtent: videoExtent
	"Both width and height of video must be within the specified limits."
	(self isVideoExtentOK: videoExtent) ifFalse: [
		| actual allowed |
		actual := videoExtent x printString, 'x', videoExtent y printString.
		allowed := maxExtent x printString, 'x', maxExtent y printString.
		self error: ('Cannot launch video:\resolution of: ', actual, '\exceeds limit of: ', allowed) withCRs
	]! !

Object subclass: #QNetVidBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Client'!

!QNetVidBuffer commentStamp: 'jcg 2/18/2009 00:54' prior: 0!
Buffers audio/video frames before they are played.!

!QNetVidBuffer class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

QNetVidBuffer subclass: #QNetVidReorderingBuffer
	instanceVariableNames: 'queue frameCleanupBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Client'!

!QNetVidReorderingBuffer commentStamp: 'jcg 2/18/2009 00:58' prior: 0!
Used to reorder frames into display-order.  See QNetVidBufferedFrame.!

!QNetVidReorderingBuffer class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QNetVidReorderingBuffer methodsFor: 'debugging' stamp: 'jcg 2/15/2009 00:51'!
allSequenceNumbers
	"Answer the sequence numbers of all frames in the buffer."
	^(queue collect: [:f | f sequenceNumber]) asSortedCollection asArray! !

!QNetVidReorderingBuffer methodsFor: 'private' stamp: 'jcg 3/14/2009 01:29'!
cleanupFrame: aFrame
	"XXXX: since this is (so far) always used to put Forms back into a pool, maybe we test for frames with nil-decodedFrame here in 'frameCleanupBlock'."
	frameCleanupBlock ifNotNilDo: [:bl | bl value: aFrame]! !

!QNetVidReorderingBuffer methodsFor: 'private' stamp: 'jcg 2/27/2009 14:58'!
flush
	frameCleanupBlock ifNotNilDo: [:block |
		queue do: [:fr | block value: fr]
	].
	queue := SortedCollection sortBlock: [:f1 :f2 | f1 cts <= f2 cts]! !

!QNetVidReorderingBuffer methodsFor: 'initialize' stamp: 'jcg 2/27/2009 15:05'!
frameCleanupBlock: aBlock
	"Set a 1-arg block that is invoked on any QNetVidBufferedFrame that is skipped/flushed."
	frameCleanupBlock := aBlock
! !

!QNetVidReorderingBuffer methodsFor: 'accessing' stamp: 'jcg 2/12/2009 00:33'!
frameWithSequenceNumber: seqNum
	^queue detect: [:frame | frame sequenceNumber = seqNum] ifNone: [nil].! !

!QNetVidReorderingBuffer methodsFor: 'private' stamp: 'jcg 3/14/2009 01:47'!
indexOfLatestFrameNoLaterThan: targetCTS
	"Answer the index of the last frame that is no later than 'targetCTS'."
	| latestIndex |
	latestIndex := nil.
	queue withIndexDo: [:frame :i |
		frame cts > targetCTS
			ifFalse: [latestIndex := i]
			ifTrue: [^latestIndex].
	].
	^latestIndex

! !

!QNetVidReorderingBuffer methodsFor: 'initialize' stamp: 'jcg 2/15/2009 15:43'!
initialize
	queue := #(). "so #flush doesn't barf"
	self flush.! !

!QNetVidReorderingBuffer methodsFor: 'private' stamp: 'jcg 3/14/2009 01:43'!
latestFrameNoLaterThan: targetCTS
	"Answer the last frame that is no later than 'targetCTS'."
	| latestFrame |
	latestFrame := nil.
	queue do: [:frame |
		frame cts > targetCTS
			ifFalse: [latestFrame := frame]
			ifTrue: [^latestFrame].
	].
	^latestFrame

! !

!QNetVidReorderingBuffer methodsFor: 'accessing' stamp: 'jcg 3/14/2009 01:55'!
popFramesForCTS: targetCTS
	"Pop frames from the queue, answering the frame that 'should be displayed' (if any). What does this mean?  We are looking for the latest already-decoded frame that is no later than 'targetCTS'."
	| latestIndex |
	latestIndex := self indexOfLatestFrameNoLaterThan: targetCTS.
	latestIndex ifNil: [^nil "no frame to display"].
	latestIndex to: 1 by: -1 do: [:ind |
		"Look backward to find the *already-decoded* frame with the latest CTS."
		| resultFrame removedFrame |
		resultFrame := queue at: ind.
		resultFrame decodedFrame ifNotNil: [
			"Found it!!  We'll discard all earlier frames, and answer this one."

			"Normally you shouldn't mess with Squeak collections while you're 
			 iterating over them.  It's OK here because I'm returning from this
			 method before iterating any further."
			(removedFrame := queue removeFirst) == resultFrame
				ifTrue: [^resultFrame "done!!"]
				ifFalse: [self cleanupFrame: removedFrame]			
		].
	].
	^nil "no frame to display"
! !

!QNetVidReorderingBuffer methodsFor: 'accessing' stamp: 'jcg 3/14/2009 01:33'!
popUpToFrame: aFrame
	"Pop all frames up-to and including 'aFrame'."
	[queue notEmpty] whileTrue: [
		| next |
		next := queue removeFirst.
		next == aFrame
			ifFalse: [self cleanupFrame: next "clean-up skipped frame"]
			ifTrue: [^self "found it!!"]
	].
! !

!QNetVidReorderingBuffer methodsFor: 'debugging' stamp: 'jcg 2/15/2009 00:39'!
queue
	"NOTE: used only for debugging... not part of public protocol of QReorderingBuffer."
	^queue! !

!QNetVidReorderingBuffer methodsFor: 'accessing' stamp: 'jcg 2/12/2009 00:09'!
receiveFrame: frame
	queue add: frame! !

Object subclass: #QNetVidBufferedFrame
	instanceVariableNames: 'data headerSize isRAP isSeek dts cts dtsDelta sequenceNumber decodedFrame'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Client'!

!QNetVidBufferedFrame commentStamp: 'jcg 2/18/2009 00:57' prior: 0!
When data corresponding to an encoded media frame is received from a network datagram, it is wrapped in a QNetVidBufferedFrame, and inserted into a buffer.  The buffered-frame contains timing information that allow the frames to be rearranged into display-order (recall that for H.264, the order that frames are decoded in is not the order that they are displayed in).  When the data is decoded, the corresponding buffered-frame is found, and the decoded-frame is stashed within it.

Instance variables:
	data			-	the encoded data for the frame
	isRAP			-	is the frame a Random Access Point
	isSeek			-	was the frame received while seeking
	dts				-	Decode Time Stamp
	cts				-	Composition Time Stamp
	sequenceNumber - in what order was this frame pushed into the decoder?
	decodedFrame	-	after the frame is decoded, the result is stashed here!

!QNetVidBufferedFrame class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QNetVidBufferedFrame class methodsFor: 'instance creation' stamp: 'jcg 11/30/2009 10:01'!
newForData: dgramData headerSize: hs dts: dts cts: cts dtsDelta: delta isSeek: seek isRAP: rap
	| frame |
	frame := self new.
	frame
		data: dgramData 
		headerSize: hs 
		dts: dts 
		cts: cts 
		dtsDelta: delta 
		isSeek: seek 
		isRAP: rap.
	^frame
! !

!QNetVidBufferedFrame methodsFor: 'accessing' stamp: 'jcg 2/8/2009 23:59'!
cts
	"Composition Time Stamp... the time the frame is to be displayed."
	^cts! !

!QNetVidBufferedFrame methodsFor: 'accessing' stamp: 'jcg 2/9/2009 01:06'!
data
	^data! !

!QNetVidBufferedFrame methodsFor: 'initialize' stamp: 'jcg 12/30/2009 16:07'!
data: dgramData headerSize: hs dts: dt cts: ct dtsDelta: delta isSeek: seek isRAP: rap
	data := dgramData.
	headerSize := hs.
	isRAP := rap.
	isSeek := seek.
	dts := dt.
	cts := ct.
	dtsDelta := delta.

	false ifTrue: [
		'NEW BUFFERED FRAME:   headerSize=', hs, '   isRAP=', isRAP, '   isSeek=', isSeek, '   dts=', dt, '   cts=', ct, '   dtsDelta=', delta displayAt: 0@0.
	].
! !

!QNetVidBufferedFrame methodsFor: 'accessing' stamp: 'jcg 11/30/2009 10:08'!
dataWithoutHeader
	^ data copyFrom: headerSize+1 to: data size
! !

!QNetVidBufferedFrame methodsFor: 'accessing' stamp: 'jcg 2/11/2009 17:14'!
decodedFrame
	^decodedFrame! !

!QNetVidBufferedFrame methodsFor: 'accessing' stamp: 'jcg 2/11/2009 17:15'!
decodedFrame: decoded "can be of many types, eg: Form, SoundBuffer, etc."
	decodedFrame := decoded! !

!QNetVidBufferedFrame methodsFor: 'accessing' stamp: 'jcg 2/8/2009 23:59'!
dts
	"Display Time Stamp... the time the frame is to arrive for decoding."
	^dts! !

!QNetVidBufferedFrame methodsFor: 'accessing' stamp: 'jcg 3/28/2009 13:40'!
dtsDelta
	"Answer the expected delta to the *next* frame's DTS."
	^dtsDelta! !

!QNetVidBufferedFrame methodsFor: 'accessing' stamp: 'jcg 11/30/2009 10:06'!
headerSize
	^headerSize! !

!QNetVidBufferedFrame methodsFor: 'accessing' stamp: 'jcg 2/9/2009 00:00'!
isRAP
	"Is this frame a Random Access Point (can we seek directly here without needing data from other frames?)?"
	^isRAP! !

!QNetVidBufferedFrame methodsFor: 'accessing' stamp: 'jcg 2/9/2009 00:00'!
isSeek
	"Is this frame being sent in response to a seek request?"
	^isSeek! !

!QNetVidBufferedFrame methodsFor: 'printing' stamp: 'jcg 2/12/2009 10:36'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	dts printOn: aStream.
	aStream nextPut: $-.
	(cts - dts) printOn: aStream.
	isRAP ifTrue: [aStream nextPutAll: '-rap'].
	isSeek ifTrue: [aStream nextPutAll: '-seek'].
	aStream nextPut: $).! !

!QNetVidBufferedFrame methodsFor: 'accessing' stamp: 'jcg 2/9/2009 00:34'!
sequenceNumber
	^sequenceNumber! !

!QNetVidBufferedFrame methodsFor: 'initialize' stamp: 'jcg 2/9/2009 00:34'!
sequenceNumber: seqNum
	sequenceNumber := seqNum! !

Object subclass: #QNetVidDatagramHeader
	instanceVariableNames: 'flags headerSize cts dts dtsDelta isRAP isSeek timestampScale'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Server'!

!QNetVidDatagramHeader commentStamp: 'jcg 11/25/2009 19:40' prior: 0!
Create and parse NetVid datagram headers.  Now that the packet format is becoming somewhat more complicated (and may vary from stream to stream), it is less confusing to have all of the code in one place.

Used to both read and write headers.  When presented with a datagram, it reads the header and sets the appropriate properties based on what it reads.  To write a header, first set all properties to the desired value, then write the header into a provided byte-array.

Header flags:
0x01	-	the sample is a Random Access Point (RAP)
0x02	-	the sample should be treated as a 'seek' (the RAP flag must be set)
0x04	-	header contains 4-byte dtsDelta to the next frame
0x08	-	wire-timestamps are multiplied by timestampScale to get actual timestamp

Instance variables:
	headerSize:	
				Size in bytes of the header.  When writing headers, this is set to nil
				whenever a property is set that changes the header-size; it is computed
				lazily when necessary.  When reading headers, the first thing done is
				to determine the header-size based on the header's flag-bits.
	cts	:		Composition Time Stamp (time that frame is actually displayed)
	dts :		Decode Time Stamp (time that frame should be submitted for decoding)
	isRAP  (flag 0x01):
	isSeek (flag 0x02): set if we are seeking through content, rather than playing it.
	timestampScale (flag 0x08):
				If nil, send CTS/DTS values as-is.  If not nil, the wire timestamps are
				equal to the actual timestamp divided by the timestampScale.  The 
				purpose is not to overflow the available 32-bits so quickly.  For example,
				for 10fps video with a 90kHz time-scale, you might use a timestampScale
				of 9000 so that the wire representation of the CTS is incremented by 1
				instead of 9000. !

!QNetVidDatagramHeader class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QNetVidDatagramHeader methodsFor: 'comparing' stamp: 'jcg 11/29/2009 14:47'!
= hdr "a QNetVidDatagramHeader"
	self class == hdr class ifFalse: [^false].
	cts = hdr cts ifFalse: [^false].
	dts = hdr dts ifFalse: [^false].
	dtsDelta = hdr dtsDelta ifFalse: [^false].
	isRAP = hdr isRAP ifFalse: [^false].
	isSeek = hdr isSeek ifFalse: [^false].
	timestampScale = hdr timestampScale ifFalse: [^false].
	^true! !

!QNetVidDatagramHeader methodsFor: 'accessing' stamp: 'jcg 11/26/2009 15:34'!
cts
	^cts! !

!QNetVidDatagramHeader methodsFor: 'accessing' stamp: 'jcg 11/29/2009 14:35'!
cts: newCTS dts: newDTS
	cts := newCTS.
	dts := newDTS.
! !

!QNetVidDatagramHeader methodsFor: 'accessing' stamp: 'jcg 11/26/2009 15:34'!
dts
	^dts! !

!QNetVidDatagramHeader methodsFor: 'accessing' stamp: 'jcg 11/29/2009 14:47'!
dtsDelta
	^dtsDelta! !

!QNetVidDatagramHeader methodsFor: 'accessing' stamp: 'jcg 11/29/2009 14:42'!
dtsDelta: newDTSDelta "or nil"
	(dtsDelta isNil xor: newDTSDelta isNil) ifTrue: [
		"Header size and flags changed."
		headerSize := nil.
		newDTSDelta 
			ifNil: [flags := flags bitClear: 4]
			ifNotNil: [flags := flags bitOr: 4].
	].
	dtsDelta := newDTSDelta.
		! !

!QNetVidDatagramHeader methodsFor: 'accessing' stamp: 'jcg 11/29/2009 14:36'!
headerSize
	headerSize ifNil: [
		headerSize := 9. "base size: flag byte + CTS + DTS".
		(flags anyMask: 4) ifTrue: ["also include DTS-delta"
			headerSize := headerSize + 4.
		].
	].
	^headerSize! !

!QNetVidDatagramHeader methodsFor: 'initialize' stamp: 'jcg 11/29/2009 14:37'!
initialize
	flags := 0.
	cts := dts := 0.
	dtsDelta := nil.
	isRAP := isSeek := false.
	timestampScale := nil.! !

!QNetVidDatagramHeader methodsFor: 'accessing' stamp: 'jcg 11/26/2009 15:37'!
isRAP
	^isRAP! !

!QNetVidDatagramHeader methodsFor: 'accessing' stamp: 'jcg 11/26/2009 16:07'!
isRAP: bool
	isRAP == bool ifTrue: [^self "nothing to do"].
	isRAP := bool.
	isRAP 
		ifTrue: [flags := flags bitOr: 1]
		ifFalse: [flags := flags bitClear: 1].! !

!QNetVidDatagramHeader methodsFor: 'accessing' stamp: 'jcg 11/26/2009 15:37'!
isSeek
	^isSeek! !

!QNetVidDatagramHeader methodsFor: 'accessing' stamp: 'jcg 11/26/2009 16:07'!
isSeek: bool
	isSeek == bool ifTrue: [^self "nothing to do"].
	isSeek := bool.
	isSeek 
		ifTrue: [flags := flags bitOr: 2]
		ifFalse: [flags := flags bitClear: 2].! !

!QNetVidDatagramHeader methodsFor: 'reading / writing' stamp: 'jcg 11/30/2009 01:22'!
readFrom: bytes startingAt: index
	| current |

	current := index.
	flags := bytes at: index.
	current := current + 1.
	isRAP := (flags anyMask: 1).
	isSeek := (flags anyMask: 2).
	
	timestampScale notNil = (flags anyMask: 8) ifFalse: [
		self error: 'timestampScale does not match header flag: ', timestampScale.
	].

	dts := bytes networkUnsignedLongAt: current.
	timestampScale ifNotNil: [dts := dts * timestampScale].
	current := current + 4.

	cts := bytes networkUnsignedLongAt: current.
	timestampScale ifNotNil: [cts := cts * timestampScale].
	current := current + 4.

	"If flag is set, read the DTS-delta."
	dtsDelta := nil.
	(flags anyMask: 4) ifTrue: [
		dtsDelta := bytes networkUnsignedLongAt: current.
		current := current + 4.
	].
		! !

!QNetVidDatagramHeader methodsFor: 'accessing' stamp: 'jcg 11/26/2009 15:38'!
timestampScale
	^timestampScale! !

!QNetVidDatagramHeader methodsFor: 'accessing' stamp: 'jcg 11/26/2009 16:04'!
timestampScale: newTimestampScale
	timestampScale = newTimestampScale ifTrue: [^self "nothing to do"].
	timestampScale := newTimestampScale.
	timestampScale = 1 ifTrue: [timestampScale := nil].
	timestampScale
		ifNil: [flags := flags bitClear: 8]
		ifNotNil: [flags := flags bitOr: 8].
! !

!QNetVidDatagramHeader methodsFor: 'reading / writing' stamp: 'jcg 11/30/2009 01:54'!
writeInto: bytes startingAt: index
	| current wireCTS wireDTS |
	(bytes size - index + 1) < self headerSize ifTrue: [
		self error: 'not enough room to write header of size: ', self headerSize
	].
	current := index.
	bytes at: current put: flags.
	current := current + 1.

	timestampScale
		ifNil: [
			wireCTS := cts.
			wireDTS := dts.
		]
		ifNotNil: [
			wireCTS := cts / timestampScale.
			wireDTS := dts / timestampScale
		].

	bytes networkUnsignedLongAt: current put: wireDTS.
	current := current + 4.
	bytes networkUnsignedLongAt: current put: wireCTS.
	current := current + 4.

	(flags anyMask: 4) ifTrue: [
		bytes networkUnsignedLongAt: current put: dtsDelta.
		current := current + 4.
	].! !

Object subclass: #QNetVidFileRecord
	instanceVariableNames: 'path modified size sha'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Server'!

!QNetVidFileRecord commentStamp: '<historical>' prior: 0!
Keeps track of the last-known attributes of an uploaded file.  Each time we try to play the file, we check against some of these attributes to see if the file has changed.  If not, we use whatever pre-processed data we have cached for the file.!

!QNetVidFileRecord class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

Object subclass: #QNetVidServices
	instanceVariableNames: 'mutex realms assets pathsToAssets servers recorders realmsPath streamManager'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Service'!

!QNetVidServices commentStamp: '<historical>' prior: 0!
Services provided for streaming audio/video.


Instance variables:
	controllers	- 	Dictionary mapping realm-names to controllers!

!QNetVidServices class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QNetVidServices class methodsFor: 'accessing' stamp: 'bobw 2/26/2010 10:27'!
baseFilename
	"Answer the base filename to use for this services log file."

	^'video'! !

!QNetVidServices class methodsFor: 'accessing' stamp: 'jcg 3/4/2009 14:53'!
default
	^Default ifNil:[Default := self new]! !

!QNetVidServices class methodsFor: 'accessing' stamp: 'jcg 3/4/2009 14:53'!
reset
	Default ifNotNil:[Default destroy].
	Default := nil! !

!QNetVidServices methodsFor: 'asset-management' stamp: 'jcg 9/28/2009 00:33'!
assetFromTracks: trackList
	| sha asset newAssetName |

	"Quickest thing is to look it up by file-path.  It's OK to use just one track's
	 file-path, because there won't be any other session-recording that also 
	 includes that same file-path."
	mutex critical: [
		pathsToAssets at: trackList first ifPresent: [:ass | 
			ass resetLastUse.
			^ass
		]
	].
	
	"Maybe the asset already exists, and we just don't have a mapping to it.  We look for the asset by its 'SHA'... actually the SHA of the concatenation of each track's SHAs."
	sha := ''.
	trackList do: [:trName |
		| file |
		[file := FileStream readOnlyFileNamed: trName]
			on: FileDoesNotExistException
			do: [:ex |
				QLogger logWarning: 'missing file while creating SHA for asset: ', trName.
				file := nil.
			].
		file ifNotNil: [
			[
				| contentStream |
				contentStream := file binary contents readStream.
				sha := sha, (TContentManager generateSHA: contentStream).
			] ensure: [file close].
		].
	].
	sha := TContentManager generateSHA: sha.

	mutex critical: [
		assets at: sha ifPresent: [:ass |
			ass resetLastUse.
			ass addPath: trackList first modificationTime: nil.
			pathsToAssets at: trackList first put: ass.
			^ass
		].
	].	

	"Couldn't find the asset... must create a new one."
	asset := QNetVidFileAsset new readSessionRecorderTracks: trackList.
	asset sha: sha.
	asset addPath: trackList first modificationTime: nil.

	"Create a reasonable name for the asset (for display on the admin pages)."	 
	[newAssetName := (trackList first copyAfterSubString: '/services/') copyUpToLast: $/] 
		on: Error 
		do: [:err |
			QLogger logWarning: 'error while computing asset-name: ', err messageText.
			newAssetName := '<error: ', err messageText, '>'
		].
	asset assetName: '.MRI FILE: ', newAssetName.

	mutex critical: [
		assets at: sha put: asset.
		pathsToAssets at: trackList first put: asset.
	].
	^asset
! !

!QNetVidServices methodsFor: 'asset-management' stamp: 'jcg 11/6/2009 13:49'!
assetNamed: sharedName
	| fullPath file modTime  sha asset |

	"We'll need this in a few places below."
	fullPath := self fullPathForSharedName: sharedName.

	"Quickest thing is to look it up by file-path."
	mutex critical: [
		pathsToAssets at: sharedName ifPresent: [:ass | 
			"We now compare file-sizes.  It's probably better to also compare
			 modification-times and SHA, but this is an improvement."
			| fileSize |
			(FileDirectory directoryEntryFor: fullPath)
				ifNil: [FileDoesNotExistException fileName: fullPath]
				ifNotNilDo: [:dirEntry | fileSize := dirEntry fileSize].
			ass fileSize = fileSize 
				ifTrue: [^ass resetLastUse; yourself]
				ifFalse: [
					"We'll fall through to the code below, first recomputing the SHA to
					 find an existing asset, and generating a new asset if necessary."
					QLogger logWarning: 'asset file-size has changed, recomputing SHA'.
					pathsToAssets removeKey: sharedName.
				].
		]
	].
	
	"Maybe the asset already exists, and we just don't have a mapping to it.  We look for the asset by its SHA."
	file := FileStream readOnlyFileNamed: fullPath. "sender handles FileDoesNotExist"
	file binary.
	modTime := file modificationTime.
	[sha := TContentManager generateSHA: file] ensure: [file close].
	mutex critical: [
		assets at: sha ifPresent: [:ass |
			ass resetLastUse.
			ass addPath: fullPath modificationTime: modTime.
			pathsToAssets at: sharedName put: ass.
			^ass
		].
	].	

	"Couldn't find the asset... must create a new one."
	asset := QNetVidFileAsset forSHA: sha filePath: fullPath cachePath: self cacheDirPath.
	asset assetName: sharedName.
	asset addPath: fullPath modificationTime: modTime.
	mutex critical: [
		assets at: sha put: asset.
		pathsToAssets at: sharedName put: asset.
	].
	^asset

	
! !

!QNetVidServices methodsFor: 'directories' stamp: 'jcg 2/19/2009 11:37'!
cacheDir
	^(FileDirectory on: self cacheDirPath) assureExistence
! !

!QNetVidServices methodsFor: 'accessing' stamp: 'ar 4/16/2011 17:13'!
cacheDirPath
	"Assumes that image is within the standard router/appserver/video installation hierarchy."
	^FileDirectory pathFromURI:
		(QPropsFile default
			at: 'OpenQwaq.NetVid.CachePath'
			ifAbsent: ['../../cache/NetVid-cache'])! !

!QNetVidServices methodsFor: 'stream services' stamp: 'bobw 2/26/2010 10:27'!
collectLogFilesRequest: xmlNode from: connection

	^QServerLogFileCollector 
		collectLogFilesRequest: xmlNode 
		from: connection 
		baseFilename: self class baseFilename! !

!QNetVidServices methodsFor: 'initialize' stamp: 'jcg 8/4/2009 17:59'!
destroy
	QLogger logInfo: 'Destroying NetVidServices'.
	self destroyAllServers.
	self destroyAllRecorders.! !

!QNetVidServices methodsFor: 'initialize' stamp: 'jcg 8/4/2009 18:00'!
destroyAllRecorders
	| recordersToDestroy |
	recordersToDestroy := mutex critical: [recorders copy].
	recordersToDestroy do: [:r | r destroy].
! !

!QNetVidServices methodsFor: 'initialize' stamp: 'jcg 6/18/2009 15:26'!
destroyAllServers
	| serversToDestroy |
	serversToDestroy := mutex critical: [servers copy].
	serversToDestroy do: [:s | s destroy].
! !

!QNetVidServices methodsFor: 'directories' stamp: 'jcg 2/19/2009 11:37'!
documentDir
	^(FileDirectory on: self documentDirPath) assureExistence
! !

!QNetVidServices methodsFor: 'directories' stamp: 'jcg 2/19/2009 11:38'!
documentDirPath
	self error: 'not yet implemented'! !

!QNetVidServices methodsFor: 'private' stamp: 'jcg 3/5/2009 00:39'!
fullPathForSharedName: alreadyTheFullName
	"Given a file-card document name, answer the full local path of the file."
	^alreadyTheFullName
! !

!QNetVidServices methodsFor: 'initialize' stamp: 'jcg 8/4/2009 18:02'!
initialize
	QLogger logInfo: 'Instantiating NetVid services'.
	mutex := Mutex new.
	assets := Dictionary new.
	pathsToAssets := Dictionary new.
	servers := Dictionary new.
	recorders := Dictionary new.
	realms := Dictionary new.
! !

!QNetVidServices methodsFor: 'stream services' stamp: 'ar 6/25/2009 13:51'!
initializeResourceLimitsFrom: xmlNode "or nil"
	| width height  extent bitrate limits |
	xmlNode ifNil: [^self "there are no resource limits"].
	width := xmlNode contentStringAt: 'width' ifAbsent: [nil].
	height := xmlNode contentStringAt: 'height' ifAbsent: [nil].

	"Read resolution limit.  Both width & height must be non-nil, or no limit is imposed."
	(width isNil xor: height isNil) ifTrue: [
		QLogger logWarning: 'need both width and height for video resolution limit'.
		extent := nil.
	].
	(width notNil & height notNil) ifTrue: [
		[extent := (Number readFrom: width)@(Number readFrom: height)]
			on: Error
			do: [:err |
				QLogger logWarning: 'error while reading video bitrate limit'.
				extent := nil.
			].
	].
	
	"Read the limit of video bitrate, if any."
	bitrate := xmlNode contentStringAt: 'bitrate' ifAbsent: [nil].
	bitrate ifNotNil: [
		[bitrate := Number readFrom: bitrate]
			on: Error 
			do: [:err |
				QLogger logWarning: 'error while reading video bitrate limit'.
				bitrate := nil.
			].
	].

	"Check if there are any limits at all.  If so, create a QNetVidAssetLimits object."
	extent isNil & bitrate isNil ifTrue: [^limits := nil].
	limits := QNetVidAssetLimits new.
	limits extent: extent.
	limits bitrate: bitrate.
	^limits	! !

!QNetVidServices methodsFor: 'stream services' stamp: 'ar 6/25/2009 13:54'!
launchRequest: xmlNode from: connection
	"Start streaming the appropriate asset, first doing whatever lazy initialization is necessary."
	| assetPath service result realmPath slash xmlReq limits |
	[xmlReq := xmlNode elements first.
	QLogger logInfo: 'Processing launch request: ', xmlReq.
	service := xmlReq contentStringAt: 'service'.
	realmPath := xmlReq contentStringAt: 'path'.
	assetPath := xmlReq contentStringAt: 'assetPath'.
	slash := FileDirectory slash.
	assetPath := self realmsPath, slash,  realmPath, slash, 'services', slash,  service, slash, assetPath.
	limits := self initializeResourceLimitsFrom: (xmlReq elementAt: 'limits' ifAbsent: [nil]).
	result := self streamAssetNamed: assetPath limits: limits.
	result := (XMLDOMParser on: result readStream) nextEntity.
	connection sendXMLResponse: result name contents:[:writer|
		writer pcData: result contentString.
		result elementsDo:[:elem| elem printXMLOn: writer].
	] request: xmlNode.

	] on: Error do: [:err |
		| msg |
		msg := 'Unexpected error while launching video'.
		QLogger logError: msg.
		QLogger logError: err.
		connection 
			sendFailureResponse: msg, ': ', err description
			request: xmlNode.
	].
! !

!QNetVidServices methodsFor: 'stream services' stamp: 'jcg 8/4/2009 17:01'!
netVidRequest: xmlNode from: connection
	| xmlReq |
	xmlReq := xmlNode elements first.
	xmlReq name caseOf: {
		[#launch]		->	[self launchRequest: xmlNode from: connection].
		[#playTracks]	-> [self playTracksRequest: xmlNode from: connection].
		[#record]		-> [self recordSessionRequest: xmlNode from: connection].
		[#ping]			->	[connection sendOK: xmlNode].
	} otherwise:[
		QLogger logWarning: 'Unknown netvid request: ', xmlNode.
		connection 
			sendFailureResponse: 'Unknown request: ', xmlNode name
			request: xmlNode.
	].
! !

!QNetVidServices methodsFor: 'stream services' stamp: 'jcg 8/4/2009 18:02'!
netVidStatus: xmlNode from: connection
	"Return information about the status of the NetVid services"
	| writer info |
	info := String new writeStream.
	writer := XMLWriter on: info.
	writer tag: 'timestamp' pcData: (DateAndTime now utcString).
	writer tag: 'version' pcData: QwaqVersion current infoString.
	writer tag: 'vmVersion' pcData: Smalltalk vmVersion.
	streamManager ifNotNil:[
		writer startTag: 'serverInfo'; endTag.
		streamManager serverInfo storeXMLOn: writer.
		writer endTag: 'serverInfo'.
		writer startTag: 'streamInfo'; endTag.
		writer stream nextPutAll: streamManager streamStatus.
		writer endTag: 'streamInfo'.
	].
	mutex critical:[
		writer tag: 'serverCount' pcData: servers size printString.
		writer tag: 'recorderCount' pcData: recorders size printString.
		writer tag: 'assetCount' pcData: assets size printString.
		servers do:[:s|
			writer startTag: 'server'; 
				attribute: 'id' value: (s controlStreamID
										ifNil: ['(no streamID)']
										ifNotNilDo: [:id | id hex]); 
			endTag.

			"Probably want more stuff here. Indeed."
			writer tag: 'asset' pcData: s assetName.
			writer tag: 'state' pcData: s playState.
			writer endTag: 'server'.
		].
	].
	connection sendXMLResponse: 'ok' contents:[:w| w stream nextPutAll: info contents] request: xmlNode.
! !

!QNetVidServices methodsFor: 'stream services' stamp: 'ar 6/25/2009 13:53'!
playTracksRequest: xmlNode from: connection
	"Start streaming a set of NHML tracks directly specified in the request."
	| service result realmPath trackList fileName realmsDir xmlReq limits |
	[xmlReq := xmlNode elements first.
	QLogger logInfo: 'Processing launch request: ', xmlReq.
	service := xmlReq contentStringAt: 'service'.
	realmPath := xmlReq contentStringAt: 'path'.
	limits := self initializeResourceLimitsFrom: (xmlReq elementAt: 'limits' ifAbsent: [nil]).

	trackList := OrderedCollection new.
	(xmlReq elementAt: #tracks ifAbsent:[nil]) ifNotNil:[:tList|
		realmsDir := FileDirectory on: self realmsPath.
		tList tagsNamed: #track do:[:trackNode|
			fileName := trackNode contentString.
			"Make the file name relative"
			[fileName beginsWith: '/'] whileTrue:[fileName := fileName allButFirst].
			(fileName beginsWith: 'services/', service) ifTrue:[
				"a bit of added paranoia in case someone tries to fake the path"
				fileName := realmsDir pathFromURI: realmPath, '/', fileName.
				trackList add: fileName.
			].
		].
	].
	
	result := self streamAssetFromTracks: trackList limits: limits.
	result := (XMLDOMParser on: result readStream) nextEntity.
	connection sendXMLResponse: result name contents:[:writer|
		writer pcData: result contentString.
		result elementsDo:[:elem| elem printXMLOn: writer].
	] request: xmlNode.
	] on: Error do: [:err |
		QLogger logError: err.
		connection sendXMLResponse: 'failed' contents:[:writer|
			writer pcData: 'Unexpected error in QNetVidServices>>playTracks:'.
		] request: xmlNode.
	]
! !

!QNetVidServices methodsFor: 'accessing' stamp: 'ar 4/16/2011 17:13'!
realmsPath
	^realmsPath ifNil: [realmsPath := QPropsFile default at: 'OpenQwaq.NetVid.RealmsPath']! !

!QNetVidServices methodsFor: 'accessing' stamp: 'ar 3/13/2009 13:55'!
realmsPath: aString
	realmsPath := aString! !

!QNetVidServices methodsFor: 'stream services' stamp: 'jcg 8/16/2010 12:26'!
recordSessionRequest: xmlNode from: connection
	"Some client is broadcasting a live audio/video session, and wants us to record it and make it available as a regular MP4 document."
	| xmlReq controlStreamID recorder |
	[xmlReq := xmlNode elements first.
	QLogger logInfo: 'Processing session-recording request: ', xmlReq.

	"Create the session-recorder."
	controlStreamID := TObjectID readHexFrom: (xmlReq contentStringAt: 'streamID').
	recorder := QSessionRecorder new.
	recorder sessionID: controlStreamID.
	recorder netVidServices: self.
	mutex critical: [recorders at: controlStreamID put: recorder].
	recorder 
		runScript: #notifyServicesOfDestruction:
		withArguments: {self}
		when: {recorder. #destroyed}.
	
	"Process the request... the recorder will respond to it directly."
	recorder
		handleRequest: xmlNode
		fromConnection: connection.
	
	] on: Error do: [:err |
		| msg |
		msg := 'Unexpected error while starting session-recording'.
		QLogger logError: msg.
		QLogger logError: err.
		connection
			sendFailureResponse: msg, ': ', err description
			request: xmlNode
	].! !

!QNetVidServices methodsFor: 'private' stamp: 'jcg 4/22/2010 15:21'!
recorderDestroyed: id "TObjectID: ID of the session-recording"
	"Notify the netvid services about the destruction of a netvid recorder."
	mutex critical: [
		recorders 
			removeKey: id
			ifAbsent: [^QLogger logWarning: 'could not find recorder with id: ', id].
		QLogger logInfo: 'removed recorder with id: ', id.
	].! !

!QNetVidServices methodsFor: 'private' stamp: 'jcg 4/22/2010 15:43'!
releaseOldAssets
	mutex critical: [
		"Release any assets that haven't been used for a day (24 * 3600 * 1000 msecs)"
		assets := assets reject: [:ass | (ass lengthOfDisuse > 86400000)].
		pathsToAssets := pathsToAssets reject: [:ass | (ass lengthOfDisuse > 86400000)].
	]! !

!QNetVidServices methodsFor: 'stream services' stamp: 'bobw 1/7/2010 18:23'!
runVideoServerTests: xmlNode from: connection
	"A remote image has requested that we run the suite of tests for the receiver."

	| writer info tester |
	info := (String new: 100) writeStream.
	writer := XMLWriter on: info.
	tester := QServerSelfTest 
				reportWriter: writer 
				connection: connection 
				xmlNode: xmlNode.
	tester runNetVidServerSuite.
	tester respond! !

!QNetVidServices methodsFor: 'private' stamp: 'jcg 4/21/2010 16:07'!
serverDestroyed: id "TObjectID: control-stream ID of netvid server"
	"Notify the netvid services about the destruction of a netvid server."
	mutex critical: [
		servers 
			removeKey: id
			ifAbsent: [^QLogger logWarning: 'could not find netvid-server with id: ', id].
		QLogger logInfo: 'removed netvid-server with id: ', id.
	].! !

!QNetVidServices methodsFor: 'stream services' stamp: 'jcg 8/20/2009 19:02'!
streamAsset: asset limits: assetLimits
	| publishID streamID videoServer extent |
	[
		"Do a quick run-through to get rid of old assets."
		self releaseOldAssets.

		"Create a new server."
		publishID := TObjectID new.
		streamID := TCryptoRandom md5HashMessage: publishID.
		videoServer  := QNetVidServer
							newWithControlStreamID: publishID
							streamManager: streamManager.
		"Double dispatch... servers come and go quite frequently, so better to attach the scripts to  them so as not to bloat our scripts dictionary."
		videoServer 
			runScript: #notifyServicesOfDestruction: 
			withArguments: {self} 
			when: {videoServer. #destroyed}.
		mutex critical: [servers at: streamID put: videoServer].

		"Open the asset and wait until the server is ready to stream it."
		videoServer limits: assetLimits. "so we can decide if the asset is allowable"
		videoServer future openMedia: asset.

		extent := 256@256.  "make one up"
		^'<ok><streamID>', streamID hex, '</streamID><appExtent>', extent, '</appExtent></ok>'
	] on: Error do: [:err |
		QLogger logError: err.
		videoServer ifNotNil: [
			[videoServer destroy.
			 mutex critical: [servers removeKey: streamID ifAbsent: []]] 
				on: Error 
				do: [:err2 | QLogger logWarning: 'error while handling error: ', err2].
		].
		^ '<failed>unexpected error: ', err, '</failed>'
	].
! !

!QNetVidServices methodsFor: 'stream services' stamp: 'ar 5/26/2009 17:30'!
streamAssetFromTracks: trackList limits: assetLimits
	| asset  |
	asset := self assetFromTracks: trackList.
	^self streamAsset: asset limits: assetLimits! !

!QNetVidServices methodsFor: 'stream services' stamp: 'ar 5/26/2009 16:59'!
streamAssetNamed: sharedName limits: assetLimits
	| asset |
	[asset := self assetNamed: sharedName] on: FileDoesNotExistException do:[
		| shortName |
		shortName := sharedName copyAfterLast: 
							FileDirectory default pathNameDelimiter.
		shortName ifEmpty: [shortName := sharedName].
		QLogger logWarning: 'video file not found on server: ', sharedName.
		^'<failed>file not found: ', shortName, '</failed>'
	].
	^self streamAsset: asset limits: assetLimits! !

!QNetVidServices methodsFor: 'accessing' stamp: 'ar 5/26/2009 11:22'!
streamManager
	"The associated stream manager"
	^streamManager! !

!QNetVidServices methodsFor: 'accessing' stamp: 'ar 5/26/2009 11:22'!
streamManager: aQStreamManager
	"The associated stream manager"
	streamManager := aQStreamManager! !

!QNetVidServices methodsFor: 'sanity' stamp: 'jcg 11/13/2009 12:59'!
testConfiguration
	| errors details |

	"Run each test and collect errors."
	errors := OrderedCollection new.
	#(
		testConfigurationOfRealmsDir
		testConfigurationOfCacheDir
		testConfigurationOfFileMoving
	) do: [:selector |
		[self perform: selector] 
			on: Error do: [:err | errors add: selector -> err messageText].
	].
	errors ifEmpty: [^self "yay!!"].

	"Gather all errors into one log-msg."
	details := String streamContents: [:str |
		errors do: [:assoc |
			str 
				nextPutAll: '      FAILED ', assoc key, '...';
				nextPutAll: '   ', assoc value;
				crlf
		]
	].
	QLogger logError: 'SERVER CONFIGURATION ERROR' details: details from: self.! !

!QNetVidServices methodsFor: 'sanity' stamp: 'jcg 11/13/2009 13:01'!
testConfigurationOfCacheDir
	self cacheDir exists ifFalse: [
		self error: 'cache directory does not exist (', self cacheDirPath, ')'.
	].
				
! !

!QNetVidServices methodsFor: 'sanity' stamp: 'jcg 11/13/2009 15:20'!
testConfigurationOfFileMoving
	"Test whether we can move files from the cache-dir to the realms-dir, and whether we can rename directories within the cache-dir."
	| cacheDir realmsDir realmsTmpDir cacheTmpDir fileName dirName file |

	cacheDir := self cacheDir. 
	realmsDir := FileDirectory on: self realmsPath.
	(cacheDir exists and: [realmsDir exists]) ifFalse: [
		"Don't have to figure out which it is... previous tests will also catch this."
		self error: 'cache-dir and/or realms-dir is missing'.
	].

	cacheTmpDir := (cacheDir directoryNamed: 'tmp') assureExistence.
	realmsTmpDir := (realmsDir directoryNamed: 'tmp') assureExistence.
	(cacheTmpDir exists and: [realmsTmpDir exists]) ifFalse: [
		"Don't have to figure out which it is... previous tests will also catch this."
		self error: 'cannot create temp directories for test'.
	].

	fileName := TObjectID new hex.
	file := cacheTmpDir forceNewFileNamed: fileName.
	file nextPutAll: fileName.
	file close.
	(cacheTmpDir fileExists: fileName) ifFalse: [
		self error: 'cannot write temp-file in cache-dir'.
	].

	"Move the file from the cache-dir to the realms-dir, and ensure all is sane."
	[cacheTmpDir rename: fileName toBe: (realmsTmpDir fullNameFor: fileName)]
		on: Error 
		do: [:err | self error: 'could not move file from cache-dir to realms-dir:  ', 
																		err description].
	(cacheTmpDir fileExists: fileName) ifTrue: [
		self error: 'file-move apparently succeeded, but it is still in cache-dir'
	].
	(realmsTmpDir fileExists: fileName) ifFalse: [
		self error: 'file-move apparently succeeded, but it is not in realms-dir'
	].

	"Move the file back from the realms-dir to the cache-dir, and ensure all is sane."
	[realmsTmpDir rename: fileName toBe: (cacheTmpDir fullNameFor: fileName)]
		on: Error 
		do: [:err | self error: 'could not move file from realms-dir to cache-dir:  ', 
																		err description].
	(realmsTmpDir fileExists: fileName) ifTrue: [
		self error: 'file-move apparently succeeded, but it is still in realms-dir'
	].
	(cacheTmpDir fileExists: fileName) ifFalse: [
		self error: 'file-move apparently succeeded, but it is not in cache-dir'
	].

	"Ensure that we can delete files."
	[cacheTmpDir deleteFileNamed: fileName]
		on: Error
		do: [:err | self error: 'error while deleting test file: ', err description].
	(cacheTmpDir fileExists: fileName) ifTrue: [
		self error: 'file-deletion apparently succeeded, but it is still there'.
	].

	"Ensure that we can rename directories, too."
	dirName := fileName.
	(cacheTmpDir directoryNamed: dirName) assureExistence.
	[cacheTmpDir rename: dirName toBe: (dirName first: 10)]
		on: Error
		do: [:err | self error: 'could not rename directory because: ', err description].
	(cacheTmpDir directoryExists: dirName) ifTrue: [
		self error: 'directory-rename apparent succeeded, but old name is still there'.
	].
	(cacheTmpDir directoryExists: (dirName first: 10)) ifFalse: [
		self error: 'directory-rename apparent succeeded, but new name is not there'.
	].
	[cacheTmpDir deleteDirectory: (dirName first: 10)]
		on: Error
		do: [:err | self error: 'error while deleting test directory: ', err description].

		! !

!QNetVidServices methodsFor: 'sanity' stamp: 'jcg 11/13/2009 12:57'!
testConfigurationOfRealmsDir
	| realmsDir |
	realmsDir := FileDirectory on: self realmsPath.
	realmsDir exists ifFalse: [
		self error: 'realms directory does not exist (', self realmsPath, ')'.
	].
				
! !

!QNetVidServices methodsFor: 'stream services' stamp: 'ar 8/20/2009 23:19'!
updateServerInfo: serverInfo
	"Update a QServerInfo record"
	mutex critical:[
		serverInfo netVidServers: servers size.
		serverInfo netVidRecorders: recorders size.
	].! !

Object subclass: #QNetVidTrackInfo
	instanceVariableNames: 'trackType trackID codec timeScale timestampScale duration bitrate dtsIncrement decoderSpecificInfo sampleRate numChannels width height'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid'!

!QNetVidTrackInfo commentStamp: 'jcg 11/30/2009 10:42' prior: 0!
Describes the media in a NetVid track.  Used on both the client- and server-side.

The 'timestampScale' modifies the meaning of the DTS/CTS values sent in the header of each media datagram.  See QNetVidDatagramHeader.!

!QNetVidTrackInfo class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QNetVidTrackInfo methodsFor: 'accessing' stamp: 'jcg 8/29/2009 01:34'!
bitrate "bits/second"
	^bitrate! !

!QNetVidTrackInfo methodsFor: 'accessing' stamp: 'jcg 8/29/2009 01:34'!
bitrate: newBitRate "bits/second"
	bitrate := newBitRate.! !

!QNetVidTrackInfo methodsFor: 'accessing' stamp: 'jcg 7/27/2009 08:19'!
codec
	^codec! !

!QNetVidTrackInfo methodsFor: 'initialize' stamp: 'jcg 7/26/2009 17:10'!
codec: codecString
	"Acceptable values:
		'avc1'		- 	H.264 video
		'AAC'		- 	AAC audio
		'qspeex'	-	Speex audio"
	codec := codecString! !

!QNetVidTrackInfo methodsFor: 'accessing' stamp: 'jcg 7/27/2009 08:11'!
decoderSpecificInfo
	^decoderSpecificInfo! !

!QNetVidTrackInfo methodsFor: 'initialize' stamp: 'jcg 7/26/2009 17:34'!
decoderSpecificInfo: aByteArray
	"Interpreted differently by different types of decoder-codecs."
	decoderSpecificInfo := aByteArray
! !

!QNetVidTrackInfo methodsFor: 'accessing' stamp: 'jcg 7/27/2009 08:19'!
dtsIncrement
	^dtsIncrement! !

!QNetVidTrackInfo methodsFor: 'initialize' stamp: 'jcg 7/26/2009 17:33'!
dtsIncrement: anInteger
	"Each subsequent sample has a DTS (decoding time stamp) that is incremented this fixed value from the previous sample."
	dtsIncrement := anInteger! !

!QNetVidTrackInfo methodsFor: 'accessing' stamp: 'jcg 7/27/2009 08:19'!
duration
	^duration! !

!QNetVidTrackInfo methodsFor: 'initialize' stamp: 'jcg 7/26/2009 17:16'!
duration: aFloat
	"The duration of the track, in seconds.  A value of 'Float infinity' is acceptable, eg: in the case of an ongoing live broadcast."
	duration := aFloat! !

!QNetVidTrackInfo methodsFor: 'accessing' stamp: 'jcg 7/26/2009 21:44'!
extent
	"Video only."
	^width@height! !

!QNetVidTrackInfo methodsFor: 'accessing' stamp: 'jcg 7/26/2009 21:44'!
height
	"Video only."
	^height! !

!QNetVidTrackInfo methodsFor: 'initialize' stamp: 'jcg 7/26/2009 18:03'!
height: anInteger 
	"Video only."
	height := anInteger
! !

!QNetVidTrackInfo methodsFor: 'xml' stamp: 'jcg 11/30/2009 10:40'!
initializeFromXmlElement: node

	trackType := node attributeAt: 'type'.
	trackID := Integer readFrom: (node contentStringAt: 'trackID') readStream.

	"Read the codec, and use it to infer the track-type (i.e. 'audio' or 'video')."
	codec := node contentStringAt: 'codec'.
	codec caseOf: {
		['avc1']		->		[trackType := 'video'].
		['AAC']		->		[trackType := 'audio'].
		['qspeex']	->		[trackType := 'audio'].
	} otherwise: [
		QLogger logWarning: 'cannot determine track-type for codec: ', codec.
		trackType := 'unknown'.
	].

	timeScale := Integer readFrom: (node contentStringAt: 'timeScale') readStream.
	duration := Float readFrom: (node contentStringAt: 'duration') readStream.
	bitrate := node contentStringAt: 'bitrate' ifAbsent: [nil].
	bitrate ifNotNil: [bitrate := Integer readFrom: bitrate readStream].
	dtsIncrement := (node contentStringAt: 'dtsIncrement')
						ifEmpty: [nil]
						ifNotEmptyDo: [:string | Integer readFrom: string readStream].
	timestampScale := (node contentStringAt: 'timestampScale')
						ifEmpty: [nil]
						ifNotEmptyDo: [:string | Integer readFrom: string readStream].

	"This one is codec-specific, and may not be necessary for come codecs."
	decoderSpecificInfo := node contentStringAt: 'decoderSpecificInfo' ifAbsent: [nil].
	decoderSpecificInfo ifNotNil: [
		decoderSpecificInfo := ByteArray readHexFrom: decoderSpecificInfo.
	].

	"The final parameters are specific to the media-type (audio or video)."
	self isAudio ifTrue: [
		sampleRate := Integer readFrom: (node contentStringAt: 'sampleRate') readStream.
		numChannels := Integer readFrom: (node contentStringAt: 'numChannels') readStream.
	].
	self isVideo ifTrue: [
		width := Integer readFrom: (node contentStringAt: 'width') readStream.
		height := Integer readFrom: (node contentStringAt: 'height') readStream.
	].! !

!QNetVidTrackInfo methodsFor: 'testing' stamp: 'jcg 7/27/2009 23:39'!
isAAC
	^self isAudio and: [codec = 'AAC']! !

!QNetVidTrackInfo methodsFor: 'testing' stamp: 'jcg 7/27/2009 23:39'!
isAVC
	^self isVideo and: [codec = 'avc1']! !

!QNetVidTrackInfo methodsFor: 'testing' stamp: 'jcg 7/27/2009 10:51'!
isAudio
	^trackType = 'audio'! !

!QNetVidTrackInfo methodsFor: 'testing' stamp: 'jcg 7/27/2009 23:40'!
isQSpeex
	^self isAudio and: [codec = 'qspeex']! !

!QNetVidTrackInfo methodsFor: 'testing' stamp: 'jcg 7/27/2009 10:51'!
isVideo
	^trackType = 'video'! !

!QNetVidTrackInfo methodsFor: 'accessing' stamp: 'jcg 7/26/2009 22:07'!
numChannels
	"Audio only."
	^numChannels! !

!QNetVidTrackInfo methodsFor: 'initialize' stamp: 'jcg 7/26/2009 18:02'!
numChannels: anInteger 
	"Audio only."
	numChannels := anInteger
! !

!QNetVidTrackInfo methodsFor: 'accessing' stamp: 'jcg 7/26/2009 22:07'!
sampleRate
	"Audio only."
	^sampleRate! !

!QNetVidTrackInfo methodsFor: 'initialize' stamp: 'jcg 7/26/2009 18:02'!
sampleRate: anInteger "in Hertz"
	"Audio only."
	sampleRate := anInteger
! !

!QNetVidTrackInfo methodsFor: 'accessing' stamp: 'jcg 7/27/2009 08:19'!
timeScale
	^timeScale! !

!QNetVidTrackInfo methodsFor: 'initialize' stamp: 'jcg 7/26/2009 17:14'!
timeScale: anInteger
	"Specifies the number of time units in 1 second.  Eg: for H.264 video this should be 90000 (as per the spec)... if the frame rate is 10fps, then the DTS of the next video frame should be 9000 greater than that of the previous frame (or for 30fps, 3000 greater)."
	timeScale := anInteger! !

!QNetVidTrackInfo methodsFor: 'accessing' stamp: 'jcg 11/30/2009 10:42'!
timestampScale
	"Modifies the meaning of the DTS/CTS values sent in the header of each media datagram.  See QNetVidDatagramHeader."
	^timestampScale! !

!QNetVidTrackInfo methodsFor: 'accessing' stamp: 'jcg 11/30/2009 10:43'!
timestampScale: integerOrNil
	"Modifies the meaning of the DTS/CTS values sent in the header of each media datagram.  See QNetVidDatagramHeader."
	timestampScale := integerOrNil! !

!QNetVidTrackInfo methodsFor: 'accessing' stamp: 'jcg 7/27/2009 08:23'!
trackID
	^trackID! !

!QNetVidTrackInfo methodsFor: 'initialize' stamp: 'jcg 7/26/2009 17:09'!
trackID: anInteger
	trackID := anInteger.! !

!QNetVidTrackInfo methodsFor: 'accessing' stamp: 'jcg 7/28/2009 13:26'!
trackType
	^trackType "'audio', 'video', etc."! !

!QNetVidTrackInfo methodsFor: 'initialize' stamp: 'jcg 7/26/2009 17:08'!
trackType: aString "either 'audio' or 'video'."
	trackType := aString.! !

!QNetVidTrackInfo methodsFor: 'accessing' stamp: 'jcg 7/26/2009 21:44'!
width
	"Video only."
	^width! !

!QNetVidTrackInfo methodsFor: 'initialize' stamp: 'jcg 7/26/2009 18:03'!
width: anInteger 
	"Video only."
	width := anInteger
! !

!QNetVidTrackInfo methodsFor: 'xml' stamp: 'jcg 8/28/2009 23:44'!
writeXMLOn: xml "an XMLWriter"
	self writeXMLOn: xml streamID: nil! !

!QNetVidTrackInfo methodsFor: 'xml' stamp: 'jcg 11/30/2009 11:13'!
writeXMLOn: xml "an XMLWriter" streamID: streamID
	"This is for the convenience of QNetVidTrackStreamer#writeXMLOn:, which needs to insert a 'streamID' element even though it's not properly part of the track-info."
	xml startTag: 'track'; attribute: 'type' value: trackType; endTag.
		streamID ifNotNil: [xml tag: 'streamID' pcData: streamID hex].
		xml tag: 'trackID' pcData: trackID printString.
		xml tag: 'codec' pcData: codec.
		xml tag: 'timeScale' pcData: timeScale printString.
		xml tag: 'duration' pcData: duration printString.
		bitrate ifNotNil: [xml tag: 'bitrate' pcData: bitrate printString].

		"XXXXX: Clients before 3.0.25 always expect the 'dtsIncrement' to be specified.
		 We can replace this with the commented-out line later."
		"dtsIncrement ifNotNil: [xml tag: 'dtsIncrement' pcData: dtsIncrement printString]."
		xml tag: 'dtsIncrement' pcData: (dtsIncrement ifNil: [-1]) printString.
		
		"Scales the timestamps that are written in the wire protocol, then scales them back on the far end.  See QNetVidDatagramHeader."
		timestampScale ifNotNil: [
			xml tag: 'timestampScale' pcData: timestampScale printString
		].

		decoderSpecificInfo ifNotNilDo: [:raw |
			"The decoder will know what to do with this."
			xml tag: 'decoderSpecificInfo' pcData: raw hex
		].
		self isAudio ifTrue: [
			xml tag: 'sampleRate' pcData: sampleRate printString.
			xml tag: 'numChannels' pcData: numChannels printString.
		].
		self isVideo ifTrue: [
			xml tag: 'width' pcData: width printString.
			xml tag: 'height' pcData: height printString.
		].
	xml endTag: 'track'.! !

!QNetVidTrackInfo methodsFor: 'xml' stamp: 'jcg 8/28/2009 23:51'!
xmlNode
	^XMLDOMParser parseDocumentFrom: self xmlString readStream! !

!QNetVidTrackInfo methodsFor: 'xml' stamp: 'jcg 8/28/2009 23:50'!
xmlString
	^String streamContents: [:s | self writeXMLOn: (XMLWriterIndenting on: s)]! !

Object subclass: #QNetVidTrackStreamer
	instanceVariableNames: 'server track publishID streamID pub currentTime headerWriter badTimeCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Server'!

!QNetVidTrackStreamer commentStamp: 'jcg 3/28/2009 13:04' prior: 0!
Streams out the data for a particular audio or video track, under the control of a QNetVidServer.

Each media frame that is streamed out has a 9-byte header.  The first byte is a bitfield containing flags; these will be described below.  The next 8 bytes hold 2 unsigned integers, the first represents the DTS (decode time-stamp) and the second the CTS (composition time-stamp... the time that the sample is to be rendered).

Header flags:
0x01	-	the sample is a Random Access Point (RAP)
0x02	-	the sample should be treated as a 'seek' (the RAP flag must be set)
0x04	-	header contains 4-byte dtsDelta to the next frame!

QNetVidTrackStreamer subclass: #QNetVidFileTrackStreamer
	instanceVariableNames: 'currentIndex file'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Server'!

!QNetVidFileTrackStreamer commentStamp: '<historical>' prior: 0!
Uses a file as the data-source for the datagrams (video-frames or audio-segments) that it sends downstream.!

!QNetVidFileTrackStreamer class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QNetVidFileTrackStreamer methodsFor: 'private' stamp: 'jcg 11/30/2009 02:06'!
datagramPayloadForSample: sampleOrIndex "NHML sample, or integer index"
	| sample data count headerSize |

	sample := sampleOrIndex isInteger 
					ifFalse: [sampleOrIndex "already a sample"]
					ifTrue: [track samples at: sampleOrIndex "get sample for index"].

	"Configure the header-writer for this sample."
	headerWriter cts: sample cts dts: sample dts.
	headerWriter dtsDelta: sample dtsDelta.
	headerWriter isRAP: sample isRAP.

	"Once the header-writer is configured, we know the header size, and can therefore
	 compute the total datagram payload size."
	headerSize := headerWriter headerSize.
	data := ByteArray new: sample dataLength + headerSize.
	headerWriter writeInto: data startingAt: 1.

	"Read sample data from the file."
	file position: sample filePosition.
	count := file readInto: data startingAt: headerSize+1 count: sample dataLength.
	count == sample dataLength ifFalse: [self error: 'not enough data for sample'].

	^data! !

!QNetVidFileTrackStreamer methodsFor: 'initialize' stamp: 'jcg 7/27/2009 22:43'!
destroy
	super destroy.
	file ifNotNil: [file close. file := nil].! !

!QNetVidFileTrackStreamer methodsFor: 'initialize' stamp: 'jcg 7/27/2009 22:44'!
initializeForServer: serv track: tr
	super initializeForServer: serv track: tr.
	currentIndex := 0.
	file := FileStream readOnlyFileNamed: track mediaFilePath.
	file binary.! !

!QNetVidFileTrackStreamer methodsFor: 'playing/seeking' stamp: 'jcg 8/5/2010 16:38'!
playTo: mediaTime "in seconds"
	| targetCTS targetIndex |

	super playTo: mediaTime.
	(self checkMediaTime: mediaTime) ifFalse: [^self "warning was logged"].

	"Compute the Composition TimeStamp (i.e. display time) that we're searching for."
	targetCTS := mediaTime * track timeScale.
	targetIndex := self sampleIndexWithCTS: targetCTS.

	"Send the samples downstream, and update the current time/index.  Avoid reading from disk if nobody downstream is listening."
	pub isPaused ifFalse: [
		currentIndex + 1 to: targetIndex do: [:ind |
			pub sendData: (self datagramPayloadForSample: ind)
		].
	].

	"Because of non-zero CTS offset, the 'targetIndex' might be smaller than the 'currentIndex'.  Use the larger one so that we don't resend any frames the next time we call #playTo: "
	currentIndex := targetIndex max: currentIndex.
	currentTime := mediaTime.! !

!QNetVidFileTrackStreamer methodsFor: 'playing/seeking' stamp: 'jcg 11/30/2009 01:56'!
seekTo: mediaTime "in seconds"
	| targetCTS payload flags|

	super seekTo: mediaTime.

	"Compute the Composition TimeStamp (i.e. display time) that we're searching for."
	targetCTS := mediaTime * track timeScale.

	"XXXX: I'm not certain that these are the right values for currentIndex and currentTime.  I'm also not sure about clamping to a minimum of 1 (although if I don't, I'll get an error, so what choice is there?)"
	currentTime := mediaTime.
	currentIndex := (self sampleIndexWithCTS: targetCTS) max: 1.
	
	"If we're not a video track, there's nothing more to do."
	track isVideo ifFalse: [^self].

	"Update the currentTime/Index with the *real* time/index, corresponding to the nearest keyframe.  This way, we don't have to flush the decoder after when we start to play again."
	currentIndex := track indexOfPreviousRAP: currentIndex.
	currentIndex == 0 ifTrue: [
		"We couldn't find a keyframe before the specified time, so don't seek."
		QLogger logWarning: 'no keyframe to seek to time: ', mediaTime.
		currentTime := 0.
		^self.
	].
	currentTime := (track timeOfSample: currentIndex).

	"Obtain payload for the datagram we're about to send."
	payload := self datagramPayloadForSample: currentIndex.

	"Send the data downstream."
	pub sendData: payload.
! !

QNetVidFileTrackStreamer subclass: #QNetVidFileTrackStreamerAVC
	instanceVariableNames: 'avcConfig'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Server'!

!QNetVidFileTrackStreamerAVC commentStamp: '<historical>' prior: 0!
A slight specialization for munging NALU size values into AVC start-codes (don't do this if our 'avcConfig' is nil, eg: for Andreas' meeting-recording code).!

!QNetVidFileTrackStreamerAVC class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QNetVidFileTrackStreamerAVC methodsFor: 'private' stamp: 'jcg 11/30/2009 01:55'!
datagramPayloadForSample: sampleOrIndex "NHML sample, or integer index"
	| data |

	"Let superclass implementation do most of the work."
	data := super datagramPayloadForSample: sampleOrIndex.
	
	"Do a final bit of munging."
	avcConfig ifNotNil: [
		data := AVCHackingUtilities 
					replaceNaluSizes: avcConfig nalUnitSize 
					withStartCodeIn: data 
					startingAt: headerWriter headerSize +  1.
	].
	^data! !

!QNetVidFileTrackStreamerAVC methodsFor: 'private' stamp: 'ar 10/6/2009 16:41'!
handleInitialSampleRequest: node "an XMLNode"
	| index payload flags base64 |

	[
		"Find the nearest keyframe."
		index := track indexOfPreviousRAP: (currentIndex max: 1).

		"Let's pretend there is always a first frame to work around the issue of crashing in the MC decoder DLL. Should handle this elsewhere but this is a hot-fix for production that appears to do the job."
		index = 0 ifTrue:[index := 1].

		"We'll treat the inital sample as a seek."
		payload := self datagramPayloadForSample: index.
		flags := (payload at: 1) bitOr: 2. "seek flag"
		payload at: 1 put: flags.

		"Encode it for inclusion in XML."
		base64 := (Base64MimeConverter mimeEncode: payload readStream) contents.

		"Respond."
		^server generateCommand: 'initialSample' xmlBlock: [:writer |
			writer tag: 'ok' pcData: base64
		].
	] on: Error do: [:err |
		QLogger logWarning: 
			'failed to respond to initial sample request because: ', err description, '   
			(index/flags/payload-size: ', index, '/', flags, '/', (payload ifNotNil: [payload size]), ')'.
		^server 
			generateCommand: 'initialSample' 
			xmlBlock: [:writer | writer tag: 'failed' pcData: '']
	].! !

!QNetVidFileTrackStreamerAVC methodsFor: 'initialize' stamp: 'jcg 3/12/2009 00:14'!
initializeForServer: serv track: tr 
	super initializeForServer: serv track: tr.
	avcConfig := tr generateDecoderSpecificInfo.! !

!QNetVidFileTrackStreamerAVC methodsFor: 'private' stamp: 'ar 5/18/2010 16:06'!
trafficTag
	"Answer the traffic-tag used to describe streamed data."
	^TRouterConstants videoTag! !

QNetVidTrackStreamer subclass: #QNetVidLiveTrackStreamer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Server'!

!QNetVidLiveTrackStreamer commentStamp: '<historical>' prior: 0!
Plays out enqueued data produced by a live source.  The live-souce (aka the 'track') currently must be an instance of QSessionRecorderTrackUploader.  At some point, there should probably be a class QNetVidLiveTrack that defines the interface between the track and it's streamer, but I'm in a hurry, so they interact in an ad-hoc manner.

Doesn't support seeking (what would that even mean?) nor providing an 'initial frame' to newly-subscribed players.!

!QNetVidLiveTrackStreamer class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QNetVidLiveTrackStreamer methodsFor: 'private' stamp: 'jcg 11/30/2009 09:01'!
datagramPayloadForEncodedData: triple
	"The argument is a 3-element array containing:
		- the DTS/CTS of the encoded data 
			(they are the same because we currently don't do out-of-order encoding)
		- the 'isRAP' boolean
		- the encoded data (a ByteArray)."
	| headerSize dtsCts encoded isRAP payload |

	"Extract data from array."
	dtsCts := triple first.  "CTS/DTS are identical (no out-of-order encoding)."
	isRAP := triple second.
	encoded := triple third.

	"Configure the the header-writer."
	headerWriter cts: dtsCts dts: dtsCts.
	headerWriter dtsDelta: nil. "use the uniform increment specified in the TrackInfo"
	headerWriter isRAP: isRAP.
	headerSize := headerWriter headerSize.
	
	payload := ByteArray new: headerSize + encoded size.
	headerWriter writeInto: payload startingAt: 1.
	payload replaceFrom: headerSize+1 to: payload size with: encoded.

	^payload

	

! !

!QNetVidLiveTrackStreamer methodsFor: 'private' stamp: 'jcg 7/28/2009 11:30'!
handleInitialSampleRequest: node "an XMLNode"
	"We send an empty response: no initial sample is provided."
	^server generateCommand: 'initialSample' xmlBlock: [:writer |
		writer tag: 'ok' pcData: ''
	].
! !

!QNetVidLiveTrackStreamer methodsFor: 'playing/seeking' stamp: 'jcg 8/5/2010 16:38'!
playTo: mediaTime "in seconds"
	| targetCTS |

	super playTo: mediaTime.
	(self checkMediaTime: mediaTime) ifFalse: [^self "warning was logged"].

	"We assume that the CTS and DTS are the same (i.e. no out-of-order frames).  If we change how we encode eg: H.264, then we will need to revisit this assumptions."
	targetCTS := mediaTime * track info timeScale.

	[track nextDataAtOrBeforeCTS: targetCTS]
		whileNotNilDo: [:next |
			"Don't bother sending the data if nobody is listening.  We don't do this
			 outside of the loop because we need to burn through the queued data."
			pub isPaused ifFalse: [
				| payload |
				payload := self datagramPayloadForEncodedData: next.
				pub sendData: payload.
			].
		].

	currentTime := mediaTime.
	! !

!QNetVidLiveTrackStreamer methodsFor: 'playing/seeking' stamp: 'jcg 11/28/2009 22:05'!
seekTo: mediaTime
	self error: 'seeking is not permitted for live streams'.! !

!QNetVidLiveTrackStreamer methodsFor: 'private' stamp: 'ar 5/18/2010 16:06'!
trafficTag
	track isAudio ifTrue: [^TRouterConstants audioTag].
	track isVideo ifTrue: [^TRouterConstants videoTag].
	^TRouterConstants generalTag! !

!QNetVidTrackStreamer class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QNetVidTrackStreamer class methodsFor: 'instance creation' stamp: 'jcg 1/22/2009 17:34'!
forServer: server track: track 
	"For now, 'track' is a MP4BoxNHMLTrack (we might generalize this later).  'server' is a QNetworkVideoServer."
	^ self new initializeForServer: server track: track! !

!QNetVidTrackStreamer methodsFor: 'private' stamp: 'hrs 1/19/2010 16:47'!
channelPriority
	"Answer the channel priority used for this track."
	"XXXX: this is the desired value for AAC audio traffic (since we don't have a specific subclass for audio/AAC).  Subclasses override this."
	track isAudio ifTrue: [^10].
	track isVideo ifTrue: [^-10].
	^0.! !

!QNetVidTrackStreamer methodsFor: 'private' stamp: 'jcg 8/5/2010 17:51'!
checkMediaTime: mediaTime
	"Check if the specified media-time is OK.  If so, answer true, otherwise false.  Also, log warnings if time is invalid (but only a few, so we don't write millions of log-entries)."
	currentTime <= mediaTime ifTrue: [
		badTimeCount := 0. 
		^true. "OK!!"].
	
	"The media time is invalid... check if we need to log a warning message."
	badTimeCount := badTimeCount + 1.
	(badTimeCount < 5 or: [badTimeCount \\ 500 = 0]) ifTrue: [
		| msg |
		msg := 'currentTime exceeds mediaTime in stream: ', streamID shortHex.
		msg := msg, ' (', currentTime, ' vs. ', mediaTime, ')   attempt: ', badTimeCount.
		msg := msg, (track isAudio ifTrue: ['   audio'] ifFalse: ['   video']).
		QLogger logWarning: msg.
		"Stop if it's ridiculous."
		badTimeCount =  180000 "50 * 3600 * 20ms/tick = 1 hour" ifTrue: [
			QLogger logError: 'server destroyed after an hour by streamer: ', streamID hex.
			server ifNotNil: [:s | s future destroy]
		].
	].
	^false! !

!QNetVidTrackStreamer methodsFor: 'initialize' stamp: 'jcg 11/23/2009 13:14'!
connect
	"Answer a promise that will be resolved when our publication connects (or fails to).  See #connectWithTimeout:"
	^pub connectWithTimeout: 120000.! !

!QNetVidTrackStreamer methodsFor: 'initialize' stamp: 'jcg 7/27/2009 22:43'!
destroy
	pub ifNotNil: [pub destroy. pub := nil].! !

!QNetVidTrackStreamer methodsFor: 'private' stamp: 'jcg 3/12/2009 17:48'!
handleCommandDatagram: dgram
		^ [self handleParsedCommand: (server parseCommandDatagram: dgram)]
			on: Error 
			do: [:err |
				"Log the error, and generate an XML request
				(this might have been a request, not a command)."
				QLogger logError: 'failed to handle command datagram: ', err description.
				server generateCommand: 'user-error' xmlBlock: [:writer |
					writer tag: 'request-failure' pcData: err description, ' (in handler)'.
				].
			]! !

!QNetVidTrackStreamer methodsFor: 'private' stamp: 'jcg 3/12/2009 14:18'!
handleInitialSampleRequest: node "an XMLNode"
	self subclassResponsibility! !

!QNetVidTrackStreamer methodsFor: 'private' stamp: 'jcg 3/26/2009 16:34'!
handleParsedCommand: node "an XMLNode"
	"Implements responsibility specified by superclass."
	[
		^(node attributeAt: 'type') caseOf: {
			['initialSample'] -> [self handleInitialSampleRequest: node].
		}.
	] on: Error do: [:err |
		QLogger logError: 'error while handling command: ', String crlf, node.
		QLogger logError: err.
		^'<failed>unhandled error on track-streamer</failed>'
	].! !

!QNetVidTrackStreamer methodsFor: 'initialize' stamp: 'jcg 8/5/2010 16:32'!
initialize
	super initialize.
	headerWriter := QNetVidDatagramHeader new.
	badTimeCount := 0.! !

!QNetVidTrackStreamer methodsFor: 'initialize' stamp: 'ar 5/18/2010 16:35'!
initializeForServer: serv track: tr 
	"For now, 'track' is a MP4BoxNHMLTrack (we might generalize this later).  'server' is a QNetworkVideoServer."
	server := serv.
	track := tr.
	headerWriter timestampScale: track info timestampScale.
	publishID := TObjectID new.
	streamID := TCryptoRandom md5HashMessage: publishID.
	currentTime := 0.
	pub := server 
				publish: publishID 
				in: QControlStreamInput
				out: QControlStreamOutput
				commandHandler: [:dgram | self handleCommandDatagram: dgram]
				dataHandler: nil.
	pub trafficTag:  self trafficTag priority: self channelPriority.
	pub streamName: self class name, '-',  (TRouterConstants tagName: self trafficTag).! !

!QNetVidTrackStreamer methodsFor: 'testing' stamp: 'jcg 1/27/2009 18:50'!
isConnected
	^pub isConnected! !

!QNetVidTrackStreamer methodsFor: 'testing' stamp: 'jcg 10/15/2009 16:58'!
isStreamPaused
	^pub isPaused
! !

!QNetVidTrackStreamer methodsFor: 'playing/seeking' stamp: 'jcg 11/28/2009 22:03'!
playTo: mediaTime "in seconds"
	"Subclass must extend this method."
	headerWriter isSeek: false.
! !

!QNetVidTrackStreamer methodsFor: 'private' stamp: 'jcg 1/27/2009 18:04'!
sampleIndexWithCTS: ctsTarget
	"Answer the index of the sample whose Composition TimeStamp (i.e. display time) is the largest one <= 'ctsTarget'."
	| dtsIndex bestIndex bestValue halfRange startIndex endIndex |

	"The sample CTS values might not be monotonic, but the DTS values are.  Let's start there."
	dtsIndex := self sampleIndexWithDTS: ctsTarget.
	dtsIndex isZero ifTrue: [^0].

	"Set up a linear search over a range bounded by the maximum CTS-offset of the track.  Remember that we might need to search backward."
	halfRange := (track maxCTSOffset / track timeScale) ceiling.
	startIndex := dtsIndex - halfRange max: 1.
	endIndex := dtsIndex + halfRange min: track samples size.
	bestValue := bestIndex := 0.
	startIndex to: endIndex do: [:ind |
		| samp |
		samp := track samples at: ind.
		samp cts <= ctsTarget ifTrue: [
			(bestValue isNil or: [bestValue < samp cts]) ifTrue: [
				bestValue := samp cts.
				bestIndex := ind
			]
		].
	].
	^bestIndex 
! !

!QNetVidTrackStreamer methodsFor: 'private' stamp: 'jcg 8/13/2009 00:17'!
sampleIndexWithDTS: dtsTarget
	"Answer the index of the sample whose Decode TimeStamp is the largest one <= 'dtsTarget'."
	| ind |
	ind := track samples findNearbyBinaryIndex: [:val | dtsTarget - val dts].
	(ind between: 1 and: track samples size) ifFalse: [
		QLogger logWarning: 'DTS-index out of range: ', ind every: 5000.
		^0
	].
	(track samples at: ind) dts > dtsTarget ifTrue: [ind := ind - 1].
	^ind! !

!QNetVidTrackStreamer methodsFor: 'playing/seeking' stamp: 'jcg 11/28/2009 22:03'!
seekTo: mediaTime "in seconds"
	"Subclass must extend this method."
	headerWriter isSeek: true.
! !

!QNetVidTrackStreamer methodsFor: 'accessing' stamp: 'jcg 1/23/2009 03:19'!
track
	^track! !

!QNetVidTrackStreamer methodsFor: 'private' stamp: 'ar 5/18/2010 16:06'!
trafficTag
	"Answer the traffic-stage used to describe streamed data."
	"XXXX: this is the desired value for AAC audio traffic (since we don't have a specific subclass for audio/AAC).  Subclasses override this."
	^TRouterConstants audioTag! !

!QNetVidTrackStreamer methodsFor: 'xml' stamp: 'jcg 8/28/2009 23:48'!
writeXMLOn: xml "an XMLWriter"
	track info writeXMLOn: xml streamID: streamID.! !

!QNetVidTrackStreamer methodsFor: 'xml' stamp: 'ar 3/18/2009 15:20'!
xmlCodecType
	track isAVC ifTrue: [^'avc1'].
	track isAAC ifTrue: [^'AAC'].
	track isQSpeex ifTrue: [^'qspeex'].
	^'unknown'! !

Object subclass: #QPluginFeedbackChannel
	instanceVariableNames: 'sem semIndex handle loop typeMap eventHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-PluginFeedback'!

!QPluginFeedbackChannel commentStamp: '<historical>' prior: 0!
QPluginFeedbackChannel provides a framework for receiving arbitrary asynchronously-generated events from a Squeak VM plugin.  "Asynchronously-generated" means that these events are not created during execution of a primitive call.  For example, frames from a webcam are often generated by the driver in a separate thread; applications do not typically poll the webcam to ask if a new frame is available.

When an event becomes available, code within the plugin picks the appropriate channel (a plugin may of course have several) and places the event in a queue.  It then signals a semaphore, notifying a QPluginFeedbackChannel that there is a new event to process.  After finishing with the event, the channel waits on the semaphore for another event to arrive.

Even though plugins that use feedback-channels share the same C++ code, each plugin manages its own channels.  An alternative design that was considered was to have one plugin manage all channels, and have other plugins utilize these channels.  This was rejected because:
	- plugins would no longer be self-contained (i.e. unloading a plugin could affect other plugins)
	- no standard standard C++ API, so plugins must all be generated by the same compiler
Therefore, subclasses are required to implement 5 primitive methods:
	#primitiveCreateFeedbackChannel:semaphoreIndex:
	#primitiveDestroyFeedbackChannel:
	#primitiveGetEvent:
	#primitivePopEvent:
	#processEvent:type:
In addition, subclasses must also implement the methods
	#initializeTypeMap
	#processEvent:
The stubs in this class contain documentation about how subclasses should implement these methods.

!

!QPluginFeedbackChannel class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QPluginFeedbackChannel methodsFor: 'initialize' stamp: 'jcg 1/12/2008 11:19'!
createHandle
	handle := ExternalAddress new.
	self primitiveCreateFeedbackChannel: handle semaphoreIndex: semIndex.! !

!QPluginFeedbackChannel methodsFor: 'initialize' stamp: 'jcg 3/7/2008 11:45'!
destroy
	loop stop.
	handle ifNotNil: [
		self primitiveDestroyFeedbackChannel: handle.
		handle := nil.
	].
	semIndex ifNotNil: [
		Smalltalk unregisterExternalObject: sem.
		semIndex := nil.
	].! !

!QPluginFeedbackChannel methodsFor: 'initialize' stamp: 'jcg 6/12/2009 20:33'!
eventHandler: someObject
	"Specify an optional handler for feedback-events from this channel (in the old days, subclasses explicitly specify how to handle events... most examples are still like this)."
	eventHandler := someObject.
	(eventHandler respondsTo: #feedbackChannelTypeMap)
		ifTrue: [typeMap := eventHandler feedbackChannelTypeMap]
		ifFalse: [self initializeTypeMap "subclass responsibility"]! !

!QPluginFeedbackChannel methodsFor: 'private' stamp: 'jcg 7/27/2008 11:43'!
getEvent
	| bytes eventClass type |
	handle ifNil: [^nil].
	bytes := self primitiveGetEvent: handle.
	bytes ifNil: [^nil].
	type := bytes signedLongAt: 1.
	eventClass := type 
						caseOf: typeMap 
						otherwise: [self error: 'no event class registered for type: ', type].
	^ eventClass fromHandle: bytes
	
	

	! !

!QPluginFeedbackChannel methodsFor: 'accessing' stamp: 'jcg 1/12/2008 16:44'!
getHandle
	^handle! !

!QPluginFeedbackChannel methodsFor: 'private' stamp: 'jcg 1/12/2008 21:32'!
handleLoopError: err
	| errString |
	errString := String streamContents: [:strm |
		| stack |
		strm nextPutAll: 'LOOP ERROR: ', err; cr.
		stack := thisContext stackOfSize: 25.
		stack := stack copyFrom: 5 to: stack size. "exclude uninformative contexts"
		stack do: [:ctxt | strm tab; print: ctxt; cr]
	].
	QLogger log: errString from: self! !

!QPluginFeedbackChannel methodsFor: 'initialize' stamp: 'jcg 1/12/2008 20:59'!
initialize
	super initialize.
	sem := Semaphore new.
	semIndex := Smalltalk registerExternalObject: sem.
	self createHandle.
	self initializeTypeMap.

	loop := QSafeProcessLoop new.
	loop 
		priority: Processor lowIOPriority;
		actionBlock: [self processNextEvent];
		handlerBlock: [:err | self handleLoopError: err];
		start
		! !

!QPluginFeedbackChannel methodsFor: 'subclass responsibilities' stamp: 'jcg 1/12/2008 21:01'!
initializeTypeMap
	"Initialize 'typeMap' to a Dictionary<Integer->Class> that gives the approriate event class (a subclass of ExternalStructure) for the given type flag."
	self subclassResponsibility! !

!QPluginFeedbackChannel methodsFor: 'private' stamp: 'jcg 1/12/2008 20:46'!
popEvent
	self primitivePopEvent: handle! !

!QPluginFeedbackChannel methodsFor: 'subclass responsibilities' stamp: 'jcg 7/22/2008 01:59'!
primitive: hndl setLogging: trueOrFalse
	"Subclass responsibility (since we don't even know what plugin we want to talk to).  An implementation might look like:

primitive: hndl setLogging: trueOrFalse
	<primitive: 'primitiveFeedbackChannelSetLogging' module: 'QWebcamPlugin'>
	^self primitiveFailed "
	
	self subclassResponsibility! !

!QPluginFeedbackChannel methodsFor: 'subclass responsibilities' stamp: 'jcg 3/7/2008 11:42'!
primitiveCreateFeedbackChannel: bytes semaphoreIndex: semaphoreIndex
	"Fill 'bytes' with a pointer to a feedback channel.  Subclass responsibility (since we don't even know what plugin we want to talk to).  An implementation might look like:

	<primitive: 'primitiveCreateFeedbackChannel' module: 'QWebcamPlugin'>
	self primitiveFailed
"
	self subclassResponsibility! !

!QPluginFeedbackChannel methodsFor: 'subclass responsibilities' stamp: 'jcg 3/7/2008 11:43'!
primitiveDestroyFeedbackChannel: hndl
	"Subclass responsibility (since we don't even know what plugin we want to talk to).  An implementation might look like:

primitiveGetEvent: hndl
	<primitive: 'primitiveDestroyFeedbackChannel' module: 'QWebcamPlugin'>
	^self primitiveFailed "
	
	self subclassResponsibility! !

!QPluginFeedbackChannel methodsFor: 'subclass responsibilities' stamp: 'jcg 3/7/2008 11:42'!
primitiveGetEvent: hndl
	"Subclass responsibility (since we don't even know what plugin we want to talk to).  An implementation might look like:

primitiveGetEvent: hndl
	<primitive: 'primitiveFeedbackChannelReadEvent' module: 'QWebcamPlugin'>
	^self primitiveFailed "
	
	self subclassResponsibility! !

!QPluginFeedbackChannel methodsFor: 'subclass responsibilities' stamp: 'jcg 3/7/2008 11:42'!
primitivePopEvent: hndl
	"Subclass responsibility (since we don't even know what plugin we want to talk to).  An implementation might look like:

primitivePopEvent: handle
	<primitive: 'primitiveFeedbackChannelPopEvent' module: 'QWebcamPlugin'>
	^self primitiveFailed "
	
	self subclassResponsibility! !

!QPluginFeedbackChannel methodsFor: 'subclass responsibilities' stamp: 'jcg 6/12/2009 20:20'!
processEvent: event "subclass of ExternalStructure"
	"Subclasses must decide to do with the 'event', a sub-instance of ExternalStructure.  As a convenience to the plugin writer, the plugin hangs on to its event until Squeak code explicitly pops it off the queue (via #primitivePopEvent:).  Therefore, for the duration of this method we can count on the C++ event object continuing to exist within the plugin; we can access resources held by the event (for example, a video frame read from a DirectShow webcam), and have those resources automatically cleaned up when the event is popped."
	eventHandler
		ifNil: [QLogger logWarning: 'no handler available for event' every: 5000] 
		ifNotNilDo: [:h | ^h processFeedbackChannelEvent: event from: self].
! !

!QPluginFeedbackChannel methodsFor: 'private' stamp: 'jcg 3/7/2008 11:46'!
processNextEvent
	| event |

	"Wait for signal; check for early-exit conditions."
	sem waitTimeoutMSecs: 500.
	loop isRunning ifFalse: [^self "loop was stopped while we were waiting"].

	"Obtain the event from the plugin, process it, and release it when we're done."
	event := self getEvent.
	event ifNil: [^self].
	[self processEvent: event] ensure: [self popEvent].
! !

!QPluginFeedbackChannel methodsFor: 'accessing' stamp: 'jcg 1/9/2008 21:53'!
semaphore
	^sem! !

!QPluginFeedbackChannel methodsFor: 'accessing' stamp: 'jcg 1/9/2008 21:53'!
semaphoreIndex
	^semIndex! !

!QPluginFeedbackChannel methodsFor: 'initialize' stamp: 'jcg 7/22/2008 02:00'!
setLogging: trueOrFalse
	handle ifNotNil: [self primitive: handle setLogging: trueOrFalse]! !

Object subclass: #QSessionRecorderFinalizer
	instanceVariableNames: 'cacheDir docPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Recorder'!

!QSessionRecorderFinalizer commentStamp: 'jcg 4/15/2010 00:26' prior: 0!
Factored out from QSessionRecorder so that it can also be used to recover session-recordings if eg: the Squeak image is killed and restarted in the middle of a recording.!

!QSessionRecorderFinalizer class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QSessionRecorderFinalizer methodsFor: 'actions' stamp: 'jcg 4/15/2010 10:05'!
addTrackToMP4: nhmlFilePath
	cacheDir ifNil: [self error: 'no cache-dir specified'].
	MP4Box add: nhmlFilePath to: 'MP4Box-SessionRecording.mp4'! !

!QSessionRecorderFinalizer methodsFor: 'accessing' stamp: 'jcg 4/15/2010 11:28'!
cacheDir
	"Answer the path to the directory where the NHML files reside."
	^cacheDir! !

!QSessionRecorderFinalizer methodsFor: 'initialize' stamp: 'jcg 4/15/2010 00:48'!
cacheDir: cacheDirPath
	"Set the directory-path where the intermediate session-recording files are stashed."
	cacheDir := cacheDirPath.
	(FileDirectory on: cacheDir) assureExistence.
! !

!QSessionRecorderFinalizer methodsFor: 'accessing' stamp: 'jcg 4/15/2010 11:28'!
docPath
	"Answer the path of the final MP4 file."
	^docPath! !

!QSessionRecorderFinalizer methodsFor: 'initialize' stamp: 'jcg 4/15/2010 00:46'!
docPath: mp4FilePath
	"Set the path where the resulting MP4 file will finally reside."
	docPath := mp4FilePath.! !

!QSessionRecorderFinalizer methodsFor: 'actions' stamp: 'jcg 4/15/2010 09:57'!
finalizeRecording
	cacheDir ifNil: [self error: 'no cache-dir specified'].
	docPath ifNil: [self error: 'no path specified for the final MP4'].! !

!QSessionRecorderFinalizer methodsFor: 'actions' stamp: 'jcg 4/15/2010 01:12'!
readMetadata
	"Used when we're recovering an interrupted session-recording."
	| file |
	[file := (FileDirectory on: cacheDir) readOnlyFileNamed: 'metadata.xml']
		on: FileDoesNotExistException 
		do: [QLogger logWarning: 'failed to find metadata.xml'.
			 ^docPath := nil].
	
	[	| xml version |
		xml := XMLDOMParser parseDocumentFrom: file.
		xml := xml elementAt: 'SessionRecording'.
		xml ifNil: [self error: 'no <SessionRecording> element'].
		version := xml attributeAt: 'version'.
		version ifNil: [self error: 'no version specified'].
		version := version asInteger.
		QLogger logInfo: 'Reading session-recording metadata, version ', version.
		version >=1 ifFalse: [self error: 'version must be >= 1'].
		docPath := xml contentStringAt: 'docPath'.
		docPath ifEmpty: [
			docPath := nil.
			self error: 'no <docPath> specified'.
		].
	] ensure: [file close].
! !

!QSessionRecorderFinalizer methodsFor: 'actions' stamp: 'jcg 4/15/2010 11:27'!
renameCacheDirUsingSHA
	"We already have the necessary .nhml files to play the new MP4; it would be a shame not to use them.  Now that we have the MP4, we can compute it's SHA and rename the cacheDirectory so that the regular MP4-playing machinery will use it."
	| file sha | 

	[file := FileStream readOnlyFileNamed: docPath]
		on: Error do: [:err |
			QLogger logError: 'failed to open newly-generated MP4: ', docPath.
			QLogger logError: err.
			^self		
		].
	[sha := TContentManager generateSHA: file] ensure: [file close].
	QLogger logInfo: 'renaming cache-dir to: ', sha, '    (was: ', cacheDir, ')'.
	(FileDirectory on: cacheDir) containingDirectory rename: cacheDir toBe: sha.
! !

!QSessionRecorderFinalizer methodsFor: 'actions' stamp: 'jcg 4/15/2010 12:01'!
renameNewMP4
	"We just created a new MP4 in the cache-directory.  Rename/move it to its final location."
	| dir |
	dir := FileDirectory on: cacheDir.
	(dir fileExists: 'MP4Box-SessionRecording.mp4') ifFalse: [
		self error: 'MP4Box-SessionRecording.mp4 does not exist in ', cacheDir
	].
	dir rename: 'MP4Box-SessionRecording.mp4' toBe: docPath.
	(FileDirectory default fileExists: docPath)	ifFalse: [
		self error: 'failed to rename MP4 to final location: ', docPath
	].! !

!QSessionRecorderFinalizer methodsFor: 'private' stamp: 'jcg 4/16/2010 12:38'!
repairAndFinalizeTrack: file "a FileStream on a .nhml file"
	QLogger logInfo: 'processing .nhml file: ', file fullName.

	"Ensure that file is properly terminated with a </NHNTStream> tag."
	file setToEnd.
	(file backUpTo: '/>') ifFalse: [^QLogger logWarning: '.nhml file has no samples'].
	((file skipTo: $<) and: [(file next: 12) = '/NHNTStream>']) ifFalse: [
		"Doesn't end in </NHNTStream>, so let's tack one on."
		QLogger logInfo: '.nhml file is not properly terminated... fixing'.
		file backUpTo: '/>'.
		file crlf; nextPutAll: '</NHNTStream>'; crlf.
		file truncate: file position.
		file flush.
	].
		
	"Add the track to the final MP4."
	self addTrackToMP4: file fullName.
! !

!QSessionRecorderFinalizer methodsFor: 'actions' stamp: 'jcg 4/16/2010 17:11'!
repairTracksAndFinalizeRecording
	| dir fileNames |
	self readMetadata.
	dir := FileDirectory on: cacheDir.
	fileNames := dir fileNames select: [:fn | fn endsWith: '.nhml'].

	"Sort the names to ensure that the video-tracks come before the audio-tracks...
	 for some undocumented reason, MP4Box requires this to be so." 
	fileNames sort: [:a :b | a > b].

	fileNames do: [:fn |
		| file |
		file := nil.
		[
			file := dir oldFileNamed: fn.
			self repairAndFinalizeTrack: file.
		] ensure: [file ifNotNil: [file close]].
	].

	self renameNewMP4.
	self renameCacheDirUsingSHA.
! !

!QSessionRecorderFinalizer methodsFor: 'actions' stamp: 'jcg 4/15/2010 12:52'!
writeMetadata
	"Used so that we can later recover an interrupted session-recording."
	| file |

	"Writing the docPath is the whole point, so it's an error if we don't have one."
	docPath ifNil: [self error: 'no docPath is available'].

	[file := (FileDirectory on: cacheDir) forceNewFileNamed: 'metadata.xml']
		on: FileDoesNotExistException 
		do: [self error: 'could not create metadata.xml in: ', cacheDir].

	[	| xml |
		xml := XMLWriterIndenting on: file.
		xml 
			xmlDeclaration: '1.0';
			startTag: 'SessionRecording'; attribute: 'version' value: '1'; endTag;
				tag: 'docPath' value: docPath;
			endTag: 'SessionRecording'.
	] ensure: [file close].
! !

Object subclass: #QStopwatch
	instanceVariableNames: 'state epoch elapsed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Client'!

!QStopwatch commentStamp: '<historical>' prior: 0!
Keeps track of time in milliseconds.!

!QStopwatch class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QStopwatch methodsFor: 'accessing' stamp: 'jcg 5/12/2010 09:30'!
elapsed
	"Rollover-proof as long as you query more often than once every several days."
	| now sinceEpoch |

	state == #start ifFalse: [^elapsed "clock isn't running"].

	now := self underlyingClockTime.
	sinceEpoch := Time milliseconds: now since: epoch.
	"Check if we need anti-rollover adjustment."
	^ (sinceEpoch > (SmallInteger maxVal // 2) )
		ifFalse: [elapsed + sinceEpoch]
		ifTrue: [
			"Adjust to avoid rollover errors."
			QLogger logInfo: 'preemptively adjusted to avoid clock roll-over'.
			elapsed := elapsed + sinceEpoch.
			epoch := now.
			elapsed
		].
! !

!QStopwatch methodsFor: 'accessing' stamp: 'jcg 2/11/2009 18:23'!
elapsed: newTime
	| savedState |
	savedState := state.
	self stop.
	elapsed := newTime.
	savedState == #start ifTrue: [self start].! !

!QStopwatch methodsFor: 'initialize' stamp: 'jcg 2/11/2009 18:01'!
initialize
	state := #stop.
	elapsed := 0.! !

!QStopwatch methodsFor: 'testing' stamp: 'jcg 6/22/2010 18:36'!
isRunning
	^state == #start! !

!QStopwatch methodsFor: 'printing' stamp: 'jcg 2/11/2009 18:20'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	(Duration milliSeconds: self elapsed) printOn: aStream.
	aStream nextPut: $).! !

!QStopwatch methodsFor: 'actions' stamp: 'jcg 2/11/2009 18:23'!
reset
	self elapsed: 0.! !

!QStopwatch methodsFor: 'actions' stamp: 'jcg 4/13/2010 10:58'!
start
	state == #start ifTrue: [^self].
	state := #start.
	epoch := self underlyingClockTime.
! !

!QStopwatch methodsFor: 'actions' stamp: 'jcg 4/13/2010 10:59'!
stop
	state == #stop ifTrue: [^self].
	elapsed := self elapsed.
	state := #stop.
	epoch := nil.
! !

!QStopwatch methodsFor: 'accessing' stamp: 'hrs 5/3/2010 10:53'!
underlyingClockTime
	"Answer a time in millseconds from the underlying source clock.  Factored out into a separate method so that we can do unit tests in a subclass."
	"NOTE: use old primitive, which won't ever go back in time."
	^Time  millisecondClockValue! !

Object subclass: #QStreamingVideoV1FileCardContents
	instanceVariableNames: 'streamID videoExtent videoCodec userName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-Texture'!

!QStreamingVideoV1FileCardContents commentStamp: '<historical>' prior: 0!
Contents for a QFileCard of type #streamingVideoV1

Once initialized, a QStreamingVideoDescription is intended to be immutable.

We have a weird double-role for this class.  We need to remain backward-compatible to circa-1.1.36 clients, so we continue to use this as the contents of webcam FileCards.  In particular, the streamID is used to specify which stream to connect to.

In later clients, instances are used in two places:
	- in the per-Forum video stream registry (QVideoRegistry)
	- in "filecards" (in panels, etc), just as in 1.1.36 and earlier.
This way, forums saved in a new client still work with 1.1.36.  However, we treat the two uses differently.  In the registry, instances describe everything about the stream: where to find it (streamID), how to decode it (codec type and extent), and who published it.  In file-cards/panels, the only important part is who is publishing the video (used to look up the real info in the registry).!

!QStreamingVideoV1FileCardContents class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QStreamingVideoV1FileCardContents class methodsFor: 'copying' stamp: 'crl 12/18/2009 16:45'!
howToPassAsArgument
	"Copy array-like objects by default"
	^#passByCopy:! !

!QStreamingVideoV1FileCardContents methodsFor: 'comparing' stamp: 'jcg 1/31/2008 19:13'!
= other
	self class == other class ifFalse: [^false].
	streamID = other streamID ifFalse: [^false].
	videoExtent = other videoExtent ifFalse: [^false].
	videoCodec = other videoCodec ifFalse: [^false].
	userName = other userName ifFalse: [^false].
	^true! !

!QStreamingVideoV1FileCardContents methodsFor: 'accessing' stamp: 'ar 9/3/2010 12:04'!
computeHashedName
	"Compute the thumbnail texture SHA for displaying the preview image for the video stream."
	^ (SecureHashAlgorithm new 
		hashStream: (ReadStream on: userName squeakToUtf8)) radix:36
! !

!QStreamingVideoV1FileCardContents methodsFor: 'accessing' stamp: 'jcg 2/3/2008 12:07'!
computeSHA
	"Compute the thumbnail texture SHA for displaying the live video stream.  Don't base SHA on streamID, since it changes each time the camera is stopped/started."
	^ TContentManager generateSHA: userName, videoExtent, videoCodec! !

!QStreamingVideoV1FileCardContents methodsFor: 'persist' stamp: 'jcg 2/15/2008 15:30'!
constructFrom: pStream
	streamID := TObjectID nilObjectID.  "The streamID will be invalid anyway, so just clear it."
	videoExtent := pStream readPoint: 'videoExtent' default: nil.
	videoCodec := pStream readString: 'videoCodec' default: nil.

	"XXXXX: Transition: renaming 'description' to 'userName'.  We continue to persist using the 'description' field, but once we start writing 'userName' instead (after there are no 1.1.36 clients in use), we will be ready for it."
	userName := pStream readString: 'description' default: ''.
	userName := pStream readString: 'userName' default: userName.
! !

!QStreamingVideoV1FileCardContents methodsFor: 'comparing' stamp: 'jcg 1/31/2008 18:59'!
hash
	^ streamID hash bitXor: (videoExtent hash bitXor: (videoCodec hash bitXor: userName hash))! !

!QStreamingVideoV1FileCardContents methodsFor: 'initialize' stamp: 'jcg 1/31/2008 14:23'!
initializeStreamID: sID extent: extent codec: codec userName: nameString
	streamID := sID.
	videoExtent := extent.
	videoCodec := codec.
	userName := nameString! !

!QStreamingVideoV1FileCardContents methodsFor: 'persist' stamp: 'jcg 2/15/2008 15:28'!
persistOn: pStream

	"The streamID will generally be nonsense (we use a QVideoRegistry to find the current streamID); emphasize this by zeroing it out."
	pStream storeUUID: 'streamID' value: TObjectID nilObjectID.

	pStream storePoint: 'videoExtent' value: videoExtent.
	pStream storeString: 'videoCodec' value: videoCodec.

	"XXXXX: Transition: renaming 'description' to 'userName'.  We continue to persist using the 'description' field, but we can start writing 'userName' instead (after there are no 1.1.36 clients in use)."
	pStream storeString: 'description' value: userName.
! !

!QStreamingVideoV1FileCardContents methodsFor: 'copying' stamp: 'jcg 1/31/2008 14:32'!
postCopy
	streamID := streamID copy.
	videoExtent := videoExtent copy.
	videoCodec := videoCodec copy.
	userName := userName copy.! !

!QStreamingVideoV1FileCardContents methodsFor: 'accessing' stamp: 'jcg 5/20/2010 16:51'!
sessionID
	"So that we're polymorphic with QWebcastRecord (as far as QClientVideoTexture is concerned).  Also see QStreamingVideoDecoder>>sessionID."
	^streamID! !

!QStreamingVideoV1FileCardContents methodsFor: 'accessing' stamp: 'jcg 9/15/2007 15:28'!
streamID
	^streamID! !

!QStreamingVideoV1FileCardContents methodsFor: 'accessing' stamp: 'jcg 9/15/2007 15:28'!
streamID: aTObjectID
	streamID := aTObjectID! !

!QStreamingVideoV1FileCardContents methodsFor: 'accessing' stamp: 'jcg 1/31/2008 14:40'!
userName
	^userName! !

!QStreamingVideoV1FileCardContents methodsFor: 'accessing' stamp: 'jcg 9/15/2007 15:30'!
videoCodec
	"Answer a String specifying the codec to use (eg: 'jpeg', 'avc1')."
	^videoCodec! !

!QStreamingVideoV1FileCardContents methodsFor: 'accessing' stamp: 'jcg 9/15/2007 15:31'!
videoCodec: codecString
	"Set a String specifying the codec to use (eg: 'jpeg', 'avc1')."
	videoCodec := codecString! !

!QStreamingVideoV1FileCardContents methodsFor: 'accessing' stamp: 'jcg 9/15/2007 15:29'!
videoExtent
	"Answer a Point describing the width and height of the video."
	^videoExtent! !

Object subclass: #QTSSRTPFileParser
	instanceVariableNames: 'version duration sdp tracks maxTrackID blockMap packets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-MP4'!

!QTSSRTPFileParser commentStamp: 'jcg 4/30/2009 11:41' prior: 0!
Work-in-progress from Dec 2008... we ended up going in a different direction, but this might still come in handy, so I don't want to throw it away.

NOTES:
- not clear that we always want little-endian (that's just what I'm currently observing)

EXAMPLE USE (rescued from a Workspace):
p := QTSSRTPFileParser new parse: (FileStream readOnlyFileNamed: 'StarWars.mov.rtp').
p writeToFile2: 'reconstituted.mp4'

packets := p packets select: [:p | p notNil].
str := WriteStream on: (ByteArray new: 100).
packets do: [:pack | pack first == 200 ifTrue: [str nextPutAll: pack fourth]].
str contents size
str := nil.

extent := 640@480.
args := QVideoArgs new usePlatformEndianness.
args codecType: 'avc1'.
args timeScale: 3000.
args width: extent x.
args height: extent y.
args bitRate: 80000.
args fps: 10.0.

dec := QVideoDecoderMC withArgs: args extent: extent.
blk := [:form | form displayAt: 0@0].
dec runScript: #value: when: {dec. #decodedFrame}.

packets do: [:pack | 
	pack first == 200 ifTrue: [
		dec decode: packets fourth offset: 0.  
		(Delay forMilliseconds: 100) wait.
	].
].


orig := (FileStream readOnlyFileNamed: 'StarWars.mov.rtp') binary; contents.
orig size
!

!QTSSRTPFileParser class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QTSSRTPFileParser methodsFor: 'accessing' stamp: 'jcg 12/20/2008 00:23'!
packets
	^packets! !

!QTSSRTPFileParser methodsFor: 'initialize' stamp: 'jcg 12/18/2008 17:48'!
parse: aStream
	self parse: aStream bigEndian: false.
! !

!QTSSRTPFileParser methodsFor: 'initialize' stamp: 'jcg 12/18/2008 23:40'!
parse: aStream bigEndian: bigEndian
	| intBuf floatBuf sdpLen numTracks blockMapSize dataStartPos blockStart |

	aStream binary.
	intBuf := ByteArray new: 4.
	floatBuf := ByteArray new: 8.

	aStream nextInto: intBuf.
	version := intBuf unsignedLongAt: 1 bigEndian: bigEndian.

	aStream nextInto: floatBuf.
	duration := floatBuf doubleAt: 1 bigEndian: bigEndian.

	aStream nextInto: intBuf.
	sdpLen := intBuf unsignedLongAt: 1 bigEndian: bigEndian.

	aStream nextInto: intBuf.
	numTracks := intBuf unsignedLongAt: 1 bigEndian: bigEndian.

	aStream nextInto: intBuf.
	maxTrackID := intBuf unsignedLongAt: 1 bigEndian: bigEndian.

	aStream nextInto: intBuf.
	blockMapSize := intBuf unsignedLongAt: 1 bigEndian: bigEndian.

	aStream nextInto: intBuf.
	dataStartPos := intBuf unsignedLongAt: 1 bigEndian: bigEndian.

	sdp := aStream next: sdpLen.
	sdp := sdp asString.

	tracks := (1 to: numTracks) collect: [:z | self parseTrackHeader: aStream bigEndian: bigEndian].
	
	blockMap := aStream next: blockMapSize.

	packets := OrderedCollection new.

	blockStart := dataStartPos.
	blockMapSize timesRepeat: [
		aStream position: blockStart.
		self parsePackets: aStream bigEndian: bigEndian. "will add directly to 'packets' iVar"
		blockStart := blockStart + 32768.
	].! !

!QTSSRTPFileParser methodsFor: 'initialize' stamp: 'jcg 12/18/2008 19:01'!
parsePackets: aStream bigEndian: bigEndian

	| shortBuf floatBuf trackID packetLength transmitTime payload |

	shortBuf := ByteArray new: 2.
	floatBuf := ByteArray new: 8.

	[
		aStream nextInto: shortBuf.
		trackID := shortBuf unsignedShortAt: 1 bigEndian: bigEndian.
		trackID >= 32768 ifTrue:  [^packets add: nil "padding at end of block"].

		aStream nextInto: shortBuf.
		packetLength := shortBuf unsignedShortAt: 1 bigEndian: bigEndian.

		aStream nextInto: floatBuf.
		transmitTime := floatBuf doubleAt: 1 bigEndian: bigEndian.

		payload := aStream next: packetLength.
		packets add: {trackID. packetLength. transmitTime. payload}.
	] repeat.

! !

!QTSSRTPFileParser methodsFor: 'initialize' stamp: 'jcg 12/18/2008 18:49'!
parseTrackHeader: aStream bigEndian: bigEndian
	| buf32 buf64 trackID timeScale bytesInTrack duration |

	buf32 := ByteArray new: 4.
	buf64 := ByteArray new: 8.

	aStream nextInto: buf32.
	trackID := buf32 unsignedLongAt: 1 bigEndian: bigEndian.

	aStream nextInto: buf32.
	timeScale := buf32 unsignedLongAt: 1 bigEndian: bigEndian.

	aStream nextInto: buf64.
	bytesInTrack := buf64 unsignedLongLongAt: 1 bigEndian: bigEndian.

	aStream nextInto: buf64.
	duration := buf64 doubleAt: 1 bigEndian: bigEndian.

	^{trackID. timeScale. bytesInTrack. duration}! !

!QTSSRTPFileParser methodsFor: 'writing' stamp: 'jcg 12/19/2008 00:00'!
writeToFile2: fileName
	| file pckts | 
	file := FileStream forceNewFileNamed: fileName.
	[ | p1 p2 |
		pckts := packets reject: [:p | p isNil].
		p1 := OrderedCollection new.
		p2 := OrderedCollection new.
		pckts do: [:p | p first = 100 ifTrue: [p1 add: p] ifFalse: [p2 add: p]].
		p1 do: [:p | file nextPutAll: p fourth].
		p2 do: [:p | file nextPutAll: p fourth].
	] ensure: [file close].! !

!QTSSRTPFileParser methodsFor: 'writing' stamp: 'jcg 12/18/2008 23:53'!
writeToFile: fileName
	| file | 
	file := FileStream forceNewFileNamed: fileName.
	[
		packets do: [:p | p ifNotNil: [file nextPutAll: p fourth]].
	] ensure: [file close].! !

Object subclass: #QTestRTPProcessorAAC
	instanceVariableNames: 'mediaDescription streamType mode constantSize hasRapFlag bitsForSize bitsForIndexLength bitsForIndexDeltaLength bitsForAuxiliaryDataSize accessUnits'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-RTP-Test'!

!QTestRTPProcessorAAC commentStamp: 'jcg 9/10/2009 10:02' prior: 0!
===========================================
Sample usage (assumes you have QTSS running on your local machine)
===========================================

resource := 'sample_h264_300kbit.mp4'.

local := RtspClientSession new hostName: 'localhost:554' resourceName: resource.
options := local options.
describe := local describe.
setup := local setupMultiple: describe wait mediaDescriptions.
setup wait.

audioClient := setup value detect: [:client | client isAudio].
videoClient := setup value detect: [:client | client isVideo].

local play.  "for as long as you want"
local pause.

audioPackets := OrderedCollection new.
[audioClient rtpPackets nextOrNil] whileNotNilDo: [:pkt | audioPackets add: pkt].
sound := QTestRTPProcessorAAC
			processPackets: audioPackets
			mediaDescription: audioClient mediaDescription.
sound play.

local destroy.  "clean up"!

!QTestRTPProcessorAAC class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QTestRTPProcessorAAC class methodsFor: 'utility' stamp: 'jcg 9/9/2009 15:05'!
processPackets: packets mediaDescription: desc
	"
	Assumptions: 
		- no out-of-order packets, no gaps (sequenceNumber increases by 1 each time)
		- no interleaving (timestamps increase monotonically)
		- each AU is constant number of audio samples
		- audio is AAC-hbr
"
	| newGuy |
	newGuy := self new.
	^newGuy processPackets: packets mediaDescription: desc.
! !

!QTestRTPProcessorAAC class methodsFor: 'utility' stamp: 'jcg 9/9/2009 10:14'!
processPacketsFrom: rtpClient
	"
	Assumptions: 
		- no out-of-order packets, no gaps (sequenceNumber increases by 1 each time)
		- no interleaving (timestamps increase monotonically)
		- each AU is constant number of audio samples
		- audio is AAC-hbr
"
	| packets  |
	packets := OrderedCollection new.
	[rtpClient rtpPackets nextOrNil] whileNotNilDo: [:p | packets add: p].
	^self processPackets: packets mediaDescription: rtpClient mediaDescription.
! !

!QTestRTPProcessorAAC methodsFor: 'private' stamp: 'jcg 9/10/2009 00:23'!
processPacket: packet "an RtpPacket"
	| payload bits headersLength headersCount units currentUnit |
		payload := packet payload.
		bits := QBigEndianBitStream on: payload.

		"Obtain AU-headers-length. "
		headersLength := bits next: 16.
		(headersLength \\ 16) = 0 ifFalse: [
			"For AAC-hbr, must be a multiple of 16 bits (see RFC 3640 section 3.3.6)"
			self error: 'AU-headers must be 16-bits long for AAC-hbr'.
		].
		headersCount := headersLength // 16.
	
		"Obtain the length each AU in bytes."
		units := OrderedCollection new.
		currentUnit := nil.
		headersCount timesRepeat: [
			currentUnit := self readRfc3640AccessUnitHeader: bits previousUnit: currentUnit.
			units add: currentUnit.
		].
		bits burnUpToByteBoundary.

		"Also see #readFmtp:"
		bitsForAuxiliaryDataSize = 0 ifFalse: [
			self error: 'The "auxiliaryDataSizeLength" parameter is not yet supported'
		].

		"Obtain the data for each access unit."
		units do: [:au | au payload: (bits nextBytes: au size)].

		^units
! !

!QTestRTPProcessorAAC methodsFor: 'as yet unclassified' stamp: 'jcg 9/10/2009 01:54'!
processPackets: packets mediaDescription: desc
	"
	Assumptions: 
		- no out-of-order packets, no gaps (sequenceNumber increases by 1 each time)
		- no interleaving (timestamps increase monotonically)
		- each AU is constant number of audio samples
		- audio is AAC-hbr
"
	| samplesPerAU samplingRate stream dec buf sound |


	"Sanity checks."
	desc codecConfig numChannels = 1 ifFalse: [self error: 'only handle 1-channel audio'].

	"Always use lower-case keys.  See comment in SDPMediaDescription#fmtp."
	self readFmtp: desc fmtp.

	"Obtain encoded AAC frames."
	accessUnits := OrderedCollection new.
	packets do: [:p | accessUnits addAll: (self processPacket: p)].

	"XXXXX: Not sure about this at all.  What happens for a multi-channel source?  We mix down to mono in the decoder, so the samples received from the decoder would be less.  Urg."
	QLogger logWarning: 'assuming 1024 samples per AAC Access-Unit'.
	samplesPerAU := 1024.

	"Get the sampling rate.  There are multiple ways to do this (i.e. could also
	 interpret the audioSpecificConfig); this one is easy."
	samplingRate := desc attributes at: 'rtpmap'. 
	samplingRate := samplingRate findTokens: Character separators, '/'.
	samplingRate := samplingRate third asNumber.

	"Decode the frames."
	dec := QAudioDecoderAAC new.
	dec createHandle: desc codecConfig bytes.
	"mono because we set decoder to mix down to mono"
	buf := SoundBuffer newMonoSampleCount: samplesPerAU. 
	stream := WriteStream on: (SoundBuffer newMonoSampleCount: samplesPerAU).
	accessUnits do: [:au | dec decode: au payload into: buf. stream nextPutAll: buf].
	dec destroy.
	sound := SampledSound samples: stream contents samplingRate: samplingRate.
	
	^sound

	! !

!QTestRTPProcessorAAC methodsFor: 'private' stamp: 'jcg 9/10/2009 00:16'!
readFmtp: fmtp "a Dictionary, as from aSDPMediaDescription fmtp"
	| mode |

	"Required MIME parameters (RFC3640 Section 4.1): 
		streamType
		profile-level-id
		config
		mode
	"
	streamType := fmtp at: 'streamtype' ifAbsent: [self error: 'missing MIME "streamType"'].

	"Double-check that these 2 appear, even though we don't use them directly."
	fmtp at: 'profile-level-id' ifAbsent: [self error: 'missing MIME "profile-level-id"'].
	fmtp at: 'config' ifAbsent: [self error: 'missing MIME "config"'].	

	mode := fmtp at: 'mode' ifAbsent: [self error: 'missing mode parameter'].
	(mode = 'AAC-hbr') ifFalse: [
		"We only support AAC-hbr, sorry."
		self error: 'mode parameter expected to be "AAC-hbr", not "', mode, '"'
	].

	"Optional MIME parameters (RFC3640 Section 4.1):
		objectType
		constantSize
		constantDuration
		maxDisplacement
		deinterleaveBufferSize
		sizeLength
		indexLength
		indexDeltaLength
		randomAccessIndication
		streamStateIndication
		auxiliaryDataSizeLength
	"
	"Skip 'objectType'."

	"One of 'constantSize' and 'sizeLength' must be present (I think!!), but not
	 both (see RFC3640-4.1)."
	constantSize := (fmtp at: 'constantsize' ifAbsent: [0]) asInteger.
	bitsForSize := (fmtp at: 'sizelength' ifAbsent: [0]) asInteger.
	bitsForIndexLength := (fmtp at: 'indexlength' ifAbsent: [0]) asInteger.
	bitsForIndexDeltaLength := (fmtp at: 'indexdeltalength' ifAbsent: [0]) asInteger.
	(constantSize isZero xor: bitsForSize isZero) ifFalse: [
		self error: 'Exactly one of "constantSize" and "sizeLength" must be present'.
	].

	"XXXXX: UNSUPPORTED!!"
	(fmtp includesKey: 'constantduration') ifTrue: [
		self error: 'The "constantDuration" parameter is not yet supported'.
	].
	(fmtp includesKey: 'ctsdeltalength') ifTrue: [
		"If we change this, also see #readRfc3640AccessUnitHeader:previousUnit: "
		self error: 'The "CTSDeltaLength" parameter is not yet supported'.
	].
	(fmtp includesKey: 'dtsdeltalength') ifTrue: [
		"If we change this, also see #readRfc3640AccessUnitHeader:previousUnit: "
		self error: 'The "DTSDeltaLength" parameter is not yet supported'.
	].
	hasRapFlag := false.
	fmtp at: 'randomaccessindication' ifPresent: [:rap | 
		rap = '0' ifFalse: [self error: 'RAP-flag is not yet supported'].
	].
	bitsForAuxiliaryDataSize := 0.
	fmtp at: 'auxilarydatasizelength' ifPresent: [:len |
		len = '0' ifFalse: [
			self error: 'The "auxiliaryDataSizeLength" parameter is not yet supported'.
		].
	].

	fmtp at: 'streamstateindication' ifPresent: [:ssi |
		"XXXXX: we know that this predicate is true (since we're AAC), but
		 I'll probably be factoring this into a superclass at some point, at
		 which point this test will become necessary (assuming that we
		 eventually support MP4 Systems Streams: see RFC3640-4.1)"
		(mediaDescription isAudio or: [mediaDescription isVideo]) ifTrue: [
			self error: '"streamStateIndication" is not compatible with audio/video streams'.
		].
	].

	"We don't support interleaving to ameliorate packet loss."
	(fmtp keys includesAnyOf: #('maxdisplacement' 'de-interleavebuffersize')) 
		ifTrue: [
			"The 'maxDisplacement' parameter MUST (RFC 3640 section 3.3.6)
			 appear if AUs are interleaved.  I believe it to be true that they
			 MUST NOT appear if interleaving is not turned on (but don't have
			 a pointer to the relevant part of the spec)."
			self error: 'interleaved AUs are not supported'
		].


	! !

!QTestRTPProcessorAAC methodsFor: 'private' stamp: 'jcg 9/10/2009 01:46'!
readRfc3640AccessUnitHeader: stream "a QBigEndianBitStream" previousUnit: prev "or nil"
	"Instantiate an Access-unit header from the stream... we won't read the payload yet."
	| auSize auIndex auStreamState |

	auSize := stream next: bitsForSize.
	prev
		ifNil: ["this is the first access-unit in the packet"
			auIndex := bitsForIndexLength > 0 
						ifTrue: [stream next: bitsForIndexLength]
						ifFalse: [0].
		]
		ifNotNil: ["there are access-units which precede this one"
			| delta |
			delta := bitsForIndexDeltaLength > 0
						ifTrue: [stream next: bitsForIndexDeltaLength]
						ifFalse: [0].
			"See RFC3640-3.2.1.1"
			auIndex := prev index + delta + 1
		].

	"XXXXX: assume that C/DTSDeltaLength are not used (see #readFmtp:)"

	"Skip 'Stream-state'... it is only used for MPEG-4 System streams."

	^Rfc3640AccessUnit new
			size: auSize;
			index: auIndex;
			state: auStreamState;
			yourself
	! !

Object subclass: #QTestRTPProcessorH264
	instanceVariableNames: 'rtp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-RTP-Test'!

!QTestRTPProcessorH264 commentStamp: 'jcg 4/29/2009 17:25' prior: 0!
Limitations:
	- not supporting time-stamp/sequence-number wraparound!

!QTestRTPProcessorH264 class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QTestRTPProcessorH264 class methodsFor: 'utility' stamp: 'jcg 4/29/2009 13:46'!
processPacketsFrom: rtpClient
	^self new processPacketsFrom: rtpClient; yourself! !

!QTestRTPProcessorH264 methodsFor: 'accessing' stamp: 'jcg 4/29/2009 18:15'!
depacketize
	"Depacketize into Access Units that can be fed directly into a H.264 decoder."
	^ self depacketizeWithTypes collect: [:assoc | assoc value]! !

!QTestRTPProcessorH264 methodsFor: 'private' stamp: 'jcg 4/29/2009 15:48'!
depacketizeStapA: payload
	| str accessUnits |
	str := payload readStream.
	(str next bitAnd: 16r1F) = 24 ifFalse: [self error: 'not a STAP-A packet'].
	accessUnits := OrderedCollection new.
	[str atEnd] whileFalse: [
		| sz au |
		sz := str next: 2.
		sz size = 2 ifFalse: [self error: 'invalid STAP-A packet'].
		sz := sz unsignedShortAt: 1 bigEndian: true.
		au := str next: sz.
		au size = sz ifFalse: [self error: 'invalid STAP-A packet'].
		accessUnits add: au
	].
	^accessUnits! !

!QTestRTPProcessorH264 methodsFor: 'accessing' stamp: 'jcg 9/9/2009 09:28'!
depacketizeWithTypes
	"Depacketize into Associations between
		- Access Unit type (see ISO 14496-10, Table 7.1)
		- raw bytes for that AU (that can be fed directly into an H.264 decoder
	"
	| accessUnits seq startCode defragmenter |

	accessUnits := OrderedCollection new.
	
	seq := rtp rtpPackets first sequenceNumber - 1.
	startCode := #(0 0 0 1) asByteArray.
	defragmenter := nil.  "just being explicit"	

	rtp rtpPackets do: [:p |
		| payload payloadType handled | 

		(seq := seq + 1) = p sequenceNumber ifFalse: [
			self error: 'out of sequence (or wraparound)'
		].

		payload := p payload.
		payloadType := payload first bitAnd: 16r1F.

		handled := false.
		(payloadType between: 1 and: 23) ifTrue: [
			"Single Unit packet: regular H.264 NAL."
			handled := true.
			accessUnits add: payloadType -> (startCode, payload).
		].
		(payloadType = 24) ifTrue: [
			"STAP-A: RTP Aggregation packet"
			| stream |
			handled := true.
			stream := ReadStream on: payload.
			stream next. "skip STAP-indicator header"
			[stream atEnd] whileFalse: [
				| sz au |
				sz := stream next: 2.
				sz := sz unsignedShortAt: 1 bigEndian: true.
				au := stream next: sz.
				au size = sz ifFalse: [self error: 'STAP-A size mismatch'].
				accessUnits add: payloadType -> (startCode, au).
			].
		].
		(payloadType = 28) ifTrue: [
			"FUA-A: RTP Fragmentation packet"
			| start end |
			handled := true.
			start := (payload second bitAnd: 128) > 0.
			end := (payload second bitAnd: 64) > 0.
			"Sanity-checks on the header."
			(payload second bitShift: 32) > 0 ifFalse: [self error: 'FUA-A is insane'].
			(start & end) ifTrue: [self error: 'FUA-A is insane'].
			start 
				ifTrue: [
					"Start a new defragmenter."
					defragmenter ifNotNil: [self error: 'unfinished FUA-A packet'].
					defragmenter := WriteStream on: (ByteArray new: 100).
					"Compose NAL-header from FU-indicator and FU-header... the
					 F and NRI fields come from the first type, and the NAL unit type
					 comes from the second byte."
					defragmenter nextPut: 
						(payload first bitAnd: 16rE0) + (payload second bitAnd: 16r1F).
					"Compose FU-payload"
					defragmenter nextPutAll: (payload copyFrom: 3 to: payload size).
				]
				ifFalse: [
					defragmenter ifNil: [self error: 'expected partial FUA-A packet'].
					"Skip NAL-header/FU-indicator and FU-header; add FU-payload"
					defragmenter nextPutAll: (payload copyFrom: 3 to: payload size).
					end ifTrue: [
						accessUnits add: 
							payloadType -> (startCode, defragmenter contents).
						defragmenter := nil.
					].
				].
		].
		handled ifFalse: [self error: 'unknown payload type: ', payloadType].
	].

	^ accessUnits! !

!QTestRTPProcessorH264 methodsFor: 'accessing' stamp: 'jcg 5/5/2009 16:21'!
extent
	| framesize |
	framesize := rtp mediaDescription attributes at: 'framesize'.
	framesize := framesize findTokens: Character separators.
	framesize := framesize second findTokens: '-'.
	framesize := framesize collect: [:num | num asNumber].
	^framesize first @ framesize second! !

!QTestRTPProcessorH264 methodsFor: 'accessing' stamp: 'jcg 4/29/2009 15:51'!
packetHeaderInfo
	"Answer collection of info derived from the header of each packet (both the RTP and H.264-payload header, according to RFC 3984).  Timestamps and sequence numbers are normalized to start at zero (OK since we're only using this for debugging)."
	| sequenceStart timestampStart |
	sequenceStart := timestampStart := nil.
	^rtp packets collect: [:p |
		| payload payloadType hdrInfo unusual |

		payload := p payload.
		sequenceStart ifNil: [sequenceStart := p sequenceNumber].
		timestampStart ifNil: [timestampStart := p timestamp].

		unusual := OrderedCollection new.
		(payload first bitShift: -7) > 0 ifTrue: [unusual add: 'NALU forbidden-zero bit is set'].

		payloadType := self payloadTypeNameFor: (payload first bitAnd: 16r1F).

		hdrInfo := Dictionary newFrom: {
			"RFC 3984, Section 5.2, and ISO 14496-10, Section 7.4.1"
			'payload type'	->	payloadType.
			"ISO 14496-10, Section 7.4.1"
			'NRI'			->	((payload first bitShift: -5) bitAnd: 3).
			'timestamp'		-> (p timestamp - timestampStart).
			'sequence'		-> (p sequenceNumber - sequenceStart).
		}.
		unusual ifNotEmpty: [hdrInfo at: 'unusual' put: unusual].
		(payloadType = 'RTP: STAP-A') ifTrue: [
			| accessUnits |
			accessUnits := self depacketizeStapA: payload.
			hdrInfo at: 'x: AU sizes' put: (accessUnits collect: [:au | au size]) asArray.
		].
		hdrInfo.
	].! !

!QTestRTPProcessorH264 methodsFor: 'accessing' stamp: 'jcg 4/29/2009 13:54'!
parameterSets
	"Answer the H.264 sequence/picture parameter sets derived from the SDP description."
	| params |
	params := rtp mediaDescription fmtp at: 'sprop-parameter-sets'.
	params := params findTokens: Character separators, '='.
	params := params collect: [:set | 
		(Base64MimeConverter mimeDecodeToBytes: set readStream) contents.
	].
	^params! !

!QTestRTPProcessorH264 methodsFor: 'accessing' stamp: 'jcg 4/29/2009 14:52'!
payloadTypeNameFor: payloadType
	| dict |
	dict := Dictionary newFrom: {
		0	->	'undefined'.
		1	->	'H264: non-IDR slice'.
		2	->	'H264: partition A slice'.
		3	->	'H264: partition B slice'.
		4	->	'H264: partition C slice'.
		5	->	'H264: IDR slice'.
		6	->	'H264: SEI'.
		7	->	'H264: sequence parameter set'.
		8	->	'H264: picture parameter set'.
		9	->	'H264: access unit delimiter'.
		10	->	'H264: end-of-sequence'.
		11	->	'H264: end-of-stream'.
		12	->	'H264: filler'.
		13	->	'H264: reserved(13)'.
		14	->	'H264: reserved(14)'.
		15	->	'H264: reserved(15)'.
		16	->	'H264: reserved(16)'.
		17	->	'H264: reserved(17)'.
		18	->	'H264: reserved(18)'.
		19	->	'H264: reserved(19)'.
		20	->	'H264: reserved(20)'.
		21	->	'H264: reserved(21)'.
		22	->	'H264: reserved(22)'.
		23	->	'H264: reserved(23)'.
		24	->	'RTP: STAP-A'.
		25	->	'RTP: STAP-B'.
		26	->	'RTP: MTAP16'.
		27	->	'RTP: MTAP24'.
		28	->	'RTP: FUA-A'.
		29	->	'RTP: FUA-B'.
		30	->	'undefined'.
		31	->	'undefined'.
	}.
	^dict at: payloadType
! !

!QTestRTPProcessorH264 methodsFor: 'initialize' stamp: 'jcg 4/29/2009 13:50'!
processPacketsFrom: rtpClient
	rtp := rtpClient.! !

!QTestRTPProcessorH264 methodsFor: 'accessing' stamp: 'jcg 5/5/2009 16:30'!
timestampsStartingAtZero
	| stamps first |
	stamps := rtp packets collect: [:p | p timestamp].
	first := stamps first.
	^stamps collect: [:s | s - first]! !

Object subclass: #QTestVideoSequence
	instanceVariableNames: 'extent generatedFrames frameCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-RTP-Test'!

!QTestVideoSequence commentStamp: 'jcg 10/16/2009 17:18' prior: 0!
Produce a simple video for testing.!

!QTestVideoSequence class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QTestVideoSequence methodsFor: 'as yet unclassified' stamp: 'jcg 7/26/2011 23:38'!
displayDecodedSequenceOfFrames
	| args encoded decoder |
	args := QVideoArgs new usePlatformEndianness.
	args codecType: 'avc1'.
	args timeScale: 3000.
	args width: extent x.
	args height: extent y.
	args bitRate: 80000.
	args fps: 10.0. 

	encoded := self generateEncodedSequenceOfFrames.
	decoder := QVideoDecoderFree withArgs: args extent: extent.
	[:form | form displayAt: 0@0] runScript: #value: when: {decoder. #decodedFrame}.
	2 timesRepeat: [
		encoded do: [:enc | 
			decoder decode: enc.
			(Delay forMilliseconds: 20) wait.
		].
	].
	decoder destroy! !

!QTestVideoSequence methodsFor: 'accessing' stamp: 'jcg 10/16/2009 11:58'!
extent
	^extent! !

!QTestVideoSequence methodsFor: 'initialize' stamp: 'jcg 10/16/2009 00:36'!
extent: ext "a Point"
	extent := ext! !

!QTestVideoSequence methodsFor: 'as yet unclassified' stamp: 'jcg 7/26/2011 23:36'!
generateEncodedFramesForever
	| enc args inCount outCount |
	args := QVideoArgs new usePlatformEndianness.
	args codecType: 'avc1'.
	args timeScale: 3000.
	args width: extent x.
	args height: extent y.
	args bitRate: 80000.
	args fps: 10.0. 

	inCount := outCount := 0.

	enc := QVideoEncoderFree withArgs: args extent: extent.

	[:foo | 'encoded frame: ', (outCount := outCount + 1), '        ' displayAt: 0@0] 
		runScript: #value: 
		when: {enc. #encodedFrame}.

	[ 
		[enc encode: (self generateFormForFrameNumber: (inCount := inCount + 1))] repeat.
	] ensure: [enc destroy].

! !

!QTestVideoSequence methodsFor: 'as yet unclassified' stamp: 'jcg 7/26/2011 23:36'!
generateEncodedSequenceOfFrames
	| enc args col keyframeCount |
	args := QVideoArgs new usePlatformEndianness.
	args codecType: 'avc1'.
	args timeScale: 3000.
	args width: extent x.
	args height: extent y.
	args bitRate: 80000.
	args fps: 10.0. 

	enc := QVideoEncoderFree withArgs: args extent: extent.
	col := OrderedCollection new.
	[:fr | col add: fr] runScript: #value: when: {enc. #encodedFrame}.

	0 to: 255 do: [:i | enc encode: (self generateFormForFrameNumber: i)].
	(Delay forMilliseconds: 500) wait.
	enc destroy.

	"Find the second key-frame, and toss it and everything after."
	keyframeCount := 0.
	generatedFrames := nil.
	1 to: col size do: [:i |
		((col at: i) at: 1) = 1 ifTrue: [keyframeCount := keyframeCount + 1].
		keyframeCount = 2 ifTrue: [
			true
				ifTrue: [generatedFrames := (col copyFrom: 1 to: i-1)]
				ifFalse: [
					generatedFrames := generatedFrames collect: [:fr | fr copyWithoutFirst].
					generatedFrames do: [:fr | 
						AVCHackingUtilities replaceStartCodesWithNaluSizes: fr
					].
				].
			^generatedFrames
		].
	].
	self error: 'could not find second keyframe'
! !

!QTestVideoSequence methodsFor: 'as yet unclassified' stamp: 'jcg 10/20/2009 22:25'!
generateForm
	| form |
	form := self generateFormForFrameNumber: frameCount.
	frameCount := frameCount + 1.
	^form
! !

!QTestVideoSequence methodsFor: 'as yet unclassified' stamp: 'jcg 10/16/2009 17:55'!
generateFormForFrameNumber: frameNum
	| form |
	form := Form extent: extent depth: 32.
	self generateFormForFrameNumber: frameNum into: form.
	^form
! !

!QTestVideoSequence methodsFor: 'as yet unclassified' stamp: 'jcg 10/16/2009 17:54'!
generateFormForFrameNumber: frameNum into: form
	| len top off on nbits |
	nbits := 8.
	extent := form extent.
	form fillColor: Color blue.
	len := (extent x / nbits) rounded.
	top := ((extent y - len - len) / 2) rounded.
	off := Color blue muchDarker.
	on := Color cyan.
	0 to: nbits - 1 do: [:shift |
		| x rect bit |
		x := extent x - (len * (shift+1)).
		rect := (x@top extent: len@(2*len)) insetBy: (extent x / 80) rounded.
		bit := ((frameNum bitShift: shift negated) bitAnd: 1) > 0.
		form fill: rect fillColor: (bit ifTrue: [on] ifFalse: [off])
	].
	^form
		! !

!QTestVideoSequence methodsFor: 'as yet unclassified' stamp: 'jcg 10/20/2009 22:25'!
generateFormInto: aForm
	self generateFormForFrameNumber: frameCount into: aForm.
	frameCount := frameCount + 1.
	^aForm
! !

!QTestVideoSequence methodsFor: 'as yet unclassified' stamp: 'jcg 10/16/2009 16:14'!
generateMP4
	| infoFile nhmlFile mediaFile encoded dts |
	infoFile := FileDirectory default forceNewFileNamed: 'generated-video-sequence-1.info'.
	infoFile binary.
	[
		extent caseOf: {
			[320@240]->[infoFile nextPutAll: QSessionCapturePane decoderConfigDataFor320x240].
			[360@240]->[infoFile nextPutAll: QSessionCapturePane decoderConfigDataFor360x240].
			[600@400]->[infoFile nextPutAll: QSessionCapturePane decoderConfigDataFor600x400].
			[640@480]->[infoFile nextPutAll: QSessionCapturePane decoderConfigDataFor640x480].
		} otherwise: [self error: 'bad extent']
	] ensure: [infoFile close].

	encoded := self generateEncodedSequenceOfFrames.

	mediaFile := FileDirectory default forceNewFileNamed: 'generated-video-sequence-1.media'.
	mediaFile binary.
	nhmlFile :=  FileDirectory default forceNewFileNamed: 'generated-video-sequence.nhml'.

	[
		nhmlFile nextPutAll: (QSessionCapturePaneBaseUI 
												generateVideoNhntStreamHeader: 90000
												fileBaseName: 'generated-video-sequence-'
												width: extent x 
												height:  extent y
												trackID: 1).

		dts := -9000.
		1 timesRepeat: [
			encoded withIndexDo: [:bytes :ind |
				mediaFile nextPutAll: bytes.
				nhmlFile nextPutAll: 
					('<NHNTSample DTS="', (dts := dts + 9000), '" dataLength="', bytes size, '"').
				ind = 1 ifTrue: [nhmlFile nextPutAll: ' isRAP="yes"'].
				nhmlFile nextPutAll: ' />'; crlf.
			].
		].
		nhmlFile nextPutAll: '</NHNTStream>'; crlf.
	] ensure: [nhmlFile close. mediaFile close].
		
! !

!QTestVideoSequence methodsFor: 'initialize' stamp: 'jcg 10/20/2009 22:26'!
initialize
	frameCount := 0.! !

Object subclass: #QTicker
	instanceVariableNames: 'delay period lastTick adjustments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-LowLevel'!

!QTicker commentStamp: 'jcg 8/15/2007 12:21' prior: 0!
(c) 2007 Qwaq Inc.  If you want to have an event occur at a regular frequency, this is more convenient than a loop where you compute a Delay to wait for.

Usage:
	t := QTicker new period: 100 "msecs".
	[t wait. someObject doSomethingThatTakesTime] repeat.

If we fall a whole tick behind, don't bother trying to catch up.

Instance Variables:
	delay		-	Delay that ticker waits on.
	period		-	desired milliseconds between tick 'events'.
	lastTick		-	Scheduled time of the last tick.
	adjustments	-	Debugging: track of how much we 'adjust' each time we fall too far behind.!

!QTicker class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QTicker methodsFor: 'debugging' stamp: 'jcg 8/15/2007 01:39'!
adjustments
	^adjustments! !

!QTicker methodsFor: 'initialize' stamp: 'jcg 8/15/2007 12:18'!
period: periodMilliseconds
	period := periodMilliseconds.
	lastTick := Time millisecondClockValue.
	delay := Delay forMilliseconds: period.

	adjustments := nil. "create a collection for debugging"
	"adjustments := OrderedCollection new."
	! !

!QTicker methodsFor: 'actions' stamp: 'jcg 8/15/2007 12:18'!
wait
	| delta |
	delta := Time millisecondsSince: lastTick.
	delta < period ifTrue: [
		delay setDelayDuration: period-delta.
		delay wait.
		delta := Time millisecondsSince: lastTick
	].
	delta >= (2*period) 
		ifFalse: [lastTick := lastTick + period "normal operation"]
		ifTrue: [
			"We've fallen behind.  Don't worry about it, but keep track."
			adjustments ifNotNil: [adjustments add: (delta - period)].
			lastTick := lastTick + delta.
		].

	"Adjust for clock roll-over."
	lastTick class == SmallInteger ifFalse: [lastTick := lastTick - SmallInteger maxVal].! !

Object subclass: #Rfc3640AccessUnit
	instanceVariableNames: 'packet size index state payload'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-RTP-Test'!

!Rfc3640AccessUnit class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!Rfc3640AccessUnit methodsFor: 'accessing' stamp: 'jcg 9/10/2009 00:09'!
index
	"AU-index from RFC3640-3.2.1."
	^index! !

!Rfc3640AccessUnit methodsFor: 'initialize' stamp: 'jcg 9/10/2009 00:08'!
index: auIndex
	index := auIndex! !

!Rfc3640AccessUnit methodsFor: 'accessing' stamp: 'jcg 9/10/2009 00:34'!
payload
	^payload! !

!Rfc3640AccessUnit methodsFor: 'initialize' stamp: 'jcg 9/10/2009 00:20'!
payload: bytes
	payload := bytes! !

!Rfc3640AccessUnit methodsFor: 'accessing' stamp: 'jcg 9/10/2009 00:09'!
size
	"AU-size from RFC3640-3.2.1."
	^size! !

!Rfc3640AccessUnit methodsFor: 'initialize' stamp: 'jcg 9/10/2009 00:08'!
size: auSize
	size := auSize! !

!Rfc3640AccessUnit methodsFor: 'accessing' stamp: 'jcg 9/10/2009 00:09'!
state
	"Stream-state from RFC3640-3.2.1."
	^state! !

!Rfc3640AccessUnit methodsFor: 'initialize' stamp: 'jcg 9/10/2009 00:08'!
state: auState
	state := auState! !

Object subclass: #RtpPacket
	instanceVariableNames: 'data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-RTP'!

!RtpPacket commentStamp: 'jcg 7/21/2009 15:23' prior: 0!
Useful for parsing RTP data received from the network, and for preparing bytes to send out over the network.!

!RtpPacket class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!RtpPacket methodsFor: 'private' stamp: 'jcg 4/24/2009 13:26'!
csrcCount
	"CSRC count (CC): 4 bits (from 4-7)"
	^(data at: 1) bitAnd: 16rF! !

!RtpPacket methodsFor: 'initialize' stamp: 'ar 10/2/2009 11:24'!
fromPayload: payload type: payloadType sequence: seqNum timestamp: timestamp source: source contributors: contributorsOrNil usePadding: usePadding headerExtension: extension isMarker: isMarker
	| totalSize byte contributors |
	totalSize := 12.
	contributors := contributorsOrNil ifNil: [#()].
	contributors size > 15 ifTrue: [
		self error: 'RTP packets has maximum of 15 contributing sources'
	].
	totalSize := totalSize + (contributors size * 4).

	extension ifNotNil: [self error: 'RTP packet header extensions are not supported'].
	usePadding ifTrue: [self error: 'RTP packet payload padding is not supported'].
	totalSize := totalSize + payload size.

	"Compose the first header byte."
	data := ByteArray new: totalSize.
	byte := 
		128 "version 2" + 
		0 "padding not supported" +
		0 "extensions not supported" +
		contributors size.
	data at: 1 put: byte.

	"Compose the second header byte."
	byte := isMarker ifTrue: [128] ifFalse: [0].
	(payloadType between: 0 and: 127) ifFalse: [
		self error: 'payload type must be in range 0-127'.
	].
	byte := byte + payloadType.
	data at: 2 put: byte.

	data unsignedShortAt: 3 put: seqNum bigEndian: true.
	data networkUnsignedLongAt: 5 put: timestamp.
	data networkUnsignedLongAt: 9 put: source.
	contributors withIndexDo: [:con :ind |
		data networkUnsignedLongAt: (ind*4 + 9) put: con
	].
	"Skip header extension (we don't implement it)"
	"Stash the payload."
	data replaceFrom: (contributors size * 4 + 13) to: data size with: payload.	
! !

!RtpPacket methodsFor: 'initialize' stamp: 'jcg 7/20/2009 14:20'!
fromRawData: rawPacketData
	data := rawPacketData! !

!RtpPacket methodsFor: 'private' stamp: 'jcg 4/24/2009 13:26'!
hasExtension
	"extension (X): 1 bit (at 3)"
	^((data at: 1) bitAnd: 16r10) = 1! !

!RtpPacket methodsFor: 'private' stamp: 'jcg 4/24/2009 13:41'!
hasMarker
	"marker (M): 1 bit (at 8)"
	^((data at: 2) bitAnd: 16r80) > 0! !

!RtpPacket methodsFor: 'private' stamp: 'jcg 4/24/2009 13:26'!
hasPadding
	"padding (P): 1 bit (at 2)"
	^((data at: 1) bitAnd: 16r20) = 1! !

!RtpPacket methodsFor: 'private' stamp: 'jcg 4/24/2009 13:26'!
marker
	"marker (M): 1 bit (at 8)"
	^(data at: 2) bitAnd: 16r80! !

!RtpPacket methodsFor: 'accessing' stamp: 'jcg 4/24/2009 14:15'!
payload
	| end |
	end := data size.
	self hasPadding ifTrue: [end := end - data last].
	^data copyFrom: self payloadStart to: end! !

!RtpPacket methodsFor: 'private' stamp: 'jcg 4/24/2009 13:33'!
payloadStart
	^13 + (4 * self csrcCount)
! !

!RtpPacket methodsFor: 'private' stamp: 'jcg 4/24/2009 13:26'!
payloadType
	"payload type (PT): 7 bits (from 9-15)"
	^(data at: 2) bitAnd: 16r7F! !

!RtpPacket methodsFor: 'accessing' stamp: 'jcg 7/20/2009 17:50'!
rawData
	^data! !

!RtpPacket methodsFor: 'private' stamp: 'jcg 4/24/2009 13:26'!
sequenceNumber
	"sequence number: 16 bits (from 16-31)"
	^data unsignedShortAt: 3 bigEndian: true! !

!RtpPacket methodsFor: 'private' stamp: 'jcg 4/24/2009 13:27'!
timestamp
	"timestamp: 32 bits (from 32-63)"
	^data unsignedLongAt: 5 bigEndian: true! !

!RtpPacket methodsFor: 'private' stamp: 'jcg 4/24/2009 13:27'!
version
	"version (V): 2 bits (from 0-1)"
	^(data at: 1) bitShift: -6! !

Object subclass: #RtpPacketizer
	instanceVariableNames: 'rtspSession rtpServer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-RTP'!

RtpPacketizer subclass: #RtpAacPacketizer
	instanceVariableNames: 'auIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-RTP'!

!RtpAacPacketizer commentStamp: 'jcg 10/14/2009 16:43' prior: 0!
Responsible for creating RTP payloads conforming to RFC3640, and sending them to the client via an RtpServer.!

!RtpAacPacketizer class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!RtpAacPacketizer methodsFor: 'initialize' stamp: 'jcg 10/14/2009 15:53'!
initialize
	super initialize.
	auIndex := 0.! !

!RtpAacPacketizer methodsFor: 'initialize' stamp: 'jcg 10/20/2009 00:38'!
sendFrame: frame "a QNetVidBufferedFrame"
	| auPayload auHeader |

	"Extract the payload first... we need it's size to create the AU-header."
	auPayload := frame dataWithoutHeader asByteArray.	

	"Construct the AU-headers (actually only one, for now)."
	auHeader := ByteArray new: 4.
	auHeader at: 2 put: 16. "one 16-bit AU-header follows"
	auPayload size > 8191 ifTrue: [self error: 'AU-size does not fit in 13 bits'].
	auHeader 
		unsignedShortAt: 3 
		put: ((auPayload size bitShift: 3) bitOr: auIndex)
		bigEndian: true.
	auIndex := (auIndex + 1) \\ 8.  "3-bit rollover"

	rtpServer
		sendData: auHeader, auPayload
		payloadType: rtpServer mediaDescription payloadType
		timestamp: frame cts
		isMarker: true "every AAC packet is a RAP".! !

RtpPacketizer subclass: #RtpAvcPacketizer
	instanceVariableNames: 'sawRAP skipCount nalTypes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-RTP'!

!RtpAvcPacketizer commentStamp: '<historical>' prior: 0!
Responsible for creating RTP payloads conforming to RFC3984 (for now, only STAP-A packets), and sending them to the client via an RtpServer.!

!RtpAvcPacketizer class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!RtpAvcPacketizer methodsFor: 'initialize' stamp: 'jcg 12/8/2009 20:31'!
initialize
	super initialize.
	sawRAP := false.
	skipCount := 0.

	nalTypes := Set new.  "for debugging... keep track of what we've seen."! !

!RtpAvcPacketizer methodsFor: 'initialize' stamp: 'jcg 12/8/2009 20:32'!
sendFrame: frame "a QNetVidBufferedFrame"

	sawRAP ifFalse: [ "don't send anything until we see a keyframe"
		frame isRAP 
			ifTrue: [
				skipCount > 0 ifTrue: [
					QLogger logInfo: 'skipped ', skipCount, ' frames before first keyframe'.
				].
				sawRAP := true.
			]
			ifFalse: [
				skipCount := skipCount + 1.
				rtpServer skipFrameAtTime: frame cts.
				^self
			]
	].

	self sendSingleNalFrame: frame.
"	self sendStapFrame: frame.	"! !

!RtpAvcPacketizer methodsFor: 'initialize' stamp: 'jcg 11/19/2009 02:33'!
sendSingleNalFrame: frame "a QNetVidBufferedFrame"
	"Send each NAL unit in a separate RTP packet."
	| nalus isLastNalu  |

	nalus := AVCHackingUtilities extractNALUs: frame dataWithoutHeader asByteArray.
	1 to: nalus size do: [:i |
		| type nri u |
		u := nalus at: i.
		type := u first bitAnd: 16r15.  "5 bits NALU type"
		nri := (u first bitShift: -5) bitAnd: 3. "2 bits Nal_ref_idc"
		nalTypes add: type->nri.

		"We know how many nalus there are, so we know if this is the last one."
		isLastNalu := (i = nalus size).

		"Check if we want to fragment the NALU."
		"XXXXX: this should be factored into a separate method"
		u size <= 1400 "close-ish to MTU size"
			ifTrue: [ "don't fragment"
				rtpServer
					sendData: u
					payloadType: rtpServer mediaDescription payloadType
					timestamp: frame cts
					isMarker: isLastNalu
			]
			ifFalse: [ "fragment, baby, fragment (see RFC 3984, Section 5.8 "
				| indicator  stream fragCount buffer  |

				"We read each fragment into the same buffer, rather than re-allocating."
				buffer := ByteArray new: 1400.
				indicator := (nri bitShift: 5) + 28 "FU-A".
				buffer at: 1 put: indicator. "always the same"
				fragCount := 0.
				stream := u readStream.
				stream next. "skip nalu header byte (we already read it above)."
				[stream atEnd] whileFalse: [
					| payload |
					"If this is the first fragment, set the 'S' bit."
					fragCount := fragCount + 1.
					fragCount = 1
						ifTrue: [buffer at: 2 put: type + 128]
						ifFalse: [buffer at: 2 put: type].

					"Read the rest of the fragment's data 
					 (returns partial copy if buffer isn't full."
					payload := stream next: (buffer size - 2) into: buffer startingAt: 3.

					"If this is the last fragment, set the 'E' bit."
					stream atEnd ifTrue: [payload at: 2 put: (payload second + 64)].

					"Send an RTP packet."
					rtpServer
						sendData: payload
						payloadType: rtpServer mediaDescription payloadType
						timestamp: frame cts
						isMarker: (stream atEnd and: [isLastNalu] ).
				].		
			].
	].
! !

!RtpAvcPacketizer methodsFor: 'initialize' stamp: 'jcg 10/22/2009 17:12'!
sendStapFrame: frame "a QNetVidBufferedFrame"
	"Send all NAL units in the frame in a single RTP packet."
	| stapHeader |

	stapHeader := 24. "STAP-A"
	frame isRAP ifTrue: [stapHeader := stapHeader bitOr: 96. "set NRI to 0x11"].
	stapHeader := ByteArray with: stapHeader.

	rtpServer
		sendData: stapHeader, frame dataWithoutHeader asByteArray
		payloadType: rtpServer mediaDescription payloadType
		timestamp: frame cts
		isMarker: frame isRAP! !

!RtpPacketizer class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!RtpPacketizer methodsFor: 'initialize' stamp: 'jcg 11/18/2009 17:50'!
server: aRTPServer
	rtpServer := aRTPServer! !

!RtpPacketizer methodsFor: 'initialize' stamp: 'jcg 11/18/2009 17:53'!
session: aRTSPSession
	rtspSession := aRTSPSession.! !

Object subclass: #RtpSession
	instanceVariableNames: 'rtsp mediaDescription protocol dataPort dataSocket controlPort controlSocket syncSource seqNum'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-RTP'!

!RtpSession commentStamp: '<historical>' prior: 0!
Base class for both client- and server-side RTP sessions.

We assume that RTP sessions are always negotiated via RTSP; in other words, they are associated with a particular RTSP session.  Although this is true in our system, it is not true generally (it is also common to use SIP or other protocols to set up RTP sessions).

_____________________
Instance variables:
rtsp			-	the RTSP session that initiated us (we hardwire this assumption 
					even though it common to establish RTP sessions via SIP, etc.)
mediaDescription	-	the SDPMediaDescription for the media in this session
protocol 		-	underlying transport: #udp, #tcp, or #interleaved (over RTSP)
dataPort		-	port (or channel, if #interleaved) number that media data arrives 
					on (for clients), or is sent on (for servers)
dataSocket 	-	the socket corresponding to 'dataPort'; nil if using #interleaved
controlPort		-	same as 'dataPort', except for RTCP control data
controlSocket	-	same as 'dataPort', except for RTCP control data
syncSource	-	the RTP SSRC
seqNumber	-	for clients, the sequence number of the most recently received
					packet.  For servers, the next sequence number to use.!

RtpSession subclass: #RtpClient
	instanceVariableNames: 'rtpPackets rtcpPackets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-RTP'!

!RtpClient commentStamp: '<historical>' prior: 0!
Represents the client-side of an RTP session.  Has dumb placeholder behavior when incoming packets are received: it stashes them in a queue (a separate queue for RTP and RTCP packets).!

!RtpClient class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!RtpClient methodsFor: 'packet-handling' stamp: 'jcg 9/9/2009 09:09'!
handleControlPacket: rtcpData
	| msg |
	msg := 
		'RECEIVED RTCP... id=', controlPort, 
		'  size=', rtcpData size, 
		'  time=', Time coarseClockValue.
	msg displayAt: 0@(controlPort*30).
! !

!RtpClient methodsFor: 'packet-handling' stamp: 'jcg 9/9/2009 09:09'!
handleDataPacket: rtpData
	| pkt msg |
	pkt := RtpPacket new fromRawData: rtpData asByteArray.
	rtpPackets nextPut: pkt. 


	msg := 
		'RECEIVED RTP... id=', dataPort, 
		'  size=', rtpData size, 
		'  seq=', pkt sequenceNumber,
		'  timestamp=', pkt timestamp,
		'  payload_type=', pkt payloadType,
		'       '.
	msg displayAt: 0@(dataPort*30 + 15).
! !

!RtpClient methodsFor: 'initialize' stamp: 'jcg 7/17/2009 16:17'!
initialize
	super initialize.
	rtpPackets := SharedQueue new.
	rtcpPackets := SharedQueue new.! !

!RtpClient methodsFor: 'socket listening' stamp: 'jcg 7/13/2009 19:07'!
listenOnTCP
	self error: 'TCP transport not yet implemented'.! !

!RtpClient methodsFor: 'socket listening' stamp: 'jcg 7/13/2009 19:07'!
listenOnUDP
	self error: 'UDP transport not yet implemented'.! !

!RtpClient methodsFor: 'debugging' stamp: 'jcg 7/17/2009 17:53'!
rtcpPackets
	"Answer a queue containing RTCP packets received by the client."
	^rtcpPackets! !

!RtpClient methodsFor: 'debugging' stamp: 'jcg 7/15/2009 18:18'!
rtpPackets
	"Answer a queue containing RTP packets received by the client."
	^rtpPackets! !

!RtpClient methodsFor: 'initialize' stamp: 'jcg 7/13/2009 18:55'!
setupTransport: transportHeaderString "Transport: header of an RTSP SETUP response"
	| tokens transportType |

	"Clear these so that it's easier to check that 
	 we received all of the necessary data."
	dataPort := controlPort := syncSource := nil.

	tokens := transportHeaderString findTokens: ','.
	tokens size = 1 ifFalse: [
		self error: 'SETUP response cannot contain multiple Transports'.
	].
	tokens := tokens first findTokens: ';'.
	transportType := tokens removeFirst.
	(transportType beginsWith: 'RTP/AVP')
		ifFalse: [self error: 'transport-specifier must begin with "RTP/AVP".'].
	transportType := transportType allButFirst: 7.
	transportType caseOf: {
		['/TCP'] -> [protocol := #tcp].
		['/UDP'] -> [protocol := #udp].
		[''] -> [protocol := #udp].
	} otherwise: [self error: 'invalid transport-specifier: RTP/AVP', transportType].

	"Process the rest of the transport parameters."
	tokens do: [:param |
		param = 'unicast' ifTrue: ["unicast is OK over UDP and TCP, so ignore"].
		(param = 'multicast' and: [protocol = #tcp]) ifTrue: [
			"The server shouldn't send this; it is nonsense."
			self error: 'multicast is not compatible with TCP transport'.
		].
		param = 'multicast' ifTrue: [self error: 'multicast streaming is not supported'].
		(param beginsWith: 'interleaved') ifTrue: [
			| ports |
			ports := param copyAfter: $=.
			ports := ports findTokens: '-'.
			ports size = 2 ifFalse: [self error: 'expected 2 "ports" for interleaved data'].
			dataPort := ports first asNumber.
			controlPort := ports second asNumber.
			protocol := #interleaved.
		].
		(param beginsWith: 'ssrc=') ifTrue: [syncSource := param copyAfter: $=].
	].

	protocol caseOf: {
		[#udp]				-> 	[self listenOnUDP].
		[#tcp]				-> 	[self listenOnTCP].
		[#interleaved]		->	["do nothing, the RTSP session will feed us packets"].
	} otherwise: [self error: 'unrecognized protocol: ', protocol].! !

RtpSession subclass: #RtpServer
	instanceVariableNames: 'timeBase timeOffset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-RTP'!

!RtpServer commentStamp: '<historical>' prior: 0!
The server-side of an RTP session is responsible for sending media data to the client.  It is NOT responsible for any application-specific media headers outside of the RTP header... other classes are responsible for this (such as RtpAacPacketizer).

An RTP session operates within the context of the RTSP session that created it.  In particular, we piggyback on the RTSP session's event-loop.
!

!RtpServer class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!RtpServer methodsFor: 'event-loop' stamp: 'jcg 7/17/2009 15:45'!
currentlyInEventLoop
	"We share an event-loop with the RTSP session that spawned us."
	^rtsp currentlyInEventLoop
! !

!RtpServer methodsFor: 'event-loop' stamp: 'jcg 7/17/2009 15:46'!
futureDo: aSelector at: deltaMSecs args: args
	"Enqueue a message on the event queue.  The compiler has been modified to generate this message when the #future message appears in the source code."
	deltaMSecs = 0 ifFalse:[^self error: 'deltaMSecs must be zero'].
	rtsp futureDo: aSelector receiver: self args: args.
	^nil
! !

!RtpServer methodsFor: 'event-loop' stamp: 'jcg 7/17/2009 15:46'!
futureSend: aSelector receiver: receiver args: args
	"Called by implementors of #futureSend:at:args: who want to enqueue a message on the event-queue.  This extra indirection helps other objects enqueue messages on our event loop."
	| promise |
	promise := TPromise new.
	rtsp enqueueEvent: (PromiseMessageSend
									promise: promise
									receiver: receiver 
									selector: aSelector 
									arguments: args).
	^promise
! !

!RtpServer methodsFor: 'initialize' stamp: 'jcg 12/15/2009 00:57'!
initialize
	super initialize.
	syncSource := ((2 raisedTo: 32) atRandom - 1).
	seqNum := (2 raisedTo: 16) atRandom - 1.
	timeBase := 0.! !

!RtpServer methodsFor: 'initialize' stamp: 'ar 10/7/2009 15:32'!
resetTimeOffset
	timeOffset := nil.
! !

!RtpServer methodsFor: 'sending' stamp: 'ar 10/1/2009 14:04'!
sendControlPacket: rtpPacket
	protocol == #interleaved ifFalse: [
		self error: 'only RTSP-interleaved transport is supported'
	].
	rtsp synchronizedWriteStream: [:stream |
		| length |
		stream nextPut: $$.
		stream nextPut: controlPort.
		length := ByteArray new: 2.
		length unsignedShortAt: 1 put: rtpPacket rawData size bigEndian: true.
		stream nextPutAll: length.
		stream nextPutAll: rtpPacket rawData.
		stream flush.
	].! !

!RtpServer methodsFor: 'initialize' stamp: 'jcg 12/14/2009 01:17'!
sendData: dataToSend payloadType: typeIndex timestamp: timestamp isMarker: isMarker
	| pkt |
	timeOffset ifNil:[timeOffset := timestamp - timeBase].
	pkt := RtpPacket new
				fromPayload: dataToSend
				type: typeIndex
				sequence: (seqNum := (seqNum + 1) \\ 65536)
				timestamp: (timestamp - timeOffset) \\ (2 bitShift: 31)
				source: syncSource
				contributors: nil
				usePadding: false
				headerExtension: nil
				isMarker: isMarker.
	self sendDataPacket: pkt.
! !

!RtpServer methodsFor: 'sending' stamp: 'jcg 7/20/2009 18:04'!
sendDataPacket: rtpPacket
	protocol == #interleaved ifFalse: [
		self error: 'only RTSP-interleaved transport is supported'
	].
	rtsp synchronizedWriteStream: [:stream |
		| length |
		stream nextPut: $$.
		stream nextPut: dataPort.
		length := ByteArray new: 2.
		length unsignedShortAt: 1 put: rtpPacket rawData size bigEndian: true.
		stream nextPutAll: length.
		stream nextPutAll: rtpPacket rawData.
		stream flush.
	].! !

!RtpServer methodsFor: 'initialize' stamp: 'ar 10/5/2009 11:25'!
seqNum
	^seqNum! !

!RtpServer methodsFor: 'initialize' stamp: 'ar 10/5/2009 11:25'!
seqNum: aNumber
	seqNum := aNumber! !

!RtpServer methodsFor: 'initialize' stamp: 'jcg 7/20/2009 02:36'!
setupTransportType: transportProtocol dataPort: dPort controlPort: cPort
	protocol := transportProtocol.
	dataPort := dPort.
	controlPort := cPort.

	protocol == #interleaved ifFalse: [
		self error: 'only #interleaved protocol is supported, not ', protocol printString
	].! !

!RtpServer methodsFor: 'initialize' stamp: 'jcg 10/20/2009 17:57'!
skipFrameAtTime: timestamp
	"Even though we're skipping this frame, we still want to start counting the time from here."
	timeOffset ifNil: [timeOffset := timestamp].! !

!RtpServer methodsFor: 'accessing' stamp: 'ar 10/27/2009 10:28'!
timeBase
	"Base time for server time stamps"
	^timeBase! !

!RtpServer methodsFor: 'accessing' stamp: 'ar 10/27/2009 10:28'!
timeBase: aNumber
	"Base time for server time stamps"
	timeBase := aNumber! !

!RtpServer methodsFor: 'accessing' stamp: 'ar 10/27/2009 14:02'!
trackID
	"The id of the underlying track"
	^mediaDescription trackInfo trackID! !

!RtpSession class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!RtpSession methodsFor: 'accessing' stamp: 'jcg 7/17/2009 16:08'!
controlPort
	^controlPort! !

!RtpSession methodsFor: 'initialize' stamp: 'jcg 7/17/2009 16:08'!
controlPort: portNum
	controlPort := portNum.! !

!RtpSession methodsFor: 'accessing' stamp: 'jcg 7/17/2009 16:07'!
dataPort
	^dataPort! !

!RtpSession methodsFor: 'initialize' stamp: 'jcg 7/17/2009 16:07'!
dataPort: portNum
	dataPort := portNum.! !

!RtpSession methodsFor: 'testing' stamp: 'jcg 9/9/2009 09:16'!
isAudio
	^mediaDescription 
		ifNil: [self error: 'rtp-session has no media-description'] 
		ifNotNilDo: [:md | md isAudio]! !

!RtpSession methodsFor: 'testing' stamp: 'jcg 9/9/2009 09:16'!
isVideo
	^mediaDescription 
		ifNil: [self error: 'rtp-session has no media-description'] 
		ifNotNilDo: [:md | md isVideo]! !

!RtpSession methodsFor: 'accessing' stamp: 'jcg 7/17/2009 16:07'!
mediaDescription
	^mediaDescription! !

!RtpSession methodsFor: 'initialize' stamp: 'jcg 7/17/2009 16:06'!
mediaDescription: desc "a SDPMediaDescription"
	mediaDescription := desc! !

!RtpSession methodsFor: 'accessing' stamp: 'jcg 7/17/2009 16:11'!
protocol
	"What is the underlying transport protocol that this RTP session talks over?  Either #udp, #tcp, or #interleaved (i.e. multiplexed over an RTSP connection)."
	^protocol! !

!RtpSession methodsFor: 'initialize' stamp: 'jcg 7/17/2009 16:12'!
rtsp: rtspSession "depending on subclass, either a RTSP client or server session."
	rtsp := rtspSession.! !

!RtpSession methodsFor: 'accessing' stamp: 'jcg 7/17/2009 16:12'!
syncSource
	^syncSource! !

!RtpSession methodsFor: 'initialize' stamp: 'jcg 7/17/2009 16:13'!
syncSource: ssrc
	syncSource := ssrc.! !

Object subclass: #SDPDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-RTSP'!

!SDPDescription commentStamp: '<historical>' prior: 0!
Base class for both session- and stream-level SDP descriptions.!

!SDPDescription class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!SDPDescription class methodsFor: 'instance creation' stamp: 'jcg 4/25/2009 21:22'!
newFromLines: sdpLines
	^self new initializeFromLines: sdpLines! !

!SDPDescription class methodsFor: 'instance creation' stamp: 'jcg 4/25/2009 21:25'!
newFromString: sdpString
	"Parse the String into a list of Associations, where the key is the type of SDP line, and the value is the rest of the line after the '=' character."
	| lines |
	lines := sdpString findTokens: String crlf.
	lines := lines collect: [:ln |
		ln second == $= ifFalse: [self error: 'invalid SDP'].
		ln first -> (ln copyFrom: 3 to: ln size)
	].
	^self newFromLines: lines! !

!SDPDescription methodsFor: 'printing' stamp: 'jcg 6/29/2009 17:28'!
fullPrintOn: aStream
	self subclassResponsibility! !

!SDPDescription methodsFor: 'printing' stamp: 'jcg 6/29/2009 17:27'!
fullPrintString
	"Answer a String whose characters are a description of the receiver."
	^ String streamContents: [:s | self fullPrintOn: s]! !

SDPDescription subclass: #SDPMediaDescription
	instanceVariableNames: 'session friendlyInfo connectionData bandwidth attributes payloadType codecConfig generalType trackInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-RTSP'!

!SDPMediaDescription commentStamp: '<historical>' prior: 0!
Instance variables (explicit SDP fields/attributes)	
	friendlyInfo 		- corresponds to the SDP "i=" field
	connectionData 	- corresponds to the SDP "c=" field (stored as tokens)
	bandwidth			- corresponds to the SDP "b=" field (stored as Associations)
	payloadType		- index used to identify type in eg: 'rtpmap' attribute

Instance variables (other)
	session - the SDPSessionDescription that this description is "owned by".
	codecConfig - currently, either a MP4BoxAACConfig or a MP4BoxAVCConfig.
	generalType - is it audio, video, or what?!

!SDPMediaDescription class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!SDPMediaDescription class methodsFor: 'instance creation' stamp: 'jcg 4/25/2009 21:01'!
newFromLines: sdpLines
	^self new initializeFromLines: sdpLines! !

!SDPMediaDescription class methodsFor: 'instance creation' stamp: 'jcg 4/25/2009 21:00'!
newFromString: sdpString
	^self newFromLines: (sdpString findTokens: String crlf)! !

!SDPMediaDescription class methodsFor: 'instance creation' stamp: 'jcg 8/29/2009 15:04'!
newFromTrackInfo: trackInfo "a QNetVidTrackInfo" payloadType: payloadTypeIndex
	^self new initializeFromTrackInfo: trackInfo payloadType: payloadTypeIndex! !

!SDPMediaDescription methodsFor: 'comparing' stamp: 'jcg 6/30/2009 18:38'!
= desc "a SDPMediaDescription"
	self class == desc class ifFalse: [^false].
	self generalType = desc generalType ifFalse: [^false].
	payloadType = desc payloadType ifFalse: [^false].	
	friendlyInfo = desc friendlyInfo ifFalse: [^false].
	connectionData = desc connectionData ifFalse: [^false].
	bandwidth = desc bandwidth ifFalse: [^false].
	attributes = desc attributes ifFalse: [^false].
	^true! !

!SDPMediaDescription methodsFor: 'accessing' stamp: 'jcg 4/26/2009 10:59'!
attributes
	^attributes! !

!SDPMediaDescription methodsFor: 'accessing' stamp: 'jcg 4/26/2009 10:17'!
bandwidth
	^bandwidth! !

!SDPMediaDescription methodsFor: 'accessing' stamp: 'jcg 9/9/2009 11:43'!
codecConfig
	^codecConfig! !

!SDPMediaDescription methodsFor: 'accessing' stamp: 'jcg 4/26/2009 10:16'!
connectionData
	^connectionData! !

!SDPMediaDescription methodsFor: 'accessing' stamp: 'jcg 4/26/2009 21:18'!
fmtp
	"If there is an 'fmtp' attribute (format-specific parameters) then answer a Dictionary<String, String> mapping parameter names to values.  The parameter values will often require further parsing, but this is not our responsibility."
	| attr tokens fmtp |
	attr := attributes at: 'fmtp' ifAbsent: [^nil].
	tokens := attr findTokens: Character separators, ';'.
	tokens removeFirst.
	fmtp := Dictionary new.
	tokens do: [:tok |
		| paramName paramVal |
		paramName := tok copyUpTo: $=.
		paramVal := tok copyAfter: $=.
		"Force parameter names to lowercase.  This hack is here because 
		 QuickTime Streaming Server apparently uses lowercase param 
		 names, so we do to (if we used the 'camel-case' versions in the 
		 RFCs, we might miss parameters that are actually there).  Yay."
		fmtp at: paramName asLowercase put: paramVal.
	].
	^fmtp
	! !

!SDPMediaDescription methodsFor: 'accessing' stamp: 'jcg 4/26/2009 10:15'!
friendlyInfo
	^friendlyInfo! !

!SDPMediaDescription methodsFor: 'accessing' stamp: 'jcg 6/29/2009 17:40'!
friendlyInfo: aString
	friendlyInfo := aString! !

!SDPMediaDescription methodsFor: 'printing' stamp: 'jcg 7/6/2009 16:35'!
fullPrintOn: aStream
	"As specified in RFC 4566:
		m=  (media name and transport address)
		i=* (media title)
		c=* (connection information -- optional if included at
		     session level)
		b=* (zero or more bandwidth information lines)
		k=* (encryption key)
		a=* (zero or more media attribute lines) "

	"Media type (always use the RTP/AVP profile)."
	aStream 
		nextPutAll: 'm='; 
		nextPutAll: self generalType; "audio or video?"
		nextPutAll: ' 0 RTP/AVP '; "don't care what port the client uses"
		nextPutAll: payloadType printString;
		crlf.

	"Friendly, human-readable info."
	friendlyInfo ifNotNil: [aStream nextPutAll: 'i=', friendlyInfo; crlf].

	"Connection info."
	connectionData ifNotNil: [
		aStream nextPutAll: 'c='.
		connectionData 
			do: [:cd | aStream nextPutAll: cd]
			separatedBy: [aStream space].
		aStream crlf.
	].

	"Bandwidth"
	bandwidth ifNotNil: [
		aStream nextPutAll: 'b=', bandwidth key, ':', bandwidth value; crlf.
	].

	"Print out all attributes."
	attributes keysAndValuesDo: [:key :val |
		aStream nextPutAll: 'a=', key, ':', val; crlf.
	].! !

!SDPMediaDescription methodsFor: 'accessing' stamp: 'jcg 7/7/2009 15:40'!
generalType
	"i.e. audio or video?"
	^generalType! !

!SDPMediaDescription methodsFor: 'initialize' stamp: 'jcg 7/7/2009 15:41'!
generalType: typeString
	"Eg: 'audio', 'video', etc."
	generalType := typeString.! !

!SDPMediaDescription methodsFor: 'initialize' stamp: 'jcg 7/7/2009 15:33'!
initialize
	super initialize.
	attributes := Dictionary new.! !

!SDPMediaDescription methodsFor: 'private' stamp: 'jcg 10/14/2009 11:32'!
initializeAACFromTrackInfo: trackInfo
	"See RFC3640: 'RTP Payload Format for Transport of MPEG-4 Elementary Streams'."
	| rtpmap fmtp profileLevelID decInfo |

	generalType := 'audio'.

	"We'll need this, so raise an error here if we don't have it."
	decInfo := trackInfo decoderSpecificInfo ifNil: [
		self error: 'missing AudioSpecificConfig'.
	].

	"Initialize the 'rtpmap' attribute.
	Eg: a=rtpmap:96 mpeg4-generic/44100/1"
	rtpmap := payloadType printString, ' mpeg4-generic/', 
				trackInfo timeScale, '/', trackInfo numChannels.
	attributes at: 'rtpmap' put: rtpmap.
	
	"XXXXX: This will be used to construct the 'fmtp' attribute below.  I spent half a day trying to figure out the correct value to put here, but failed.  RFC3640 says that it should be the 'audioProfileLevelIndication' from ISO14496-3, but real MP4 files that I have hinted using MP4Box have values falling in the 'reserved for ISO use' range, and I haven't been able to find more detailed information about how to choose these values.  So, I'll make one up!!"
	"NOTE: Andreas noticed that QTSS uses a value of 40, so we use that. "
	"SPECULATION: although RFC3640 says this is 'a decimal representation of the 
	 MPEG-4 Profile Level indication' (defined in 14496-1 Table 5 for audio streams), 
	 maybe it is actually hexidecimal.  Whether it means 16r40 or 10r40, they both 
	 fall within Table 5's range for 'reserved for ISO use'.  14496-1 doesn't expand 
	 on what is meant by this, but reading between the lines, this means a value 
	 that is specified in 14496-3.  If this is true, then perhaps this actually matches 
	 the 'objectType' of 64?  This is quite a leap; to be honest, I have no idea why 
	 40 is the right value."
	QLogger logWarning: 'hallucinating an AAC profile-level-id of 40'.
	profileLevelID := 40.

	"Initialize the 'fmtp' attribute.
	Eg: fmtp:96 profile-level-id=41; config=1208; streamType=5; mode=AAC-hbr; objectType=64; sizeLength=13; indexLength=3; indexDeltaLength=3"
	fmtp := payloadType printString, 
				' profile-level-id=', profileLevelID, "see speculation above"
				'; config=', decInfo hex, 
				'; streamType=5',  "MP4-audio: RFC3640-4.1 and 14496-1, table 9"
				'; mode=AAC-hbr',  "XXXXX: maybe not always? when?"
				'; objectType=64', "10r64 = 16r40 = audio... see 14496-1, Table 8"
				'; sizeLength=13; indexLength=3; indexDeltaLength=3'. "Always."
	attributes at: 'fmtp' put: fmtp.
! !

!SDPMediaDescription methodsFor: 'private' stamp: 'jcg 9/22/2009 16:18'!
initializeAVCFromTrackInfo: trackInfo
	"See RFC3984: 'RTP Payload Format for H.264 Video'."
	| rtpmap fmtp profileLevelID avc frameSize parameterSets decInfo |

	generalType := 'video'.

	"We'll need this, so raise an error here if we don't have it."
	decInfo := trackInfo decoderSpecificInfo ifNil: [
		self error: 'missing AVCDecoderConfigurationRecord'.
	].

	"Initialize the 'rtpmap' attribute.
	Eg: a=rtpmap:96 H264/90000"
	rtpmap := payloadType printString, ' H264/', trackInfo timeScale.
	attributes at: 'rtpmap' put: rtpmap.

	"Initialize the 'fmtp' attribute.
	Eg: a=fmtp:97 profile-level-id=4D4015; packetization-mode=1; sprop-parameter-sets=J01AFakYEAS2ANQYBBrbCte98BA=,KN4JyA==
	"
	avc := AVCDecoderConfigurationRecord fromBytes: decInfo.
	profileLevelID := {avc profileIndication. avc profileCompatibility. avc levelIndication}.
	profileLevelID := profileLevelID asByteArray hex.
	parameterSets := String streamContents: [:s |
		s nextPutAll: 'sprop-parameter-sets='.
		(avc sequenceParameterSets, avc pictureParameterSets)
			do: [:ps |
				| input b64 |
				"I'd like to use #skip: to skip past the first 4 bytes of the param-sets, but 
				 Base64MimeConverter resets the stream position before reading from it."
				"input := ps readStream.
				input skip: 4. "
				input := (ps copyFrom: 5 to: ps size) readStream.
				b64 := Base64MimeConverter mimeEncode: input.
				s nextPutAll: b64 contents.
			]
			separatedBy: [s nextPut: $,].
	].
	fmtp := payloadType printString, 
				' profile-level-id=', profileLevelID,
				'; packetization-mode=1',  "XXXXX: let's try it out."
				'; ', parameterSets.
	attributes at: 'fmtp' put: fmtp.

	"Initialize the 'framesize' attribute."
	frameSize := payloadType printString, ' ', trackInfo width, '-', trackInfo height.
	attributes at: 'framesize' put: frameSize.
	! !

!SDPMediaDescription methodsFor: 'initialize' stamp: 'jcg 8/12/2009 11:37'!
initializeFromLines: sdpLines
	"As specified in RFC 4566:
		m=  (media name and transport address)
		i=* (media title)
		c=* (connection information -- optional if included at
		     session level)
		b=* (zero or more bandwidth information lines)
		k=* (encryption key)
		a=* (zero or more media attribute lines) "
	| stream next mediaType rtpmap fmtp |
	stream := sdpLines readStream.

	"Read media type."
	(stream peek key == $m) ifFalse: [self error: 'expected media-type'].
	mediaType := stream next value findTokens: Character separators.
	generalType := mediaType first. "audio, video, etc."
	mediaType third = 'RTP/AVP' ifFalse: [
		self error: 'only the RTP/AVP SDP profile is supported, not: ', mediaType third.
	].
	payloadType := mediaType fourth asNumber.

	"Read session-info (optional)."
	friendlyInfo := nil.
	(stream peek key == $i) ifTrue: [friendlyInfo := stream next value].

	"Read connectionData (optional).  If present, tokenize."
	connectionData := nil.
	(stream peek key == $c) ifTrue: [
		connectionData := stream next value findTokens: Character separators.
	].

	"Read bandwidth information (option).  If present, tokenize."
	bandwidth := nil.
	(stream peek key == $b) ifTrue: [
		bandwidth := stream next value findTokens: ':'.
		bandwidth := bandwidth first -> bandwidth second asNumber.
	].	

	"Read encryption keys (we don't support this yet)."
	[stream peek key == $k] whileTrue: [
		QLogger logWarning: 'encryption keys are not supported'.
		stream next.
	].

	"Read session attributes."
	attributes := Dictionary new.
	[next := stream peek. next notNil and: [next key == $a]] whileTrue: [
		| line attrName attrRawValue |
		line := stream next value.
		attrName := line copyUpTo: $:.
		attrRawValue := line copyAfter: $:.
		(attributes includesKey: attrName) ifTrue: [
			self error: 'duplicate attribute: ', attrName
		].
		attributes at: attrName put: attrRawValue.
	].

	"Create 'codecConfig' (eg: MP4BoxAAC/AVCConfig) from the info that we've read."
	rtpmap := attributes at: 'rtpmap' ifAbsent: [self error: 'missing "rtpmap" attribute'].
	rtpmap := rtpmap findTokens: ' '.
	rtpmap := (rtpmap last findTokens: '/') first.
	fmtp := attributes at: 'fmtp' ifAbsent: [self error: 'missing "fmtp" attribute'].
	fmtp := fmtp copyAfter: Character space.

	((generalType = 'audio') and: [rtpmap = 'mpeg4-generic']) ifTrue: [
		codecConfig := AACAudioSpecificConfig new initializeFromFMTP: fmtp.
		^self "success!!"
	].
	((generalType = 'video') and: [rtpmap = 'H264']) ifTrue: [
		codecConfig := AVCDecoderConfigurationRecord new initializeFromFMTP: fmtp.
		^self "success!!"
	].

	"Just for unit-testing."
	(rtpmap beginsWith: 'qwaq-test-echo') ifTrue: [^self "success!!"].

	QLogger logWarning: 'unknown media type: ', mediaType first, '/', rtpmap.
	
	

	

! !

!SDPMediaDescription methodsFor: 'initialize' stamp: 'ar 10/19/2009 18:52'!
initializeFromTrackInfo: aQNetVidTrackInfo payloadType: pType

	trackInfo := aQNetVidTrackInfo.
	friendlyInfo := nil.
	connectionData := nil.
	payloadType := pType.
	bandwidth := (trackInfo bitrate / 8 / 1000) rounded.  "in KB/sec, not bits/sec"
	bandwidth := 'AS' -> bandwidth.  "Application-Specific: see RFC4566"
	"Ignore duration: we already have it in the session-description."
	attributes at: 'control' put: 'trackID=', trackInfo trackID.
	attributes at: 'mpeg4-esid' put: trackInfo trackID printString.
	
	"Only AAC and H.264 tracks are supported."
	trackInfo isAAC ifTrue: [^self initializeAACFromTrackInfo: trackInfo].
	trackInfo isAVC ifTrue: [^self initializeAVCFromTrackInfo: trackInfo].
	self error:  'track must be AAC or H.264'.


	


! !

!SDPMediaDescription methodsFor: 'testing' stamp: 'jcg 9/9/2009 09:21'!
isAudio
	^generalType = 'audio'! !

!SDPMediaDescription methodsFor: 'testing' stamp: 'jcg 9/9/2009 09:21'!
isVideo
	^generalType = 'video'! !

!SDPMediaDescription methodsFor: 'accessing' stamp: 'jcg 6/30/2009 18:23'!
payloadType
	^payloadType! !

!SDPMediaDescription methodsFor: 'initialize' stamp: 'jcg 6/30/2009 18:24'!
payloadType: anInteger
	payloadType := anInteger! !

!SDPMediaDescription methodsFor: 'copying' stamp: 'jcg 6/30/2009 17:45'!
postCopy
	super postCopy.

	attributes := attributes deepCopy.! !

!SDPMediaDescription methodsFor: 'accessing' stamp: 'jcg 4/26/2009 16:36'!
serverIP
	"Answer a String representing the IP address to connect to for this media-description."
	| |
	"Look first for connection info for this track."
	connectionData ifNotNilDo: [:cd |
		({cd first. cd second} = #('IN' 'IP4')) ifFalse: [self error: 'expected an IPv4 address'].
		cd third = '0.0.0.0' 
			ifFalse: [^cd third "found it!!"]
			ifTrue: [QLogger logInfo: 'media description has IP 0.0.0.0; ignoring'].
	].
	"We didn't find suitable info in the track, so look in the session."
	session connectionData ifNotNilDo: [:cd |
		({cd first. cd second} = #('IN' 'IP4')) ifFalse: [self error: 'expected an IPv4 address'].
		cd third = '0.0.0.0' 
			ifFalse: [^cd third "found it!!"]
			ifTrue: [QLogger logInfo: 'session description has IP 0.0.0.0; ignoring'].
	].
	"If we still haven't found it, use the origin IP address."
	session origin ifNotNilDo: [:cd |
		({cd fourth. cd fifth} = #('IN' 'IP4')) ifFalse: [self error: 'expected an IPv4 address'].
		^cd sixth
	].
	self error: 'could not find the server IP address'
	! !

!SDPMediaDescription methodsFor: 'accessing' stamp: 'jcg 4/26/2009 16:15'!
session
	^session! !

!SDPMediaDescription methodsFor: 'initialize' stamp: 'jcg 4/26/2009 16:09'!
session: sessionDescription
	session := sessionDescription! !

!SDPMediaDescription methodsFor: 'accessing' stamp: 'ar 10/19/2009 18:51'!
trackInfo
	"If present, describes the QNetVidTrackInfo used to generate the SDP media description"
	^trackInfo! !

!SDPMediaDescription methodsFor: 'accessing' stamp: 'ar 10/19/2009 18:51'!
trackInfo: aQNetVidTrackInfo
	"If present, describes the QNetVidTrackInfo used to generate the SDP media description"
	trackInfo := aQNetVidTrackInfo! !

SDPDescription subclass: #SDPSessionDescription
	instanceVariableNames: 'protocolVersion origin sessionName friendlyInfo uri email phone connectionData bandwidth timing attributes mediaDescriptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-RTSP'!

!SDPSessionDescription commentStamp: 'jcg 7/21/2009 16:06' prior: 0!
Parsed representation of an SDP session-description, which can also be used in the other direction by first initalizing it and then creating a textual representation via #fullPrintOn:.  

Holds top-level information, but not (directly) information about individual streams... we maintain a collection of SDPMediaDescriptions for that purpose.!

!SDPSessionDescription class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!SDPSessionDescription methodsFor: 'comparing' stamp: 'jcg 6/30/2009 17:58'!
= desc "a SDPSessionDescription"
	self class == desc class ifFalse: [^false].
	protocolVersion = desc protocolVersion ifFalse: [^false].
	origin = desc origin ifFalse: [^false].
	sessionName = desc sessionName ifFalse: [^false].
	friendlyInfo = desc friendlyInfo ifFalse: [^false].
	uri = desc uri ifFalse: [^false].
	email = desc email ifFalse: [^false].
	phone = desc phone ifFalse: [^false].
	connectionData = desc connectionData ifFalse: [^false].
	bandwidth = desc bandwidth ifFalse: [^false].
	timing = desc timing ifFalse: [^false].
	attributes = desc attributes ifFalse: [^false].
	mediaDescriptions = desc mediaDescriptions ifFalse: [^false].
	^true! !

!SDPSessionDescription methodsFor: 'accessing' stamp: 'jcg 7/7/2009 15:26'!
addMediaDescription: desc "an SDPMediaDescription"
	mediaDescriptions ifNil: [mediaDescriptions := OrderedCollection new].
	mediaDescriptions add: desc.
	desc session: self.! !

!SDPSessionDescription methodsFor: 'accessing' stamp: 'jcg 6/30/2009 17:54'!
attributes
	^attributes! !

!SDPSessionDescription methodsFor: 'accessing' stamp: 'jcg 6/30/2009 17:54'!
bandwidth
	^bandwidth! !

!SDPSessionDescription methodsFor: 'initialize' stamp: 'jcg 8/29/2009 23:45'!
bandwidth: anInteger
	bandwidth := anInteger! !

!SDPSessionDescription methodsFor: 'accessing' stamp: 'jcg 4/25/2009 21:49'!
connectionData
	^connectionData! !

!SDPSessionDescription methodsFor: 'initialize' stamp: 'jcg 7/7/2009 17:40'!
connectionData: array "eg: #('IN' 'IP4' '127.0.0.1')."
	connectionData := array! !

!SDPSessionDescription methodsFor: 'accessing' stamp: 'jcg 4/25/2009 21:49'!
email
	^email! !

!SDPSessionDescription methodsFor: 'accessing' stamp: 'jcg 4/26/2009 10:14'!
friendlyInfo
	^friendlyInfo! !

!SDPSessionDescription methodsFor: 'initialize' stamp: 'jcg 6/29/2009 17:40'!
friendlyInfo: aString
	friendlyInfo := aString! !

!SDPSessionDescription methodsFor: 'printing' stamp: 'jcg 7/7/2009 14:53'!
fullPrintOn: aStream	
	"As specified in RFC 4566:
		v=  (protocol version)
		o=  (originator and session identifier)
		s=  (session name)
		i=* (session information)
		u=* (URI of description)
		e=* (email address)
		p=* (phone number)
		c=* (connection information -- not required if included in all media)
		b=* (zero or more bandwidth information lines)
		!!!! One or more time descriptions ('t=' and 'r=' lines; see below)
		z=* (time zone adjustments)
		k=* (encryption key)
		a=* (zero or more session attribute lines)
		!!!! Zero or more media descriptions "
	| |

	"SDP version 0."
	aStream nextPutAll: 'v=', protocolVersion; crlf. 

	"Originator and session identifier."
	aStream nextPutAll: 'o='.
	origin do: [:val | aStream nextPutAll: val asString] separatedBy: [aStream space].
	aStream crlf.

	"Session Name.  If none, the RFC recommends using a single space."
	aStream nextPutAll: 's=', (sessionName ifNil: [' ']); crlf.

	"Friendly, human-readable info."
	friendlyInfo ifNotNil: [aStream nextPutAll: 'i=', friendlyInfo; crlf].

	"URI, email address, phone number (all are optional)."
	uri ifNotNil: [aStream nextPutAll: 'u=', uri; crlf].
	email ifNotNil: [aStream nextPutAll: 'e=', email; crlf].
	phone ifNotNil: [aStream nextPutAll: 'p=', phone; crlf].

	"Connection info."
	connectionData ifNotNil: [
		aStream nextPutAll: 'c='.
		connectionData 
			do: [:cd | aStream nextPutAll: cd]
			separatedBy: [aStream space].
		aStream crlf.
	].

	"Bandwidth"
	bandwidth ifNotNil: [
		aStream nextPutAll: 'b=', bandwidth key, ':', bandwidth value; crlf.
	].

	"Timing: we call all sessions 'permanent'; so far, there is no definite
	 time range that we can associate with the session."
	aStream nextPutAll: 't=0 0'; crlf.

	"Print out all attributes."
	attributes keysAndValuesDo: [:key :val |
		aStream nextPutAll: 'a=', key, ':', val; crlf.
	].

	"Finally, tell all the individual media-stream descriptions to print themselves."
	mediaDescriptions do: [:desc | desc fullPrintOn: aStream].


	! !

!SDPSessionDescription methodsFor: 'initialize' stamp: 'jcg 9/16/2009 10:10'!
initialize
	super initialize.
	attributes := Dictionary new.
	mediaDescriptions := OrderedCollection new.

	"See RFC2326... section C.1.1.  This seems to be a sensible default.  It's what we see from QuickTime Streaming Server, and what we'll use for the RTSP sessions that we publish." 
	attributes at: 'control' put: '*'.! !

!SDPSessionDescription methodsFor: 'initialize' stamp: 'jcg 7/7/2009 15:26'!
initializeFromLines: sdpLines
	"As specified in RFC 4566:
		v=  (protocol version)
		o=  (originator and session identifier)
		s=  (session name)
		i=* (session information)
		u=* (URI of description)
		e=* (email address)
		p=* (phone number)
		c=* (connection information -- not required if included in all media)
		b=* (zero or more bandwidth information lines)
		!!!! One or more time descriptions ('t=' and 'r=' lines; see below)
		z=* (time zone adjustments)
		k=* (encryption key)
		a=* (zero or more session attribute lines)
		!!!! Zero or more media descriptions "
	| stream next |
	stream := sdpLines readStream.
	
	"Read protocol version."
	(stream peek key == $v) ifFalse: [self error: 'expected protocol-version'].
	protocolVersion := stream next value asInteger.

	"Read originator... tokenize, but don't process any further.  
	 For more detail, see the comment in #origin"
	(stream peek key == $o) ifFalse: [self error: 'expected originator info'].
	origin := stream next value findTokens: Character separators.
	origin at: 2 put: origin second asNumber.
	origin at: 3 put: origin third asNumber.

	"Read session name."
	(stream peek key == $s) ifFalse: [self error: 'expected session name'].
	sessionName := stream next value.

	"Read session-info (optional)."
	friendlyInfo := nil.
	(stream peek key == $i) ifTrue: [friendlyInfo := stream next value].

	"Read session URI (optional)."
	uri := nil.
	(stream peek key == $u) ifTrue: [uri := stream next value].

	"Read session email address (optional)."
	email := nil.
	(stream peek key == $e) ifTrue: [email := stream next value].

	"Read session phone number (optional)."
	phone := nil.
	(stream peek key == $p) ifTrue: [phone := stream next value].

	"Read connectionData (optional).  If present, tokenize."
	connectionData := nil.
	(stream peek key == $c) ifTrue: [
		connectionData := stream next value findTokens: Character separators.
	].

	"Read bandwidth information (option).  If present, tokenize."
	bandwidth := nil.
	[stream peek key == $b] whileTrue: [
		bandwidth
			ifNil: [
				bandwidth := stream next value findTokens: ':'.
				bandwidth := bandwidth first -> bandwidth second asNumber.
			]
			ifNotNil: [
				"The spec allows multiple bandwidth values, but we only support one."
				QLogger logWarning: 'session bandwidth was already read. ignoring.'.
				stream next.
			].
	].	

	"Read start/stop times."
	timing := nil.
	[stream peek key == $t] whileTrue: [
		timing 
			ifNil: [timing := stream next value findTokens: Character separators]
			ifNotNil: [
				QLogger logWarning: 'only support one time-range. ignoring.'.
				stream next
			].
	].
	[stream peek key == $r] whileTrue: [
		QLogger logWarning: 'repeating time-ranges are not supported'.
		stream next.
	].
	[stream peek key == $z] whileTrue: [
		QLogger logWarning: 'time-zone offsets are not supported'.
		stream next.
	].

	"Read encryption keys (we don't support this yet)."
	[stream peek key == $k] whileTrue: [
		QLogger logWarning: 'encryption keys are not supported'.
		stream next.
	].

	"Read session attributes."
	attributes := Dictionary new.
	[stream peek key == $a] whileTrue: [
		| line attrName attrRawValue |
		line := stream next value.
		attrName := line copyUpTo: $:.
		attrRawValue := line copyAfter: $:.
		(attributes includesKey: attrName) ifTrue: [
			self error: 'duplicate attribute: ', attrName
		].
		attributes at: attrName put: attrRawValue.
	].

	"Read media descriptions."
	mediaDescriptions := OrderedCollection new.
	[next := stream peek. next notNil and: [next key == $m]] whileTrue: [
		| mediaLines desc |
		mediaLines := OrderedCollection new.
		mediaLines add: stream next.
		[next := stream peek. next notNil and: [next key ~~ $m]] whileTrue: [
			mediaLines add: stream next
		].
		desc := SDPMediaDescription newFromLines: mediaLines.
		self addMediaDescription: desc.
	].

	self validate.

	
	! !

!SDPSessionDescription methodsFor: 'accessing' stamp: 'jcg 4/26/2009 10:57'!
mediaDescriptions
	^mediaDescriptions! !

!SDPSessionDescription methodsFor: 'accessing' stamp: 'jcg 6/30/2009 18:35'!
nextPayloadTypeIndex
	"See RFC3551, Table 5.  We don't use static payload-types.  The purpose of this method is to increment the dynamic-payload-time index once for each media-description that we add."
	mediaDescriptions
		ifEmpty: [96]
		ifNotEmpty: [mediaDescriptions last payloadType+1].! !

!SDPSessionDescription methodsFor: 'accessing' stamp: 'jcg 4/26/2009 16:30'!
origin
	"Answer the session origin, as described in RFC4566, section 5.2.  Each field is represented by a separate String (6 in total):
	- username		
	- sess-id			(globally unique; suggested to use NTP format timestamp)
	- sess-version		(again, NTP timestamp is recommded)
	- nettype			(eg: 'IN' for 'internet')
	- addrtype			(eg: 'IP4' for 'Internet Protocol, version 4')
	- unicast-address	(eg: '67.228.145.227')
"
	^origin! !

!SDPSessionDescription methodsFor: 'initialize' stamp: 'jcg 7/7/2009 14:49'!
origin: serverName sessionID: idNumber sessionVersion: versionNumber ipAddress: addrString
	origin := OrderedCollection new.
	origin
		add: serverName; 
		add: idNumber; 
		add: versionNumber; 
		add: 'IN';
		add: 'IP4';
		add: addrString.! !

!SDPSessionDescription methodsFor: 'accessing' stamp: 'jcg 4/25/2009 21:49'!
phone
	^phone! !

!SDPSessionDescription methodsFor: 'copying' stamp: 'jcg 6/30/2009 17:45'!
postCopy
	super postCopy.

	mediaDescriptions := mediaDescriptions collect: [:md |
		md copy session: self; yourself
	].
	attributes := attributes deepCopy.

	"XXXXX: Probably should copy others, too (like 'connectionData')."
	! !

!SDPSessionDescription methodsFor: 'accessing' stamp: 'jcg 4/25/2009 21:47'!
protocolVersion
	^protocolVersion! !

!SDPSessionDescription methodsFor: 'initialize' stamp: 'jcg 7/7/2009 12:44'!
protocolVersion: versionNumber
	protocolVersion := versionNumber.! !

!SDPSessionDescription methodsFor: 'accessing' stamp: 'jcg 6/29/2009 14:43'!
range
	"Answer the value from the Range attribute; raise an error if none exists.  The answer is a 2-element array representing the start and end of the range.  SDP allows the range to be specified in multiple formats; we support only the Normal Play Time format."

	"XXXXX: actually, we only support a subset of NPT format.  See RFC2326-3.6 for what we're supposed to support.  We assume that the from/to values are represented in seconds.  Here are examples of what we don't support yet: 
	npt=12:05:35-12:07:53	(don't support hhmmss format)
	npt=234.2-				(must explicitly specify both from/to)
	npt=now-					(don't support 'now' constant)
"
 
	| r |
	r := attributes at: 'range' ifAbsent: [self error: 'no "range" attribute found'].
	r := r findTokens: ';'.
	r := r 
		detect: [:string | string beginsWith: 'npt']
		ifNone: [self error: 'invalid "range" attribute... we only accept "npt" ranges'].
	(r includes: $:) ifTrue: [self error: 'we do not support "hhmmss" format'].
	(r includesSubString: 'now') 
		ifTrue: [self error: 'we do not support the "now" constant'].
	r := r copyAfter: $=.
	r := r findTokens: '- '.
	r size = 2 
		ifFalse: [self error: 'invalid "range" attribute... expect single key/value pair'].
	^{r first asNumber. r second asNumber}! !

!SDPSessionDescription methodsFor: 'accessing' stamp: 'jcg 6/29/2009 14:41'!
range: r "a 2-element array"
	"Set the value of the Range attributed, using Normal Play Time format (NPT: see RFC2326).  We only support the 'npt-sec' format."
	attributes at: 'range' put: 'npt=', r first, '-', r second.
	! !

!SDPSessionDescription methodsFor: 'accessing' stamp: 'jcg 4/25/2009 21:47'!
sessionName
	^sessionName! !

!SDPSessionDescription methodsFor: 'initialize' stamp: 'jcg 7/7/2009 14:55'!
sessionName: nameString
	sessionName := nameString! !

!SDPSessionDescription methodsFor: 'accessing' stamp: 'jcg 6/30/2009 17:54'!
timing
	^timing! !

!SDPSessionDescription methodsFor: 'initialize' stamp: 'jcg 8/27/2009 23:57'!
timing: array "eg: #('0' '0')."
	timing := array! !

!SDPSessionDescription methodsFor: 'accessing' stamp: 'jcg 4/25/2009 21:49'!
uri
	^uri! !

!SDPSessionDescription methodsFor: 'initialize' stamp: 'jcg 4/25/2009 21:48'!
validate

	"See RFC4566-5.1"	
	protocolVersion = 0 ifFalse: [
		self error: 'validation failed: bad protocol version: ', protocolVersion
	].

	"See RFC4566-5.7"
	(connectionData notNil or: 
	[mediaDescriptions allSatisfy: [:md | md connectionData notNil]])
		ifFalse: [self error: 'validation failed: missing connection data'].
	! !

ExternalStructure subclass: #QDecodedFrameMetadataMC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-LowLevel'!

!QDecodedFrameMetadataMC commentStamp: '<historical>' prior: 0!
Used to retrieve data corresponding to a decoded picture from the H.264 decoder.!

!QDecodedFrameMetadataMC class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QDecodedFrameMetadataMC class methodsFor: 'field definition' stamp: 'jcg 1/31/2009 14:37'!
fields
	"QDecodedFrameMetadataMC defineFields"
	^#(
		(version 'long')
		(inputSequenceNumber 'long')
		(outputputSequenceNumber 'long')
		"The rest are from ISO/IEC 13818-2 section 6.2.3: picture_header"
		(temporalReference 'long')
		(pictureCodingType 'long') "picture type of last picture decoded"
		(pictureType 'long') "picture type of current displayed frame"
		(vbvDelay 'long')
		(fullPelForwardVector 'long')
		(forwardFCode 'long')
		(fullPelBackwardVector 'long')
		(backwardFCode 'long')
		"For sanity check."
		(sanity 'long')
	)! !

!QDecodedFrameMetadataMC methodsFor: 'accessing' stamp: 'jcg 1/31/2009 14:37'!
backwardFCode
	"This method was automatically generated"
	^handle signedLongAt: 41! !

!QDecodedFrameMetadataMC methodsFor: 'accessing' stamp: 'jcg 1/31/2009 14:37'!
backwardFCode: anObject
	"This method was automatically generated"
	handle signedLongAt: 41 put: anObject! !

!QDecodedFrameMetadataMC methodsFor: 'accessing' stamp: 'jcg 1/31/2009 14:37'!
forwardFCode
	"This method was automatically generated"
	^handle signedLongAt: 33! !

!QDecodedFrameMetadataMC methodsFor: 'accessing' stamp: 'jcg 1/31/2009 14:37'!
forwardFCode: anObject
	"This method was automatically generated"
	handle signedLongAt: 33 put: anObject! !

!QDecodedFrameMetadataMC methodsFor: 'accessing' stamp: 'jcg 1/31/2009 14:37'!
fullPelBackwardVector
	"This method was automatically generated"
	^handle signedLongAt: 37! !

!QDecodedFrameMetadataMC methodsFor: 'accessing' stamp: 'jcg 1/31/2009 14:37'!
fullPelBackwardVector: anObject
	"This method was automatically generated"
	handle signedLongAt: 37 put: anObject! !

!QDecodedFrameMetadataMC methodsFor: 'accessing' stamp: 'jcg 1/31/2009 14:37'!
fullPelForwardVector
	"This method was automatically generated"
	^handle signedLongAt: 29! !

!QDecodedFrameMetadataMC methodsFor: 'accessing' stamp: 'jcg 1/31/2009 14:37'!
fullPelForwardVector: anObject
	"This method was automatically generated"
	handle signedLongAt: 29 put: anObject! !

!QDecodedFrameMetadataMC methodsFor: 'accessing' stamp: 'jcg 1/31/2009 14:37'!
inputSequenceNumber
	"This method was automatically generated"
	^handle signedLongAt: 5! !

!QDecodedFrameMetadataMC methodsFor: 'accessing' stamp: 'jcg 1/31/2009 14:37'!
inputSequenceNumber: anObject
	"This method was automatically generated"
	handle signedLongAt: 5 put: anObject! !

!QDecodedFrameMetadataMC methodsFor: 'accessing' stamp: 'jcg 1/31/2009 14:37'!
outputputSequenceNumber
	"This method was automatically generated"
	^handle signedLongAt: 9! !

!QDecodedFrameMetadataMC methodsFor: 'accessing' stamp: 'jcg 1/31/2009 14:37'!
outputputSequenceNumber: anObject
	"This method was automatically generated"
	handle signedLongAt: 9 put: anObject! !

!QDecodedFrameMetadataMC methodsFor: 'accessing' stamp: 'jcg 1/31/2009 14:37'!
pictureCodingType
	"This method was automatically generated"
	^handle signedLongAt: 17! !

!QDecodedFrameMetadataMC methodsFor: 'accessing' stamp: 'jcg 1/31/2009 14:37'!
pictureCodingType: anObject
	"This method was automatically generated"
	handle signedLongAt: 17 put: anObject! !

!QDecodedFrameMetadataMC methodsFor: 'accessing' stamp: 'jcg 1/31/2009 14:37'!
pictureType
	"This method was automatically generated"
	^handle signedLongAt: 21! !

!QDecodedFrameMetadataMC methodsFor: 'accessing' stamp: 'jcg 1/31/2009 14:37'!
pictureType: anObject
	"This method was automatically generated"
	handle signedLongAt: 21 put: anObject! !

!QDecodedFrameMetadataMC methodsFor: 'accessing' stamp: 'jcg 1/31/2009 14:37'!
sanity
	"This method was automatically generated"
	^handle signedLongAt: 45! !

!QDecodedFrameMetadataMC methodsFor: 'accessing' stamp: 'jcg 1/31/2009 14:37'!
sanity: anObject
	"This method was automatically generated"
	handle signedLongAt: 45 put: anObject! !

!QDecodedFrameMetadataMC methodsFor: 'accessing' stamp: 'jcg 1/31/2009 14:37'!
temporalReference
	"This method was automatically generated"
	^handle signedLongAt: 13! !

!QDecodedFrameMetadataMC methodsFor: 'accessing' stamp: 'jcg 1/31/2009 14:37'!
temporalReference: anObject
	"This method was automatically generated"
	handle signedLongAt: 13 put: anObject! !

!QDecodedFrameMetadataMC methodsFor: 'accessing' stamp: 'jcg 1/31/2009 14:37'!
vbvDelay
	"This method was automatically generated"
	^handle signedLongAt: 25! !

!QDecodedFrameMetadataMC methodsFor: 'accessing' stamp: 'jcg 1/31/2009 14:37'!
vbvDelay: anObject
	"This method was automatically generated"
	handle signedLongAt: 25 put: anObject! !

!QDecodedFrameMetadataMC methodsFor: 'accessing' stamp: 'jcg 1/31/2009 14:37'!
version
	"This method was automatically generated"
	^handle signedLongAt: 1! !

!QDecodedFrameMetadataMC methodsFor: 'accessing' stamp: 'jcg 1/31/2009 14:37'!
version: anObject
	"This method was automatically generated"
	handle signedLongAt: 1 put: anObject! !

ExternalStructure subclass: #QVideoFrameEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-Webcam'!

!QVideoFrameEvent commentStamp: 'jcg 1/12/2008 16:30' prior: 0!
Corresponds to the QWebcamPlugin C++ structure Qwaq::SqueakVideoFrameEvent, which is used by Qwaq::VideoFrameEvent to communicate information about the video frame back to Squeak.  !

!QVideoFrameEvent class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QVideoFrameEvent class methodsFor: 'field definition' stamp: 'jcg 1/12/2008 19:31'!
fields
	"QVideoFrameEvent defineFields"
	^#(
		(type 'long')
		(sampleTime 'double')
		(bufferSize 'ulong')
		(buffer 'unsigned char*')
	)! !

!QVideoFrameEvent methodsFor: 'accessing' stamp: 'jcg 1/12/2008 20:48'!
buffer
	"This method was automatically generated"
	^ExternalData fromHandle: (handle pointerAt: 17) type: ExternalType void asPointerType! !

!QVideoFrameEvent methodsFor: 'accessing' stamp: 'jcg 1/12/2008 20:48'!
buffer: anObject
	"This method was automatically generated"
	handle pointerAt: 17 put: anObject getHandle.! !

!QVideoFrameEvent methodsFor: 'accessing' stamp: 'jcg 1/12/2008 20:48'!
bufferSize
	"This method was automatically generated"
	^handle unsignedLongAt: 13! !

!QVideoFrameEvent methodsFor: 'accessing' stamp: 'jcg 1/12/2008 20:48'!
bufferSize: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 13 put: anObject! !

!QVideoFrameEvent methodsFor: 'double-dispatch' stamp: 'jcg 1/13/2008 00:12'!
processIn: camera
	camera readFrameFrom: self! !

!QVideoFrameEvent methodsFor: 'accessing' stamp: 'jcg 1/12/2008 20:48'!
sampleTime
	"This method was automatically generated"
	^handle doubleAt: 5! !

!QVideoFrameEvent methodsFor: 'accessing' stamp: 'jcg 1/12/2008 20:48'!
sampleTime: anObject
	"This method was automatically generated"
	handle doubleAt: 5 put: anObject! !

!QVideoFrameEvent methodsFor: 'accessing' stamp: 'jcg 1/12/2008 20:48'!
type
	"This method was automatically generated"
	^handle signedLongAt: 1! !

!QVideoFrameEvent methodsFor: 'accessing' stamp: 'jcg 1/12/2008 20:48'!
type: anObject
	"This method was automatically generated"
	handle signedLongAt: 1 put: anObject! !

ExternalStructure subclass: #QWebcamParams
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-Webcam'!

!QWebcamParams commentStamp: '<historical>' prior: 0!
Mirrors the C++ struct WebcamDShowParams from QWebcamPlugin:

struct WebcamDShowParams
{
	// version 1 fields
	int version;
	int width;
	int height;
	double fps;
	// version 2 fields
	//	(none yet)
};

!

!QWebcamParams class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QWebcamParams class methodsFor: 'field definition' stamp: 'jcg 1/12/2008 17:07'!
fields
	"QWebcamParams defineFields"

	"REMEMBER: when updating this, you might need to add padding so that the fields are aligned wit those in the C++ struct.  For instance, I originally had 'fps' before 'semInd', but by swapping them 'fps' falls on an 8-byte boundary.  Schweet."

	^ #(
			"version 1 fields"
			(version		'long')
			(width		'long')
			(height		'long')
			(fps			'double')
			"version 2 fields (none yet)"
		)! !

!QWebcamParams methodsFor: 'private' stamp: 'jcg 12/31/2007 17:10'!
currentVersion
	"Current version of struct."
	^1
! !

!QWebcamParams methodsFor: 'accessing' stamp: 'jcg 1/12/2008 17:12'!
fps
	"This method was automatically generated"
	^handle doubleAt: 13! !

!QWebcamParams methodsFor: 'accessing' stamp: 'jcg 1/12/2008 17:12'!
fps: anObject
	"This method was automatically generated"
	handle doubleAt: 13 put: anObject! !

!QWebcamParams methodsFor: 'accessing' stamp: 'jcg 1/12/2008 17:12'!
height
	"This method was automatically generated"
	^handle signedLongAt: 9! !

!QWebcamParams methodsFor: 'accessing' stamp: 'jcg 1/12/2008 17:12'!
height: anObject
	"This method was automatically generated"
	handle signedLongAt: 9 put: anObject! !

!QWebcamParams methodsFor: 'accessing' stamp: 'jcg 12/31/2007 17:33'!
semInd
	"This method was automatically generated"
	^handle signedLongAt: 13! !

!QWebcamParams methodsFor: 'accessing' stamp: 'jcg 12/31/2007 17:33'!
semInd: anObject
	"This method was automatically generated"
	handle signedLongAt: 13 put: anObject! !

!QWebcamParams methodsFor: 'private' stamp: 'jcg 12/31/2007 17:09'!
setHandle: anObject
	super setHandle: anObject.
	self isNull ifFalse: [self version: self currentVersion].! !

!QWebcamParams methodsFor: 'accessing' stamp: 'jcg 1/12/2008 17:12'!
version
	"This method was automatically generated"
	^handle signedLongAt: 1! !

!QWebcamParams methodsFor: 'accessing' stamp: 'jcg 1/12/2008 17:12'!
version: anObject
	"This method was automatically generated"
	handle signedLongAt: 1 put: anObject! !

!QWebcamParams methodsFor: 'accessing' stamp: 'jcg 1/12/2008 17:12'!
width
	"This method was automatically generated"
	^handle signedLongAt: 5! !

!QWebcamParams methodsFor: 'accessing' stamp: 'jcg 1/12/2008 17:12'!
width: anObject
	"This method was automatically generated"
	handle signedLongAt: 5 put: anObject! !

QCullingRectangle subclass: #QVideoRectangle
	instanceVariableNames: 'speaker'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-Texture'!

!QVideoRectangle commentStamp: '<historical>' prior: 0!
Used for display on a QDisplaySheet.

Note that video rectangles have a pointerDown event-mask
(to allow clicking to resume video.)!

!QVideoRectangle class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QVideoRectangle class methodsFor: 'defaults' stamp: 'bgf 11/10/2009 16:23'!
defaultEventMask
	^ EventPointerDown! !

!QVideoRectangle methodsFor: 'initialize' stamp: 'jcg 1/25/2008 13:03'!
destroy
	super destroy.
	self destroyTexture.! !

!QVideoRectangle methodsFor: 'initialize' stamp: 'jcg 1/25/2008 13:03'!
destroyTexture
	| mat |
	mat := super material.
	mat texture ifNotNilDo: [:txtr |
		mat texture: nil.
		txtr destroy
	].
	! !

!QVideoRectangle methodsFor: 'initialize' stamp: 'crl 1/11/2010 14:51'!
initialize
	| mat |
	super initialize.

	mat := QVideoMaterial new
						ambientColor: #(0.9 0.9 0.9 1) asVectorColor;
						diffuseColor: #(1 1 1 1) asVectorColor;
						emissiveColor: #(0.2 0.2 0.2 1) asVectorColor;
					 	specularColor: #(0 0 0 1)  asVectorColor;
						shininess: 0.1;
						hashedName: '1234567890123456789012345678901'
						yourself.
	super material: mat.
	speaker := QSpeaker new.
	self addChild: speaker.
	speaker startPlaying! !

!QVideoRectangle methodsFor: 'initialize' stamp: 'crl 12/16/2009 17:57'!
initializeWithDescription: desc "a QStreamingVideoDescription"
	| mat |
	mat := super material.
	self destroyTexture.
	mat texture: QWebcamTexture new.
	mat texture description: desc.
	mat hashedName: (desc ifNotNil: [desc computeHashedName]).
! !

!QVideoRectangle methodsFor: 'initialize' stamp: 'crl 4/15/2010 17:38'!
initializeWithWebcastRecord: record "a QWebcastRecord"
	| mat |
	mat := super material.
	self destroyTexture.
	QLogger logInfo: 'marking speaker for secure video'.
	speaker markForSecureVideo.
	mat texture: ((QWebcastTexture new) speaker: speaker; yourself).
	mat texture description: record.
	mat hashedName: record sessionID.
! !

!QVideoRectangle methodsFor: 'initialize' stamp: 'jcg 1/25/2008 12:54'!
material: ignore! !

!QVideoRectangle methodsFor: 'accessing' stamp: 'jcg 9/15/2007 10:38'!
originalAspect
	| videoExtent |
	videoExtent := self material texture videoExtent.
	^videoExtent y / videoExtent x asFloat! !

!QVideoRectangle methodsFor: 'events' stamp: 'bgf 5/29/2008 18:15'!
pointerUp: event

	"If the user clicks in a video area, 
	 we signal (via the avatar-user) so there's a chance to reactivate video."

	event avatar signal: #videoRectangleClicked! !

RtspSession subclass: #QRtspBroadcastSession
	instanceVariableNames: 'webcast netVidClient netVidStreamID rtpServers creationTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-RTSP'!

!QRtspBroadcastSession commentStamp: 'jcg 9/10/2009 10:18' prior: 0!
Receives data from a NetVid session (via a RtspSessionBroadcaster).!

!QRtspBroadcastSession class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QRtspBroadcastSession class methodsFor: 'instance creation' stamp: 'jcg 9/11/2009 17:13'!
forBroadcaster: bcaster "an RtspNetVidBroadcaster "
	^self new broadcaster: bcaster; yourself! !

!QRtspBroadcastSession methodsFor: 'accessing' stamp: 'jcg 12/8/2009 19:31'!
age
	"Answer a Duration."
	^DateAndTime now - creationTime! !

!QRtspBroadcastSession methodsFor: 'initialize' stamp: 'jcg 12/8/2009 17:10'!
broadcaster: bcaster "an RtspNetVidBroadcaster "
	"XXXXX: for compability... remove me any time in 2010."
	self webcast: bcaster.
! !

!QRtspBroadcastSession methodsFor: 'netvid' stamp: 'jcg 12/14/2009 20:28'!
connectToNetVidStreamID: newStreamID
	| elapsed hasTracks |
	[
		netVidStreamID := newStreamID.
		self destroyNetVidClient.
	
		netVidClient := QRtspBroadcastNetVidClient new.
		netVidClient 
			webcast: webcast;
			streamManager: webcast streamManager;
			playerOutputClass: RtspNetVidTrackBroadcaster.
		self runScript: #onNetVidClientDestroyed: when: { netVidClient. #destroyed }.
		self 
			runScript: #onNetVidControlStreamDestroyed: 
			when: {netVidClient. #controlStreamDestroyed}.
		netVidClient subscribeToControlStream: newStreamID.
		netVidClient isConnected ifFalse: [
			QLogger logWarning: 'failed to connect NetVid control-stream'.
			self destroy.
		].
		"Wait for NetVid client to connect to all tracks listed in the SDP."
		hasTracks := false.
		elapsed := [
			| numTracks |
			numTracks := webcast sdp mediaDescriptions size.
			60 timesRepeat: [
				hasTracks ifFalse: [hasTracks := netVidClient allPlayers size = numTracks].
				hasTracks ifFalse: [(Delay forMilliseconds: 500) wait]
			].
		] timeToRun.
		hasTracks
			ifTrue: [QLogger logInfo: 'NetVid connected all tracks in ', elapsed, 'msecs']
			ifFalse: [
				QLogger logWarning: 'NetVid client never connected all necessary tracks'.
				self destroy.
			].
	] on: Error do: [:err |
		QLogger logError: 'error while connecting to NetVid stream'.
		QLogger logError: err.
		self destroy
	].

	self processRtspRequests.! !

!QRtspBroadcastSession methodsFor: 'accessing' stamp: 'jcg 12/8/2009 19:32'!
creationTime
	^creationTime! !

!QRtspBroadcastSession methodsFor: 'initialize' stamp: 'jcg 9/14/2009 12:53'!
destroyNetVidClient
	netVidClient ifNotNilDo: [:nvc |
		netVidClient := nil.
		self stopAllScriptsTriggeredBy: nvc.
		nvc destroy.
	].
! !

!QRtspBroadcastSession methodsFor: 'request-handling' stamp: 'ar 10/19/2009 19:01'!
handlePAUSE: req
	| fields | 
	QLogger logInfo: 'received PAUSE request'.
	state := #paused.
	fields := self defaultResponseFields.
	req sendResponse: 200 fields: fields.
	netVidClient pauseLocally.! !

!QRtspBroadcastSession methodsFor: 'request-handling' stamp: 'ar 10/27/2009 17:32'!
handlePLAY: req
	| fields base | 

	QLogger logInfo: 'received PLAY request'.

	QLogger logWarning: 'waiting briefly for NetVid client to connect'.
(Delay forMilliseconds: 300) wait.

	state == #play ifTrue: [^self].
	state := #play.
	fields := self defaultResponseFields.

	fields at: 'RTP-Info' put: (String streamContents:[:s|
		base := req rawUrl.
		(base endsWith: '/') ifFalse: [base := base, '/'].
		rtpServers do:[:server|
			s nextPutAll: 'url=', base, 'trackID=', server trackID,';'.
			s nextPutAll: 'seq=', (server seqNum+1), ';'.
			s nextPutAll: 'rtptime=', server timeBase.
			server resetTimeOffset.
		] separatedBy:[s nextPut: $,].
	]).

	req sendResponse: 200 fields: fields.
	netVidClient unpauseLocally.! !

!QRtspBroadcastSession methodsFor: 'request-handling' stamp: 'ar 10/12/2009 11:30'!
handleSETPARAM: req
	req sendResponse: 200 fields: Dictionary new.
! !

!QRtspBroadcastSession methodsFor: 'request-handling' stamp: 'jcg 6/16/2010 18:51'!
handleSETUP: req
	| trackID fields server mediaDescription trackPlayer |

	"XXXXX: would be better if we verified that whole URL matches up."
	trackID := req url schemeSpecificPart copyAfterLast: $/.
	trackID ifEmpty: [
		"The request doesn't specify a particular track, 
		 but we don't support aggregate control."
		QLogger logInfo: 'SETUP: 459 response for: ', req url schemeSpecificPart.
		^req send459Response.
	].

	"We only support 'interleaved' transport, so make sure the client is OK with that."
	(self parseTransportTypes: req) 
		detect: [:tr | 
			QLogger logInfo: 'TRANSPORT: ', tr. 
			tr first = 'RTP/AVP/TCP']
		ifNone: [
			QLogger logWarning: 'client did not request RTP/AVP/TCP transport'.
			^req send461Response
		].

	"Find the request track in the SDP."
	mediaDescription := (webcast sdp mediaDescriptions)
		detect: [:desc | trackID = (desc attributes at: 'control' ifAbsent: [nil])]
		ifNone: [
			QLogger logWarning: 'trackID does not match any media-description'.
			^req send404Response
		].				
	server := RtpServer new.
	server 
		setupTransportType: #interleaved 
		dataPort: rtpServers size *2 
		controlPort: rtpServers size *2+1.
	server rtsp: self.
	server mediaDescription: mediaDescription.
	rtpServers add: server.

	"Hook up the track player with the RTP server so that data is passed along properly"
	trackPlayer := netVidClient allPlayers 
		detect:[:tp| tp trackID = mediaDescription trackInfo trackID] ifNone:[nil].
	trackPlayer ifNil:[
		QLogger logError: 'Track player not found (track id: ', trackID,')'.
		^req send404Response
	] ifNotNil:[
		trackPlayer output rtpServer: server.
	].

	fields := Dictionary new.
	fields 
		at: 'Transport'
		put: 'RTP/AVP/TCP;unicast;',
			'interleaved=', server dataPort, '-', server controlPort, ';',
			'ssrc=', ((server syncSource hex allButFirst: 3) padded: #left to: 8 with: $0).
	fields at: 'Session' put: sessionID.
	"The following are headers observed from QTSS. 
	The x-Dynamic-Rate header is REQUIRED by QT 7.6.4 otherwise the behavior
	is erratic (video randomly not showing)."
	fields at: 'Cache-Control' put: 'must-revalidate'.
	fields at: 'x-Transport-Options' put: 'late-tolerance=1.400000'.

	"If this isn't our first SETUP request, then we're done.  Otherwise, we need to compute (or make up) a value for 'x-Dynamic-Rate'."
	rtpServers size > 0 ifTrue: [
		^req sendResponse: 200 fields: fields
	].

	"Toggle whether we send an OPTIONS request to determine round-trip time."
	"XXXXX: not enabled for now... when we enable it, the client never sends anything back after the expected 501 response.  It's not clear why... looking at Wireshark, it looks like we're sending the right stuff.  There might be a timing dependency built into the QuickTime Player code, or something.  Anyway, it seems to work OK if we make up a round-trip time."
	false
		ifFalse: [
			"Old way: just make up a value."
			fields at: 'x-Dynamic-Rate' put: '1;rtt=100'.
			req sendResponse: 200 fields: fields.
		]
		ifTrue: [
			"New way: send random data, and time how long it takes to get the response."
			"XXXXX: it smells funny that part of this code is in the connection and some of
			 it is in the session.  Not sure what the proper approach is right now."
			connection roundTripPromise whenFulfilled: [:rtt |
				QLogger logInfo: 'determined round-trip time to be: ', rtt.
				fields at: 'x-Dynamic-Rate' put: '1;rtt=', rtt.
				req sendResponse: 200 fields: fields.
			].
			connection synchronizedWriteStream: [:str |
				str nextPutAll: 'OPTIONS * RTSP/1.0'; crlf.
				str nextPutAll: 'Content-type: application/x-random-data'; crlf.
				str nextPutAll: 'Content-length: 1400'; crlf; crlf.
				str nextPutAll: (TObjectID new: 1400) hex.
				str flush.
			].
		].
! !

!QRtspBroadcastSession methodsFor: 'initialize' stamp: 'jcg 12/8/2009 19:30'!
initialize
	super initialize.
	rtpServers := OrderedCollection new.
	creationTime := DateAndTime now.
! !

!QRtspBroadcastSession methodsFor: 'private' stamp: 'jcg 10/28/2009 16:02'!
netVidClientDestroyed: nvc
	"Should be run from within event-loop (see #onNetVidClientDestroyed:)."
	nvc == netVidClient
		ifTrue: [self destroyNetVidClient]
		ifFalse: [
			"This is OK; since we always send #destroyNetVidClient before creating 
			 a new client, we will have already destroyed 'nvc'.  We can only end up
			 here if #onDestroyNetVidClientDestroyed: runs and enqueues its message,
			 and #destroyNetVidClient then runs before this method reaches the front
			 of the event-loop queue.  Again, this is nothing to be concerned about.  "
		].
! !

!QRtspBroadcastSession methodsFor: 'private' stamp: 'jcg 10/28/2009 16:02'!
onNetVidClientDestroyed: nvc "a QNetVidClient"
	"We synchronously received this notification from our net-vid client... schedule it to be executed on our event-loop."
	self future netVidClientDestroyed: nvc! !

!QRtspBroadcastSession methodsFor: 'events' stamp: 'jcg 9/14/2009 14:44'!
onNetVidControlStreamDestroyed: controlStream
	QLogger logInfo: 'NetVid control-stream was destroyed; shutting down.'.
	self future destroy.! !

!QRtspBroadcastSession methodsFor: 'initialize' stamp: 'jcg 10/20/2009 10:49'!
privateDestroy
	super privateDestroy.
	netVidClient ifNotNilDo: [:nvc | nvc destroy].! !

!QRtspBroadcastSession methodsFor: 'request-handling' stamp: 'jcg 9/14/2009 13:22'!
readyForRequests
	"As long as the NetVid client is connected and we have a track-listing, we're ready to process requests."
	netVidClient 
		ifNil: [^false]
		ifNotNilDo: [:nc |
			nc isConnected ifFalse: [^false].
			nc sdp ifNil: [^false].
			^true
		].
		! !

!QRtspBroadcastSession methodsFor: 'accessing' stamp: 'jcg 12/8/2009 19:56'!
webcast
	^webcast! !

!QRtspBroadcastSession methodsFor: 'initialize' stamp: 'jcg 12/8/2009 17:10'!
webcast: wcast "a QWebcast"
	webcast := wcast.
	self future connectToNetVidStreamID: webcast netVidStreamID.! !

QSharedDocument subclass: #QStreamingVideoDocument
	instanceVariableNames: 'volume autoPlay looping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Integration'!

!QStreamingVideoDocument commentStamp: '<historical>' prior: 0!
An MP4/MPV video document (or an MRI session recording).
Adds some playback hints to QSharedDocument.!

!QStreamingVideoDocument class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QStreamingVideoDocument class methodsFor: 'inspector' stamp: 'bgf 1/28/2010 11:50'!
addPropertyRows: dialog forFrame: svdocref
	| row |
	super addPropertyRows: dialog forFrame: svdocref.

	row := QBoolean2PropertyRow 
							newForFlag: ' Auto-play upon launch' 
							flag: ' Loop to beginning'.
	row
		fetchBlock: [ :docref | { (docref get: #isAutoPlay) . (docref get: #isLooping)  } ];
		acceptBlock: [ :b2 :docref | 
			docref future isAutoPlay: (b2 first). 
			docref future isLooping: (b2 second) 
		];
		balloonHelp: ('Should the video play immediately when launched?\\Should the video play again from the beginning when it reaches the end?' withCRs).		
	row flag2 left: row flag2 left + 50.

	dialog addRow: row.
! !

!QStreamingVideoDocument class methodsFor: 'customs' stamp: 'jcg 5/29/2009 16:05'!
needsFullDownloadToCreateFileCard
	"The whole point of streaming video from the server is not having users download it."
	^false! !

!QStreamingVideoDocument methodsFor: 'comparing' stamp: 'bgf 4/11/2010 13:31'!
= other
	"Since we have instance-specific properties,
	 don't fool the document tool into treating separate displays as one.
	 We do need provide equality tests though, to allow the document-shelving system to detect redundancies."
	super = other ifFalse: [ ^ false ].
	volume = other volume ifFalse: [ ^ false ].
	autoPlay = other isAutoPlay ifFalse: [ ^ false ].
	looping = other isLooping ifFalse: [ ^ false ].
	^ true! !

!QStreamingVideoDocument methodsFor: 'testing' stamp: 'bgf 7/24/2009 23:00'!
canUseAsForumWelcome
	"As of 2.0.26, with the welcome document display rooted in the scene."
	^ true! !

!QStreamingVideoDocument methodsFor: 'persist' stamp: 'jcg 4/9/2009 14:00'!
constructFrom: pStream
	super constructFrom: pStream.
	volume := pStream readNumber: 'volume' default: 0.5.
	autoPlay := pStream readBool: 'autoPlay' default: false.
	looping := pStream readBool: 'looping' default: false.
	
	! !

!QStreamingVideoDocument methodsFor: 'initialize' stamp: 'jcg 4/9/2009 13:58'!
initialize
	super initialize.
	volume := 0.5.
	autoPlay := false.
	looping := false.! !

!QStreamingVideoDocument methodsFor: 'accessing' stamp: 'jcg 4/9/2009 13:57'!
isAutoPlay
	^autoPlay! !

!QStreamingVideoDocument methodsFor: 'accessing' stamp: 'bgf 7/31/2009 01:44'!
isAutoPlay: aBool
	autoPlay ~= aBool ifTrue: [
		autoPlay := aBool.
		self signal: #frameChanged with: self.	 
			"Generic prop-tool update, nothing to do with video frames!!"
	].! !

!QStreamingVideoDocument methodsFor: 'accessing' stamp: 'jcg 4/9/2009 13:59'!
isLooping
	^ looping! !

!QStreamingVideoDocument methodsFor: 'accessing' stamp: 'bgf 7/31/2009 01:43'!
isLooping: aBool
	looping ~= aBool ifTrue: [
		looping := aBool.
		self signal: #frameChanged with: self.	 
			"Generic prop-tool update, nothing to do with video frames!!"
	].! !

!QStreamingVideoDocument methodsFor: 'persist' stamp: 'jcg 4/9/2009 14:00'!
persistOn: pStream
	super persistOn: pStream.
	pStream storeNumber: 'volume' value: volume default: 0.5.
	pStream storeBool: 'autoPlay' value: autoPlay default: false.
	pStream storeBool: 'looping' value: looping default: false.
! !

!QStreamingVideoDocument methodsFor: 'accessing' stamp: 'jcg 4/7/2009 00:08'!
volume
	"Answer the volume that this video should be played at."
	^volume! !

!QStreamingVideoDocument methodsFor: 'accessing' stamp: 'jcg 4/7/2009 00:08'!
volume: newVolume
	"Set the volume that this video should be played at."
	volume := newVolume! !

TConic subclass: #QVideoCamera
	instanceVariableNames: 'isCapturing sessionID sheet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-Secure'!

!QVideoCamera commentStamp: '<historical>' prior: 0!
'
	A very simple representation of a video camera, just enough to indicate a viewing direction and handle a few user input events. Intended to be the on-island part counterpart to an off-island netvidserver, for transmitting secure video of a viewpoint.!

!QVideoCamera class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QVideoCamera class methodsFor: 'defaults' stamp: 'crl 2/5/2010 12:22'!
defaultEventMask
	^EventPointerDown! !

!QVideoCamera class methodsFor: 'accessing' stamp: 'crl 2/4/2010 16:11'!
resourceType
	^#secureVideoCamera! !

!QVideoCamera methodsFor: 'initialize' stamp: 'crl 2/5/2010 16:21'!
initialize
	super initialize.
	isCapturing := false! !

!QVideoCamera methodsFor: 'accessing' stamp: 'crl 4/15/2010 15:21'!
isCapturing
	^isCapturing! !

!QVideoCamera methodsFor: 'events' stamp: 'crl 2/19/2010 16:16'!
onSheetContentChanged: card
	QLogger logInfo: 'sheet content changed: ', card printString.
	(card content respondsTo: #streamID)
		ifTrue: [self signal: #relayStreamID with: card content streamID]
		ifFalse: [self signal: #relayRenderedView]! !

!QVideoCamera methodsFor: 'events' stamp: 'crl 4/15/2010 14:37'!
pointerDown: event
	super pointerDown: event.
	QLogger logInfo: 'pointer down'.
	self toggle! !

!QVideoCamera methodsFor: 'resources' stamp: 'crl 2/5/2010 16:22'!
registerResource
	"Register myself as a resource."

	(self island)
		registerResource: self
		type: self resourceType.! !

!QVideoCamera methodsFor: 'resources' stamp: 'crl 2/5/2010 16:22'!
resourceType
	"Answer my resource type."

	^self class resourceType! !

!QVideoCamera methodsFor: 'accessing' stamp: 'crl 2/4/2010 16:17'!
root: newRoot
	frameRoot 
		ifNotNil: [ self unregisterResource ].
	super root: newRoot.
	frameRoot 
		ifNotNil: [ self registerResource ].! !

!QVideoCamera methodsFor: 'initialize' stamp: 'crl 2/18/2010 16:39'!
sessionID: aTObjectID
	sessionID := aTObjectID! !

!QVideoCamera methodsFor: 'initialize' stamp: 'crl 2/19/2010 18:03'!
sheet: aQDisplaySheet
	sheet := aQDisplaySheet.
	self
		startScript: #onSheetContentChanged:
		when: {sheet. #contentChanged}! !

!QVideoCamera methodsFor: 'events' stamp: 'crl 4/30/2010 15:22'!
toggle
	isCapturing := isCapturing not.
	QLogger logInfo: 'toggling camera'.
	self signal: #captureStateChanged with: isCapturing! !

!QVideoCamera methodsFor: 'resources' stamp: 'crl 2/5/2010 16:23'!
unregisterResource
	"Unregister myself as a resource."

	(self island)
		unregisterResource: self
		type: self resourceType! !

QNetworkServer subclass: #QNetVidServer
	instanceVariableNames: 'playState assetState errorDescription asset limits streamers stopwatch isLooping resumeAfterSeek'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Server'!

!QNetVidServer commentStamp: '<historical>' prior: 0!
A QNetVidServer is responsible for serving a single user-uploaded video file.  The original file should contain one video and one audio track.  We intend to process the file to create lower-bitrate versions that clients can automatically switch between, as appropriate.

#playState can be #paused or #playing
#assetState can be #noMedia, #processing, #ready, #error
!

!QNetVidServer class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QNetVidServer class methodsFor: 'client-streaming' stamp: 'jcg 2/4/2009 18:42'!
directoryForClientNHMLFiles
	"XXXX: TEMPORARY (only while we're streaming directly from the client, instead of from a dedicated server)."
	"Answer the path of the directory where we store the pre-processed (by MP4Box) files that are ready to serve."
	^FileDirectory prefsDirectory pathFromURI: 'streaming-beta'.! !

!QNetVidServer class methodsFor: 'client-streaming' stamp: 'jcg 2/4/2009 18:42'!
processForClientStreaming: mp4FilePath
	"Process the specified file, putting the resulting NHML files into the place that we'll stream it from."
	self processForStreaming: mp4FilePath into: self directoryForClientNHMLFiles
! !

!QNetVidServer class methodsFor: 'utilities' stamp: 'jcg 2/20/2009 17:41'!
processForStreaming: mp4FilePath into: targetDirPath
	| localFileName nhmlDirPath |
	(mp4FilePath endsWith: '.mp4') ifFalse: [self error: 'Not an MP4 file'].
	localFileName := (mp4FilePath copyUpToLast: $.) copyAfterLast: $/ .
	nhmlDirPath := (FileDirectory on: targetDirPath) pathFromURI: localFileName.

	^nhmlDirPath
	! !

!QNetVidServer methodsFor: 'accessing' stamp: 'jcg 2/6/2009 15:40'!
anyAudioStreamer
	^self audioStreamers ifEmpty: [nil] ifNotEmptyDo: [:str | str anyOne]
! !

!QNetVidServer methodsFor: 'accessing' stamp: 'jcg 2/6/2009 15:40'!
anyVideoStreamer
	^self videoStreamers ifEmpty: [nil] ifNotEmptyDo: [:str | str anyOne]
! !

!QNetVidServer methodsFor: 'private' stamp: 'jcg 7/27/2009 23:48'!
assetIsReady: readyAsset
	"Now that the asset is 'ready' (i.e. we have finished processing it with MP4Box, etc.), we can set ourselves up for streaming."
	| nhmlTracks promises publishStartTime |

	asset == readyAsset ifFalse: [
		"The world has moved on... the asset that has 
		 become ready is no longer our current asset."
		^self
	].

	asset state = #error ifTrue: [
		self assetState: #error.
		^self sendTrackListing
	].

	"Keep only the AVC-video and AAC-audio tracks."
	nhmlTracks := Dictionary	 new.
	asset tracks keysAndValuesDo: [:k :v | 
		| info |
		info := v info.
		(info isAVC or: [info isAAC] or:[info isQSpeex])
			ifTrue: [nhmlTracks at: k put: v]
			ifFalse: [QLogger logWarning: 'discarding ', 
						(v isVideo ifTrue: ['video'] ifFalse: ['audio']), 
						' track of unknown type'
			]
	].

	"If resource limits have been set, check whether this assets exceeds them."
	"XXXX: this can be improved... I'm just trying to get the pipeline in place."
	limits ifNotNil: [
		| maxAudioBitrate maxVideoBitrate maxVideoExtent |
		maxAudioBitrate := maxVideoBitrate := 0.0.
		maxVideoExtent := 0@0.

		"Obtain the maximum bitrates and extent."
		nhmlTracks do: [:tr |
			| bitrate info |
			info := tr info.
			bitrate := tr averageBitrate.
			info isVideo ifTrue: [
				bitrate > maxVideoBitrate ifTrue: [maxVideoBitrate := bitrate].
				info extent > maxVideoExtent ifTrue: [maxVideoExtent := info extent].
			].
			info isAudio ifTrue: [
				bitrate > maxAudioBitrate ifTrue: [maxAudioBitrate := bitrate].
			].
		].

		"Did we break the limits?"
		[limits validateVideoExtent: maxVideoExtent.
		 limits validateBitrate: maxVideoBitrate + maxAudioBitrate] 
			on: Error
			do: [:err |
				self assetState: #error.
				errorDescription := err messageText.
				^self sendTrackListing		
			].
	].
	
	"Create track streamers that will serve each track."
	publishStartTime := Time millisecondClockValue.
	streamers := nhmlTracks collect: [:tr | self createTrackStreamerFor: tr].

	"Publish streams for the streamers, and wait for them all to be established."
	promises := streamers collect: [:st | st connect].
	promises do: [:pr | pr wait "start publication of all before waiting for any"].
	streamers do: [:st | 
		"XXXX: raising an error here is a bit harsh, but what else should we do?"
		st isConnected ifFalse: [self error: 'failed to publish stream for track']
	].
	QLogger logInfo: 'published ', streamers size, ' tracks for asset: "', asset printDescription, '" in ', 
									(Time millisecondsSince: publishStartTime), 'ms'.
	
	"State was #noMedia; now it's paused."
	self pause.
	self assetState: #ready.

	"Tell everyone downstream about the new track listing."
	self sendTrackListing! !

!QNetVidServer methodsFor: 'accessing' stamp: 'jcg 6/22/2009 14:49'!
assetName
	"Human-readable name for the asset"
	^asset ifNil: ['(no asset)'] ifNotNil: [asset assetName]! !

!QNetVidServer methodsFor: 'private' stamp: 'jcg 3/30/2009 13:58'!
assetState: newState
	"Handle stuff that must be taken care of when leaving a state, no matter which new state we're entering.  Finally, notify listeners that state has changed."
	assetState == newState ifTrue: [^self "state didn't change"].
	assetState := newState.
	self signal: #assetStateChanged with: newState.
! !

!QNetVidServer methodsFor: 'accessing' stamp: 'jcg 2/6/2009 15:55'!
audioStreamers
	^streamers select: [:st | st track isAudio]! !

!QNetVidServer methodsFor: 'accessing' stamp: 'jcg 9/13/2009 12:04'!
bandwidth
	"Not yet implemented... here as a placeholder that can be used by #sdp."
	^nil! !

!QNetVidServer methodsFor: 'private' stamp: 'jcg 7/28/2009 01:32'!
createTrackStreamerFor: track
	| streamerClass info |
	info := track info.
	streamerClass := asset isLive
							ifTrue: [QNetVidLiveTrackStreamer]
							ifFalse: [info isAVC 
											ifTrue: [QNetVidFileTrackStreamerAVC]
											ifFalse: [QNetVidFileTrackStreamer]].
	^streamerClass forServer: self track: track! !

!QNetVidServer methodsFor: 'initialize' stamp: 'jcg 6/25/2010 01:00'!
defaultProcessPriority
	"We're playing media, including audio... priority must be high."
	^Processor lowIOPriority - 1! !

!QNetVidServer methodsFor: 'accessing' stamp: 'jcg 3/1/2009 13:49'!
duration
	^asset ifNil: [0.0] ifNotNil: [asset duration]! !

!QNetVidServer methodsFor: 'subclass responsibilities' stamp: 'jcg 4/22/2010 02:45'!
handleParsedCommand: node "an XML node"
	"Implements responsibility specified by superclass."
	^(node attributeAt: 'type') caseOf: {
		['play'] -> [self play].
		['pause'] -> [self handlePauseRequest].
		['seek'] -> [self handleSeekRequest: node]. 
		['setProperties'] -> [self handleSetProperties: node].
		['trackListing'] -> [
			"Answer the request."
			self generateCommand: 'trackListing' xmlBlock: [:xml |
				self writeTrackListingXMLOn: xml.
			].
		].
		['endSeek'] -> [resumeAfterSeek ifTrue: [self play]].
	} otherwise: [super handleParsedCommand: node]! !

!QNetVidServer methodsFor: 'private' stamp: 'jcg 4/22/2010 02:22'!
handlePauseRequest
	"A client just asked us to pause."
	resumeAfterSeek := false.
	self pause.
! !

!QNetVidServer methodsFor: 'private' stamp: 'jcg 4/22/2010 02:23'!
handleSeekRequest: node "an XML node"
	| time | 
	playState == #playing ifTrue: [resumeAfterSeek := true].
	time := (node firstTagNamed: #time) characterData asNumber.
	self seekTo: time.
	^self generateCommand: #seekResponse xmlBlock: [:xml | ]! !

!QNetVidServer methodsFor: 'private' stamp: 'jcg 3/27/2009 14:59'!
handleSetProperties: node "an XML node"
	"Read a list of properties of the form: 
		<property propType='Boolean' propName='isLooping'>true</property>."
	node elements do: [:elem |
		| value |
		elem name = #property ifFalse: [
			self error: 'expected list of <property> elements'
		].
		value := (elem attributeAt: 'propType') caseOf: {
			['String']	->	[elem contentString].
			['Number']	->  [Number readFrom: elem contentString].
			['Boolean']	->	[Boolean readFrom: elem contentString].
		}.
		(elem attributeAt: 'propName') caseOf: {
			['isLooping']	->	[self isLooping: value].
		}
	].! !

!QNetVidServer methodsFor: 'initialize' stamp: 'jcg 4/22/2010 02:30'!
initialize
	super initialize.
	assetState := #noMedia.
	playState := #paused.
	streamers := IdentitySet new.
	stopwatch := QStopwatch new.
	isLooping := false.
	resumeAfterSeek := false.

! !

!QNetVidServer methodsFor: 'private' stamp: 'jcg 3/27/2009 15:15'!
isLooping: bool
	isLooping = bool ifTrue: [^self].
	isLooping := bool.
	
	self 
		sendCommand: 'looping'
		xmlBlock: [:xml | xml tag: 'isLooping' pcData: isLooping printString]! !

!QNetVidServer methodsFor: 'initialize' stamp: 'jcg 4/4/2009 10:06'!
limits: aQNetVidLimits "or nil"
	"Set limits on the bitrate, etc. that this server is allowed to stream."
	limits := aQNetVidLimits! !

!QNetVidServer methodsFor: 'services' stamp: 'jcg 4/21/2010 15:36'!
notifyServicesOfDestruction: aQNetVidServices
	"So that the script is attached to us, instead of the much longer-lived services (where repeated destruction of servers would end up bloating the scripts dictionary)."
	aQNetVidServices serverDestroyed: self controlStreamID! !

!QNetVidServer methodsFor: 'initialize' stamp: 'jcg 6/16/2010 18:53'!
openMedia: aQNetVidAsset
	"Use the specified media asset."

	"Always happy to not do any work."
	asset == aQNetVidAsset ifTrue: [^self].

	"Tear down existing asset."
	asset ifNotNil: [asset removeUser: self].
	self pause.
	stopwatch stop; reset.
	streamers do: [:st | st destroy].
	streamers := IdentitySet new.

	"If there is no new asset, there's nothing to do but tell everyone."
	(asset := aQNetVidAsset) ifNil: [
		self assetState: #noMedia.
		^self sendTrackListing
	].
	asset addUser: self.

	"If the asset hasn't already been processed, tell everyone that we're waiting for it."
	asset readyPromise isResolved ifFalse: [
		self assetState: #processing.
		self sendTrackListing.
	].

	"Schedule final processing for when the asset is finished processing."
	asset readyPromise whenFulfilled: [:val |
		self future assetIsReady: aQNetVidAsset
	].
! !

!QNetVidServer methodsFor: 'private' stamp: 'jcg 3/30/2009 13:52'!
pause
	playState == #paused ifTrue: [^self "already paused"].
	self playState: #paused.

	self sendCommand: 'pause' xmlBlock: [:xml | 
		xml tag: 'mediaTime' pcData: stopwatch elapsed printString
	].
! !

!QNetVidServer methodsFor: 'private' stamp: 'jcg 6/22/2010 18:49'!
play
	playState == #playing ifTrue: [^self "already playing"].
	self playState: #playing.
	self startTicker.

	self sendCommand: 'play' xmlBlock: [:xml | 
		xml tag: 'mediaTime' pcData: stopwatch elapsed printString
	].! !

!QNetVidServer methodsFor: 'accessing' stamp: 'jcg 3/30/2009 13:53'!
playState
	"Current state of the server, i.e., paused, playing etc."
	^playState! !

!QNetVidServer methodsFor: 'private' stamp: 'jcg 6/22/2010 18:50'!
playState: newState
	"Handle stuff that must be taken care of when leaving a state, no matter which new state we're entering.  Finally, notify listeners that state has changed."
	playState == newState ifTrue: [^self "state didn't change"].
	playState caseOf: {
		[#playing] -> [self stopTicker].
	} otherwise: [].

	"Set the state and notify listeners."
	playState := newState.
	self signal: #playStateChanged with: newState.
! !

!QNetVidServer methodsFor: 'initialize' stamp: 'jcg 12/11/2009 12:53'!
privateDestroy
	playState := #destroyed.
	self stopTicker.
	asset ifNotNilDo: [:ass |
		asset := nil.
		ass removeUser: self.
	].
	streamers do: [:streamer | streamer destroy].
	streamers := IdentitySet new.

	super privateDestroy.! !

!QNetVidServer methodsFor: 'accessing' stamp: 'jcg 9/22/2009 16:23'!
sdp
	"Construct an SDPSessionDescription from our currently-known tracks."
	"NOTE: if you change this, also check the similar version in QNetVidClient."
	| sdpSession duration range payloadType |

	[
		sdpSession := SDPSessionDescription new.
		sdpSession protocolVersion: 0.
		
		"Some placeholders."
		sdpSession 
			origin: 'PLACEHOLDER' 
			sessionID: 0 
			sessionVersion: 0 
			ipAddress: '127.0.0.1'.
		sdpSession sessionName: 'PLACEHOLDER.mp4'.

		"skip session-name, friendly-info, uri, email, and phone."
		"XXXXX: need to update for IPv6"
		sdpSession connectionData: #('IN' 'IP4' '0.0.0.0').
		sdpSession bandwidth: self bandwidth.
		sdpSession timing: #('0' '0').

		"If we know a finite duration, set it."
		range := '0- '.
		duration := asset duration.
		(duration isNumber and: [duration isInfinite not]) ifTrue: [range := range, duration].
		sdpSession attributes at: 'range' put: range.

		"Create the SDP descriptions for each media track."
		payloadType := 95. "One less than the first dynamic payload type."
		asset tracks do: [:track |
			| sdpTrack |
			sdpTrack := SDPMediaDescription 
										newFromTrackInfo: track info
										payloadType: (payloadType := payloadType+1).
			sdpSession addMediaDescription: sdpTrack.
		].
	] on: Error do: [:err |
		QLogger logWarning: 'failed to create SDP because: ', err messageText.
		sdpSession := nil.
	].

	^sdpSession! !

!QNetVidServer methodsFor: 'private' stamp: 'jcg 2/11/2009 18:32'!
seekTo: time
	self pause.
	stopwatch elapsed: (time * 1000) rounded "to milliseconds".
	streamers do: [:s | s seekTo: time].
	self sendCommand: 'seek' xmlBlock: [:xml |
		xml tag: #time pcData: time printString
	].
! !

!QNetVidServer methodsFor: 'private' stamp: 'jcg 9/22/2009 16:32'!
sendTrackListing
	"Broadcast the current list of tracks, as well as other information."
	self sdp
		ifNotNilDo: [:sdp | controlStream propertyAt: 'sdp' put: sdp fullPrintString]
		ifNil: [
			"Old-style session-recordings may not be able to generate an SDP description.
			 If we're trying to stream an old .MRI then don't worry about this warning.  
			 Otherwise, we'll probably want to investigate why this is happening."
			QLogger logWarning: 'could not set stream SDP property (maybe an .MRI?)'.
		].
	self sendCommand: 'trackListing' xmlBlock: [:xml |
		self writeTrackListingXMLOn: xml.
	].! !

!QNetVidServer methodsFor: 'ticking' stamp: 'jcg 6/22/2010 18:45'!
startTicker
	"Schedule a #tick that will continue scheduling more #tick messages until stopped."
	stopwatch isRunning ifTrue: [^self "already ticking"].
	stopwatch start.
	self future tick.
	! !

!QNetVidServer methodsFor: 'ticking' stamp: 'jcg 6/22/2010 18:45'!
stopTicker
	"See #tick... if the stopwatch isn't running, then no more ticks will be scheduled."
	stopwatch stop.
	! !

!QNetVidServer methodsFor: 'accessing' stamp: 'jcg 10/15/2009 16:55'!
streamers
	"Make a copy for clean-livin'... don't want sync problems with those outside the event-loop."
	^streamers copy! !

!QNetVidServer methodsFor: 'ticking' stamp: 'jcg 6/22/2010 18:53'!
tick
	[
		| elapsed |
		stopwatch isRunning ifFalse: [^self "we've stopped ticking"].
		elapsed := stopwatch elapsed / 1000.0. "convert to seconds"
		elapsed >= self duration 
			ifFalse: [streamers do: [:s | s playTo: elapsed] "play normally"]
			ifTrue: [
				"Jump back to beginning, and if we're looping, start playing again."
				self seekTo: 0.0.
				isLooping 
					ifTrue: [self play]
					ifFalse: [resumeAfterSeek := false].
			].
		"Schedule the next tick."
		stopwatch isRunning ifTrue: [(self future: 20) tick].
	] 
		on: Error 
		do: [:err | 
			self pause.  
			QLogger logError: err
		]! !

!QNetVidServer methodsFor: 'accessing' stamp: 'jcg 2/6/2009 15:55'!
videoStreamers
	^streamers select: [:st | st track isVideo]! !

!QNetVidServer methodsFor: 'private' stamp: 'jcg 4/22/2010 01:40'!
writeFeatureListingXMLOn: xml

	"We handle the #seekEnd command so that we can resume playing if we were
	 playing at the time that the last seek was received."
	xml startTag: #resumePlayAfterSeek; endEmptyTag: #resumePlayAfterSeek.! !

!QNetVidServer methodsFor: 'private' stamp: 'jcg 4/4/2009 12:13'!
writeTrackListingXMLOn: xml
	xml tag: #duration pcData: self duration printString.
	xml tag: #playState pcData: playState.
	xml startTag: #assetState; endTag.
	xml pcData: assetState.
	assetState == #error ifTrue: [
		"XXXX: This is a filthy last-minute hack.  If we specify an errorDescription
		 ourself, use that one.  Otherwise, use the asset's errorDescription.  The 
		 reasoning is that assets can be shared between Forums and even Orgs
		 (since they are completely SHA-based), but eg: bitrate-limits are scoped
		 per-org, so we can't bash that error message directly into the asset."
		errorDescription 
			ifNotNil: [xml tag: #description pcData: errorDescription]
			ifNil: [asset ifNotNil: [xml tag: #description pcData: asset errorDescription]].
	].
	xml endTag: #assetState.

	xml tag: #currentTime pcData: stopwatch elapsed printString.
	xml tag: #isLooping pcData: isLooping printString.
	xml tag: #trackCount pcData: streamers size printString.
	streamers do: [:st | st writeXMLOn: xml].! !

QNetVidServer subclass: #QRelayNetVidServer
	instanceVariableNames: 'relayedTrackListings lastSelectedListing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Server'!

!QRelayNetVidServer class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QRelayNetVidServer methodsFor: 'accessing' stamp: 'crl 2/22/2010 18:33'!
addTrackListing: node
	^relayedTrackListings at: (relayedTrackListings size + 1) put: node! !

!QRelayNetVidServer methodsFor: 'initialize' stamp: 'crl 4/5/2010 18:26'!
initialize
	super initialize.
	relayedTrackListings := IdentityDictionary new! !

!QRelayNetVidServer methodsFor: 'private' stamp: 'crl 5/3/2010 14:55'!
writeTrackListingXMLOn: xml
	lastSelectedListing
		ifNil: [lastSelectedListing := relayedTrackListings anyOne]
		ifNotNil: [
			relayedTrackListings size > 1 ifTrue: [lastSelectedListing := relayedTrackListings detect: [:listing | listing ~~ lastSelectedListing]]].
	lastSelectedListing elements do: [:element | element printOn: xml stream]! !

CPlayer subclass: #QStreamingVideoPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Integration'!

!QStreamingVideoPlayer commentStamp: 'jcg 2/6/2009 18:05' prior: 0!
Tweak world for playing streaming-video in a TweakProjectWorld.  Talks to the embedded/embeddable apps, and sets up video-client (and currently also the video-server).  Doesn't provide the UI for interacting with the video; we use QStreamingVideoPlayerUI for that.

HACK: we currently rely on the fact that we don't have multiple quality/resolution versions of the same video stream.  This allows us to take a short-cut and display video directly in the Tweak world (not as a separate background texture in the TEmbeddedApp, or anything like that).!

QStreamingVideoPlayer defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="embeddedApp" toSet="embeddedApp:" changeEvent="embeddedAppChanged">embeddedApp</field>
	<field toGet="embeddableApp" toSet="embeddableApp:" changeEvent="embeddableAppChanged">embeddableApp</field>
	<field toGet="croquetSession" toSet="croquetSession:" changeEvent="croquetSessionChanged">croquetSession</field>
	<field toGet="videoClient" toSet="videoClient:" changeEvent="videoClientChanged">videoClient</field>
	<field toGet="videoTexture" toSet="videoTexture:" changeEvent="videoTextureChanged">videoTexture</field>
	<field toGet="videoSHA" toSet="videoSHA:" changeEvent="videoSHAChanged">videoSHA</field>
	<field toGet="clientUI" toSet="clientUI:" changeEvent="clientUIChanged">clientUI</field>
	<field toGet="timeOfLastUse" toSet="timeOfLastUse:" changeEvent="timeOfLastUseChanged">timeOfLastUse</field>
	<field toGet="timeOfLastLocalUse" toSet="timeOfLastLocalUse:" changeEvent="timeOfLastLocalUseChanged">timeOfLastLocalUse</field>
	<field toGet="speaker" toSet="speaker:" changeEvent="speakerChanged">speaker</field>
	<field toGet="speakerInput" toSet="speakerInput:" changeEvent="speakerInputChanged">speakerInput</field>
	<field toGet="clientSpeaker" toSet="clientSpeaker:" changeEvent="clientSpeakerChanged">clientSpeaker</field>
	<field toGet="errorBox" toSet="errorBox:" changeEvent="errorBoxChanged">errorBox</field>
	<field toGet="suspendedImage" toSet="suspendedImage:" changeEvent="suspendedImageChanged">suspendedImage</field>
	<field toGet="cacheResponsibleForLaunch" toSet="cacheResponsibleForLaunch:" changeEvent="cacheResponsibleForLaunchChanged">cacheResponsibleForLaunch</field>
</fields>'!

!QStreamingVideoPlayer class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QStreamingVideoPlayer methodsFor: 'private' stamp: 'jcg 2/26/2009 23:13'!
audioSession
	^croquetSession audioSession! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 5/19/2010 12:20'!
cacheResponsibleForLaunch
	"Answer the cacheResponsibleForLaunch of the receiver"
	<bewareOf: #cacheResponsibleForLaunchChanged>
	^self propertyValueAt: #cacheResponsibleForLaunch! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 5/19/2010 12:20'!
cacheResponsibleForLaunch: aValue
	"Modify the receiver's cacheResponsibleForLaunch"
	^self propertyValueAt: #cacheResponsibleForLaunch put: aValue with: #cacheResponsibleForLaunchChanged! !

!QStreamingVideoPlayer methodsFor: 'private' stamp: 'crl 4/29/2010 16:40'!
checkForClientSpeaker
	"Every time we're notified that the list of speakers has changed, try to find a match.  Once we find one, stop listening."
	| mgr newClientSpeaker |
	mgr := self speakerManager ifNil: [^self].
	newClientSpeaker := (mgr future speakerAt: (speaker get: #objectID)) wait.
	clientSpeaker = newClientSpeaker ifTrue: [^self].
	clientSpeaker := newClientSpeaker.
	clientSpeaker ifNotNil: [
		speakerInput := 
			(clientSpeaker future newInputOfClass: QClientSpeakerNetVidInput) wait.
		speakerInput player: self.

		"Now that we have a new speaker, we don't need to keep checking.
		 However, once our speaker is destroyed (eg: during a reset-sound), 
		 we want to start checking again."
		self stopScript: #startCheckingForClientSpeaker.
		self 
			startScript: #startCheckingForClientSpeaker 
			when: {clientSpeaker. #destroyed}.

		"This check was successful... we don't need to do another."
		self signal: #stopCheckingForClientSpeaker.
	].
! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 2/26/2009 23:08'!
clientSpeaker
	"Answer the clientSpeaker of the receiver"
	<bewareOf: #clientSpeakerChanged>
	^self propertyValueAt: #clientSpeaker! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 2/26/2009 23:08'!
clientSpeaker: aValue
	"Modify the receiver's clientSpeaker"
	^self propertyValueAt: #clientSpeaker put: aValue with: #clientSpeakerChanged! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 2/6/2009 15:35'!
clientUI
	"Answer the clientUI of the receiver"
	<bewareOf: #clientUIChanged>
	^self propertyValueAt: #clientUI! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 2/6/2009 15:35'!
clientUI: aValue
	"Modify the receiver's clientUI"
	^self propertyValueAt: #clientUI put: aValue with: #clientUIChanged! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 2/6/2009 12:59'!
croquetSession
	"Answer the croquetSession of the receiver"
	<bewareOf: #croquetSessionChanged>
	^self propertyValueAt: #croquetSession! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 2/6/2009 12:59'!
croquetSession: aValue
	"Modify the receiver's croquetSession"
	^self propertyValueAt: #croquetSession put: aValue with: #croquetSessionChanged! !

!QStreamingVideoPlayer methodsFor: 'initialize' stamp: 'bgf 4/2/2009 11:35'!
destroy
	super destroy.
	self destroyVideoClient.

	"Aids to GC."
	embeddedApp := nil.
	croquetSession := nil.
	clientSpeaker := nil.! !

!QStreamingVideoPlayer methodsFor: 'private' stamp: 'jcg 3/9/2009 13:05'!
destroyVideoClient
	videoClient ifNotNilDo: [:vc |
		clientUI videoClient: nil.
		videoClient := nil.

		QLogger logInfo:
			'destroying NetVid-client (streamID: ',
			(vc controlStreamID ifNotNilDo: [:id | id hex]), ')'.
		vc destroy.
	].
		! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 2/6/2009 14:03'!
document
	^embeddedApp get: #document! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 2/18/2009 15:19'!
documentSharedName
	^self document ifNotNilDo: [:doc | doc get: #sharedName]! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 2/6/2009 14:02'!
documentShortName
	^self document ifNotNilDo: [:doc | doc get: #shortName]! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 2/6/2009 12:59'!
embeddableApp
	"Answer the embeddableApp of the receiver"
	<bewareOf: #embeddableAppChanged>
	^self propertyValueAt: #embeddableApp! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 2/6/2009 12:59'!
embeddableApp: aValue
	"Modify the receiver's embeddableApp"
	^self propertyValueAt: #embeddableApp put: aValue with: #embeddableAppChanged! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 2/6/2009 12:59'!
embeddedApp
	"Answer the embeddedApp of the receiver"
	<bewareOf: #embeddedAppChanged>
	^self propertyValueAt: #embeddedApp! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 2/6/2009 12:59'!
embeddedApp: aValue
	"Modify the receiver's embeddedApp"
	^self propertyValueAt: #embeddedApp put: aValue with: #embeddedAppChanged! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 3/8/2009 00:19'!
errorBox
	"Answer the errorBox of the receiver"
	<bewareOf: #errorBoxChanged>
	^self propertyValueAt: #errorBox! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 3/8/2009 00:19'!
errorBox: aValue
	"Modify the receiver's errorBox"
	^self propertyValueAt: #errorBox put: aValue with: #errorBoxChanged! !

!QStreamingVideoPlayer methodsFor: 'private' stamp: 'jcg 3/8/2009 14:22'!
errorFont
	"Answer the font used to display error messages."
	^(TextStyle named: #BitstreamVeraSans) fontOfSize: 20.! !

!QStreamingVideoPlayer methodsFor: 'private' stamp: 'jcg 8/3/2010 16:47'!
extentOfErrorMessage: msgString
	"Answer the pixel-width of the specified string, rendered in the default error font."
	| font lines width height | 
	font := self errorFont.
	lines := msgString findTokens: Character cr.
	lines ifEmpty: [lines := #('')].
	width := (lines collect: [:s | font widthOfStringOrText: s]) max.
	height := (font pixelSize + 10) * lines size.
	^width@height
	! !

!QStreamingVideoPlayer methodsFor: 'private' stamp: 'ar 8/12/2009 13:54'!
handleDecodedAudio: buf "a SoundBuffer" samplingRate: samplingRate from: decoder
	"Plugged into 'videoClient' via #audioRenderBlock:."
	speakerInput ifNotNil: [
		speakerInput handleDecodedAudio: buf samplingRate: samplingRate.
	]! !

!QStreamingVideoPlayer methodsFor: 'private' stamp: 'jcg 3/27/2009 18:55'!
handleDecodedFrame: aForm from: videoTrackPlayer
	"Plugged into 'videoClient' via #videoRenderBlock:."
	| gf | 
	gf := self graphicForm.
	(gf isNil or: [gf extent ~= aForm extent]) ifTrue: [
		gf := Form extent: aForm extent depth: 32.
		self graphicForm: gf.
	].
	aForm displayOn: gf at: 0@0.
	self invalidate.! !

!QStreamingVideoPlayer methodsFor: 'private' stamp: 'jcg 3/8/2009 14:08'!
hideControls
	clientUI visible: false! !

!QStreamingVideoPlayer methodsFor: 'initialize' stamp: 'jcg 4/7/2009 00:21'!
initialize
	super initialize.

	"Subtract a bit so that the first call to #wasUsedLocally is guaranteed to broadcast a #wasUsed signal."
	timeOfLastLocalUse := Time coarseClockValue - 2000.
	timeOfLastUse := Time coarseClockValue.
	
	"For now, we're displaying the video in the Tweak world, so it is OK to fill in the player... if we want to have a background TTexture behind the tweak-world-TTexture, then we'll have to change this."
	self color: Color white.
	"self color: Color transparent."

	self define: #clientUI as: QStreamingVideoPlayerUI new.
	clientUI videoPlayer: self.
	self addLast: clientUI.

! !

!QStreamingVideoPlayer methodsFor: 'suspending' stamp: 'jcg 4/8/2009 16:13'!
isVideoSuspended
	"Answer true if video display is temporarily suspended (eg: if the user is 'Away')."
	^suspendedImage notNil! !

!QStreamingVideoPlayer methodsFor: 'private' stamp: 'jcg 12/11/2009 13:04'!
launchServerIfNecessary
	| streamID response svcMgr svcName |

	embeddedApp ifNil: [
		^QLogger logInfo: 'not launching yet because embedded-app is nil'
	].
	croquetSession ifNil: [
		^QLogger logInfo: 'not launching yet because croquet-session is nil'
	].
	(embeddedApp get: #streamID) ifNotNilDo: [:id |
		"Someone else has already set up a (presumably valid) streamID."
		^QLogger logInfo: 'not launching because streamID already exists: ', id hex
	].
	self responsibleForLaunch ifFalse: [
		^QLogger logInfo: 'not launching because I am not the launcher'.
	].

	QLogger logInfo: 'launching server-based streaming video'.
	svcMgr := croquetSession owner serviceMgr.
	svcName := embeddedApp controller serviceName.
	response := svcMgr 
					netvidLaunch: self documentSharedName 
					service: svcName
					hubID: croquetSession hubID.

	"Hopefully we succeeded."
	response name = #ok
		ifFalse: [
			| errorMsg reason |
			QLogger logWarning: 'launch attempt failed: ', response.
			QActivityCapture 
				action: 'LaunchStreamingVideoFail'
				details: self serviceManagerPath.
			reason := response contentString.
			(reason = 'Unknown request netvid')
				ifTrue: [reason := 'Server does not support streaming video'].
			errorMsg := ('Video launch failed:\', reason) withCRs.
			width := (self widthOfErrorMessage: errorMsg) + 40.
			embeddedApp future appExtent: width@256.
			embeddedApp future errorMessage: errorMsg.
		]
		ifTrue: [
			streamID := TObjectID readHexFrom: (response contentStringAt: 'streamID').
			extent := Point readFrom: (response contentStringAt: 'appExtent').

			embeddedApp future appExtent: extent.
			embeddedApp future streamID: streamID.

			"HACK, obviously."
			QJoshHacks lastNetVidID: streamID.

			QActivityCapture 
				action: 'LaunchStreamingVideo'
				details: self serviceManagerPath, '   ', streamID hex.
		].! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 2/6/2009 13:26'!
launcherID
	^embeddedApp ifNotNil: [embeddedApp get: #launcherID]! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 2/28/2009 18:59'!
millisecondsSinceLastRender
	^ embeddableApp 
			ifNotNilDo: [:app | app millisecondsSinceLastRender]
			ifNil: [0]! !

!QStreamingVideoPlayer methodsFor: 'events' stamp: 'jcg 3/1/2009 11:47'!
onDestroyWorld
	<on: destroyWorld>
	self destroyVideoClient! !

!QStreamingVideoPlayer methodsFor: 'events' stamp: 'jcg 4/8/2009 10:17'!
onEmbeddableAppChanged
	<on: embeddableAppChanged>

	"If there is a network reconnect, we should be destroyed, and a replacement created."
	embeddableApp ifNotNilDo: [:embeddable | 
		embeddable shouldDestroyUponReconnect: true.
		embeddable useMipmapping: false.
	]
! !

!QStreamingVideoPlayer methodsFor: 'events' stamp: 'jcg 3/8/2009 15:02'!
onEmbeddedAppChanged
	| controlStreamID |
	<on: embeddedAppChanged>

	"Hook up with our QClientSpeaker ASAP."
	speaker := embeddedApp get: #speaker.
	self startCheckingForClientSpeaker.

	"Check if there's already an error to display."
	(embeddedApp get: #errorMessage) ifNotNilDo: [:msg | 
		self onErrorMessageChanged: msg
	].

	"If we're responsible to set up streams, then do it."	
	self launchServerIfNecessary.

	"If there is already a control-stream published, then we want to subscribe to it."
	controlStreamID := (embeddedApp get: #streamID).
	controlStreamID ifNotNil: [self onStreamChanged: controlStreamID].! !

!QStreamingVideoPlayer methodsFor: 'events' stamp: 'jcg 4/8/2009 23:41'!
onErrorMessageChanged: errorMessage
	<on: errorMessageChanged in: embeddedApp>
	errorBox ifNotNil: [
		errorBox destroy.
		errorBox := nil.
	].

	errorMessage ifNil: [^self invalidate].

	self hideControls. "only display controls when not in an error state"

	errorBox := CPlayer new.
	errorBox color: (Color r:0.15 g:0.25 b:0.5).
	errorBox roundCorners: false.
	errorBox textEnabled: true.
	errorBox textAnchorPoint: #center.
	errorBox textFont: self errorFont.
	errorBox textColor: Color white.
	errorBox extent: (self extentOfErrorMessage: errorMessage) + 20.
	errorBox position: self center.
	errorBox text: errorMessage.

	(self width - 10) < errorBox width
		ifTrue: [errorBox scale: (self width - 10.0) / errorBox width]
		ifFalse: [errorBox scale: 1.0].

	self addFirst: errorBox. "behind the 'suspendImage', if it exists."
	self invalidate.! !

!QStreamingVideoPlayer methodsFor: 'events' stamp: 'jcg 4/8/2009 23:25'!
onExtentChanged
	"The only thing that we need to adjust are the display overlays."
	<on: extentChanged>
	errorBox ifNotNilDo: [:box | box position: self center].
	suspendedImage ifNotNilDo: [:im | im position: self center].
	! !

!QStreamingVideoPlayer methodsFor: 'events' stamp: 'jcg 4/8/2009 17:55'!
onMouseDown
	<on: mouseDown>
	"Check if we should try to resume video."
	self isVideoSuspended ifTrue: [
		"uuuuuuuuuuuuggh"
		[embeddableApp session mainView owner controlBar checkVideoSession]
			on: Error 
			do: [:err |
				"At least resume for this one video player."
				self resumeVideo.
				QLogger logWarning: 'failed to resume video for all players: ', err.
			].
		^self "if video was suspended, this is the only thing we do on mouse-click"
	]! !

!QStreamingVideoPlayer methodsFor: 'events' stamp: 'jcg 3/8/2009 14:06'!
onMouseEnter
	<on: mouseEnter>
	self showControls! !

!QStreamingVideoPlayer methodsFor: 'events' stamp: 'jcg 3/8/2009 14:09'!
onMouseLeave
	<on: mouseLeave>
	self hideControls! !

!QStreamingVideoPlayer methodsFor: 'events' stamp: 'jcg 3/17/2009 19:03'!
onMouseMove
	<on: mouseMove>
	self wasUsedLocally! !

!QStreamingVideoPlayer methodsFor: 'events' stamp: 'jcg 4/8/2009 16:35'!
onRender
	<on: wasRendered in: embeddableApp>
	self isVideoSuspended ifTrue: [^self "don't want video to start playing"].
	videoClient ifNotNil: [
		videoClient unpauseVideo.
		"Avoid rendering going idle if we're watching a moofie..."
		(videoClient isPlaying and: [ croquetSession notNil ]) ifTrue: [
			croquetSession updateLastEventTime.
		]].
	! !

!QStreamingVideoPlayer methodsFor: 'events' stamp: 'jcg 10/5/2009 18:45'!
onStreamChanged: newStreamID
	<on: streamChanged in: embeddedApp>

	self destroyVideoClient.
	newStreamID ifNil: [^self "nothing to do"].

	self onErrorMessageChanged: 'Preparing video stream...'.

	"Create a new video client.  Care is taken to set up the render-blocks before we connect, else we'll miss the initial video frame."
	QLogger logInfo: 'creating new NetVid-client (streamID: ', newStreamID hex, ')'.
	videoClient := QNetVidClient new.
	videoClient streamManager: croquetSession mediaController mediaPlugin.
	videoClient updateTrackBlock:[self signal: #tracksChanged].
	videoClient videoRenderBlock: [:form :p| 
		self handleDecodedFrame: form from: p.
	].
	videoClient audioRenderBlock: [:buf :samplingRate :decoder | 
		self handleDecodedAudio: buf samplingRate: samplingRate from: decoder.
	].
	videoClient future subscribeToControlStream: newStreamID.			
	clientUI videoClient: videoClient.

	speakerInput ifNotNilDo: [:in | in updatePlayState].! !

!QStreamingVideoPlayer methodsFor: 'events' stamp: 'jcg 3/17/2009 19:26'!
onTickToHideUI
	<ticking: 0.5>
	(Time coarseMillisecondsSince: timeOfLastUse) > 2000 ifTrue: [self hideControls]! !

!QStreamingVideoPlayer methodsFor: 'events' stamp: 'hrs 2/2/2010 17:21'!
onTracksChanged
	"Pick an audio and a video track player at random."
	<on: tracksChanged>

	videoClient ifNil: [^QLogger logWarning: 'No video client'.].

	videoClient assetState = #error ifTrue: [
		self onErrorMessageChanged: videoClient assetErrorDescription.
		^self.
	].

	videoClient videoPlayers ifNotEmpty:[
		| trackPlayer |
		trackPlayer := videoClient videoPlayers anyOne.	"XXXX: blech"
		(embeddedApp get: #appExtent) = trackPlayer extent ifFalse: [
			embeddedApp future appExtent: trackPlayer extent.
		].
		videoClient addVideoPlayer: trackPlayer.
	].
	videoClient audioPlayers ifNotEmpty:[
		videoClient addAudioPlayer: videoClient audioPlayers anyOne.  "XXXX: aargh"
	].

	"Clear 'Preparing video stream...' message."
	self onErrorMessageChanged: nil.

	"Do auto-play/looping as appropriate."
	self sendInitialCommandsIfNecessary.
! !

!QStreamingVideoPlayer methodsFor: 'events' stamp: 'jcg 2/6/2009 13:04'!
onVideoTextureChanged: newTextureOrNil
	<on: backgroundTextureChanged in: embeddedApp>
	videoTexture := nil.
	videoSHA := newTextureOrNil
						ifNil: [nil]
						ifNotNil: [newTextureOrNil sha]
! !

!QStreamingVideoPlayer methodsFor: 'private' stamp: 'jcg 5/19/2010 12:21'!
responsibleForLaunch
	"We need to lazily compute and cache this value because QStreamingVideoApp
	 clears the 'launcherID' in #streamID:, so we can't necessarily recompute this later."
	cacheResponsibleForLaunch ifNotNil: [^cacheResponsibleForLaunch].
	"I'm responsible for launch if:
		- I'm the one who dropped a file-card on a panel (or similar UI gesture), or
		- I'm the first one into a Forum that has video on the walls."
	cacheResponsibleForLaunch :=
		(self launcherID = croquetSession sessionID) or: [embeddableApp isNewSession].
	^cacheResponsibleForLaunch
! !

!QStreamingVideoPlayer methodsFor: 'suspending' stamp: 'jcg 4/8/2009 17:29'!
resumeVideo
	"Support for pausing video when user is 'Away': displays an overlay and pauses video."
	self isVideoSuspended ifFalse: [^self "already suspended"].
	suspendedImage destroy.
	suspendedImage := nil
! !

!QStreamingVideoPlayer methodsFor: 'private' stamp: 'jcg 5/18/2010 02:52'!
sendInitialCommandsIfNecessary
	"When a video is launched, there's a bit of time before the tracks are ready to play.  Once it is ready to play, whoever launched it should send some additional commands, based on properties set in the document."
	
	| isAutoPlay isLooping tries |

	self responsibleForLaunch ifFalse: [
		^QLogger logInfo: 'not sending initial commands because I am not the launcher'.
	].
	
	videoClient ifNil: [
		^QLogger logInfo: 'not sending initial commands because there is no video client'.
	].

	(videoClient audioPlayers, videoClient videoPlayers) ifEmpty: [
		^QLogger logInfo: 'not sending initial commands because there are no tracks'.
	].

	isAutoPlay := embeddedApp get: #isAutoPlay.
	isLooping := embeddedApp get: #isLooping.
	QLogger logInfo: 
				'sending initial commands (auto-play: ', 
				isAutoPlay, '  looping: ', isLooping, ')'.
	isLooping ifTrue: [videoClient serverIsLooping: isLooping].

	"Wait for up to 2 seconds for the video-track players to connect
	 before sending the 'play' command (so that we don't miss the first
	 keyframe).  If we still haven't connected, don't block forever... just
	 go ahead and send 'play'."
	tries := 10.
	[tries > 0] whileTrue: [
		(videoClient videoPlayers allSatisfy: [:vp | vp isConnected])
			ifTrue: [tries := 0]
			ifFalse: [tries := tries - 1].
		self wait: 0.2.
	].
	videoClient play.
	
	! !

!QStreamingVideoPlayer methodsFor: 'events' stamp: 'jcg 4/30/2009 18:04'!
serviceManagerPath
	^self document ifNotNilDo: [:doc | doc get: #asServiceManagerPath]! !

!QStreamingVideoPlayer methodsFor: 'private' stamp: 'jcg 4/8/2009 16:38'!
showControls
	"Only show the controls if there is no error being displayed."
	clientUI visible: (errorBox isNil & videoClient notNil & self isVideoSuspended not)! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 2/26/2009 23:08'!
speaker
	"Answer the speaker of the receiver"
	<bewareOf: #speakerChanged>
	^self propertyValueAt: #speaker! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 2/26/2009 23:08'!
speaker: aValue
	"Modify the receiver's speaker"
	^self propertyValueAt: #speaker put: aValue with: #speakerChanged! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 2/27/2009 00:09'!
speakerInput
	"Answer the speakerInput of the receiver"
	<bewareOf: #speakerInputChanged>
	^self propertyValueAt: #speakerInput! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 2/27/2009 00:09'!
speakerInput: aValue
	"Modify the receiver's speakerInput"
	^self propertyValueAt: #speakerInput put: aValue with: #speakerInputChanged! !

!QStreamingVideoPlayer methodsFor: 'private' stamp: 'jcg 3/6/2009 13:49'!
speakerManager
	[^self audioSession speakerManager]
		on: Error do: [
			QLogger logWarning: 'Could not obtain speaker-manager'.
			^nil
		].! !

!QStreamingVideoPlayer methodsFor: 'private' stamp: 'jcg 4/10/2010 16:24'!
startCheckingForClientSpeaker
	"Every time we're notified that the list of speakers has changed, try to find a match.  Once we find one, stop listening."
	self 
		startScript: #checkForClientSpeaker 
		when: {croquetSession owner. #clientSpeakersChanged}.
	self startScript: #checkForClientSpeaker! !

!QStreamingVideoPlayer methodsFor: 'private' stamp: 'jcg 4/8/2010 16:55'!
stopCheckingForClientSpeaker
	"Use a separate script to stop checking to workaround a deadlock apparently resulting from a low-level (VM-ish) mutex bug (we used to do this at the end of #checkForClientSpeaker)."
	<on: stopCheckingForClientSpeaker>
	self stopScript: #checkForClientSpeaker! !

!QStreamingVideoPlayer methodsFor: 'suspending' stamp: 'bgf 4/9/2009 00:00'!
suspendVideo
	"Support for pausing video when user is 'Away': displays an overlay and pauses video."
	| form |

	self isVideoSuspended ifTrue: [^self "already suspended"].

	form := QStreamingVideoDecoder formForDisabledVideo: 256@192.
	suspendedImage := CPlayer new.
	suspendedImage graphic: form.
	suspendedImage extent: form extent.
	suspendedImage color: (Color black alpha: 0.6).
	suspendedImage center: self center.
	self addLast: suspendedImage.

	"Do this last (in particular, after 'suspendedImage' has been set),
	 otherwise we might start again."
	videoClient ifNotNilDo: [:vc | vc pauseVideo].
! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 4/8/2009 16:12'!
suspendedImage
	"Answer the suspendedImage of the receiver"
	<bewareOf: #suspendedImageChanged>
	^self propertyValueAt: #suspendedImage! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 4/8/2009 16:12'!
suspendedImage: aValue
	"Modify the receiver's suspendedImage"
	^self propertyValueAt: #suspendedImage put: aValue with: #suspendedImageChanged! !

!QStreamingVideoPlayer methodsFor: 'ticking' stamp: 'hrs 11/6/2009 14:57'!
tick
	<ticking: 1>

	(croquetSession isDemon or: [croquetSession owner mobileProxy notNil])
		ifTrue: [videoClient ifNotNilDo: [:vc | vc unpauseVideo]]
		ifFalse: [
			self millisecondsSinceLastRender > 2000 ifTrue: [
				videoClient ifNotNilDo: [:vc | vc pauseVideo]
			]
		].! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 3/17/2009 19:24'!
timeOfLastLocalUse
	"Answer the timeOfLastLocalUse of the receiver"
	<bewareOf: #timeOfLastLocalUseChanged>
	^self propertyValueAt: #timeOfLastLocalUse! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 3/17/2009 19:24'!
timeOfLastLocalUse: aValue
	"Modify the receiver's timeOfLastLocalUse"
	^self propertyValueAt: #timeOfLastLocalUse put: aValue with: #timeOfLastLocalUseChanged! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 3/17/2009 19:24'!
timeOfLastUse
	"Answer the timeOfLastUse of the receiver"
	<bewareOf: #timeOfLastUseChanged>
	^self propertyValueAt: #timeOfLastUse! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 3/17/2009 19:24'!
timeOfLastUse: aValue
	"Modify the receiver's timeOfLastUse"
	^self propertyValueAt: #timeOfLastUse put: aValue with: #timeOfLastUseChanged! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 2/5/2009 22:15'!
videoClient
	"Answer the videoClient of the receiver"
	<bewareOf: #videoClientChanged>
	^self propertyValueAt: #videoClient! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 2/5/2009 22:15'!
videoClient: aValue
	"Modify the receiver's videoClient"
	^self propertyValueAt: #videoClient put: aValue with: #videoClientChanged! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 2/6/2009 13:03'!
videoSHA
	"Answer the videoSHA of the receiver"
	<bewareOf: #videoSHAChanged>
	^self propertyValueAt: #videoSHA! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 2/6/2009 13:03'!
videoSHA: aValue
	"Modify the receiver's videoSHA"
	^self propertyValueAt: #videoSHA put: aValue with: #videoSHAChanged! !

!QStreamingVideoPlayer methodsFor: 'private' stamp: 'jcg 4/8/2009 17:04'!
videoSession
	^embeddableApp session videoSession ! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 2/6/2009 13:00'!
videoTexture
	"Answer the videoTexture of the receiver"
	<bewareOf: #videoTextureChanged>
	^self propertyValueAt: #videoTexture! !

!QStreamingVideoPlayer methodsFor: 'accessing' stamp: 'jcg 2/6/2009 13:00'!
videoTexture: aValue
	"Modify the receiver's videoTexture"
	^self propertyValueAt: #videoTexture put: aValue with: #videoTextureChanged! !

!QStreamingVideoPlayer methodsFor: 'events' stamp: 'jcg 3/17/2009 19:26'!
wasUsed
	<on: wasUsed in: embeddedApp>
	timeOfLastUse := Time coarseClockValue.
	self showControls.
! !

!QStreamingVideoPlayer methodsFor: 'events' stamp: 'jcg 3/17/2009 19:31'!
wasUsedLocally
	self wasUsed. "show UI controls"

	"Throttle frequency of #future messages."
	(Time coarseMillisecondsSince: timeOfLastLocalUse) > 250 ifTrue: [
		"Broadcast signal so that everybody displays the video controls."
		embeddedApp future signal: #wasUsed.
		timeOfLastLocalUse := Time coarseClockValue.
	]! !

!QStreamingVideoPlayer methodsFor: 'private' stamp: 'jcg 3/8/2009 14:46'!
widthOfErrorMessage: msgString
	"Answer the pixel-width of the specified string, rendered in the default error font."
	^(self extentOfErrorMessage: msgString) x! !

CPlayer subclass: #QStreamingVideoPlayerUI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Integration'!

!QStreamingVideoPlayerUI commentStamp: 'jcg 2/6/2009 18:01' prior: 0!
Provides controls for starting, stopping, and seeking through a video stream.!

QStreamingVideoPlayerUI defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="videoClient" toSet="videoClient:" changeEvent="videoClientChanged">videoClient</field>
	<field toGet="videoPlayer" toSet="videoPlayer:" changeEvent="videoPlayerChanged">videoPlayer</field>
	<field toGet="speaker" toSet="speaker:" changeEvent="speakerChanged">speaker</field>
	<field toGet="playButton" toSet="playButton:" changeEvent="playButtonChanged">playButton</field>
	<field toGet="loopButton" toSet="loopButton:" changeEvent="loopButtonChanged">loopButton</field>
	<field toGet="seekSlider" toSet="seekSlider:" changeEvent="seekSliderChanged">seekSlider</field>
	<field toGet="volumeSlider" toSet="volumeSlider:" changeEvent="volumeSliderChanged">volumeSlider</field>
	<field toGet="volumeLabel" toSet="volumeLabel:" changeEvent="volumeLabelChanged">volumeLabel</field>
	<field toGet="isInteracting" toSet="isInteracting:" changeEvent="isInteractingChanged">isInteracting</field>
	<field toGet="currentTime" toSet="currentTime:" changeEvent="currentTimeChanged">currentTime</field>
	<field toGet="currentTimeLabel" toSet="currentTimeLabel:" changeEvent="currentTimeLabelChanged">currentTimeLabel</field>
</fields>'!

!QStreamingVideoPlayerUI class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QStreamingVideoPlayerUI methodsFor: 'accessing' stamp: 'jcg 2/6/2009 14:23'!
currentTime
	"Answer the currentTime of the receiver"
	<bewareOf: #currentTimeChanged>
	^self propertyValueAt: #currentTime! !

!QStreamingVideoPlayerUI methodsFor: 'accessing' stamp: 'jcg 2/6/2009 14:23'!
currentTime: aValue
	"Modify the receiver's currentTime"
	^self propertyValueAt: #currentTime put: aValue with: #currentTimeChanged! !

!QStreamingVideoPlayerUI methodsFor: 'accessing' stamp: 'jcg 4/3/2009 16:18'!
currentTimeLabel
	"Answer the currentTimeLabel of the receiver"
	<bewareOf: #currentTimeLabelChanged>
	^self propertyValueAt: #currentTimeLabel! !

!QStreamingVideoPlayerUI methodsFor: 'accessing' stamp: 'jcg 4/3/2009 16:18'!
currentTimeLabel: aValue
	"Modify the receiver's currentTimeLabel"
	^self propertyValueAt: #currentTimeLabel put: aValue with: #currentTimeLabelChanged! !

!QStreamingVideoPlayerUI methodsFor: 'private' stamp: 'bgf 7/29/2009 00:12'!
doLayout
	| targetWidth minTargetWidth newScale edge |
	
	container ifNil: [^self].
	targetWidth := container width - 16.
	minTargetWidth := 300.
	newScale := 1.0.
	targetWidth < minTargetWidth 
		ifFalse: [
			self scale: 1.0.
			self costume clearMatrixFlag.
			self costume fixGeometryAfterPivotChange.
			self color: (Color black alpha: 0.65).
		]
		ifTrue: [
			newScale := targetWidth / minTargetWidth asFloat.
			targetWidth := minTargetWidth.
			self scale: newScale.
			self color: Color gray.
		].
	targetWidth > 360 ifTrue: [ 
		edge := 8
	] ifFalse: [
		edge := (newScale * 5) truncated max: 4.
	].
	
	self width: (container width - (2*edge)).
	self left: edge.
	playButton topLeft: edge@edge; fullBounds.
	loopButton topLeft: (playButton right + edge)@(edge).

	seekSlider topLeft: (loopButton left+1)@(loopButton bottom + (edge-1)).
	seekSlider width: (self width - edge - 1 - loopButton left).
	seekSlider fullBounds.
	self height: seekSlider bottom + edge.

	currentTimeLabel textAnchorPoint: #rightCenter.
	currentTimeLabel extent: (80@20); hResizing: #rigid.
	currentTimeLabel topRight: (seekSlider topLeft - (4@0)).

	volumeLabel textAnchorPoint: #leftCenter.
	volumeLabel extent: (64@20); hResizing: #rigid.
	volumeSlider width: 
		( ((targetWidth // 3)  
			min: ( width - (3*edge) - (loopButton right)) ) 
			min: ((120 * newScale) truncated)).
	volumeSlider topRight: (self width - edge)@(playButton top+2).
	volumeSlider fullBounds.
	(volumeSlider left - (loopButton right)) > 70 ifTrue: [
		volumeLabel topRight: (volumeSlider topLeft - (4@0)).
		volumeLabel visible: true.
	] ifFalse: [ 
		volumeLabel visible: false.
	].

	container ifNotNil: [
		self bottom: container bottom - edge.
	].! !

!QStreamingVideoPlayerUI methodsFor: 'initialize' stamp: 'jcg 4/22/2010 02:10'!
initialize
	super initialize.
	
	isInteracting := false.
	currentTime := 0.0.

	self define: #playButton as: CButton new.
	self define: #loopButton as: CImageButton new.
	self define: #seekSlider as: CScrollBar new.
	self define: #volumeSlider as: CScrollBar new.
	self define: #volumeLabel as: CLabel new.
	self define: #currentTimeLabel as: CLabel new.

	self initializeSliderEvents: volumeSlider script: #onInteraction signal: #mouseDown.
	self initializeSliderEvents: seekSlider script: #onInteraction signal: #mouseDown.
	self initializeSliderEvents: seekSlider script: #onEndSeek signal: #mouseUp.

	seekSlider visibleFraction: 0.04.
	volumeSlider min: 0.0.
	volumeSlider max: 1.0.
	volumeSlider step: 0.1.

! !

!QStreamingVideoPlayerUI methodsFor: 'initialize' stamp: 'jcg 4/22/2010 02:09'!
initializeSliderEvents: slider script: scriptName signal: signalName
	"We want to start the same script when there's a mouse-down in many of the slider's sub-elements."
	{	
		slider. 
		slider costume knob. 
		slider costume forwardButton. 
		slider costume backButton.
	} do: [:elem | self startScript: scriptName when: {elem. signalName}].! !

!QStreamingVideoPlayerUI methodsFor: 'accessing' stamp: 'jcg 3/17/2009 20:03'!
isInteracting
	"Answer the isInteracting of the receiver"
	<bewareOf: #isInteractingChanged>
	^self propertyValueAt: #isInteracting! !

!QStreamingVideoPlayerUI methodsFor: 'accessing' stamp: 'jcg 3/17/2009 20:03'!
isInteracting: aValue
	"Modify the receiver's isInteracting"
	^self propertyValueAt: #isInteracting put: aValue with: #isInteractingChanged! !

!QStreamingVideoPlayerUI methodsFor: 'accessing' stamp: 'bgf 3/27/2009 01:31'!
loopButton
	"Answer the loopButton of the receiver"
	<bewareOf: #loopButtonChanged>
	^self propertyValueAt: #loopButton! !

!QStreamingVideoPlayerUI methodsFor: 'accessing' stamp: 'bgf 3/27/2009 01:31'!
loopButton: aValue
	"Modify the receiver's loopButton"
	^self propertyValueAt: #loopButton put: aValue with: #loopButtonChanged! !

!QStreamingVideoPlayerUI methodsFor: 'events' stamp: 'jcg 3/17/2009 23:35'!
onClientChanged
	<on: videoClientChanged>
	videoClient ifNotNilDo: [:vc |
		seekSlider max: vc duration.
	]! !

!QStreamingVideoPlayerUI methodsFor: 'events' stamp: 'bgf 4/4/2009 18:27'!
onClientCurrentTimeChanged
	"React to a time change in the video-client."
	<on: currentTimeChanged in: videoClient>
	videoClient ifNotNilDo: [:vc | 
		currentTime := vc currentTime.
		seekSlider value: currentTime.
		self setTimeLabel: currentTime.
	].! !

!QStreamingVideoPlayerUI methodsFor: 'events' stamp: 'jcg 3/17/2009 23:35'!
onClientDurationChanged
	<on: durationChanged in: videoClient>
	seekSlider min: 0.0.
	seekSlider max: videoClient duration.
! !

!QStreamingVideoPlayerUI methodsFor: 'events' stamp: 'jcg 3/30/2009 13:39'!
onClientStateChangedTo: newState
	<on: playStateChanged in: videoClient>
	newState caseOf: {
		[#playing] -> [
			playButton enable.
			playButton label: 'Pause'.
			playButton propertyValueAt: #selected put: true.	"No trigger." 
			playButton costume onSelectedChanged.

		].
		[#paused] -> [
			playButton enable.
			playButton label: 'Play'.
			playButton propertyValueAt: #selected put: false.  "No trigger." 
			playButton costume onSelectedChanged.
		].
	} otherwise: [playButton label: 'Play'. playButton disable]! !

!QStreamingVideoPlayerUI methodsFor: 'events' stamp: 'jcg 2/6/2009 14:39'!
onContainerChanged
	<on: containerChanged>
	self doLayout! !

!QStreamingVideoPlayerUI methodsFor: 'events' stamp: 'jcg 2/6/2009 14:38'!
onContainerExtentChanged
	<on: extentChanged in: container>
	self doLayout! !

!QStreamingVideoPlayerUI methodsFor: 'events' stamp: 'jcg 4/22/2010 02:25'!
onEndSeek
	self waitTick.  "wait for last seek to go out first."
	videoClient ifNotNilDo: [:vc | vc endSeek].
! !

!QStreamingVideoPlayerUI methodsFor: 'events' stamp: 'jcg 3/18/2009 00:05'!
onInteraction
	"Disable updates from the client while we are interacting with the controls."
	self pauseScript: #onClientCurrentTimeChanged.
	self pauseScript: #onSpeakerVolumeChanged.
	isInteracting := true.
	self hand waitUntil: #mouseUp.
	isInteracting := false.
	self resumeScript: #onClientCurrentTimeChanged.
	self pauseScript: #onSpeakerVolumeChanged.! !

!QStreamingVideoPlayerUI methodsFor: 'events' stamp: 'jcg 3/27/2009 14:58'!
onIsLoopingChangedTo: bool
	<on: isLoopingChanged in: videoClient>
	loopButton propertyValueAt: #selected put: bool. "No trigger"
	loopButton onSelectedChanged.
	! !

!QStreamingVideoPlayerUI methodsFor: 'events' stamp: 'bgf 3/27/2009 01:31'!
onLoopButtonFire
	<on: fire in: loopButton>
	loopButton selected: (loopButton selected not).! !

!QStreamingVideoPlayerUI methodsFor: 'events' stamp: 'jcg 3/27/2009 14:47'!
onLoopSelectedChanged
	<on: selectedChanged in: loopButton>

	videoClient ifNotNilDo: [:vc | vc serverIsLooping: (loopButton selected)].! !

!QStreamingVideoPlayerUI methodsFor: 'events' stamp: 'bgf 4/4/2009 18:21'!
onSeekSliderValueChanged
	<on: valueChanged in: seekSlider>
	isInteracting ifFalse: [^self].
	videoClient ifNotNilDo: [:vc | 
		vc seekTo: seekSlider value asFloat.
		self setTimeLabel: (seekSlider value  asFloat).
		container ifNotNilDo: [:c | c wasUsedLocally].
	].! !

!QStreamingVideoPlayerUI methodsFor: 'events' stamp: 'jcg 3/18/2009 00:19'!
onSpeakerChanged
	<on: speakerChanged in: container>
	speaker := container speaker.
	speaker ifNotNilDo: [:spkr |
		volumeSlider value: (spkr get: #volume)
	].! !

!QStreamingVideoPlayerUI methodsFor: 'events' stamp: 'bgf 3/27/2009 00:31'!
onSpeakerVolumeChanged: newVolume
	<on: volumeChanged in: speaker>
	isInteracting ifFalse: [  "Prevent twitchy slider when I'm driving it."
		volumeSlider value: newVolume
	].! !

!QStreamingVideoPlayerUI methodsFor: 'events' stamp: 'jcg 4/7/2009 00:23'!
onVolumeSliderValueChanged
	<on: valueChanged in: volumeSlider>

	"Do this first... whoever's dragging the slider, we always update the label"
	volumeLabel text: self volumeString.

	"Only the person doing the dragging should be sending future messages."
	isInteracting ifFalse: [^self].

	"Send #volume: to the replicated player, which will pass it on to the speaker."
	videoPlayer embeddedApp future volume: volumeSlider value.
	container ifNotNilDo: [:c | c wasUsedLocally].
! !

!QStreamingVideoPlayerUI methodsFor: 'accessing' stamp: 'jcg 2/6/2009 14:23'!
playButton
	"Answer the playButton of the receiver"
	<bewareOf: #playButtonChanged>
	^self propertyValueAt: #playButton! !

!QStreamingVideoPlayerUI methodsFor: 'accessing' stamp: 'jcg 2/6/2009 14:23'!
playButton: aValue
	"Modify the receiver's playButton"
	^self propertyValueAt: #playButton put: aValue with: #playButtonChanged! !

!QStreamingVideoPlayerUI methodsFor: 'events' stamp: 'bgf 3/27/2009 02:01'!
playClicked
	<on: fire in: playButton>
	
	playButton selected: playButton selected not.! !

!QStreamingVideoPlayerUI methodsFor: 'events' stamp: 'jcg 4/30/2009 18:10'!
playSelectedChanged
	<on: selectedChanged in: playButton>
	
	videoClient
		ifNil: [QLogger logWarning: 'client is nil in #playClicked']
		ifNotNilDo: [:c | 
			| hex |
			hex := c controlStreamID ifNotNilDo: [:id | id hex].
			hex ifNil: [hex := 'no streamID'].
			playButton selected
				ifTrue: [
					QActivityCapture action: 'PlayStreamingVideo' details: hex.
					c play.
				]
				ifFalse: [
					QActivityCapture action: 'PauseStreamingVideo' details: hex.
					c pause.
				].
		].
! !

!QStreamingVideoPlayerUI methodsFor: 'accessing' stamp: 'jcg 3/17/2009 23:34'!
seekSlider
	"Answer the seekSlider of the receiver"
	<bewareOf: #seekSliderChanged>
	^self propertyValueAt: #seekSlider! !

!QStreamingVideoPlayerUI methodsFor: 'accessing' stamp: 'jcg 3/17/2009 23:34'!
seekSlider: aValue
	"Modify the receiver's seekSlider"
	^self propertyValueAt: #seekSlider put: aValue with: #seekSliderChanged! !

!QStreamingVideoPlayerUI methodsFor: 'private' stamp: 'bgf 4/4/2009 18:24'!
setTimeLabel: time

	"Time is in media-time already... just format it."
	|rounded hr min sec timeString|

	rounded := time rounded.
	hr := rounded // 3600.
	min := (rounded \\ 3600) // 60.
	sec := rounded \\ 60.
	timeString := String streamContents: [:str |
		hr printOn: str.
		str nextPut: $:.
		str nextPutAll: (min printPaddedWith: $0 to: 2 base: 10).			
		str nextPut: $:.
		str nextPutAll: (sec printPaddedWith: $0 to: 2 base: 10).
	].
	currentTimeLabel value: timeString.
! !

!QStreamingVideoPlayerUI methodsFor: 'initialize' stamp: 'bgf 7/29/2009 00:13'!
setupColors

	"Body color is set in doLayout."
	self borderColor: (Color darkGray alpha: 0.2).

	self setupSliderColors: seekSlider.
	self setupSliderColors: volumeSlider.

	playButton fillColor: (Color gray: 0.6).
	playButton borderColor: (Color gray: 0.15).

	volumeLabel color: Color transparent.
	volumeLabel textColor: (Color gray: 0.8).

	currentTimeLabel color: Color transparent.
	currentTimeLabel textColor: (Color gray: 0.8).! !

!QStreamingVideoPlayerUI methodsFor: 'initialize' stamp: 'sn 5/13/2011 13:19'!
setupCostume
	| buttonFont |

	super setupCostume.
	self setupColors.
	self roundCorners: false.
	self borderStyle: #simple.
	self borderWidth: 1.

	buttonFont := (StrikeFont familyName: #'LiberationMono' pointSize: 14).
	
	playButton font: buttonFont; label: 'Play' translateMe.
	playButton extent: 68@23; roundCorners: false;
				hResizing: #rigid; vResizing: #rigid.
	loopButton extent: 22@22; 
		fillAlpha: 0;
		graphicAnchorPoint: #center;
		graphicFit: #scale;
		borderWidth: 1; borderColor: (Color gray:0.05);
		normalImage: (QForms current import: 'Looping-Off.png' from: 'icons/Qwaq');
		selectedImage: (QForms current import: 'Looping-On.png' from: 'icons/Qwaq').
	
	self 
		add: playButton;
		add: loopButton;
		add: seekSlider;
		add: volumeSlider;
		add: volumeLabel;
		add: currentTimeLabel.

	volumeLabel width: 80.
	volumeLabel font: (StrikeFont familyName: #'LiberationMono' pointSize: 11).
	"You'd think that using #volumeString would work (instead of hard-wiring it), 
	 but it doesn't... I don't understand why."
	volumeSlider value: 10.
	volumeLabel value: (self volumeString).

	currentTimeLabel font: (StrikeFont familyName: #'LiberationMono' pointSize: 11).
	currentTimeLabel value: '0:00:00'.

	self doLayout.
! !

!QStreamingVideoPlayerUI methodsFor: 'initialize' stamp: 'bgf 3/27/2009 02:04'!
setupSliderColors: slider

	slider color: (Color gray: 0.2).
	slider costume knob color: (Color gray: 0.4).

	slider costume knobShadow 
		color: (Color gray: 0.15);
		borderColor: (Color gray: 0.05).
	slider costume backButton 
		color: (Color gray: 0.4);
		borderColor: (Color gray: 0.1).
	slider costume forwardButton 
		color: (Color gray: 0.4);
		borderColor: (Color gray: 0.1).
! !

!QStreamingVideoPlayerUI methodsFor: 'accessing' stamp: 'jcg 3/18/2009 00:02'!
speaker
	"Answer the speaker of the receiver"
	<bewareOf: #speakerChanged>
	^self propertyValueAt: #speaker! !

!QStreamingVideoPlayerUI methodsFor: 'accessing' stamp: 'jcg 3/18/2009 00:02'!
speaker: aValue
	"Modify the receiver's speaker"
	^self propertyValueAt: #speaker put: aValue with: #speakerChanged! !

!QStreamingVideoPlayerUI methodsFor: 'accessing' stamp: 'jcg 2/6/2009 15:43'!
videoClient
	"Answer the videoClient of the receiver"
	<bewareOf: #videoClientChanged>
	^self propertyValueAt: #videoClient! !

!QStreamingVideoPlayerUI methodsFor: 'accessing' stamp: 'jcg 2/6/2009 15:43'!
videoClient: aValue
	"Modify the receiver's videoClient"
	^self propertyValueAt: #videoClient put: aValue with: #videoClientChanged! !

!QStreamingVideoPlayerUI methodsFor: 'accessing' stamp: 'jcg 4/7/2009 00:21'!
videoPlayer
	"Answer the videoPlayer of the receiver"
	<bewareOf: #videoPlayerChanged>
	^self propertyValueAt: #videoPlayer! !

!QStreamingVideoPlayerUI methodsFor: 'accessing' stamp: 'jcg 4/7/2009 00:21'!
videoPlayer: aValue
	"Modify the receiver's videoPlayer"
	^self propertyValueAt: #videoPlayer put: aValue with: #videoPlayerChanged! !

!QStreamingVideoPlayerUI methodsFor: 'accessing' stamp: 'jcg 3/18/2009 00:20'!
volumeLabel
	"Answer the volumeLabel of the receiver"
	<bewareOf: #volumeLabelChanged>
	^self propertyValueAt: #volumeLabel! !

!QStreamingVideoPlayerUI methodsFor: 'accessing' stamp: 'jcg 3/18/2009 00:20'!
volumeLabel: aValue
	"Modify the receiver's volumeLabel"
	^self propertyValueAt: #volumeLabel put: aValue with: #volumeLabelChanged! !

!QStreamingVideoPlayerUI methodsFor: 'accessing' stamp: 'jcg 3/17/2009 23:34'!
volumeSlider
	"Answer the volumeSlider of the receiver"
	<bewareOf: #volumeSliderChanged>
	^self propertyValueAt: #volumeSlider! !

!QStreamingVideoPlayerUI methodsFor: 'accessing' stamp: 'jcg 3/17/2009 23:34'!
volumeSlider: aValue
	"Modify the receiver's volumeSlider"
	^self propertyValueAt: #volumeSlider put: aValue with: #volumeSliderChanged! !

!QStreamingVideoPlayerUI methodsFor: 'private' stamp: 'jcg 8/11/2010 17:33'!
volumeString
	"Answer a string describing the current volume level."
	| vol str |
	vol := volumeSlider value.
	vol = 0.0 
		ifTrue: [str := '0 ']
		ifFalse: [
			str := (vol*9 + 1) truncated asString.
			str size == 1 ifTrue: [str := str, ' ']].	
	^ 'Volume: ', str
	! !

TClientObject subclass: #QClientVideoCamera
	instanceVariableNames: 'mediaController manager showWarning allTracks videoFrameRate videoExtent videoBitRate videoServer videoAsset encoder captureView encodedFrameCount capturedFrameCount startTimeMSecs captureCam broadcastSessionID placeTransform videoClient audioRecorder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-Secure'!

!QClientVideoCamera commentStamp: 'crl 2/10/2010 11:41' prior: 0!
'
	Each of my instances is the off-island counterpart to a corresponding replicated video camera. The replicated video camera establishes a viewpoint in a space, and a user interface. The off-island camera captures video and audio appropriate for that viewpoint, and makes those streams available.!

!QClientVideoCamera class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QClientVideoCamera class methodsFor: 'instance creation' stamp: 'crl 2/4/2010 17:59'!
for: replicatedObjectRef manager: aQSecureWebcastManager controller: aController
	^(self new)
		mediaController: aController;
		manager: aQSecureWebcastManager; 
		ref: replicatedObjectRef;
		yourself! !

!QClientVideoCamera methodsFor: 'capturing' stamp: 'crl 2/9/2010 14:28'!
addAudioTrack
	"Add a new audio track to the recording.  There's some cut'n'paste goin' on, so be sure to check other similar methods when you make changes."
	| baseName track trackID aacConfig |
	trackID := allTracks size+1.
	baseName := 'audio', trackID.

	aacConfig := self ui audioSession streamMixer aacConfig.

	track := QSessionRecorderTrackUploader 
		name: baseName,'.nhml' 
		type: 'audio' encoding: 'aac'.
	track info
		trackType: 'audio';
		trackID: trackID;
		codec: 'AAC';
		timeScale: aacConfig samplingFrequency;
		duration: Float infinity; 
		dtsIncrement: 1024;
		sampleRate: aacConfig samplingFrequency;
		numChannels: aacConfig numChannels;
		decoderSpecificInfo: aacConfig bytes;
		bitrate: 64000; "hardwired into QAudioPlugin"
		timestampScale: 1024. "same as DTS-increment"
	
	^track! !

!QClientVideoCamera methodsFor: 'capturing' stamp: 'crl 2/5/2010 17:10'!
addVideoTrack
	"Add a new video track to the recording."

	| baseName track trackID decoderConfigData |

	trackID := allTracks size+1.
	baseName := 'video', trackID.

	track := QSessionRecorderTrackUploader 
		name: baseName,'.nhml' 
		type: 'video' encoding: 'avc'.

	[ 
		| tempEncoder |
		[	tempEncoder := self createEncoderForCurrentSettings.
			decoderConfigData := tempEncoder decoderConfigurationRecord asByteArray.
		] ensure: [tempEncoder ifNotNilDo: [:enc | enc destroy]].
	] on: Error do: [:err |
		QLogger logError: err.
		self error: 'unable to generate decoder configuration'
	].

	track info
		trackType: 'video';
		trackID: trackID;
		codec: 'avc1';
		timeScale: 90000;
		duration: Float infinity; 
		dtsIncrement: (90000 / videoFrameRate);
		width: videoExtent x;
		height: videoExtent y;
		decoderSpecificInfo: decoderConfigData;
		bitrate: videoBitRate;
		timestampScale: 90000 / videoFrameRate. "same as DTS-increment"

	^track! !

!QClientVideoCamera methodsFor: 'accessing' stamp: 'crl 2/8/2010 17:56'!
cameraTransform
	"The local transform of the fixed or dynamic position, or that of the captureCam.
	May be extended by subclasses."
	^placeTransform ifNil:[captureCam localTransform].! !

!QClientVideoCamera methodsFor: 'control' stamp: 'crl 2/5/2010 15:37'!
canCapture
	"Answer whether my environment is conducive for capture."

	| ui |

	"Warn once per capture attempt."
	showWarning := true.

	ui := manager view owner.

	"XXXXX: Josh: IIRC, we won't run 3.0 clients against older servers... if so, remove this test."
	((ui serviceMgr netvidPing: ui session hubID) name == #ok) ifFalse: [
		ui inform: 'The server does not support recording'.
		^false].

	"If current audio-interface doesn't support recording, pop up a dialog and give up."
	(
		[ui audioSession audioInterface supportsRecording]
			on: Error
			do: [:error |
				QLogger logError: error.
				ui inform:  'Failed to start audio-capture due to error in audio sub-system'.
				^false]
	)
		ifTrue: [^true]
		ifFalse: [
			(
				CDialog 
					confirm: (
						'Session capture requires OpenAL to be enabled.',
						String cr,
						String cr,
						'Open the Sound Settings pane to make this change?')
					yes: 'Yes'
					no: 'No'
					label: 'OpenAL is disabled'
			)
				ifTrue: [ui controlBar adjustSound].

			^false].
	! !

!QClientVideoCamera methodsFor: 'capturing' stamp: 'jcg 3/17/2010 12:30'!
createCaptureView
	captureView := self ui session viewPaneClass new.
	captureView player: self.
	captureView bounds: (0@0 extent: videoExtent).
	captureView 
		useOGLForSavedScene: false;
		isMiniScene: true;
		isSessionCapture: true;
		space: self ui mainView activeSpace.
	captureView renderWhenObscured:
		"i.e., do NOT render when obscured on Windows pre Vista."
		((Smalltalk platformName = 'Win32') and:[Smalltalk osVersion < '6.0'])  not.

	"Render every other frame"
	captureView renderInterval: 2.! !

!QClientVideoCamera methodsFor: 'private' stamp: 'crl 2/9/2010 11:19'!
createEncoderForCurrentSettings
	^self
		createEncoderForExtent: videoExtent 
		bitRate: videoBitRate
		frameRate: videoFrameRate! !

!QClientVideoCamera methodsFor: 'private' stamp: 'jcg 7/26/2011 23:36'!
createEncoderForExtent: ext bitRate: br frameRate: fps
	| args |
	args := QVideoArgs new usePlatformEndianness.
	args codecType: 'avc1'.
	args timeScale: 3000.
	args width: videoExtent x.
	args height: videoExtent y.
	args bitRate: videoBitRate.
	args fps: videoFrameRate asFloat.
	^QVideoEncoderFree withArgs: args extent: videoExtent! !

!QClientVideoCamera methodsFor: 'initialize' stamp: 'crl 2/8/2010 13:44'!
destroyVideoServer
	videoServer ifNotNilDo: [:vs |
		videoServer := nil.
		vs destroy.
	].
	videoAsset := nil! !

!QClientVideoCamera methodsFor: 'accessing' stamp: 'crl 2/9/2010 12:17'!
elapsedMSecs
	^Time millisecondsSince: startTimeMSecs! !

!QClientVideoCamera methodsFor: 'private' stamp: 'crl 2/9/2010 11:48'!
expectedFrame
	"While recording, what frame should I be encoding now, according to the time base?"
	^ self elapsedMSecs * videoFrameRate // 1000 + 1.! !

!QClientVideoCamera methodsFor: 'initialize' stamp: 'crl 2/9/2010 12:56'!
initialize
	super initialize.
	allTracks := Dictionary new.! !

!QClientVideoCamera methodsFor: 'initialize' stamp: 'crl 2/4/2010 18:02'!
manager: aQVideoDecoderManager 
	manager := aQVideoDecoderManager! !

!QClientVideoCamera methodsFor: 'accessing' stamp: 'crl 2/4/2010 18:00'!
mediaController: aController
	mediaController := aController! !

!QClientVideoCamera methodsFor: 'capturing' stamp: 'crl 2/9/2010 16:17'!
onCaptureFrame
	"Capture a rendered frame. Push it into the encoder if there is one."
	| form expectedFrame cv maxFrames |

	cv := captureView ifNil:[^self].
	encoder ifNil:[^self].

	"XXXX: Fixme. We need to set the camera here again since the viewpane will dump it when OpenGL changes (which it does upon the first frame). Consequently, we skip all the frames that have 'wrong' camera to avoid flickering."
	captureCam ifNotNil: [
		(captureCam := self ui avatar camera) == cv camera ifFalse: [
		cv camera: captureCam.
		^self].
	].

	form := cv savedSceneForm ifNil:[^self].
	expectedFrame := self expectedFrame.

	"Amortize catching-up; no more than 2 frames per normal rendered frame.
	 Encoding is costly, if we're behind, forcing more encoding 
	 per rendered frame just drives everything further behind.
	 But if the UI is in idle-render, we expect large gaps between frames, so allow more infill."

	maxFrames := (self ui isIdlingFrames ifTrue: [ 15 ] ifFalse: [ 2 ]).
	1 to: maxFrames do: [ : i |
		expectedFrame > capturedFrameCount ifTrue: [ 
			"Don't push frames back to back, give a pause; otherwise the encoder
	 		 tries to launch worker threads and often crashes in the MainConcept code."
			i > 1 ifTrue: [ (Delay forMilliseconds: 10) wait ].
			encoder ifNil: [ ^ self ].
			encoder encode: form.
			"Don't push them more than 4x  as fast as the frame-rate would indicate."
			capturedFrameCount := capturedFrameCount + 1.
		]].
! !

!QClientVideoCamera methodsFor: 'events' stamp: 'crl 4/22/2010 15:58'!
onCaptureStateChanged: shouldCapture
	(ref island get: #id) = (self ui avatar replica island get: #id) ifTrue: [
		QLogger logInfo: 'should capture: ', shouldCapture printString.
		shouldCapture
			ifTrue: [self startCapturing]
			ifFalse: [self stopCapturing]]! !

!QClientVideoCamera methodsFor: 'encoding' stamp: 'jcg 1/31/2012 01:21'!
onFrameEncoded: bytes
	"Capture encoded bytes. Push both data and meta-data into the upload."
	| isRAP bytesToUpload videoTrack |

	encodedFrameCount := encodedFrameCount + 1.
	
	isRAP := ((bytes at: 1) bitAnd: 1) > 0 "get 'isRAP' bit from Qwaq flag byte.". 
	bytesToUpload := bytes copyWithoutFirst. "skip Qwaq flag byte"
	bytesToUpload := AVCHackingUtilities replaceStartCodesWithNaluSizes: bytesToUpload.

	videoTrack := allTracks at: #video ifAbsent: [nil].
	videoTrack ifNotNil: [videoTrack
								addData: bytesToUpload  
								samples: (90000 / videoFrameRate) 
								isRAP: isRAP].! !

!QClientVideoCamera methodsFor: 'events' stamp: 'crl 2/9/2010 16:33'!
onNetVidServerDestroyed
	"This only happens when the server is destroyed unexpectedly (because when we do it ourselves, we first nil out the reference before destroying it... see #destroyVideoServer)."
	allTracks := Dictionary new. "so that #stopUploading doesn't hang"
	"Forked because Tweak teardown resulting from #stopRecording
	 will result in this #onNetVidServerDestroyed script being killed."
		"ar 9/29/2009: And why is that a problem?"
	self startScript: #stopCapturing.
! !

!QClientVideoCamera methodsFor: 'events' stamp: 'crl 2/8/2010 14:38'!
onReceiveEncodedAudio: bytes
	| audioTrack |
	audioTrack := allTracks at: #audio ifAbsent: [nil].
	audioTrack ifNotNil: [audioTrack addData: bytes samples: 1024 isRAP: true].! !

!QClientVideoCamera methodsFor: 'events' stamp: 'crl 2/19/2010 18:04'!
onRelayRenderedView
	QLogger logInfo: 'relay rendered view'! !

!QClientVideoCamera methodsFor: 'events' stamp: 'crl 2/22/2010 18:30'!
onRelayStreamID: streamID
	QLogger logInfo: 'relaying streamID: ', streamID.
	QLogger logInfo: 'creating new NetVid-client (streamID: ', streamID, ')'.

	videoClient := QNetVidClient new.
	videoClient streamManager: manager view session mediaController mediaPlugin.
	self runScript: #onVideoClientDestroyed when: {videoClient. #destroyed}.
	self runScript: #onVideoClientTracksChanged:with:with: when: {videoClient. #tracksChanged}.
	videoClient future subscribeToControlStream: (TObjectID readHexFrom: streamID)! !

!QClientVideoCamera methodsFor: 'events' stamp: 'crl 5/3/2010 10:53'!
onVideoClientDestroyed
	QLogger logInfo: 'video client destroyed'! !

!QClientVideoCamera methodsFor: 'events' stamp: 'crl 5/3/2010 10:57'!
onVideoClientTracksChanged: ignored with: alsoIgnored with: trackListingNode
	"Launch a NetVidServer to stream the video from a netvid client."
	"Integrate/refactor this with >>startPublishing."

	| publishID subscribeID |

	QLogger logInfo: 'video client tracks changed'.

	"self destroyVideoServer."

	videoBitRate := 360000  "45kbytes/sec".
	videoFrameRate := 10.
	videoExtent := 600@400.

	"For now, use the avatar's camera. Later, hack up a destination that corresponds to where the on-island camera is."
	captureCam := self ui avatar camera.
	placeTransform := nil.

	audioRecorder := self ui audioSession noMixedSourcesRecorder.
	audioRecorder future addClient: self.

	"Add the video track"
	allTracks
		at: #video
		put: self addVideoTrack;
		at: #audio
		put: self addAudioTrack.

	publishID := TObjectID new.
	subscribeID := TCryptoRandom hashMessage: publishID.

	videoAsset := QNetVidLiveAsset new.
	videoAsset assetName: 'CapturedSession-', subscribeID hex.
	videoAsset addTrack: (allTracks at: #video).
	videoAsset addTrack: (allTracks at: #audio).
	
	videoServer ifNil: [videoServer := QRelayNetVidServer
						newWithPublishedControlStream: publishID
						mediaController: self ui session mediaController].
	(videoServer future yourself) wait.
	(videoServer future controlStreamFilter: [:output | false]) wait.
	(videoServer future addTrackListing: trackListingNode) wait. 
	(videoServer future openMedia: videoAsset) wait.
	(videoServer future yourself) wait. "wait for previous publish, etc. to finish"
	"HACK, obviously."
	QJoshHacks lastNetVidID: subscribeID.

	self
		startScript: #onNetVidServerDestroyed
		when: {videoServer. #destroyed}.

	videoServer future play.

	broadcastSessionID := TObjectID new.
	QLogger logInfo: 'new broadcast session: ', 
						broadcastSessionID hex, '/', videoServer controlStreamID hex.
	self ui serviceMgr
		publishWebcast: 'a viewpoint'
		description: 'an in-world viewpoint'
		service: self ui serviceSvc name
		sessionID: broadcastSessionID
		streamID: videoServer controlStreamID
		videoExtent: videoExtent
		stompExisting: true! !

!QClientVideoCamera methodsFor: 'printing' stamp: 'crl 2/10/2010 18:26'!
printOn: aStream
	super printOn: aStream.
	videoServer ifNotNilDo: [:vs |
		aStream nextPutAll: '(stream: ', (vs controlStreamID ifNotNilDo: [:id | id shortHex]) printString, ')'.
	].! !

!QClientVideoCamera methodsFor: 'initialize' stamp: 'crl 2/19/2010 16:16'!
registerForEvents
	super registerForEvents.
	self
		startScript: #onCaptureStateChanged:
		when: {ref. #captureStateChanged};
		startScript: #onRelayStreamID:
		when: {ref. #relayStreamID};
		startScript: #onRelayRenderedView
		when: {ref. #relayRenderedView}! !

!QClientVideoCamera methodsFor: 'control' stamp: 'crl 4/20/2010 17:26'!
startCapturing
	videoBitRate := 360000  "45kbytes/sec".
	videoFrameRate := 10.
	videoExtent := 600@400.

	"For now, use the avatar's camera. Later, hack up a destination that corresponds to where the on-island camera is."
	captureCam := self ui avatar camera.
	placeTransform := nil.

	audioRecorder := self ui audioSession noMixedSourcesRecorder.
	audioRecorder future addClient: self.

	"Add the video track"
	allTracks
		at: #video
		put: self addVideoTrack;
		at: #audio
		put: self addAudioTrack.

	"Start everything in reverse order so that we start capturing as soon as possible."
	self
		startPublishing;
		startEncoding;
		startVideoCapture;
		startVoiceCapture! !

!QClientVideoCamera methodsFor: 'encoding' stamp: 'crl 2/9/2010 16:21'!
startEncoding
	"Start encoding any captured frames"
	"That is, set the encoder, so that it will get used in #onCaptureFrame."

	self stopEncoding.
	encoder := self createEncoderForCurrentSettings.
	self
		startScript: #onFrameEncoded:
		when: {encoder. #encodedFrame}! !

!QClientVideoCamera methodsFor: 'control' stamp: 'bgf 4/14/2010 17:50'!
startPublishing
	"Launch a NetVidServer to stream the captured video."

	| publishID subscribeID |

	self destroyVideoServer.

	publishID := TObjectID new.
	subscribeID := TCryptoRandom hashMessage: publishID.

	videoAsset := QNetVidLiveAsset new.
	videoAsset assetName: 'CapturedSession-', subscribeID hex.
	videoAsset addTrack: (allTracks at: #video).
	videoAsset addTrack: (allTracks at: #audio).
	
	videoServer := QNetVidServer
						newWithPublishedControlStream: publishID
						mediaController: self ui session mediaController.
	videoServer future controlStreamFilter: [:output | false].
	videoServer future openMedia: videoAsset.
	(videoServer future yourself) wait. "wait for previous publish, etc. to finish"
	"HACK, obviously."
	QJoshHacks lastNetVidID: subscribeID.

	self
		startScript: #onNetVidServerDestroyed
		when: {videoServer. #destroyed}.

	videoServer future play.

	broadcastSessionID := TObjectID new.
	QLogger logInfo: 'new broadcast session: ', 
						broadcastSessionID hex, '/', videoServer controlStreamID hex.
	self ui serviceMgr
		publishWebcast: 'a viewpoint'
		description: 'an in-world viewpoint'
		service: self ui currentForumName
		sessionID: broadcastSessionID
		streamID: videoServer controlStreamID
		videoExtent: videoExtent
		stompExisting: true! !

!QClientVideoCamera methodsFor: 'capturing' stamp: 'crl 2/9/2010 16:16'!
startVideoCapture
	"Start capturing the current view"
	self stopVideoCapture.
	capturedFrameCount := encodedFrameCount := 0.
	startTimeMSecs := Time millisecondClockValue.

	self createCaptureView.

	captureCam ifNil:[
		captureView camera localTransform: self cameraTransform.
	] ifNotNil:[
		captureView camera: captureCam.
	].

	self ui session addBottomPane: captureView.
	self
		startScript: #onCaptureFrame
		when: {captureView. #savedSceneChanged}! !

!QClientVideoCamera methodsFor: 'capturing' stamp: 'crl 4/20/2010 17:29'!
startVoiceCapture
	"Start capturing voice"
	self stopVoiceCapture.
	self 
		runScript: #onReceiveEncodedAudio: 
		when: {audioRecorder. #encodedRecordedAudioFrame}! !

!QClientVideoCamera methodsFor: 'control' stamp: 'crl 4/20/2010 18:37'!
stopCapturing
	audioRecorder future removeClient: self.

	self
		stopVoiceCapture;
		stopVideoCapture;
		stopEncoding;
		stopPublishing.

	allTracks := IdentityDictionary new! !

!QClientVideoCamera methodsFor: 'encoding' stamp: 'crl 2/8/2010 14:00'!
stopEncoding
	"Stop encoding frames."

	encoder ifNotNil:[
		| e |
		e := encoder.
		encoder := nil.

		"Make sure we've quiesced before killing the low-level encoder,
	 	 to void racey behavior on Mac MC libraries."
		[ (Delay forSeconds: 1) wait.  e destroy ] fork.
	]! !

!QClientVideoCamera methodsFor: 'control' stamp: 'crl 2/9/2010 12:13'!
stopPublishing
	"Don't wait for anything, just kill the server immediately."

	self destroyVideoServer! !

!QClientVideoCamera methodsFor: 'capturing' stamp: 'crl 2/8/2010 14:33'!
stopVideoCapture
	"Stop capturing the current view"
	captureView ifNotNil:[
		| elapsed |
		self ui session ifNotNilDo: [:sess |
			"Bulletproof... session might already be nil during shutdown."
			sess removePane: captureView.
		].
		captureView := nil.

		"Logging."
		elapsed := self elapsedMSecs.
		QLogger logInfo: 
			'encoded ', encodedFrameCount, '/', capturedFrameCount, 
			' video frames in ', elapsed, 
			'ms (', (encodedFrameCount * 1000.0 / elapsed), 'fps)'.
	].! !

!QClientVideoCamera methodsFor: 'capturing' stamp: 'crl 2/8/2010 14:35'!
stopVoiceCapture
	"Stop capturing voice."

	self stopScript: #onReceiveEncodedAudio:! !

!QClientVideoCamera methodsFor: 'accessing' stamp: 'crl 2/10/2010 19:06'!
streamID
	^videoServer ifNotNilDo: [:vs | vs controlStreamID]! !

!QClientVideoCamera methodsFor: 'accessing' stamp: 'crl 2/5/2010 16:52'!
ui
	^manager view owner! !

TClientObject subclass: #QClientVideoTexture
	instanceVariableNames: 'manager mediaController description tokens'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-Texture'!

!QClientVideoTexture commentStamp: '<historical>' prior: 0!
(c) 2007 Qwaq Inc.  QClientVideoTexture is the off-island counterpart to QVideoTexture (see that class comment).  The displayed image is updated from a video stream.
!

!QClientVideoTexture class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QClientVideoTexture class methodsFor: 'instance creation' stamp: 'crl 12/16/2009 17:41'!
for: replicatedObjectRef manager: videoManager controller: aController
	^(self new)
		mediaController: aController;
		manager: videoManager; 
		ref: replicatedObjectRef;
		yourself! !

!QClientVideoTexture methodsFor: 'accessing' stamp: 'crl 12/18/2009 17:38'!
description: desc "QStreamingVideoV1FileCardContents or QWebcastRecord"
	description = desc ifTrue: [^self "nothing has changed"].
	description ifNotNil: [manager future removeClient: self of: description sessionID].
	description := desc.
	description ifNotNil: [manager future
							addClient: self
							of: description sessionID 
							description: description 
							controller: mediaController].
! !

!QClientVideoTexture methodsFor: 'initialize' stamp: 'jcg 2/1/2008 13:34'!
destroy
	super destroy.
	self stopScript: #description:.
	self description: nil. "this will also decrement the # of users of this video stream."
	manager removeClientTexture: self.! !

!QClientVideoTexture methodsFor: 'initialize' stamp: 'jcg 12/29/2009 17:28'!
initializeForRef
	| exported desc  |
	super initializeForRef.

	"The tokens must not change (at least between adding/removing self as client of a particular stream)... otherwise we will get confused about whether the stream is still being used by anyone."
	tokens := {ref islandID}.
	self startScript: #description: when: {ref. #streamDescriptionChanged}.
	[
		exported := ref get: #exportVideoDescription.
		desc := exported ifNotNil: [TIslandCopyImporter new importData: exported].
	] on: Error do: [:err | 
		QLogger logError: 'failed to import video description because: ', err description.
		desc := nil.
	].

	self description: desc




! !

!QClientVideoTexture methodsFor: 'initialize' stamp: 'jcg 8/8/2007 17:23'!
manager: aQVideoDecoderManager 
	manager := aQVideoDecoderManager! !

!QClientVideoTexture methodsFor: 'accessing' stamp: 'ar 10/17/2007 11:58'!
mediaController
	^mediaController! !

!QClientVideoTexture methodsFor: 'accessing' stamp: 'ar 10/17/2007 11:59'!
mediaController: aController
	mediaController := aController! !

!QClientVideoTexture methodsFor: 'accessing' stamp: 'jcg 2/19/2008 16:44'!
tokens
	^tokens! !

QEmbeddedApp subclass: #QStreamingVideoApp
	instanceVariableNames: 'streamID speaker errorMessage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Integration'!

!QStreamingVideoApp commentStamp: '<historical>' prior: 0!
On-island portion of an app to play streaming video.  Almost everything is handled off-island... this class only provides a way to specify which video is to be viewed, and a place to display it.!

!QStreamingVideoApp class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QStreamingVideoApp class methodsFor: 'instance creation' stamp: 'bgf 3/5/2009 15:48'!
fileCardBacking
	"Stub to allow this class to fit where the tembeddable app class is expected."
	^ 'MovieCard.png'! !

!QStreamingVideoApp class methodsFor: 'instance creation' stamp: 'jcg 2/5/2009 22:26'!
newForDocument: ssDoc extent: anExtent
	"Protocol for launching in the panel/filecard system"
	^ (self new)	
		document: ssDoc
		yourself.! !

!QStreamingVideoApp methodsFor: 'initialize' stamp: 'jcg 4/7/2009 00:26'!
document: sharedDoc
	super document: sharedDoc.
	speaker volume: sharedDoc volume.! !

!QStreamingVideoApp methodsFor: 'accessing' stamp: 'jcg 3/8/2009 13:54'!
errorMessage
	^errorMessage! !

!QStreamingVideoApp methodsFor: 'accessing' stamp: 'jcg 3/8/2009 13:54'!
errorMessage: newMessage
	errorMessage = newMessage ifTrue: [^self].
	errorMessage := newMessage.
	self signal: #errorMessageChanged with: errorMessage! !

!QStreamingVideoApp methodsFor: 'initialize' stamp: 'bgf 4/8/2009 01:01'!
initialize
	super initialize.

	speaker := QSpeaker new.
	speaker rotationAroundY: 180.
	"The following translation ensures we fall within a sound region
	 that might be nestled inside the room when the panel is on a boundary wall.   
	 Sound regions hand-placed within rooms, inset to prevent bleed-through partitions.
	 Avatars cannot get much closer than this to walls, so the displacement is minor.)" 
	speaker translationX: 0 y: 0 z: 1.5.
	self addChild: speaker.
	speaker startPlaying.

	self 
		name: #TweakProjectWorld
		extent: 256@256
		data: #(makeWorld: QStreamingVideoPlayer).
	self objectName: 'Streaming Video Player'.
	
	! !

!QStreamingVideoApp methodsFor: 'accessing' stamp: 'jcg 4/9/2009 14:34'!
isAutoPlay
	^document isAutoPlay! !

!QStreamingVideoApp methodsFor: 'accessing' stamp: 'jcg 4/9/2009 14:34'!
isLooping
	^document isLooping! !

!QStreamingVideoApp methodsFor: 'running' stamp: 'hrs 4/26/2010 19:20'!
shouldRunUponLoad
	^self isAutoPlay! !

!QStreamingVideoApp methodsFor: 'accessing' stamp: 'jcg 2/26/2009 23:05'!
speaker
	^speaker! !

!QStreamingVideoApp methodsFor: 'running' stamp: 'jcg 3/27/2009 00:37'!
stopRunning
	super stopRunning.
	self streamID: nil.! !

!QStreamingVideoApp methodsFor: 'accessing' stamp: 'jcg 2/5/2009 11:50'!
streamID
	^streamID! !

!QStreamingVideoApp methodsFor: 'accessing' stamp: 'jcg 5/19/2010 12:17'!
streamID: aTObjectID
	streamID := aTObjectID.
	self signal: #streamChanged with: streamID.

	"Once we've been launched, clear the launcher ID.
	 This prevents reconnections by that user from automatically relaunching."
	streamID ifNotNil: [
		launcherID := nil.
	].! !

!QStreamingVideoApp methodsFor: 'accessing' stamp: 'jcg 4/7/2009 00:09'!
volume
	^document volume! !

!QStreamingVideoApp methodsFor: 'accessing' stamp: 'jcg 4/7/2009 00:09'!
volume: newVolume
	speaker volume: newVolume.
	document volume: newVolume.
! !

QControlStreamOutput subclass: #QVideoStreamOutput
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-Streaming'!

!QVideoStreamOutput commentStamp: 'jcg 8/9/2007 00:37' prior: 0!
(c) 2007 Qwaq Inc.  This subclass is only to distinguish video streams from other stream types.!

!QVideoStreamOutput class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QVideoStreamOutput methodsFor: 'accessing' stamp: 'ar 5/18/2010 16:41'!
defaultChannelPriority
	"Use the lowest (background) priority for streaming video updates down to the clients"
	^VideoPriority! !

!QVideoStreamOutput methodsFor: 'accessing' stamp: 'bgf 10/27/2007 14:15'!
trafficTag
	"Default categorization for traffic through the channel"
	^ VideoTag! !

Object subclass: #RtspClient
	instanceVariableNames: 'hostName address port timeout reuseSocket socketStream seqNum responses mutex reader readerStopped rtpHandlers'
	classVariableNames: ''
	poolDictionaries: 'TRouterConstants'
	category: 'Qwaq-Video-RTSP'!

!RtspClient commentStamp: '<historical>' prior: 0!
Talks to a RtspService.  It's not clear whether RtspClient and RtspClientSession should be merged.!

!RtspClient class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!RtspClient methodsFor: 'initialize' stamp: 'jcg 6/23/2009 15:03'!
destroy
	mutex critical: [
		reader ifNotNilDo: [:r | reader := nil. r terminate].
		socketStream ifNotNilDo: [:s | socketStream := nil. s close].
	].! !

!RtspClient methodsFor: 'private' stamp: 'jcg 7/14/2009 16:06'!
enqueueResponse: aResponse
	mutex critical: [responses add: aResponse].! !

!RtspClient methodsFor: 'initialize' stamp: 'jcg 6/22/2009 18:41'!
hostName
	"The canonical host name for the target host, incl. the port if needed. 
	For example: forums.qwaq.com or forums.qwaq.com:8080 etc."
	^hostName! !

!RtspClient methodsFor: 'initialize' stamp: 'jcg 6/23/2009 14:58'!
hostName: aString
	hostName := aString.
	address := NetNameResolver addressForName: (aString copyUpTo: $:).
	port := ((aString copyAfter: $:) ifEmpty:['554']) asNumber.

	reuseSocket ifTrue: [
		| newSocket |
		socketStream ifNotNil: [socketStream close].
		newSocket := Socket newTCP.
		newSocket connectTo: address port: port waitForConnectionFor: 5.
		socketStream := SocketStream on: newSocket.
		socketStream timeout: timeout.
	].! !

!RtspClient methodsFor: 'initialize' stamp: 'jcg 7/14/2009 16:12'!
initialize
	super initialize.
	reuseSocket := true.
	seqNum := 0.
	responses := OrderedCollection new.
	rtpHandlers := Dictionary new.
	mutex := Mutex new.

	"Simplest to just always have it running."
	reader := self fork: #runReaderProcess at: Processor lowIOPriority! !

!RtspClient methodsFor: 'accessing' stamp: 'jcg 7/14/2009 14:40'!
interleavedPacketHandlerAt: index
	mutex critical: [
		^rtpHandlers at: index ifAbsent: [self error: 'missing rtp handler: ', index]
	]! !

!RtspClient methodsFor: 'accessing' stamp: 'jcg 7/14/2009 14:42'!
interleavedPacketHandlerAt: index put: handlerOrNil
	"Set the handler for interleaved RTP/RTCP packets (or clear it by passing 'nil')."
	mutex critical: [
		handlerOrNil
			ifNil: [
				"Clear the handler at the specified index."
				rtpHandlers removeKey: index ifAbsent: [
					"If it's missing, it's not an error, but perhaps a cause for concern."
					QLogger logWarning: 'attempted to remove missing handler at: ', index
				]
			]
			ifNotNil: [
				"Set the handler at the specified index."
				rtpHandlers at: index ifPresent: [
					"It is an error to stomp on an existing RTP-handler."
					self error: 'handler already exists at: ', index
				].
				rtpHandlers at: index put: handlerOrNil
			]
	]
! !

!RtspClient methodsFor: 'private' stamp: 'jcg 6/22/2009 23:03'!
obtainSocketStream
	"Obtain a socket-stream to be used for sending/receiving a message."
	| newSocket stream |
	reuseSocket ifTrue: [^socketStream].

	newSocket := Socket newTCP.
	newSocket connectTo: address port: port waitForConnectionFor: 5.
	stream := SocketStream on: Socket.
	stream timeout: timeout.
	^stream
	! !

!RtspClient methodsFor: 'sending' stamp: 'ar 10/27/2009 14:16'!
rtspSend: method request: uri headers: headerBlock content: content type: mimeType
	| stream savedStream response debug |

	stream := self obtainSocketStream.

	stream isConnected ifFalse: [ConnectionClosed signal].

	"XXXX: change this to 'true' to pop up an inspector containing the outgoing request string."
	debug := false.
	debug ifTrue: [
		savedStream := stream.
		stream := WriteStream on: String new.
	].

	stream nextPutAll: method; nextPutAll: ' rtsp://', hostName, '/', uri, ' RTSP/1.0'; crlf.
	stream nextPutAll: 'Cseq: '; nextPutAll: (seqNum := seqNum + 1) printString; crlf.
	stream nextPutAll: 'User-Agent: ', QwaqVersion current version; crlf.
	
	"Send any other headers necessary for the request."
	headerBlock ifNotNilDo: [:hb | hb value: stream].

	"If there is additional content beyond the request-headers,
	 its type and length must be specified."
	content ifNotNil: [
		stream nextPutAll: 'Content-Type: ', mimeType; crlf.
		stream nextPutAll: 'Content-Length: ', content size; crlf.
	].

	"The first empty line represents the end of the request headers."
	stream crlf.
	
	"Write the content, if any."
	content ifNotNil: [stream nextPutAll: content].

	debug ifTrue: [
		| requestString |
		requestString := stream contents.
		savedStream nextPutAll: requestString.
		stream := savedStream.
		{'DEBUG RTSP REQUEST'. requestString} inspect.
	].

	"Force the data to be sent, and tally the network traffic."
	stream flush.
	TTrafficCounter sent: (stream socket totalBytesSent) tag: VideoTag.
	stream socket resetTotalBytesSent.

	"Prepare to handle the response."
	response := RtspResponse new.
	response sequenceNumber: seqNum.

	reuseSocket
		ifTrue: [self enqueueResponse: response "for asynchronous handling"]
		ifFalse: [
			response readFrom: stream.
			stream close.
		].

	^response promise "will resolve when response is complete"! !

!RtspClient methodsFor: 'private' stamp: 'jcg 7/15/2009 18:57'!
runReaderLoopOnce
	"Answer true if a message was handled, false otherwise."
	| stream  |
	socketStream ifNil: [^false] ifNotNilDo: [:s | stream := s].

	"Ensure that we have enough data for subsequent peeks.
	 Assume that any packet will be >= 8 bytes."
	[stream peek: 8] 
		on: ConnectionTimedOut
		do: [^false "that's OK, we'll try again soon"].

	(stream peek: 1) = '$' ifTrue: [
		"Receiving an interleaved binary RTP/RTCP packet."
		| hdr id sz packet handler |
		hdr := stream next: 4.
		hdr := hdr asByteArray.
		id := hdr byteAt: 2.
		sz := hdr unsignedShortAt: 3 bigEndian: true.
		packet := stream next: sz.
		mutex critical: [handler := rtpHandlers at: id ifAbsent: [nil]].
		handler
			ifNil: [QLogger logWarning: 'no channel handler for id: ', id every: 5000]
			ifNotNil: [handler first perform: handler second with: packet].
		^true
	].

	(stream peek: 8) = 'RTSP/1.0' ifTrue: [
		"Receiving a response to a request."
		| nextResponse |
		mutex critical: [
			responses ifEmpty: [
				readerStopped := true.
				self error: 'unanticipated response from server'
			].
			nextResponse := responses removeFirst.
			"Reading the response will cause a promise to be resolved;
			 see RTSPServiceResponse#readFrom: "
			nextResponse readFrom: stream
		].
		^true
	].

	"XXXXX: there's a possibility that the server is sending a message that
	 doesn't correspond to a request (eg: an ANNOUNCE), but we don't
	 handle that right now (other than to throw an error)."
	(stream peek: 4) ifNotEmptyDo: [:peek |
		peek size = 4 ifTrue: [
			((peek first = $$) or: [peek beginsWith: 'RTSP']) ifFalse: [
				self error: 'unexpected message from server: ', stream nextAllInBuffer.
			]
		]
	].

	^false "no message handled"! !

!RtspClient methodsFor: 'private' stamp: 'jcg 7/14/2009 16:08'!
runReaderProcess
	readerStopped := false.
	[readerStopped] whileFalse: [
		| handledMessage |
		[	
			handledMessage := self runReaderLoopOnce.
			handledMessage ifFalse: [
				"Wait a moment before trying again."
				(Delay forMilliseconds: 20) wait.
			].
		] on: Error do: [:err |
			QLogger logError: err.
			readerStopped := true.
			reader := nil.
			[self destroy] fork.  "XXXXX: hack"
		].
	]
! !

Object subclass: #RtspClientSession
	instanceVariableNames: 'resource sessionID state client lastResponse sessionDescription rtpClients mutex contentBaseUrl'
	classVariableNames: ''
	poolDictionaries: 'TRouterConstants'
	category: 'Qwaq-Video-RTSP'!

!RtspClientSession commentStamp: '<historical>' prior: 0!
TO-DO:
- no proper cleanup of 'rtpClients' on #destroy
- add an event-loop?!

!RtspClientSession class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!RtspClientSession methodsFor: 'accessing' stamp: 'jcg 7/16/2009 14:34'!
contentBaseUrl
	"RFC2326, Appendix C.1.1"
	^contentBaseUrl! !

!RtspClientSession methodsFor: 'accessing' stamp: 'jcg 7/16/2009 14:43'!
controlUrl
	"RFC2326, Appendix C.1.1"
	^self controlUrlFor: sessionDescription
! !

!RtspClientSession methodsFor: 'accessing' stamp: 'jcg 9/15/2009 16:03'!
controlUrlFor: desc "an SDPSessionDescription or SDPMediaDescription"
	"RFC2326, Appendix C.1.1"
	"XXXXX: should verify that we comply with RFC1808 (I haven't checked what this is)."
	| uri |
	uri := desc attributes at: 'control' ifAbsent: [^nil].
	uri = '*' ifTrue: [^contentBaseUrl].
	uri := URI fromString: uri.
	uri isAbsolute ifTrue: [
		"Not hard to do, just haven't done it."
		self error: 'cannot handle absolute control-URL'
	].
	uri := (URI fromString: contentBaseUrl) schemeSpecificPart, uri printString.
	uri first = $/ ifTrue: [uri := uri copyWithoutFirst].
	^uri
! !

!RtspClientSession methodsFor: 'rtsp methods' stamp: 'jcg 6/26/2009 12:04'!
describe
	"Implements the DESCRIBE method for RTSP 1.0"
	^self
		rtspSend: 'DESCRIBE'
		request: resource
		headers: [:s | s nextPutAll: 'Accept: application/sdp'; crlf]
		content: nil
		type: nil
		resolver: [:response | self handleDescribeResponse: response].! !

!RtspClientSession methodsFor: 'initialize' stamp: 'jcg 6/23/2009 15:01'!
destroy
	client ifNotNil: [
		client destroy.
		client := nil.
	]! !

!RtspClientSession methodsFor: 'responses' stamp: 'ar 3/23/2010 14:21'!
handleDescribeResponse: response
	"Handle the response to the DESCRIBE request that we sent."
	| contentType sdp |
	response isSuccess ifFalse: [
		QLogger logWarning: 'Unsuccessful DESCRIBE request: ', response status.
		^nil
	].
	contentType := response headerAt: 'content-type' ifAbsent: [nil].

	"Figure out the 'contentBaseUrl' (RFC2326, Appendix C.1.1)."
	response headerAt: 'content-location' ifPresent: [:url | contentBaseUrl := url].
	response headerAt: 'content-base' ifPresent: [:url | contentBaseUrl := url].
	contentBaseUrl ifNil: [contentBaseUrl := resource].
	(contentBaseUrl endsWith: '/') ifFalse: [contentBaseUrl := contentBaseUrl, '/'].

	sdp := (contentType = 'application/sdp')
		ifFalse: [nil]
		ifTrue: [SDPSessionDescription newFromString: response content].
	sdp ifNil: [
		QLogger logWarning: 'unexpected content type: ', contentType.
		^nil.
	].

	sessionDescription ifNotNilDo: [:desc |
		"I believe that the specs support changing the description, but I'm not supporting it for now (anyway, I'm the one writing the server)."
		desc = sdp ifFalse: [self error: 'session-description must not change'].
	].
	^sessionDescription := sdp.
! !

!RtspClientSession methodsFor: 'responses' stamp: 'jcg 7/21/2009 18:15'!
handlePauseResponse: response
	"Handle the response to the PAUSE request that we sent."
	response isSuccess ifFalse: [
		QLogger logWarning: 'Unsuccessful PAUSE request: ', response status.
		"XXXXX: figure out what to do here (what state to transition to, etc.?)"
		^nil
	].
	self state: #ready! !

!RtspClientSession methodsFor: 'responses' stamp: 'jcg 7/21/2009 18:15'!
handlePlayResponse: response
	"Handle the response to the PLAY request that we sent."
	response isSuccess ifFalse: [
		QLogger logWarning: 'Unsuccessful PLAY request: ', response status.
		"XXXXX: figure out what to do here (what state to transition to, etc.?)"
		^nil
	].
	self state: #play! !

!RtspClientSession methodsFor: 'responses' stamp: 'ar 3/23/2010 14:23'!
handleSetupResponse: response rtpClient: rtpClient
	"Handle the response to the SETUP request that we sent."
	"If we don't already have a session-id, obtain one from the response.  If we do, ensure that it matches the one in the response."
	| transport |

	response isSuccess ifFalse: [
		QLogger logWarning: 'Unsuccessful SETUP request: ', response status.
		"XXXXX: figure out what to do here (what state to transition to, etc.?)"
		^nil
	].
	sessionID
		ifNil: [sessionID := response headerAt: 'session']
		ifNotNil: [self validateResponseSessionID: response].

	transport := response headerAt: 'transport' 
								ifAbsent: [self error: 'missing Transport: header'].
	rtpClient setupTransport: transport.
	
	"XXXXX: we're running around in circles with this initialization; it's not pretty."
	(rtpClient protocol == #interleaved) ifTrue: [
		client 
			interleavedPacketHandlerAt: rtpClient dataPort 
			put: {rtpClient. #handleDataPacket:}.
		client 
			interleavedPacketHandlerAt: rtpClient controlPort
			put: {rtpClient. #handleControlPacket:}
	].

	^rtpClient
		! !

!RtspClientSession methodsFor: 'initialize' stamp: 'jcg 7/21/2009 18:11'!
hostName: hostName resourceName: resourceName
	client := RtspClient new.
	client hostName: hostName.
	resource := resourceName.! !

!RtspClientSession methodsFor: 'initialize' stamp: 'jcg 7/8/2009 15:28'!
initialize
	super initialize.
	state := #init.
	rtpClients := Dictionary new.
	mutex := Mutex new.! !

!RtspClientSession methodsFor: 'accessing' stamp: 'jcg 6/26/2009 12:10'!
lastResponse
	^lastResponse! !

!RtspClientSession methodsFor: 'rtsp methods' stamp: 'ar 3/23/2010 14:23'!
options
	"Implements the OPTIONS method for RTSP 1.0"
	^self
		rtspSend: 'OPTIONS'
		request: resource
		headers: nil
		content: nil
		type: nil
		resolver: [:response |
			response headerAt: 'public' ifPresent: [:opt | opt findTokens: ', '].
		].
! !

!RtspClientSession methodsFor: 'rtsp methods' stamp: 'jcg 7/21/2009 13:01'!
pause
	"Implements the PAUSE method for RTSP 1.0.  We assume that the server/session support aggregate control (i.e. we don't individually tell the audio/video tracks to play/pause)."

	"Sanity check."
	sessionID ifNil: [self error: 'cannot PAUSE without a session-ID'].

	^self
		rtspSend: 'PAUSE'
		request: self controlUrl
		headers: nil
		content: nil
		type: nil
		resolver: [:response | self handlePauseResponse: response].
! !

!RtspClientSession methodsFor: 'rtsp methods' stamp: 'jcg 7/15/2009 16:06'!
play
	"Play the whole thing."
	^self playFrom: 0 to: nil
! !

!RtspClientSession methodsFor: 'rtsp methods' stamp: 'jcg 7/16/2009 14:49'!
playFrom: start to: end
	"Implements the PLAY method for RTSP 1.0.  We assume that the server/session support aggregate control (i.e. we don't individually tell the audio/video tracks to play/pause)."

	"Sanity check."
	sessionID ifNil: [self error: 'cannot PLAY without a session-ID'].

	^self
		rtspSend: 'PLAY'
		request: self controlUrl
		headers: [:stream |
			stream 
				nextPutAll: 'Range: npt=', start, '-', (end ifNil: [''] ifNotNil: [end]);
				crlf.
		]
		content: nil
		type: nil
		resolver: [:response | self handlePlayResponse: response].
! !

!RtspClientSession methodsFor: 'accessing' stamp: 'jcg 7/15/2009 18:34'!
rtpClients
	^rtpClients! !

!RtspClientSession methodsFor: 'private' stamp: 'jcg 6/16/2010 18:45'!
rtspSend: method request: uri headers: headerBlock content: content type: mimeType resolver: responseBlock
	| innerPromise outerPromise |
	outerPromise := TPromise new.
	innerPromise := client
						rtspSend: method
						request: uri
						headers: [:stream | 
							"XXXXX: Uug.  One more reason for RTSPClient2 and RTSPClientSession to merge."
							sessionID ifNotNil: [stream nextPutAll: 'Session: ', sessionID; crlf].
							headerBlock ifNotNil: [headerBlock value: stream].
						]
						content: nil
						type: nil.
	innerPromise whenFulfilled: [:response |
		lastResponse := response.
		response isError ifTrue: [
			QLogger logWarning: 'Request failed: ', response status.
			{'REQUEST FAILED'. response} inspect.
			self destroy.
			outerPromise fulfill: nil.
		]
		ifFalse: [
			"XXXXX: We assume that anything that isn't a failure is a success,
			 but we should explicitly be handling redirects."
			outerPromise fulfill: (responseBlock value: response)
		].
	].
	^outerPromise! !

!RtspClientSession methodsFor: 'rtsp methods' stamp: 'jcg 7/21/2009 15:08'!
setup: mediaDesc "a SDPMediaDescription"
	"Implements the SETUP method for RTSP 1.0.  NOTE: don't call this twice in a row if we don't already have a session-ID... if we do then the second response's session-ID won't  match the first one.  Instead it is recommended to use #setupStreams:"
	| controlID rtp highestPort portString |

	"Extract parameters from the media-description."
	controlID := self controlUrlFor: mediaDesc.
	controlID ifNil: [self error: 'no control-URL available for media-description'].

	"Create the client that will handle the RTP/RTSP traffic."
	mutex critical: [
		(rtpClients includesKey: controlID) ifTrue: [
			self error: 'client already exists for track (', controlID, ')'.
		].
		rtp := RtpClient new.
		rtp rtsp: self.
		rtp mediaDescription: mediaDesc.
		rtp dataPort: (rtpClients size * 2).
		rtp controlPort: (rtpClients size * 2 + 1).
		rtpClients at: controlID put: rtp
	].
	
	"Figure out what ports to tell the server to send data on."
	highestPort := -1.
	rtpClients do: [:c | highestPort := highestPort max: c controlPort].
	portString := 'interleaved=', (highestPort+1), '-', (highestPort+2).
	
	^self
		rtspSend: 'SETUP'
		request: controlID
		headers: [:stream |
			stream nextPutAll: 'Transport: RTP/AVP/TCP;unicast;', portString; crlf.
			sessionID ifNotNil: [stream nextPutAll: 'Session: ', sessionID; crlf].
		]
		content: nil
		type: nil
		resolver: [:response | self handleSetupResponse: response rtpClient: rtp].
! !

!RtspClientSession methodsFor: 'rtsp methods' stamp: 'jcg 6/16/2010 14:29'!
setupMultiple: listOfSDPMediaDescriptions
	"Implements the SETUP method for each of the specified media-descriptions."
	| answerPromise list firstPromise |
	list := listOfSDPMediaDescriptions copy.

	"We could only wait for the first if we know that we don't yet have a sessionID,
	 but this way the code is simpler."
	firstPromise := self setup: list removeFirst.
	list ifEmpty: [^firstPromise].
	
	"There was more than one media-track... wait for the first one to finish, 
	 then set up the rest (now that we have a session-ID, these can be pipelined)."
	answerPromise := TPromise new.	
	firstPromise whenFulfilled: [:val1 | "XXXXX: assume success"
		| nextPromise resultingClients |
		resultingClients := OrderedCollection new.
		resultingClients add: val1.
		list do: [:desc | 
			nextPromise := self setup: desc.
			nextPromise whenFulfilled: [:val2 | resultingClients add: val2].

		].
		"When the last one is resolved, resolve the 'answerPromise'."
		nextPromise whenFulfilled: [
			self state: #ready.
			answerPromise fulfill: resultingClients].	
	].	
	^answerPromise
! !

!RtspClientSession methodsFor: 'private' stamp: 'jcg 7/15/2009 16:23'!
state: newState
	state == newState ifFalse: [
		state := newState.
		self signal: #stateChanged with: state.
	].! !

!RtspClientSession methodsFor: 'private' stamp: 'ar 3/23/2010 14:22'!
validateResponseSessionID: response
	"Only call this once we already have a session-ID."
	| responseSessionID |
	sessionID ifNil: [self error: 'Need a session-ID before verifying response session-ID'].
	responseSessionID := response headerAt: 'session' ifAbsent: [nil].
	(sessionID = responseSessionID)
		ifFalse: [self error: 'session-ID mismatch: ', sessionID, ' vs. ', responseSessionID].! !

TObject subclass: #QBaseVideoCamera
	instanceVariableNames: 'friendlyName deviceUID frameExtent forms formIndex fps mutex isRecording'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-LowLevel'!

!QBaseVideoCamera commentStamp: 'jcg 1/11/2008 12:33' prior: 0!
Provides a framework for getting video from an external camera.  Subclasses use different plugins to
control / obtain-data-from different camera APIs (eg: QuickTime and DirectShow).

When creating handle, subclasses must take the following fields into account:
	- fps 
		-eg: QuickTime requires Squeak-side code to poll at a certain rate
		-w/DirectShow we want the filter-graph to only generate frames at the desired rate.!

!QBaseVideoCamera class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QBaseVideoCamera class methodsFor: 'workspace snippets' stamp: 'jcg 7/26/2011 23:38'!
snippetForLatencyMeasurement
	| c fps extent args enc dec grabbed encoded decoded b1 b2 b3 recording loop |
	"Copy the following into a workspace..."

"Use the appropriate subclass of QBaseVideoCamera for your platform."
c := QWebcam new.
fps := 15.0.
extent := 320@240.
c extent: extent.
c fps: fps.

args := QVideoArgs new usePlatformEndianness.
args codecType: 'avc1'.
args timeScale: 3000.
args width: extent x.
args height: extent y.
args bitRate: 80000.
args fps: fps.

QVideoEncoderFree setErrorLog: 'QVideoCodecFree.log'.
enc := QVideoEncoderFree withArgs: args extent: extent.
dec := QVideoDecoderFree withArgs: args extent: extent.

grabbed := encoded := decoded := 0.

b1 := [:form | grabbed:=grabbed+1. form displayAt: 0@0. enc encode: form].
b1 runScript: #value: when: {c. #grabbedFrame}.

b2 := [:bytes | encoded:=encoded+1. dec decode: bytes offset: 1].
b2 runScript: #value: when: {enc. #encodedFrame}.

b3 := [:form | decoded:=decoded+1. form displayAt: (extent x)@0].
b3 runScript: #value: when: {dec. #decodedFrame}.

recording := false.
loop := [[recording] 
			whileTrue: [
				grabbed asString, ' (grabbed)' displayAt: 100@245.
				encoded asString, ' (encoded)' displayAt: 100@260.
				decoded asString, ' (decoded)' displayAt: 100@275.
				(Delay forMilliseconds: 100) wait.
			]].

"Everything up to this point was set-up.  Run the following line
to start recording, encoding, and decoding."
c startRecording. recording := true. loop forkAt: 60.

"When you've had enough, run the following."
c stopRecording. recording := false.
c destroy. enc destroy. dec destroy.
! !

!QBaseVideoCamera methodsFor: 'accessing' stamp: 'bgf 10/15/2009 14:50'!
cameraName
	^ friendlyName ifNil: [ 'Camera' ].! !

!QBaseVideoCamera methodsFor: 'subclass responsibilities' stamp: 'jcg 1/11/2008 10:47'!
createHandle
	"Subclasses must implement this method.  IMPORTANT: the plugin may not be able to satisfy the requested video extent.  If this is the case, then subclasses MUST set 'extent' to the real size of the video."
	self subclassResponsibility! !

!QBaseVideoCamera methodsFor: 'accessing' stamp: 'bgf 2/13/2008 11:45'!
currentForm
	"Answer a copy of the current form."
	forms ifNil: [ ^ nil ].
	forms size < formIndex ifTrue: [ ^ nil ].
	^ (forms at: formIndex) deepCopy! !

!QBaseVideoCamera methodsFor: 'initialize' stamp: 'jcg 1/11/2008 13:04'!
destroy
	mutex critical: [
		self stopRecording.
		self destroyHandle.
		self privateDestroy.
	].! !

!QBaseVideoCamera methodsFor: 'subclass responsibilities' stamp: 'jcg 1/11/2008 12:38'!
destroyHandle
	"Subclasses must implement this method."
	self subclassResponsibility! !

!QBaseVideoCamera methodsFor: 'accessing' stamp: 'bgf 10/15/2009 14:50'!
deviceUID
	"If know, the persistent UID identifying the capture device desired (or in use)."
	^ deviceUID! !

!QBaseVideoCamera methodsFor: 'accessing' stamp: 'bgf 10/15/2009 15:22'!
deviceUID: aUIDString
	"The persistent UID identifying the capture device desired (or in use).
	 Setting this to a uid from the camera discovery enumeration allows choosing a particular camera.
	 Set this to nil to indicate that the system-default capture is desired."
	deviceUID := aUIDString! !

!QBaseVideoCamera methodsFor: 'accessing' stamp: 'bgf 10/15/2009 15:08'!
extent
	"Legacy alias for frameExtent"
	^ self frameExtent! !

!QBaseVideoCamera methodsFor: 'accessing' stamp: 'bgf 10/15/2009 15:08'!
extent: newExtent
	"Set the capture-form extent.
	 This is also the point at which we create the underlying camera device,
	 and so the deviceUID: should be set prior to this.
	 Legacy alias for frameExtent"

	self frameExtent: newExtent! !

!QBaseVideoCamera methodsFor: 'accessing' stamp: 'jcg 1/11/2008 12:33'!
fps
	^fps! !

!QBaseVideoCamera methodsFor: 'accessing' stamp: 'jcg 3/29/2010 22:17'!
fps: newFPS
	| roundedFPS |
	"Use heursitic to reduce frequency that we call the primitive to adjust webcam
	 properties.  Always increase immediately if target is greater than  current FPS; 
	 drop down only if target is several FPS lower than the current value."
	roundedFPS := newFPS rounded.
	(roundedFPS > fps or: [fps - roundedFPS > 2]) ifTrue: [
		fps := roundedFPS.
		self privateSetCameraFrameRate.
	].
! !

!QBaseVideoCamera methodsFor: 'accessing' stamp: 'bgf 10/15/2009 15:23'!
frameExtent
	"Point - dimensions of the video (the forms we capture from the camera)"
	^ frameExtent! !

!QBaseVideoCamera methodsFor: 'accessing' stamp: 'bgf 10/15/2009 16:36'!
frameExtent: newExtentPt
	"Set the capture-form extent.
	 This is also where we create the underlying camera device,
	 and so the deviceUID: should be set prior to this."

	mutex critical: [
		| wasRecording |
		frameExtent = newExtentPt ifTrue: [^self].
		wasRecording := self isRecording.
		wasRecording ifTrue: [self stopRecording].

		self destroyHandle.
		frameExtent := newExtentPt.
		self createHandle.
		
		"Must follow #createHandle, since the actual extent may differ from the requested."
		self prepareFormsForReadback.
	
		wasRecording ifTrue: [self startRecording].

		"The extent might have changed in #createHandle; 
		 answer the real extent so that clients can adjust appropriately."
		^ frameExtent
	].! !

!QBaseVideoCamera methodsFor: 'private' stamp: 'ar 8/6/2008 17:32'!
handleError: err
	"Subclasses might want to override or extend this to notify interested parties, etc."
	QLogger logError: err from: self.
! !

!QBaseVideoCamera methodsFor: 'initialize' stamp: 'bgf 3/21/2009 21:13'!
initialize
	isRecording := false.
	mutex := Mutex new.
	fps := 5.0.! !

!QBaseVideoCamera methodsFor: 'testing' stamp: 'jcg 1/11/2008 12:46'!
isRecording
	^isRecording! !

!QBaseVideoCamera methodsFor: 'private' stamp: 'jcg 1/13/2008 00:20'!
nextForm
	"Answer the next form to read a frame into."
	| form | 
	form := forms at: formIndex.
	formIndex := (formIndex \\ forms size) + 1.
	^form! !

!QBaseVideoCamera methodsFor: 'private' stamp: 'bgf 10/15/2009 15:09'!
prepareFormsForReadback
	"Initialize the Forms that we will read video data back into."
	forms := Array new: 5.
	formIndex := 1.
	1 to: forms size do: [:i | forms at: i put: (Form extent: frameExtent depth: 32)].! !

!QBaseVideoCamera methodsFor: 'subclass responsibilities' stamp: 'jcg 1/11/2008 13:03'!
privateDestroy
	"Subclass responsibility.  Do whatever other cleanup is necessary when this camera will never be used again."! !

!QBaseVideoCamera methodsFor: 'subclass responsibilities' stamp: 'jcg 1/11/2008 12:36'!
privateSetCameraFrameRate
	"Subclass responsibility.  Do whatever is necessary to grab video at the newly-set frame-rate."
	self subclassResponsibility.! !

!QBaseVideoCamera methodsFor: 'subclass responsibilities' stamp: 'jcg 1/10/2008 12:34'!
privateStartRecording
	"Subclasses must implement this method.  If the operation fails, they MUST throw an error."
	self subclassResponsibility! !

!QBaseVideoCamera methodsFor: 'subclass responsibilities' stamp: 'jcg 1/10/2008 12:35'!
privateStopRecording
	"Subclasses must implement this method.  If the operation fails, they MUST throw an error."
	self subclassResponsibility! !

!QBaseVideoCamera methodsFor: 'private' stamp: 'bgf 10/15/2009 15:25'!
signalGrabbedFrame: aForm
	false ifTrue: [
		"Debugging - shows frames upon receipt from the camera, prior to encoding"
		'Grab ', (Time millisecondClockValue) displayAt: 10@10.
		aForm displayAt: 10@30.
	].
	self signal: #grabbedFrame with: aForm.! !

!QBaseVideoCamera methodsFor: 'recording' stamp: 'jcg 1/10/2008 12:48'!
startRecording
	"Start grabbing frames from the camera.  If there is an error, update the recording status."
	mutex critical: [
		isRecording ifTrue: [^self].
		isRecording := true.
		[self privateStartRecording "subclass responsibility"]
			on: Error
			do: [:err | 
				isRecording := false.
				self handleError: err.
			]
	]
! !

!QBaseVideoCamera methodsFor: 'recording' stamp: 'jcg 1/10/2008 12:48'!
stopRecording
	"Stop grabbing frames from the camera."
	mutex critical: [
		isRecording ifFalse: [^self].
		isRecording := false.
		[self privateStopRecording "subclass responsibility"]
			on: Error
			do: [:err | self handleError: err]
	]! !

TObject subclass: #QNetVidTrackPlayer
	instanceVariableNames: 'output client trackInfo streamID sub lastFrame headerReader'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Client'!

!QNetVidTrackPlayer commentStamp: '<historical>' prior: 0!
Responsible for subscribing to and processing data from a media-track.  The actual data-processing is handled by a sub-instance of QNetVidTrackPlayerOutput.

Subclasses used to handle different types of media (eg: audio and video), but now this is the responsibility of the 'output'.  The subclasses remain for now (they hard-code the initialization of the 'output'), but they should go away.

Operates withing the context of a QNetVidClient.  For example, it shares the same event-loop (sending #future to the track-player causes a message to be enqueued on the client's event-loop).!

QNetVidTrackPlayer subclass: #QNetVidAudioTrackPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Client'!

!QNetVidAudioTrackPlayer commentStamp: '<historical>' prior: 0!
Plays through streaming audio data (AAC-only for now).

Instance variables:
aacConfig		-	Data for 'AudioSpecificConfig' from ISO/IEC 14496-3:2001(E)!

!QNetVidAudioTrackPlayer class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QNetVidAudioTrackPlayer methodsFor: 'initialize' stamp: 'jcg 8/11/2009 23:13'!
createOutput
	output := client createAudioPlayerOutput. 
! !

!QNetVidAudioTrackPlayer methodsFor: 'testing' stamp: 'jcg 2/1/2009 18:22'!
isAudio
	^true! !

!QNetVidTrackPlayer class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QNetVidTrackPlayer class methodsFor: 'instance creation' stamp: 'jcg 2/18/2009 00:34'!
newForClient: mediaClient fromXmlElement: xmlNode
	"Answer a new instance, initialized according to the info in 'xmlNode'."
	| trackType playerClass |
	xmlNode name = #track ifFalse: [
		self error: 'node name must be #track, not #', xmlNode name.
	].
	trackType := xmlNode attributeAt: 'type'.
	playerClass := trackType caseOf: {
		['audio']->[QNetVidAudioTrackPlayer].
		['video']->[QNetVidVideoTrackPlayer].
	} otherwise: [self error: 'expected audio or video track, not: ', trackType].
	^playerClass new 
				client: mediaClient;
				initializeFromXmlElement: xmlNode; 
				yourself! !

!QNetVidTrackPlayer methodsFor: 'accessing' stamp: 'jcg 8/28/2009 00:34'!
bandwidth
	"Not yet implemented... here as a placeholder that can be used by #sdpFor:."
	^nil! !

!QNetVidTrackPlayer methodsFor: 'accessing' stamp: 'jcg 8/27/2009 17:56'!
client
	^client! !

!QNetVidTrackPlayer methodsFor: 'initialize' stamp: 'jcg 8/27/2009 17:57'!
client: netVidClient
	"Must call this once, before any other initialization."
	client ifNotNil: [self error: 'client was already set'].
	client := netVidClient.
	self createOutput.
	output trackPlayer: self.

! !

!QNetVidTrackPlayer methodsFor: 'initialize' stamp: 'jcg 8/5/2009 10:31'!
createOutput
	"XXXXX: Later, we need a way to specify the type of output.  For now, we let subclasses create their own output in a hardwired manner."
	self subclassResponsibility.
! !

!QNetVidTrackPlayer methodsFor: 'initialize' stamp: 'jcg 8/30/2009 17:43'!
destroy
	self signal: #destroyed with: self.
	sub destroy.
	output ifNotNilDo: [:o | 
		output := nil.
		o destroy
	].! !

!QNetVidTrackPlayer methodsFor: 'accessing' stamp: 'jcg 8/29/2009 01:15'!
dtsIncrement
	^trackInfo dtsIncrement! !

!QNetVidTrackPlayer methodsFor: 'private' stamp: 'jcg 8/29/2009 01:14'!
expectedDTS
	"Answer the expected DTS of the next frame, assuming that it arrives in sequence.  We either use an explicitly-specified delta from the previous frame DTS (if it is was included in the last frame's datagram), or assume a uniform DTS increment if it isn't."
	lastFrame ifNil: [^nil].
	^lastFrame dts + (lastFrame dtsDelta ifNil: [trackInfo dtsIncrement])! !

!QNetVidTrackPlayer methodsFor: 'future' stamp: 'jcg 2/1/2009 21:45'!
futureDo: aSelector at: deltaMSecs args: args
	"Enqueue a message on the event queue.  The compiler has been modified to generate this message when the #future message appears in the source code."
	deltaMSecs = 0 ifFalse:[^self error: 'deltaMSecs must be zero'].
	client futureDo: aSelector receiver: self args: args.
	^nil
! !

!QNetVidTrackPlayer methodsFor: 'future' stamp: 'jcg 2/1/2009 21:45'!
futureSend: aSelector at: deltaMSecs args: args
	"Enqueue a message on the event queue.  The compiler has been modified to generate this message when the #future message appears in the source code.  Answers a promise that will be resolved with the result of performing the message."
	deltaMSecs = 0 ifFalse:[^self error: 'deltaMSecs must be zero'].
	^client futureSend: aSelector receiver: self args: args.
! !

!QNetVidTrackPlayer methodsFor: 'stream management' stamp: 'jcg 3/12/2009 22:45'!
handleData: dgram
	"Handle a media datagram."
	self handleMediaData: dgram data
! !

!QNetVidTrackPlayer methodsFor: 'private' stamp: 'jcg 12/14/2009 08:12'!
handleMediaData: payload
	"Handle the payload from a media datagram.  We used to do this directly in #handleData, but refactored so this code can be called from elsewhere."
	| frame wasHandled |
	
	client playState == #destroyed ifTrue: [^self].

	headerReader readFrom: payload startingAt: 1.
	frame := QNetVidBufferedFrame 
				newForData: payload
				headerSize: headerReader headerSize
				dts: headerReader dts
				cts: headerReader cts
				dtsDelta: headerReader dtsDelta
				isSeek: headerReader isSeek
				isRAP: headerReader isRAP.

	wasHandled :=frame isSeek 
								ifTrue: [output handleSeekFrame: frame]
								ifFalse: [output handleRegularFrame: frame].
	lastFrame := wasHandled ifTrue: [frame] ifFalse: [nil].! !

!QNetVidTrackPlayer methodsFor: 'initialize' stamp: 'jcg 11/30/2009 09:45'!
initialize
	super initialize.
	headerReader := QNetVidDatagramHeader new.! !

!QNetVidTrackPlayer methodsFor: 'initialize' stamp: 'jcg 11/30/2009 10:44'!
initializeFromXmlElement: node

	trackInfo := QNetVidTrackInfo new initializeFromXmlElement: node.
	headerReader timestampScale: trackInfo timestampScale.
	streamID := client xmlOID: node for: 'streamID'.
	
	output initializeFromXmlElement: node.

	sub := client
				subscribe: streamID 
				in: QControlStreamInput
				out: QControlStreamOutput
				commandHandler: nil
				dataHandler: [:dgram | self handleData: dgram].

	"When the stream is connected/destroyed, we want to handle it in the event-loop."
	self runScript: [:s | self future streamDestroyed: s] when: {sub. #destroyed}.
	self runScript: [:s | self future streamConnected: s] when: {sub. #connected}.

	sub connectWithTimeout: 120000.  "should be plenty'o'time."
	

				! !

!QNetVidTrackPlayer methodsFor: 'testing' stamp: 'jcg 2/1/2009 18:21'!
isAudio
	^false! !

!QNetVidTrackPlayer methodsFor: 'testing' stamp: 'jcg 5/18/2010 02:33'!
isConnected
	"Is the subscription for this track-player connected?"
	^sub ifNil: [false] ifNotNil: [sub isConnected]! !

!QNetVidTrackPlayer methodsFor: 'testing' stamp: 'jcg 2/1/2009 18:22'!
isVideo
	^false! !

!QNetVidTrackPlayer methodsFor: 'private' stamp: 'jcg 2/11/2009 15:55'!
lastDTS
	"Answer the DTS of the last frame pushed into the decoder."
	^lastFrame ifNotNil: [lastFrame dts]! !

!QNetVidTrackPlayer methodsFor: 'accessing' stamp: 'jcg 8/5/2009 11:53'!
lastFrame
	"Answer the last frame that was allowed through for further processing."
	^lastFrame! !

!QNetVidTrackPlayer methodsFor: 'printing' stamp: 'jcg 9/28/2009 22:14'!
logName
	^String streamContents: [:s | 
		s nextPutAll: self class name. 
		self printStreamOn: s
	].! !

!QNetVidTrackPlayer methodsFor: 'accessing' stamp: 'jcg 8/6/2009 12:52'!
output
	^output! !

!QNetVidTrackPlayer methodsFor: 'stream management' stamp: 'jcg 2/1/2009 22:34'!
pause
	sub ifNotNil: [sub pause].
	! !

!QNetVidTrackPlayer methodsFor: 'private' stamp: 'jcg 8/5/2009 11:21'!
playTo: mediaTime "in seconds"
	"Play up to the specified time."
	output playTo: mediaTime
! !

!QNetVidTrackPlayer methodsFor: 'printing' stamp: 'jcg 9/28/2009 22:13'!
printOn: aStream
	super printOn: aStream.
	self printStreamOn: aStream.! !

!QNetVidTrackPlayer methodsFor: 'printing' stamp: 'jcg 9/28/2009 22:13'!
printStreamOn: aStream
	streamID ifNotNilDo: [:id | aStream nextPut: $(; nextPutAll: id shortHex; nextPut: $)].! !

!QNetVidTrackPlayer methodsFor: 'private-commands' stamp: 'jcg 3/12/2009 17:20'!
sendRequest: cmdName xmlBlock: writerBlock
	"Send command over 'controlStream'."
	^client sendRequest: cmdName via: sub xmlBlock: writerBlock expectXmlResponse: true! !

!QNetVidTrackPlayer methodsFor: 'private' stamp: 'jcg 3/9/2009 13:00'!
streamConnected: subscription
	"XXXXX: what do we want to do here?"
	sub == subscription
		ifTrue: [QLogger logInfo: 'subscription connected']
		ifFalse: [QLogger logInfo: 'subscription connected, but is not ours']! !

!QNetVidTrackPlayer methodsFor: 'private' stamp: 'jcg 3/9/2009 13:00'!
streamDestroyed: subscription
	"XXXXX: what do we want to do here?"
	sub == subscription
		ifTrue: [QLogger logInfo: 'subscription destroyed']
		ifFalse: [QLogger logInfo: 'subscription destroyed, but is not ours']! !

!QNetVidTrackPlayer methodsFor: 'accessing' stamp: 'jcg 2/1/2009 18:57'!
streamID
	^streamID! !

!QNetVidTrackPlayer methodsFor: 'accessing' stamp: 'jcg 8/29/2009 01:14'!
timeScale
	^trackInfo timeScale! !

!QNetVidTrackPlayer methodsFor: 'accessing' stamp: 'jcg 8/29/2009 01:13'!
trackID
	^trackInfo trackID! !

!QNetVidTrackPlayer methodsFor: 'accessing' stamp: 'jcg 8/29/2009 12:37'!
trackInfo
	^trackInfo! !

!QNetVidTrackPlayer methodsFor: 'stream management' stamp: 'jcg 2/1/2009 22:34'!
unpause
	sub ifNotNil: [sub unpause].
	! !

QNetVidTrackPlayer subclass: #QNetVidVideoTrackPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Client'!

!QNetVidVideoTrackPlayer commentStamp: 'jcg 2/18/2009 00:53' prior: 0!
Contains functionality specific to playing a video-track.

(actually, contains some more generic functionality that should be pushed up into the superclass).!

!QNetVidVideoTrackPlayer class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QNetVidVideoTrackPlayer methodsFor: 'initialize' stamp: 'jcg 8/11/2009 23:13'!
createOutput
	output := client createVideoPlayerOutput. 
! !

!QNetVidVideoTrackPlayer methodsFor: 'accessing' stamp: 'jcg 8/5/2009 11:29'!
extent
	"XXXXX: not sure if anybody sends this... keeping the accessor around just in case."
	^output extent! !

!QNetVidVideoTrackPlayer methodsFor: 'accessing' stamp: 'jcg 8/5/2009 11:30'!
height
	"XXXXX: not sure if anybody sends this... keeping the accessor around just in case."
	^output height! !

!QNetVidVideoTrackPlayer methodsFor: 'testing' stamp: 'jcg 2/1/2009 18:22'!
isVideo
	^true! !

!QNetVidVideoTrackPlayer methodsFor: 'private' stamp: 'jcg 6/16/2010 18:52'!
requestInitialFrame
	"Decide whether we need to request/display a video frame, so the user isn't looking at a blank white screen."
	| promise |
	promise := self sendRequest: 'initialSample' xmlBlock: [:empty | ].
	promise whenFulfilled: [:node "an XMLNode" |
		| base64 decoded |
		base64 := node contentStringAt: 'ok'.
		base64
			ifEmpty: [QLogger logWarning: 'failed request for initial frame']
			ifNotEmpty: [
				"After a final check to make sure we're still paused, play the frame."
				decoded := (Base64MimeConverter 
								mimeDecodeToBytes: base64 readStream) contents.
				client isPlaying ifFalse: [self handleMediaData: decoded].
			].
	].! !

!QNetVidVideoTrackPlayer methodsFor: 'private' stamp: 'ar 3/20/2009 15:48'!
streamConnected: subscription
	"Inform the client about the connection so it can request an initial frame if desired"
	super streamConnected: subscription.
	client videoStreamConnected: self.! !

!QNetVidVideoTrackPlayer methodsFor: 'accessing' stamp: 'jcg 8/5/2009 11:30'!
width
	"XXXXX: not sure if anybody sends this... keeping the accessor around just in case."
	^output width! !

TObject subclass: #QNetVidTrackPlayerOutput
	instanceVariableNames: 'trackPlayer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Client-Output'!

!QNetVidTrackPlayerOutput commentStamp: '<historical>' prior: 0!
Handles encoded media frames received from the server.  Subclasses implement the appropriate way to handle the frames.  Examples:
	- decode them for rendering (video on screen, audio through speakers)
	- record them for later transformation into an .MP4 file
	- pass through for RTSP streaming

Instance variables:
trackPlayer - the QNetVidTrackPlayer that we are the output for.
client - the QNetVidClient that we belong to.!

QNetVidTrackPlayerOutput subclass: #QNetVidNullPlayerOutput
	instanceVariableNames: 'width height'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-RTSP'!

!QNetVidNullPlayerOutput commentStamp: '<historical>' prior: 0!
All subclass-responsibilities are implemented as no-ops.!

!QNetVidNullPlayerOutput class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QNetVidNullPlayerOutput methodsFor: 'initialize' stamp: 'jcg 9/15/2009 18:24'!
eventLoopOwner: anObject
	"No-op."! !

!QNetVidNullPlayerOutput methodsFor: 'accessing' stamp: 'hrs 11/19/2009 15:08'!
extent
	"QStreamingvideoPlayer>>onTrackChanged sends this."
	^width@height! !

!QNetVidNullPlayerOutput methodsFor: 'private' stamp: 'jcg 9/14/2009 11:27'!
handleRegularFrame: frame
	"No-op."
	^true "yeah, sure, we 'handled' it."! !

!QNetVidNullPlayerOutput methodsFor: 'private' stamp: 'jcg 9/14/2009 11:27'!
handleSeekFrame: frame
	"No-op."
	^true "yeah, sure, we 'handled' it."! !

!QNetVidNullPlayerOutput methodsFor: 'initialize' stamp: 'hrs 11/19/2009 15:09'!
initializeFromXmlElement: node
	width := Number readFrom: (node contentStringAt: 'width' ifAbsent: '1').
	height := Number readFrom: (node contentStringAt: 'height' ifAbsent: '1').! !

!QNetVidNullPlayerOutput methodsFor: 'private' stamp: 'jcg 9/14/2009 11:28'!
playTo: mediaTime "in seconds"
	"No-op."
! !

QNetVidTrackPlayerOutput subclass: #QNetVidTrackDecoder
	instanceVariableNames: 'client buffer decoder lastCTS'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Client-Output'!

!QNetVidTrackDecoder commentStamp: '<historical>' prior: 0!
Decodes media frames into a form appropriate for rendering.!

QNetVidTrackDecoder subclass: #QNetVidAudioTrackDecoder
	instanceVariableNames: 'codecName aacConfig sampleRate numChannels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Client-Output'!

!QNetVidAudioTrackDecoder commentStamp: 'jcg 8/5/2009 10:37' prior: 0!
Plays through streaming audio data (AAC-only for now).

Instance variables:
aacConfig		-	Data for 'AudioSpecificConfig' from ISO/IEC 14496-3:2001(E)!

!QNetVidAudioTrackDecoder class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QNetVidAudioTrackDecoder methodsFor: 'initialize' stamp: 'jcg 8/5/2009 08:55'!
createBuffer
	"XXXX: it's not necessary to use a reordering buffer for audio, which is already in order.  It's just quicker to do it this way for now."

	^QNetVidReorderingBuffer new.! !

!QNetVidAudioTrackDecoder methodsFor: 'frame-handling' stamp: 'jcg 6/28/2010 12:27'!
handleRegularFrame: frame "a QNetVidBufferedFrame"
	| decodedFrame sampleCount | 

	"If we're out-of-sequence, restart with a fresh buffer and decoder."
	trackPlayer expectedDTS == frame dts ifFalse: [
		buffer flush.
		decoder ifNotNil: [decoder destroy].
		self setupDecoder.
	].

	"Decode and buffer the frame."
	sampleCount := trackPlayer dtsIncrement.
	sampleCount > 0
		ifTrue: [
			decodedFrame := SoundBuffer newMonoSampleCount: sampleCount.
			decoder decode: frame data offset: frame headerSize into: decodedFrame.
			"Immediately send the frame to the client rather than buffering it internally 
			 for 0.5sec.  Instead, the buffering will occur in the QAudioPlugin, thereby
			 reducing the frequency of glitchies."
			client decodedAudioFrame: decodedFrame sampleRate: sampleRate from: self.
			^true "sweet, sweet success"
		]
		ifFalse: [
			QLogger 
				logWarning: 'DTS-increment is zero for track with streamID: ', 
																	trackPlayer streamID 
				every: 10000.
			^false "did not successfully handle this datagram"
		].
	! !

!QNetVidAudioTrackDecoder methodsFor: 'frame-handling' stamp: 'jcg 8/5/2009 10:24'!
handleSeekFrame: frame "a QNetVidBufferedFrame"
	"Really, there's no reason for the server to be sending audio-frames while seeking.  But, let's cover our bases and assume that it might."
	^false "don't handle the frame"
! !

!QNetVidAudioTrackDecoder methodsFor: 'initialize' stamp: 'jcg 8/5/2009 10:37'!
initializeFromXmlElement: node
	"Let the superclass do its thing, including setting up the media stream."
	super initializeFromXmlElement: node.

	"Read the info necessary to initialize the decoder."
	"XXXX: this is kinda nonsense... there should be a class that knows how to
	 read/write itself as XML, that is shared between the client and server."
	codecName := (node contentStringAt: 'codec') asLowercase.
	codecName = 'aac' ifTrue:[
		"This is the AudioSpecificConfig from ISO/IEC 14496-3:2001(E)."
		aacConfig := node contentStringAt: 'decoderSpecificInfo' ifAbsent:[nil].
		aacConfig ifNil: [
			QLogger logWarning: 'no decoder-specific info found.'.
			^self future destroy
		].
		"Change from ASCII-hex to a TObjectID (which we'll use as a ByteArray)."
		aacConfig := ByteArray readHexFrom: aacConfig readStream.
	].
	sampleRate := Number readFrom: (node contentStringAt: 'sampleRate').
	numChannels := Number readFrom: (node contentStringAt: 'numChannels').
! !

!QNetVidAudioTrackDecoder methodsFor: 'private' stamp: 'jcg 6/30/2010 09:16'!
playTo: mediaTime "in seconds"
	"No-op.  See #handleRegularFrame:... we do no buffering here, instead immediately pushing decoded frames downstream, where they will be buffered in the QAudioPlugin."
! !

!QNetVidAudioTrackDecoder methodsFor: 'private' stamp: 'jcg 8/5/2009 11:25'!
renderFrame: aFrame
	client decodedAudioFrame: aFrame decodedFrame sampleRate: sampleRate from: self! !

!QNetVidAudioTrackDecoder methodsFor: 'private' stamp: 'jcg 8/5/2009 10:38'!
setupDecoder
	codecName = 'aac' ifTrue:[
		decoder := QAudioDecoderAAC new.
		decoder createHandle: aacConfig.
		^self].
	codecName = 'qspeex' ifTrue:[
		decoder := QSpeexCodec new.
		^self].
	^self error: 'Unknown codec: ', codecName! !

!QNetVidTrackDecoder class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QNetVidTrackDecoder methodsFor: 'initialize' stamp: 'jcg 8/5/2009 08:54'!
createBuffer
	"Instantiate a new buffer of the appropriate type.  Perhaps this should be done when we read the track info, but for now we know that all audio tracks will be AAC and all video will be H.264."
	self subclassResponsibility! !

!QNetVidTrackDecoder methodsFor: 'initialize' stamp: 'jcg 8/5/2009 10:24'!
destroy
	super destroy.
	decoder ifNotNilDo: [:d | 
		decoder := nil.
		d destroy
	].! !

!QNetVidTrackDecoder methodsFor: 'initialize' stamp: 'jcg 8/5/2009 11:21'!
initialize
	super initialize.
	lastCTS := -1.
	buffer := self createBuffer.! !

!QNetVidTrackDecoder methodsFor: 'private' stamp: 'jcg 8/5/2009 11:20'!
playTo: mediaTime "in seconds"
	"Play up to the specified time."
	| targetCTS frame |

	targetCTS := (mediaTime * trackPlayer timeScale) rounded.
	frame := buffer popFramesForCTS: targetCTS.
	frame ifNotNil: [
		lastCTS := frame cts.
		self renderFrame: frame
	].

	"For debugging.  'X' is a global variable pointing to an OrderedCollection."
"	frame 
		ifNotNil: [
			X add: {	'FOUND FRAME'. 
						frame sequenceNumber. 
						frame dts. 
						frame cts.  
						targetCTS. 
						'         ', Time millisecondClockValue
			}.
		]
		ifNil: [
			X add: {	'NO FRAME FOUND'.  
						targetCTS. 
						'         ', Time millisecondClockValue
			}
		].
"		
! !

!QNetVidTrackDecoder methodsFor: 'initialize' stamp: 'jcg 8/27/2009 17:58'!
trackPlayer: player
	super trackPlayer: player.
	client := trackPlayer client.! !

QNetVidTrackDecoder subclass: #QNetVidVideoTrackDecoder
	instanceVariableNames: 'avcConfig width height frameCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Client-Output'!

!QNetVidVideoTrackDecoder commentStamp: '<historical>' prior: 0!
Contains functionality specific to decoding/rendering an H.264 video-track.!

!QNetVidVideoTrackDecoder class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QNetVidVideoTrackDecoder methodsFor: 'initialize' stamp: 'jcg 8/5/2009 08:55'!
createBuffer
	| buf |
	buf := QNetVidReorderingBuffer new.
	buf frameCleanupBlock: [:fr | 
		"Reuse Forms that we're finished with... reduce allocation/GC overhead."
		fr decodedFrame ifNotNilDo: [:decoded | decoded returnToFormPool]
	].
	^buf! !

!QNetVidVideoTrackDecoder methodsFor: 'private' stamp: 'jcg 7/27/2011 01:46'!
decodedFrame: form "a QDecodedFrame"
	| frame |

true ifTrue: [
	"HACK!!!!!! This displays the proper frames, but we're not buffering them to play them out at the appropriate time; we're at the mercy of when they arrive from the network.  Fixing this will require changes in QVideoCodecPluginFree that I don't know how to make quite yet.  I intend to take my time and do things right, which might also entail reworking the image-side code."
	client decodedVideoFrame: form from: self.
	^self
].

	frame := buffer frameWithSequenceNumber: form metadata inputSequenceNumber.
	frame 
		ifNotNil: [frame decodedFrame: form] 
		ifNil: [^form returnToFormPool].

	"If we're not playing (eg: when seeking, just paused, etc.), then we want to display the frame immediately."
	client playState == #playing ifFalse: [
		(frame isSeek or: [frame cts > lastCTS]) ifTrue: [
			buffer popUpToFrame: frame.
			self renderFrame: frame.
		].
	].

	"For debugging. 'Y' is a global variable pointing to an OrderedCollection."
"
	Y add: {
		#decodedFrame: . 
		form metadata inputSequenceNumber. 
		Time millisecondClockValue
	}.
	frame ifNil: [Y add: {'CANNOT FIND FRAME FOR FORM: '. buffer allSequenceNumbers}].
"! !

!QNetVidVideoTrackDecoder methodsFor: 'private' stamp: 'jcg 12/30/2009 15:55'!
ensureStartCodesIn: frame
	"Depending on who is sending the frame it may have start-codes (i.e. from NetVidServer) or NALU sizes (i.e. webcast pane).  Check which is the case, and rewrite if necessary to contain start-codes."
	| initial |
	initial := frame data networkUnsignedLongAt: frame headerSize + 1.
	(initial = 1 "start code") ifFalse: [
		AVCHackingUtilities 
			replaceNaluSizes: avcConfig nalUnitSize
			withStartCodeIn: frame data
			startingAt: frame headerSize + 1
	]! !

!QNetVidVideoTrackDecoder methodsFor: 'accessing' stamp: 'jcg 8/5/2009 11:29'!
extent
	^width@height! !

!QNetVidVideoTrackDecoder methodsFor: 'private' stamp: 'jcg 8/5/2009 11:27'!
flushDecoder
	decoder ifNotNil: [
		"Flushing decoder increments plugin-internal frame count, 
		 so we must update ours to match."
		frameCount := frameCount + 1.
		decoder flush.
	]! !

!QNetVidVideoTrackDecoder methodsFor: 'private' stamp: 'jcg 7/28/2010 14:03'!
handleRegularFrame: frame "a QNetVidBufferedFrame"
	
	QJoshHacks receiveButIgnoreVideo ifTrue: [^false].
		
	decoder ifNil: [
		QLogger logWarning: 'no decoder available for regular-frame' every: 5000.
		frameCount := 0.
		^false "didn't handle the frame"
	].

	"Proceed differently  depending on whether we're in-sequence or not."
	
	trackPlayer expectedDTS == frame dts
		ifFalse: [
			"We're out-of-sequence, so we can only play this frame if it's a RAP."
			frame isRAP 
				ifFalse: [^false]
				ifTrue: [buffer flush "a good, safe place to do it"].
		]
		ifTrue: [
			"We processed the previous frame in the sequence, so we're OK 
			 to process this one too (taking a bit of extra care if the previous 
			 frame was a seek)."
			| lastFrame |
			lastFrame := trackPlayer lastFrame.
			lastFrame isSeek ifTrue: [
				"If the last frame was a seek, we flushed the decoder, so we 
				 need to re-decode the seek frame for it to act as the predecessor
				 for the current frame.  Remember: every time we push a frame 
				 into the decoder, we must increment the frame-count."
				frameCount := frameCount + 1.
				decoder 
					decode: lastFrame data 
					offset: lastFrame headerSize.
			].
		].

	"Now we have the preliminaries out of the way; we can deal with this frame."
	frame sequenceNumber: (frameCount := frameCount + 1).
	self ensureStartCodesIn: frame.
	buffer receiveFrame: frame.

	decoder decode: frame data offset: frame headerSize.

	^true "sweet, sweet success"
! !

!QNetVidVideoTrackDecoder methodsFor: 'private' stamp: 'jcg 7/28/2010 14:03'!
handleSeekFrame: frame "a QNetVidBufferedFrame"
	
	QJoshHacks receiveButIgnoreVideo ifTrue: [^false].
	
	decoder ifNil: [
		QLogger logWarning: 'no decoder available for seek-frame' every: 5000.
		frameCount := 0.
		^false "didn't handle the frame"
	].

	"We don't care about anything that came before."
	self flushDecoder. 
	buffer flush.

	"Process this frame, and flush the decoder to get it ASAP."
	frame sequenceNumber: (frameCount := frameCount + 1).
	self ensureStartCodesIn: frame.
	buffer receiveFrame: frame.
	decoder decode: frame data offset: frame headerSize.
	self flushDecoder.

	^true "sweet, sweet success"! !

!QNetVidVideoTrackDecoder methodsFor: 'accessing' stamp: 'jcg 8/5/2009 11:29'!
height
	^height! !

!QNetVidVideoTrackDecoder methodsFor: 'initialize' stamp: 'jcg 7/26/2011 23:38'!
initializeFromXmlElement: node
	| codec args fps |
	"Let the superclass do its thing, including setting up the media stream."
	super initializeFromXmlElement: node.

	"Read the info necessary to initialize the decoder."
	"XXXX: this is kinda nonsense... there should be a class that knows how to
	 read/write itself as XML, that is shared between the client and server."
	codec := node contentStringAt: 'codec'.
	codec = 'avc1' ifFalse: [
		"We only handle one type of video H.264.  If we get something else, we barf."
		QLogger logWarning: 'expected "avc1" codec, got: "', codec, '"'.
		^self future destroy
	].
	(node contentStringAt: 'decoderSpecificInfo') 
		ifEmpty: [avcConfig := nil "let's be explicit"]
		ifNotEmpty:[:data|
			avcConfig := ByteArray readHexFrom: data.
			avcConfig := AVCDecoderConfigurationRecord new 
								initializeFromDecoderSpecificInfo: avcConfig.
		].
	width := Number readFrom: (node contentStringAt: 'width').
	height := Number readFrom: (node contentStringAt: 'height').

	"We now have enough information to create a decoder for the stream."
	fps := (trackPlayer timeScale / trackPlayer dtsIncrement) asFloat.
	args := QVideoArgs new 
					usePlatformEndianness;
					codecType: 'avc1';
					timeScale: trackPlayer timeScale;
					width: width;
					height: height;
					bitRate: 80000; "XXXX: the server needs to send this info"
					fps: fps; 
					setFrameReorderingFlag: false;
					yourself.
	decoder := QVideoDecoderFree withArgs: args extent: width@height.

	"We will track of how many frames we have pushed into this decoder."
	frameCount := 0.

	"Prime the decoder with the decoder-specific info that we received.  As always, increment the 'frameCount' each time we push data into the decoder."
	avcConfig ifNotNil:[
		(avcConfig sequenceParameterSets, avcConfig pictureParameterSets) do: [:data | 
			frameCount := frameCount + 1.
			decoder decode: data
		].
	].

	self runScript: #decodedFrame: when: {decoder. #decodedFrame}.! !

!QNetVidVideoTrackDecoder methodsFor: 'private' stamp: 'jcg 8/5/2009 11:30'!
renderFrame: aFrame
	client decodedVideoFrame: aFrame decodedFrame from: self.! !

!QNetVidVideoTrackDecoder methodsFor: 'accessing' stamp: 'jcg 8/5/2009 11:29'!
width
	^width! !

QNetVidTrackPlayerOutput subclass: #QNetVidTrackNhmlRecorder
	instanceVariableNames: 'recorder nhmlHeader decoderSpecificInfo nhmlFile infoFile mediaFile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Recorder'!

!QNetVidTrackNhmlRecorder commentStamp: 'jcg 10/16/2009 10:29' prior: 0!
As it receives media samples from the network, it stores the data in a file, and constructs an NHML/MP4Box index file.  When streaming is completed, is uses MP4Box to add this data as a track of an MP4 file.!

!QNetVidTrackNhmlRecorder class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QNetVidTrackNhmlRecorder methodsFor: 'initialize' stamp: 'jcg 4/16/2010 12:41'!
finalizeRecording: finalizer "a QSessionRecorderFinalizer"
	| nhmlPath |

	nhmlFile ifNil: [^QLogger logWarning: 'no file available to finalize recording'].

	nhmlPath := nhmlFile fullName.
	QLogger logInfo: 'finalizing NHML track...'.
	nhmlFile nextPutAll: '</NHNTStream>'; crlf.
	nhmlFile close.
	mediaFile close.
	infoFile close.
	nhmlFile := mediaFile := infoFile := nil. "so that  we only finalize once"

	finalizer addTrackToMP4: nhmlPath.
! !

!QNetVidTrackNhmlRecorder methodsFor: 'frame-handling' stamp: 'jcg 8/6/2009 18:16'!
handleRegularFrame: frame "a QNetVidBufferedFrame"
	| msg |
	msg := String streamContents: [:s |
		s nextPutAll: '<NHNTSample DTS="'.
		frame dts printOn: s.
		s nextPutAll: '" dataLength="'.
		(frame data size - frame headerSize) printOn: s.
		s nextPut: $".
		frame isRAP ifTrue: [s nextPutAll: ' isRAP="yes"'].
		s nextPutAll: ' />'.
	].
	nhmlFile nextPutAll: msg; crlf.
	mediaFile nextPutAll: frame dataWithoutHeader.
	^true! !

!QNetVidTrackNhmlRecorder methodsFor: 'initialize' stamp: 'jcg 8/11/2009 23:35'!
initializeFromXmlElement: node
	| base nhmlFileName infoFileName mediaFileName directory |
	super initializeFromXmlElement: node.
	trackPlayer isAudio
		ifTrue: ["AAC audio"
			| sampleRate numChannels |
			sampleRate := node contentStringAt: 'sampleRate'.
			sampleRate ifEmpty: [self error: 'no sampleRate specified'].
			numChannels := node contentStringAt: 'numChannels'.
			numChannels ifEmpty: [self error: 'no numChannels specified'].
			(node contentStringAt: 'codec') = 'AAC' 
				ifFalse: [self error: 'must be AAC audio'].
			nhmlHeader := QSessionRecorderPane 
								generateAudioNhntStreamHeader: trackPlayer timeScale
								fileBaseName: 'audio' 
								sampleRate: sampleRate 
								numChannels: numChannels 
								trackID: trackPlayer trackID
		]
		ifFalse: ["H.264 video"
			| width height |
			width := node contentStringAt: 'width'.
			width ifEmpty: [self error: 'no width specified'].
			height := node contentStringAt: 'height'.
			height ifEmpty: [self error: 'no height specified'].
			(node contentStringAt: 'codec') = 'avc1' 
				ifFalse: [self error: 'must be H.264 video'].
			nhmlHeader := QSessionRecorderPane 
								generateVideoNhntStreamHeader: trackPlayer timeScale
								fileBaseName: 'video' 
								width: width 
								height: height 
								trackID: trackPlayer trackID
	].
	decoderSpecificInfo := node contentStringAt: 'decoderSpecificInfo'.
	decoderSpecificInfo ifEmpty: [self error: 'missing decoderSpecificInfo'].
	decoderSpecificInfo := ByteArray readHexFrom: decoderSpecificInfo.

	"Now that we have a trackID, open the files that we'll record onto."
	base := (trackPlayer isAudio ifTrue: ['audio'] ifFalse: ['video']), trackPlayer trackID.
	nhmlFileName := base, '.nhml'.
	infoFileName := base, '.info'.
	mediaFileName := base, '.media'.

	"XXXXX: error-handling would be nice."
	directory := FileDirectory on: recorder cacheDir.
	directory assureExistence.
	nhmlFile := directory newFileNamed: nhmlFileName.
	infoFile := directory newFileNamed: infoFileName.
	mediaFile := directory newFileNamed: mediaFileName.
	infoFile binary.
	mediaFile binary.

	"Finally, write the data that we've already obtained."
	nhmlFile nextPutAll: nhmlHeader.
	infoFile nextPutAll: decoderSpecificInfo.! !

!QNetVidTrackNhmlRecorder methodsFor: 'private' stamp: 'jcg 8/6/2009 14:12'!
playTo: mediaTime "in seconds"
	"No-op... we already did everything necessary in #handleRegularFrame:"
	! !

!QNetVidTrackNhmlRecorder methodsFor: 'initialize' stamp: 'jcg 8/6/2009 12:58'!
recorder: aQSessionRecorder
	recorder := aQSessionRecorder.! !

QNetVidTrackPlayerOutput subclass: #QNetVidTrackPassthrough
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Client-Output'!

!QNetVidTrackPassthrough commentStamp: '<historical>' prior: 0!
Placeholder.  WIll be used to handle encoded media that we don't want to decode and display, but instead want to keep in its encoded form.!

!QNetVidTrackPassthrough class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QNetVidTrackPlayerOutput class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QNetVidTrackPlayerOutput methodsFor: 'initialize' stamp: 'jcg 8/5/2009 10:43'!
destroy
	"No-op for now.  Subclasses should extend this behavior as necessary."! !

!QNetVidTrackPlayerOutput methodsFor: 'frame-handling' stamp: 'jcg 8/5/2009 09:29'!
handleRegularFrame: frame "a QNetVidBufferedFrame"
	"Handle a frame received while playing through the stream normally (i.e. not seeking).  Subclasses must answer true if the frame was handled and false if it was ignored."
	self subclassResponsibility.
	^false "did not handle the frame"
! !

!QNetVidTrackPlayerOutput methodsFor: 'frame-handling' stamp: 'jcg 8/5/2009 09:28'!
handleSeekFrame: frame "a QNetVidBufferedFrame"
	"Handle a frame received while seeking through the stream.  Subclasses must answer true if the frame was handled and false if it was ignored."
	self subclassResponsibility.
	^false "did not handle the frame"
! !

!QNetVidTrackPlayerOutput methodsFor: 'initialize' stamp: 'jcg 8/5/2009 10:35'!
initializeFromXmlElement: node
	"Subclasses know what to do."! !

!QNetVidTrackPlayerOutput methodsFor: 'private' stamp: 'jcg 9/5/2009 21:13'!
playTo: mediaTime "in seconds"
	self subclassResponsibility! !

!QNetVidTrackPlayerOutput methodsFor: 'initialize' stamp: 'ar 8/12/2009 13:49'!
trackPlayer
	^trackPlayer! !

!QNetVidTrackPlayerOutput methodsFor: 'initialize' stamp: 'jcg 8/5/2009 11:43'!
trackPlayer: player
	trackPlayer := player! !

QNetVidTrackPlayerOutput subclass: #RtspNetVidTrackBroadcaster
	instanceVariableNames: 'session sdp rtpPacketizer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-RTSP'!

!RtspNetVidTrackBroadcaster commentStamp: 'jcg 8/27/2009 15:25' prior: 0!
Fans out media-data from a single NetVid track to the corresponding RTP 'channels' on a collection of RTSP sessions.
!

!RtspNetVidTrackBroadcaster class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!RtspNetVidTrackBroadcaster methodsFor: 'testing' stamp: 'jcg 9/15/2009 18:25'!
currentlyInEventLoop
	^session ifNil: [false] ifNotNilDo: [:sess | sess currentlyInEventLoop]! !

!RtspNetVidTrackBroadcaster methodsFor: 'initialize' stamp: 'jcg 8/31/2009 14:23'!
destroy
	"We consider the session-broadcaster to be our owner, so #destroy should run there."
	self currentlyInEventLoop ifFalse: [^self future destroy].
	super destroy.! !

!RtspNetVidTrackBroadcaster methodsFor: 'initialize' stamp: 'jcg 10/30/2009 17:54'!
eventLoopOwner: aQRtspBroadcastSession
	session ifNotNil: [self error: 'session already set'. "set once, never cleared"].
	session := aQRtspBroadcastSession! !

!RtspNetVidTrackBroadcaster methodsFor: 'future' stamp: 'jcg 10/28/2009 13:19'!
futureDo: aSelector at: deltaMSecs args: args
	"Enqueue a message on the event queue.  The compiler has been modified to generate this message when the #future message appears in the source code."
	deltaMSecs = 0 ifFalse:[^self error: 'deltaMSecs must be zero'].
	session ifNil: [^self error: 'session is nil for future send of: ', aSelector printString].
	session futureDo: aSelector receiver: self args: args.
	^nil
! !

!RtspNetVidTrackBroadcaster methodsFor: 'future' stamp: 'jcg 10/28/2009 13:23'!
futureSend: aSelector at: deltaMSecs args: args
	"Enqueue a message on the event queue.  The compiler has been modified to generate this message when the #future message appears in the source code.  Answers a promise that will be resolved with the result of performing the message."
	deltaMSecs = 0 ifFalse:[^self error: 'deltaMSecs must be zero'].
	session ifNil: [^self error: 'session is nil for future send of: ', aSelector printString].
	^session futureSend: aSelector receiver: self args: args.
! !

!RtspNetVidTrackBroadcaster methodsFor: 'frame-handling' stamp: 'jcg 11/1/2009 11:09'!
handleRegularFrame: frame "a QNetVidBufferedFrame"
	"If we have an RTP server attached, push it out via the RTP server"

	[rtpPacketizer ifNotNilDo: [:pktzr | pktzr sendFrame: frame]]
		on: ConnectionClosed 
		do: [session connectionDestroyed].

	^true
! !

!RtspNetVidTrackBroadcaster methodsFor: 'private' stamp: 'jcg 9/5/2009 21:14'!
playTo: mediaTime "in seconds"
	"No-op... we already did everything necessary in #handleRegularFrame:"
	! !

!RtspNetVidTrackBroadcaster methodsFor: 'accessing' stamp: 'jcg 10/20/2009 00:24'!
rtpServer: aRTPServer
	"The RTP server attached to this output"
	rtpPacketizer := nil.
	aRTPServer ifNil: [^self].
	aRTPServer mediaDescription isAudio ifTrue: [
		rtpPacketizer := RtpAacPacketizer new.
		rtpPacketizer server: aRTPServer.
	].
	aRTPServer mediaDescription isVideo ifTrue: [
		rtpPacketizer := RtpAvcPacketizer new.
		rtpPacketizer server: aRTPServer.
	].
	rtpPacketizer ifNil: [self error: 'did not create an RTP packetizer'].
! !

!RtspNetVidTrackBroadcaster methodsFor: 'private' stamp: 'jcg 8/27/2009 15:03'!
sessionDestroyed: rtspSession
	"Should only be sent by an RtspSessionBroadcaster from within its event-loop."

	self currentlyInEventLoop ifFalse: [self error: 'must be called from within event-loop'].! !

TObject subclass: #QPersistentClientSpeakerInput
	instanceVariableNames: 'replicatedSpeaker speakerInput clientSpeaker speakerPlayer speakerManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-Session'!

!QPersistentClientSpeakerInput commentStamp: 'crl 4/29/2010 17:12' prior: 0!
'
	Each of my instances provides access to the current non-replicated speaker corresponding to a replicated speaker, for use by a QSecureWebcast.

!

!QPersistentClientSpeakerInput class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QPersistentClientSpeakerInput class methodsFor: 'instance creation' stamp: 'crl 4/29/2010 18:09'!
on: aQSpeaker for: speakerPlayer
	"Answer an instance of myself which provides access to the speaker input for the current non-replicated speaker corresponding to aQSpeaker, for speakerPlayer (e.g., a QSecureWebcast or QStreamingVideoPlayer)."

	^(self new)
		replicatedSpeaker: aQSpeaker
		speakerPlayer: speakerPlayer! !

!QPersistentClientSpeakerInput methodsFor: 'initialize' stamp: 'jcg 6/16/2010 18:27'!
checkForClientSpeaker
	| newClientSpeaker |

	QLogger logInfo: 'checking for client speaker ', (replicatedSpeaker get: #objectID) printString.
	newClientSpeaker := (speakerManager future speakerAt: (replicatedSpeaker get: #objectID)) wait.
	clientSpeaker = newClientSpeaker ifTrue: [
		QLogger logInfo: 'already have the current client speaker for ', (replicatedSpeaker get: #objectID) printString.
		self signal: #stopCheckingForClientSpeaker.
		^self].
	clientSpeaker := newClientSpeaker.
	clientSpeaker ifNotNil: [
		speakerInput := (clientSpeaker future newInputOfClass: QClientSpeakerNetVidInput) wait.
		speakerInput player: speakerPlayer.
		clientSpeaker future updatePlayState.

		"Now that we have a new speaker, we don't need to keep checking.
		However, once our speaker is destroyed (eg: during a reset-sound),
		we want to start checking again."
		self stopScript: #startCheckingForClientSpeaker.
		self 
			startScript: #startCheckingForClientSpeaker 
			when: {clientSpeaker. #destroyed}.

		"This check was successful... we don't need to do another."
		QLogger logInfo: 'finished checking for client speaker', (replicatedSpeaker get: #objectID) printString.
		self signal: #stopCheckingForClientSpeaker]! !

!QPersistentClientSpeakerInput methodsFor: 'playing audio' stamp: 'crl 4/30/2010 11:54'!
handleDecodedAudio: buf samplingRate: samplingRate
	clientSpeaker
		ifNil: [QLogger logInfo: 'persistent speaker input hasn''t found its client speaker yet...']
		ifNotNil: [speakerInput handleDecodedAudio: buf samplingRate: samplingRate]! !

!QPersistentClientSpeakerInput methodsFor: 'initialize' stamp: 'crl 4/29/2010 18:34'!
initialize
	self
		startScript: #stopCheckingForClientSpeaker
		when: {self. #stopCheckingForClientSpeaker}! !

!QPersistentClientSpeakerInput methodsFor: 'initialize' stamp: 'crl 5/3/2010 09:22'!
replicatedSpeaker: aQSpeaker speakerPlayer: thePlayer
	replicatedSpeaker := aQSpeaker.
	speakerPlayer := thePlayer.
	speakerManager := speakerPlayer speakerManager.
	self startCheckingForClientSpeaker! !

!QPersistentClientSpeakerInput methodsFor: 'events' stamp: 'crl 5/3/2010 09:33'!
startCheckingForClientSpeaker
	"Every time we're notified that the list of speakers has changed, try to find a match.  Once we find one, stop listening."

	self 
		startScript: #checkForClientSpeaker 
		when: {speakerManager. #clientSpeakersChanged}.
	self startScript: #checkForClientSpeaker! !

!QPersistentClientSpeakerInput methodsFor: 'events' stamp: 'crl 4/30/2010 12:10'!
stopCheckingForClientSpeaker
	"Use a separate script to stop checking to workaround a deadlock apparently resulting from a low-level (VM-ish) mutex bug (we used to do this at the end of #checkForClientSpeaker)."
	QLogger logInfo: 'stopping checkForClientSpeaker script'.
	self stopScript: #checkForClientSpeaker! !

TObject subclass: #QStreamingVideoDecoder
	instanceVariableNames: 'manager streamID subscription userCount texture decoder lastTextureUse lastForm state description mediaController tokens'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-Session'!

!QStreamingVideoDecoder commentStamp: 'jcg 8/9/2007 19:04' prior: 0!
(c) 2007 Qwaq Inc.  QStreamingVideoDecoder has two responsibilities: to manage a subscription to a single video stream, and to decode that video stream into a QClientVideoTexture.
!

!QStreamingVideoDecoder class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QStreamingVideoDecoder class methodsFor: 'instance creation' stamp: 'jcg 1/31/2008 23:27'!
forStreamID: streamID manager: aQVideoDecoderManager description: aQStreamingVideoDescription controller: aController
	| streamingDecoder |
	streamingDecoder := super new.
	streamingDecoder
		initializeForStreamID: streamID 
		manager: aQVideoDecoderManager
		description: aQStreamingVideoDescription
		controller: aController.
	^ streamingDecoder! !

!QStreamingVideoDecoder class methodsFor: 'utilities' stamp: 'jcg 4/8/2009 16:17'!
formForDisabledVideo: extent
	"Answer a Form that is displayed when video is temporarily suspended."
	| disabledForm grad col1 col2 canvas fontHeight | 

	[ 	| filePath |
		filePath := (FileDirectory default pathFromURI: 'icons/Qwaq/VideoDisabled.png').
		^(ImageReadWriter formFromFileNamed: filePath) scaledToSize: extent.
	]
		on: Error 
		do: [nil].

	"Can't load the form, let's create one."
	col1 := Color green muchDarker.
	col2 := Color blue muchDarker.
	grad := GradientFillStyle ramp: {0.0->col1.  0.5->col2.  1.0->col1}.
	grad origin: 0@0.
	grad direction: 0@extent y.
	disabledForm := Form extent: extent depth: 32.
	canvas := FormCanvas on: disabledForm.
	canvas fillRectangle: disabledForm boundingBox fillStyle: grad.
	fontHeight := extent y // 10.
	canvas 
		drawString: 'Click to See WebCams' 
		at: 16@((extent y - fontHeight) // 2)
		font: ((TextStyle named: 'BitstreamVeraSans') fontOfSize: fontHeight)
		color: Color yellow.
	^disabledForm! !

!QStreamingVideoDecoder class methodsFor: 'defaults' stamp: 'bgf 6/1/2008 09:57'!
interimColor
	"Color for fill of rectangles while video stream is coming up;
	 a bit different from neutral gray so it looks like something's going on."
	^Color r:0.32 g:0.4 b: 0.45! !

!QStreamingVideoDecoder methodsFor: 'actions' stamp: 'jcg 12/29/2009 17:55'!
addClientTexture: client "a QClientVideoTexture"
	"XXXX fix the comment"
	"Add the specified tokens.  Signal if the number of distinct tokens has changed."
	| distinctTokens |
	distinctTokens := tokens sizeAsSet.
	tokens addAll: client tokens.
	distinctTokens = tokens sizeAsSet ifFalse: [self signal: #tokensChanged with: tokens asSet].! !

!QStreamingVideoDecoder methodsFor: 'accessing' stamp: 'jcg 1/31/2008 23:31'!
codecType
	^description videoCodec! !

!QStreamingVideoDecoder methodsFor: 'private' stamp: 'jcg 11/23/2009 13:14'!
connectToStream
	"Begin the process of connecting to the published video stream (unless we have already started the process previously)."

	"XXXX: use QVideoStreamInput/Output later (once all routers have them)"
	subscription := TMediaStreamSubscription 
						streamID: streamID
						mediaController: self mediaController
						inputClass: QVideoStreamInput
						outputClass: QVideoStreamOutput.
	self registerSubscriptionScripts.
	[subscription ifNotNilDo: [:s | s connectWithTimeout: 120000]] fork.
! !

!QStreamingVideoDecoder methodsFor: 'private' stamp: 'jcg 3/17/2009 13:27'!
createTextureForForm: aForm
	| texForm |

	"For now, don't mess with TTextureNPOT... just allocate a bigger texture, and only use part of it."
	"texture := TTextureNPOT fromForm: aForm mipmap: false shrinkFit: true extension: nil."

	texForm := Form extent: aForm extent asLargerPowerOfTwo depth: 32.
	texForm copy: (0@0 extent: aForm extent) from: 0@0 in: aForm rule: Form over.
	texture := TTexture fromForm: texForm mipmap: false shrinkFit: false extension: nil.
	texture textureScale: (aForm extent / texForm extent asFloatPoint).
	texture sha: description computeSHA.

	lastTextureUse := RealTime millisecondClockValue.
	self 
		runScript: #noteUseOfTextureIn:isMainView: 
		when: {texture. #installedTexture}.
	TContentManager default substituteForm: texture.
! !

!QStreamingVideoDecoder methodsFor: 'accessing' stamp: 'bgf 2/12/2008 23:51'!
description

	"The video stream description for the stream I represent"
	^ description! !

!QStreamingVideoDecoder methodsFor: 'initialize' stamp: 'jcg 5/20/2010 16:45'!
destroy
	state == #destroyed ifTrue: [^self "already destroyed"].
	state := #destroyed.

	subscription ifNotNil: [
		self unregisterSubscriptionScripts.
		subscription destroy.
		subscription := nil.
	].
	self destroyDecoder.
	self stopScript: #noteUseOfTextureIn:isMainView:.
	self stopScript: #videoDisabled:.
	TContentManager default flushTextureSHA: description computeSHA.
	self signal: #destroyed with: self "in case anyone else cares"! !

!QStreamingVideoDecoder methodsFor: 'initialize' stamp: 'jcg 2/2/2009 16:59'!
destroyDecoder
	decoder ifNotNilDo: [:d |
		self stopScript: #handleDecodedFrame:.
		d destroy.
		decoder := nil.
	]! !

!QStreamingVideoDecoder methodsFor: 'private' stamp: 'jcg 5/14/2008 23:17'!
disableVideo
	"Our manager globally disabled video.  Do the right thing (tm)."
	| disabledForm |
	self privatePause.
	disabledForm := self formForDisabledVideo.
	self updateTexture: disabledForm.
	self signal: #decodedFrame with: disabledForm! !

!QStreamingVideoDecoder methodsFor: 'private' stamp: 'bgf 6/1/2008 09:50'!
enableVideo
	"Our manager globally enabled video.  Do the right thing (tm)."
	lastForm ifNotNil: [
		"Give immediate visual feedback that the enable has happened."
		lastForm fillWithColor: (self class interimColor).
		self updateTexture: lastForm.
		self signal: #decodedFrame with: lastForm.
	].
	self videoWasRenderedRecently ifTrue: [self privatePlay].! !

!QStreamingVideoDecoder methodsFor: 'accessing' stamp: 'jcg 1/31/2008 23:30'!
extent
	^description videoExtent! !

!QStreamingVideoDecoder methodsFor: 'private' stamp: 'jcg 4/8/2009 16:17'!
formForDisabledVideo
	"Answer a Form that is displayed when video is temporarily suspended."
	^self class formForDisabledVideo: self extent.
! !

!QStreamingVideoDecoder methodsFor: 'futures' stamp: 'crl 12/24/2009 13:05'!
futureDo: aSelector at: deltaMSecs args: args
	"Enqueue a message on the event queue.  The compiler has been modified to generate this message when the #future message appears in the source code."
	deltaMSecs = 0 ifFalse:[^self error: 'deltaMSecs must be zero'].
	manager futureDo: aSelector receiver: self args: args.
	^nil
! !

!QStreamingVideoDecoder methodsFor: 'futures' stamp: 'crl 12/24/2009 13:06'!
futureSend: aSelector at: deltaMSecs args: args
	"Enqueue a message on the event queue.  The compiler has been modified to generate this message when the #future message appears in the source code.  Answers a promise that will be resolved with the result of performing the message."
	deltaMSecs = 0 ifFalse:[^self error: 'deltaMSecs must be zero'].
	^manager futureSend: aSelector receiver: self args: args.
! !

!QStreamingVideoDecoder methodsFor: 'private' stamp: 'jcg 8/11/2007 01:47'!
handleControl: data
	'HANDLING CONTROL of size: ', data size displayAt: 0@10! !

!QStreamingVideoDecoder methodsFor: 'private' stamp: 'jcg 2/13/2009 17:55'!
handleDecodedFrame: aForm

	"If we already have a form, release it back to the decoder.  We'd use less memory if we returned it immediately after we're done (so that it would be available to read the next frame into), but we signal #decodedFrame below, and we don't know for sure when all of the listeners for this signal are done with the frame."
	lastForm ifNotNil: [lastForm returnToFormPool].

	"Allow anyone to access the last decoded Form."
	lastForm := aForm.
	self updateTexture: aForm.

	"Notify the others (do this first, because it might prevent us from pausing below)."
	self signal: #decodedFrame with: lastForm.

	"Keep track of how recently we actually rendered the video... if we haven't used it for a few seconds, we'll pause the stream."
	self videoWasRenderedRecently ifFalse: [self privatePause].

! !

!QStreamingVideoDecoder methodsFor: 'private' stamp: 'jcg 10/21/2008 11:02'!
handleMedia: data	
	"Push the data into the decoder."
	| timestamp isKeyframe |

	timestamp := data networkUnsignedLongAt: 2.
	isKeyframe := (data at: 6) = 1.

"XXXX: we don't yet do anything with the 'timestamp' or 'isKeyframe' data."
"	'TIMESTAMP: ', timestamp, '            ' displayAt: 100@50.' "
"	isKeyframe 
		ifTrue: ['keyframe: yes      ' displayAt: 100@100]
		ifFalse: ['keyframe: no      ' displayAt: 100@100]."

	"The decoder may not quite be created yet (or perhaps the video isn't even in view); if so skip the frame."
	decoder ifNotNilDo: [:d |
		[d decode: data offset: 6]	"Skip the Media Stream header and 'isKeyframe' bytes"
			on: Error
			do: [:err | QLogger log: 'error pushing data into decoder ', err from: self]
	].! !

!QStreamingVideoDecoder methodsFor: 'testing' stamp: 'jcg 2/19/2008 21:55'!
hasClients
	"If we are not holding any client tokens, then we can infer that we have no clients."
	^ tokens size > 0! !

!QStreamingVideoDecoder methodsFor: 'accessing' stamp: 'jcg 1/31/2008 23:33'!
height
	^description videoExtent y! !

!QStreamingVideoDecoder methodsFor: 'initialize' stamp: 'jcg 2/19/2008 16:48'!
initialize
	super initialize.
	userCount := 0.
	state := #initial.
	tokens := Bag new.! !

!QStreamingVideoDecoder methodsFor: 'initialize' stamp: 'jcg 5/14/2008 18:01'!
initializeForStreamID: aTObjectID manager: aQVideoDecoderManager description: aQStreamingVideoDescription controller: aController
	streamID := aTObjectID.
	manager := aQVideoDecoderManager.
	description := aQStreamingVideoDescription.
	mediaController := aController.
	self startScript: #videoDisabled: when: {manager. #videoGloballyDisabled}.
	self connectToStream.
	self setupDecoder.

! !

!QStreamingVideoDecoder methodsFor: 'testing' stamp: 'crl 2/10/2010 16:42'!
isLive
	^true! !

!QStreamingVideoDecoder methodsFor: 'accessing' stamp: 'jcg 5/14/2008 23:42'!
lastForm
	"Used by observers to get the last Form that the texture was updated with (so that eg: QWebcamPane shows the same thing as in-world video-textures."
	^manager videoDisabled 
		ifTrue: [self formForDisabledVideo]
		ifFalse: [lastForm]! !

!QStreamingVideoDecoder methodsFor: 'accessing' stamp: 'ar 10/17/2007 12:00'!
mediaController
	^mediaController! !

!QStreamingVideoDecoder methodsFor: 'accessing' stamp: 'ar 10/17/2007 12:00'!
mediaController: aController
	mediaController := aController! !

!QStreamingVideoDecoder methodsFor: 'private' stamp: 'jcg 10/21/2008 10:11'!
noteUseOfTexture
	"The texture was just rendered... ensure that the stream is unpaused."
	lastTextureUse := RealTime millisecondClockValue.
	manager videoDisabled ifFalse: [self privatePlay].
! !

!QStreamingVideoDecoder methodsFor: 'private' stamp: 'jcg 3/17/2009 13:37'!
noteUseOfTextureIn: ogl isMainView: isMainView
	"The texture was just rendered... ensure that the stream is unpaused;
	 but only for the main scene, and only for my live-view."
	isMainView ifTrue: [self noteUseOfTexture].
! !

!QStreamingVideoDecoder methodsFor: 'accessing' stamp: 'jcg 5/14/2008 02:05'!
ogl
	^manager view ogl! !

!QStreamingVideoDecoder methodsFor: 'private-play/pause' stamp: 'jcg 5/14/2008 23:07'!
privatePause
	subscription ifNotNil: [subscription pause].
	self destroyDecoder! !

!QStreamingVideoDecoder methodsFor: 'private-play/pause' stamp: 'jcg 5/14/2008 23:12'!
privatePlay
	decoder ifNil: [self setupDecoder].
	subscription ifNotNil: [subscription unpause].
! !

!QStreamingVideoDecoder methodsFor: 'private' stamp: 'jcg 8/11/2007 01:43'!
registerSubscriptionScripts
	self runScript: #subscriptionDestroyed when: {subscription. #destroyed}.
	self runScript: #subscriptionConnected when: {subscription. #connected}.
	self runScript: #handleMedia: when: {subscription. #sendMedia}.
	self runScript: #handleControl: when: {subscription. #sendMediaDownStream}.! !

!QStreamingVideoDecoder methodsFor: 'actions' stamp: 'jcg 12/29/2009 17:52'!
removeClientTexture: client "a QClientVideoTexture"
	"XXXX fix the comment"
	"Remove the specified tokens.  Signal if the number of distinct tokens has changed."
	| distinctTokens |
	distinctTokens := tokens sizeAsSet.
	[tokens removeAll: client tokens]
		on: Error 
		do: [:err | QLogger log: '#removeClientTokens: ', err description from: self].
	distinctTokens = tokens sizeAsSet ifFalse: [self signal: #tokensChanged with: tokens asSet].
! !

!QStreamingVideoDecoder methodsFor: 'accessing' stamp: 'jcg 5/20/2010 16:51'!
sessionID
	"So that we're polymorphic with QSecureWebcast (as far as QSecureWebcastManager is concerned).  Also see QStreamingVideoV1FileCardContents>>sessionID."
	^streamID! !

!QStreamingVideoDecoder methodsFor: 'private' stamp: 'jcg 5/14/2008 21:33'!
setupDecoder
	| args decoderClass |

	args := QVideoArgs new usePlatformEndianness.
	args codecType: self codecType.
	args timeScale: 3000.
	args width: self width.
	args height: self height.

	decoderClass := self videoSession ifNotNilDo: [:vs | vs decoderClassFor: self codecType].
	decoderClass ifNil: [
		Transcript cr; show: '#setupDecoder ... no decoder found for codec type: ', self codecType.
		^self destroy
	].

	"Create the decoder."
	[decoder := decoderClass withArgs: args extent: self extent] on: Error do: [:err |
		Transcript cr; show: '#setupDecoder ... error: ', err description.
		^self destroy
	].
	self runScript: #handleDecodedFrame: when: {decoder. #decodedFrame}


	! !

!QStreamingVideoDecoder methodsFor: 'accessing' stamp: 'jcg 1/24/2008 13:43'!
streamID
	^streamID! !

!QStreamingVideoDecoder methodsFor: 'accessing' stamp: 'jcg 1/31/2008 23:28'!
streamingVideoDescription
	"Provide a description of the video, suitable for others to use to connect to the video."
	^ description copy! !

!QStreamingVideoDecoder methodsFor: 'private' stamp: 'jcg 5/14/2008 23:54'!
subscriptionConnected
	QLogger log: 'subscription was connected: ', streamID from: self.
	manager videoDisabled
		ifTrue: [self disableVideo]
		ifFalse: [self privatePlay].! !

!QStreamingVideoDecoder methodsFor: 'private' stamp: 'jcg 4/3/2008 10:27'!
subscriptionDestroyed
	QLogger log: 'subscription was destroyed: ', streamID from: self.
	self destroy.! !

!QStreamingVideoDecoder methodsFor: 'testing' stamp: 'jcg 2/20/2008 00:01'!
tokens
	"Answer a Set with all of the tokens for this decoder."
	^tokens asSet
	! !

!QStreamingVideoDecoder methodsFor: 'private' stamp: 'jcg 8/11/2007 01:44'!
unregisterSubscriptionScripts
	self stopScript: #subscriptionDestroyed.
	self stopScript: #subscriptionConnected.
	self stopScript: #handleMedia:.
	self stopScript: #handleControl:.! !

!QStreamingVideoDecoder methodsFor: 'private' stamp: 'jcg 5/14/2008 21:38'!
updateTexture: aForm
	texture 
		ifNil: [self createTextureForForm: aForm deepCopy]
		ifNotNil: [
			| dirtyRect |
			dirtyRect := aForm boundingBox.
			texture form copy: dirtyRect from: 0@0 in: aForm rule: Form over.
			texture invalidate: dirtyRect.
		].
! !

!QStreamingVideoDecoder methodsFor: 'accessing' stamp: 'jcg 8/8/2007 22:42'!
userCount
	^userCount! !

!QStreamingVideoDecoder methodsFor: 'private' stamp: 'jcg 5/14/2008 21:23'!
videoDisabled: videoIsDisabled
	"Our manager globally enabled or disabled video.  Do the right thing (tm)."
	videoIsDisabled ifTrue: [self disableVideo] ifFalse: [self enableVideo]! !

!QStreamingVideoDecoder methodsFor: 'private' stamp: 'jcg 12/2/2007 22:44'!
videoSession
	manager ifNil: [^nil].
	manager view ifNotNilDo: [:v | ^v videoSession].
	^nil! !

!QStreamingVideoDecoder methodsFor: 'private' stamp: 'jcg 5/14/2008 23:22'!
videoWasRenderedRecently
	lastTextureUse ifNil: [^false].
	^(RealTime millisecondsSince: lastTextureUse) <= 2000! !

!QStreamingVideoDecoder methodsFor: 'accessing' stamp: 'jcg 1/31/2008 23:33'!
width
	^description videoExtent x! !

TObject subclass: #QVideoCameraManager
	instanceVariableNames: 'view camera encoder stream state mutex videoSpec alreadyWarnedUser startTime watermark desiredDeviceName desiredDeviceUID'
	classVariableNames: 'DT KDl KDr KDt KIl KIr KIt KPl KPr KPt LatencySetpoint MaxFrameInterval MinFrameInterval RenderingSetpoint Reporting TrafficOutSetpoint'
	poolDictionaries: 'TRouterConstants'
	category: 'Qwaq-Video-Session'!

!QVideoCameraManager commentStamp: '<historical>' prior: 0!
(c) 2007 Qwaq Inc.  Responsible for grabbing frames from the camera, encoding them, and pushing them downstream.  Oh yeah, and setting up the avatar's video-texture face.!

!QVideoCameraManager class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QVideoCameraManager methodsFor: 'private' stamp: 'jcg 11/23/2009 13:14'!
beginPublication
	"XXXX: use QVideoStreamInput/Output later (once all routers have them)"
	stream := TMediaStreamPublication 
						publishID: TObjectID new
						mediaController: self mediaController
						inputClass: QVideoStreamInput
						outputClass: QVideoStreamOutput.
	QLogger logInfo: 'publishing stream: ', stream streamID.
	stream streamName: 'Video stream: ', self userLoginName.
	self startScript: #publicationDestroyed when: {stream. #destroyed}.
	self startScript: #publicationConnected when: {stream. #connected}.
	self startScript: #pause when: {stream. #pause}.
	self startScript: #unpause when: {stream. #unpause}.

	[stream ifNotNilDo: [:s | s connectWithTimeout: 120000]] fork.! !

!QVideoCameraManager methodsFor: 'accessing' stamp: 'jcg 1/29/2008 09:56'!
camera
	^camera! !

!QVideoCameraManager methodsFor: 'private' stamp: 'jcg 5/5/2008 11:53'!
checkComputerPerformance
	"Check the computer performance (right now, just the number of CPUs), and if it is low, pop up an informational dialogue to tell the user that the video frame-rate might be decreased."
	| msg |

	alreadyWarnedUser ifTrue: [^self].
	CPlatform current numberOfCPUs > 1 ifTrue: [^self].
	alreadyWarnedUser := true. "so we don't do it again"

	msg := String streamContents: [:str | 
		str 
			nextPutAll: 'Your computer has a single CPU.'; cr;
			nextPutAll: 'Video frame rate may be decreased.'; cr; cr;
			nextPutAll: '(current quality setting: ', self videoSession qualitySettingString, ')'.
	].
	view owner signalInformDialog: msg label: 'Performance Warning'.

	! !

!QVideoCameraManager methodsFor: 'accessing' stamp: 'bgf 10/15/2009 16:20'!
desiredDeviceName
	"If indicated, the friendly of the most recent device chosen by user as their capture web-cam."
	^ desiredDeviceName! !

!QVideoCameraManager methodsFor: 'accessing' stamp: 'bgf 10/16/2009 17:25'!
desiredDeviceName: aFriendlyName uid: aDeviceUID
	"Specify the device (from discovery) of the camera the user wants to use.
	 Nil means use whatever device the system offers as default."
	mutex critical: [
		| change |
		change := (aDeviceUID ~= desiredDeviceUID).
		desiredDeviceName := aFriendlyName.
		desiredDeviceUID  := aDeviceUID.
		(change and: [self isChatting]) ifTrue: [
			self destroy; startVideoChat.
		]].! !

!QVideoCameraManager methodsFor: 'accessing' stamp: 'bgf 10/15/2009 16:18'!
desiredDeviceUID
	"The device-UID (from discovery) of the camera the user wants to use.
	 Nil means use whatever device the system offers as default."
	^ desiredDeviceUID! !

!QVideoCameraManager methodsFor: 'private' stamp: 'crl 12/17/2009 16:10'!
destroy
	mutex critical: [
		self stopAllScripts.
		self destroyCamera.
		self destroyEncoder.
		stream ifNotNil: [
			"Remove the 'keepalive' token that we stashed in the stream-decoder."
			QLogger logInfo: 'destroying stream: ', stream streamID.
			self videoSession webcastManager ifNotNilDo: 
				[:dm | dm removeClient: self of: stream streamID].

			stream destroy.
			stream := nil.
		].
		self fetchAvatarCostume ifNotNilDo: [:costume | costume future setVideoFace: nil].
		self fetchAvatarReplica ifNotNilDo: [:rep | rep future registerVideoStream: nil].
		state := #initial.
	].! !

!QVideoCameraManager methodsFor: 'private' stamp: 'jcg 8/11/2007 01:34'!
destroyCamera
	camera ifNil: [^self].
	camera destroy.
	camera := nil! !

!QVideoCameraManager methodsFor: 'private' stamp: 'bgf 10/15/2009 16:33'!
destroyEncoder
	| e |
	encoder ifNil: [^self].
	e := encoder.
	encoder := nil.

	"We disconnect  from the decoder 
	 earlier than we destroy the underlying beast 	
 	 to dodge potential race problems in the MC libraries on Mac."

	[ (Delay forSeconds: 2) wait. e destroy ] fork.
! !

!QVideoCameraManager methodsFor: 'actions' stamp: 'bgf 10/16/2009 17:10'!
devicesUpdate: newDevices oldDevices: oldDevices
	"Notification that the available devices have changed.
	 If we're running a camera that is no longer listed, turn it off."
	camera ifNil: [ ^ self ].
	camera deviceUID ifNotNil: [ : uid |
		| curSpec |
		curSpec := newDevices detect: [ : spec | spec second = uid ] ifNone: [ nil ].
		curSpec ifNil: [
			QLogger logInfo: 'Webcam removed. Stopping video'.
			[ view owner controlBar microphoneMessage: 'Webcam removed. Stopping video.'] 
				on: Error 
				do: [ ].
			self endVideoChat.
		]].

	"Don't keep the dduid set to a camera that ain't there,
	 so the simple start behavior will fall back to using the new default device."
	desiredDeviceUID ifNotNil: [
		(newDevices anySatisfy: [ : spec | spec second = desiredDeviceUID ])
		 ifFalse:[ 
			desiredDeviceUID := nil.
			desiredDeviceName := nil.
		]].
! !

!QVideoCameraManager methodsFor: 'dynamic control' stamp: 'hrs 11/20/2007 12:17'!
doUpdateRate
	"A 'P.I.D.' closed-loop controller to dynamically adjust the recording frame rate such that:
	- the rendering frame rate is better than RenderingSetpoint
      - latency (as round-trip messages per second) is better than LatencySetpoint, 
	- outbound video traffic (bits per second) is less than TrafficOutSetpoint,
	regardless of whatever else is going on with the computer and network.  
	That is, we increase or decrease frame rate only as much as is needed to just satisfy the above --
	subject to an overall MinFrameIntervale and MaxFrameInterval. If all is well, we max out on camera 
	frame rate. But if either CPU or network is too bogged down, or if we're putting out more than are arbitrarilly
	chosen max output, this controller spaces out the camera frames to match. 

	The general scheme is to have a single loop that runs three PID results that picks camera frame rate 
	interval to just match each of the above. Then we choose the larger frame interval (1/camera fps), 
	subject to the constraint of a min and max frame interval."
	| delay 
		measuredValue1 measuredError1  accumulatedError1 deltaError1 lastError1  p1  i1 d1 pid1
		measuredValue2 measuredError2  accumulatedError2 deltaError2 lastError2  p2  i2 d2 pid2
		measuredValue3 measuredError3  accumulatedError3 deltaError3 lastError3  p3  i3 d3 pid3
		controlledValue stats1 stats2 stats3
		report reportCount latency minFrameInterval lastInterval |

	"Initialize class variables, though they can be changed dynamically for tuning"

	"'pins' for the dials."
	MinFrameInterval := 1000/24.0.  "milliseconds between camera frames, @24fps = studio films."
	MaxFrameInterval := 1000/1.0.   "@1fps"

	"See #frameInterval: for an explanation of the 'direction' of the next three parameters."
	RenderingSetpoint := 10.0. 		"rendering fps"
	LatencySetpoint := 1000/500.0.  	"round trip messages per second @500ms latency"
	TrafficOutSetpoint := 20000.0. 	"20kb/s target output from camera"

	DT := 0.1. "Sampling rate in seconds. Should be less than about 1/10 of the desired response time."

	KPr := 10.0.   	"rendering performance coefficients for P,I,D"
	KIr := 2.0.
	KDr := 5.0.

	KPl := 20.0.		"latency performance coeficients for P,I,D"
	KIl := 2.0.
	KDl := 0.0.

	KPt := 0.5/1000.	"Outgoing traffic coefficients for P,I,D"
	KIt := 1.0/1000.
	KDt := 0.0.
	"The precise tuning of the above Kx and DT coefficients is not critical. 'Better' tuning just makes the 
	system respond to changes faster, or hold a value more steady. As long as the tuning isn't so 
	bad that we get stuck at Min/MaxFrameInterval, we'll still  satisfy our criterion even with
	bad tuning.
	Tune  separately for rendering, latency etc. Set the coefficients for all but one of them to zero. 
	Then start with KP:=Ki:=KD:=1 for the one set, and vary that KP by factors of 10 until the 
	result oscillates, then back off to, say, 0.6 of that. Then KI and KD.
	It is common for KDx to be 0.0 if it isn't needed to stabilize the output.

	NOTE that while class var changes will effect a running loop, other code changes require you to 
	stop and restart the camera before they take effect.
	To watch stuff change, inspect an instance of QVideoCamera and watch fps, or 
	set Reporting := true and open a big transcript."

	stats1 := QFrameRate newForView: self view.
	stats1 windowSize: 10. "average measured value over last n samples. See #windowSize:."
	self flag: #FIXME. "latencyStatistics have some problems:
		- Can get screwed up by multiple senders? (Subwindow copy gets occasional error when 
			simultaneously doing a speed test?) Probably fixed by Croquet-Router-ar.238?
		- TMediaControllerEndpoint>>runPinger is creating explicit ping messages about 
			4x/second and measuring their latency. That's ok, but what we really want is 
			latency of all (our camera?) messages returning during our DT window. 
		- Not particularly lightweight (about 15x slower than QFrameRate).
		- subwindow average answers zero, but from our perspective, any subwindow that has no
		  responses indicates a max latency (infinite or at least > window size), not a zero latency."
	stats2 := view owner latencyStatistics. 
	stats3 := QCounterRate newFor: (TTrafficCounter current outboundCountsFor: VideoTag).  
	stats3 windowSize: ((1.0/videoSpec fps/DT) ceiling max: 2). "Try to have data each iteration."

	"respect user's chosen quality as a max frame rate. This gives a way for the camera owner to manually
	slow things down if OTHER users are telling him that their load is too high. Eventually, we should have
	each user report problems to the camera owner's updateRate control loop."
	minFrameInterval := MinFrameInterval max: 1000.0/videoSpec fps.

	delay := Delay forSeconds: DT.
	lastError1 := accumulatedError1 := 0.	"Initial conditions."
	lastError2 := accumulatedError2 := 0.	
	lastError3 := accumulatedError3 := 0.	
	report := ''. reportCount :=0.  

	[camera] whileNotNil: [

		"------ Control code guts ------"
		"First PID controller:"
		measuredValue1 := stats1 frameRate.   "rendered frames/second. Higher number is better."
		lastInterval := stats1 lastPeriodInSeconds.  "Should be close to DT, but Delay can vary a bit."
		lastInterval > 0.0 ifFalse: ["e.g., at startup" lastInterval := DT].
      	measuredError1 := RenderingSetpoint - measuredValue1.
    		p1 := KPr * measuredError1.
		accumulatedError1 := measuredError1 * lastInterval + accumulatedError1
			"Don't let saturation 'wind up' the accumulator such that we have to work it off forever."
			min: 10*RenderingSetpoint max: 10*RenderingSetpoint negated. 
    		i1 := KIr * accumulatedError1.
		deltaError1 := measuredError1 - lastError1.
    		d1 := KDr * deltaError1 / lastInterval.
		pid1 := p1 + i1 + d1.
		"We don't seem to need anything fancier, such as open loop feedForward."

		"Second PID controller for a different performance criterion:"
		"measured round trip messages/second. Higher is better."
		latency := (stats2 subWindowOfDuration: 500) average.
		measuredValue2 := 1000.0 / (latency > 0.0 ifTrue: [latency] ifFalse: [500 "max"]) .  
      	measuredError2 := LatencySetpoint - measuredValue2.
    		p2 := KPl * measuredError2.
		accumulatedError2 := measuredError2 * lastInterval + accumulatedError2
				min: 10*LatencySetpoint max: 10*LatencySetpoint negated. 
    		i2 := KIl * accumulatedError2.
		deltaError2 := measuredError2 - lastError2.
    		d2 := KDl * deltaError2 / lastInterval.
		pid2 := p2 + i2 + d2.

		"Third controller. Traffic is non-zero only if one other subscriber, and then varies depending on
		how much the picture changes from frame to frame. Note that this means that increasing the interval
		between frames might not result in lower traffic, at least not in a linear reduction. That's ok, PID accepts
		that."
 		measuredValue3 := stats3 frameRate.  "need rate, not total, because Delay interval might vary from DT."
		measuredError3 := measuredValue3 - TrafficOutSetpoint. "Note reversed sign."
		p3 := KPt * measuredError3.
		accumulatedError3 := measuredError3 * lastInterval + accumulatedError3
				min: 10*TrafficOutSetpoint max: 10*TrafficOutSetpoint negated. 
    		i3 := KIt * accumulatedError3.
		deltaError3 := measuredError3 - lastError3.
    		d3 := KDt * deltaError3 / lastInterval.
		pid3 := p3 + i3 + d3.
 
    		controlledValue := ((pid1  max: pid2) max: pid3) min: MaxFrameInterval max: minFrameInterval.
		self frameInterval: controlledValue.
  		lastError1 := measuredError1.
  		lastError2 := measuredError2.
  		lastError3 := measuredError3.
 		"------ End of control code ------"

		Reporting = true "not nil either" ifTrue: [
			report := report, '
', (controlledValue roundTo: 1), '
    ', (self report: ' render' m: measuredValue1 e: measuredError1 eInt: accumulatedError1 eDer: deltaError1
		p: p1 i: i1 d: d1 pid: pid1), '
    ', (self report: 'latency' m: measuredValue2 e: measuredError2 eInt: accumulatedError2 eDer: deltaError2
		p: p2 i: i2 d: d2 pid: pid2), '
    ', (self report: 'traffic' m: measuredValue3 e: measuredError3 eInt: accumulatedError3 eDer: deltaError3
		p: p3 i: i3 d: d3 pid: pid3).

			reportCount := reportCount + 1.
			"Transcript output really messes with our frame rate, so don't do it often."
			(reportCount \\ 40) isZero ifTrue: [
				Transcript cr; show: report. 
				report := ''.
				5 timesRepeat: [delay wait]. "and when we do, stop controlling for a while."
				].
			].   "End of reporting."

		delay wait.
		].
	stats1 stopAllScripts.
	Transcript cr; show: 'End camera frame rate update.'.
! !

!QVideoCameraManager methodsFor: 'private' stamp: 'bgf 4/4/2009 15:58'!
encodeFrame: aForm

	watermark ifNotNil: [
		| pos |
		pos := aForm extent - watermark extent // 2.
		aForm copy: watermark boundingBox from: watermark to: pos rule: Form blend
	].
	encoder ifNotNil: [ encoder encode: aForm ].! !

!QVideoCameraManager methodsFor: 'actions' stamp: 'bgf 10/15/2009 16:27'!
endVideoChat

	state = #suspended ifTrue: [ ^self ]. "no double loops"

	"Status-status rather than info so it doesn't replace an info message from failed startup."
	view owner statusStatus: 'Turning off your camera'; waitTick.

	"Upload a preview that will be shown if no video stream is available."
	self uploadPreview.

	self destroy.
	self signal: #endedVideoChat.! !

!QVideoCameraManager methodsFor: 'private' stamp: 'bgf 8/18/2007 17:58'!
fetchAvatarCostume

	"Get the current replica costume far ref, or nil if it is not available for any reason;
	 returns a reference to a TAvatarProxy.  
	 All the guards cover cases like exit/disconnect/reconnect, mistiming under heavy load, and so on."
	view ifNil: [ ^ nil].
	view avatar ifNil: [ ^ nil ].
	view avatar replica ifNotNilDo: [ : rep |
		rep isValidFarRef ifTrue: [
			^ rep get: #costume
		].
	].
	^ nil.! !

!QVideoCameraManager methodsFor: 'private' stamp: 'jcg 9/14/2007 16:43'!
fetchAvatarReplica

	"Get the current replica far ref, or nil if it is not available for any reason;
	 returns a reference to a TAvatarProxy.  
	 All the guards cover cases like exit/disconnect/reconnect, mistiming under heavy load, and so on."
	view ifNil: [ ^ nil].
	view avatar ifNil: [ ^ nil ].
	view avatar replica ifNotNilDo: [ : rep |
		rep isValidFarRef ifTrue: [^rep].
	].
	^ nil.! !

!QVideoCameraManager methodsFor: 'accessing' stamp: 'bgf 11/10/2009 13:17'!
frameInterval: milliseconds
	"We can set fps on the fly without changing the videoSpec (which forms the initial value).
	New #videoSpec: messages will overrwrite.

	#doUpdateRate controls the frame rate using this method, and all the dynamic control stuff
	is designed with higher numbers indicating higher performance (i.e., higher 'output' or 'work product') 
	for both measured values and for controlled values."
	camera ifNotNil: [
		camera fps: 1000.0/milliseconds.
	].! !

!QVideoCameraManager methodsFor: 'actions' stamp: 'jcg 1/29/2008 10:05'!
frameRate
	^camera ifNotNil: [camera fps]! !

!QVideoCameraManager methodsFor: 'private' stamp: 'ar 9/3/2010 12:04'!
hashedUserLoginName
	"Hashed version of the username that the user logged into Forums with; used to locate the preview texture for the video stream."
	| login |
	login := self userLoginName ifNil: [^nil].
 	^ (SecureHashAlgorithm new hashStream: (ReadStream on: login squeakToUtf8)) radix:36! !

!QVideoCameraManager methodsFor: 'initialize' stamp: 'bgf 10/15/2009 16:27'!
initialize
	state := #initial.
	mutex := Mutex new.
	alreadyWarnedUser := false.
	! !

!QVideoCameraManager methodsFor: 'testing' stamp: 'jcg 9/12/2007 08:38'!
isChatting
	"We destroy the camera each time we stop chatting, so this is reasonable."
	^ camera notNil! !

!QVideoCameraManager methodsFor: 'accessing' stamp: 'jcg 8/10/2007 01:12'!
mediaController
	^ view session mediaController! !

!QVideoCameraManager methodsFor: 'dynamic control' stamp: 'bgf 11/7/2007 08:22'!
outboundBPS

	"For illustration: bytes/second outbound video in the past 3 seconds."

	^ (TTrafficCounter current outboundCountsFor: VideoTag) averageForInterval: 3! !

!QVideoCameraManager methodsFor: 'private' stamp: 'jcg 9/11/2007 15:55'!
pause
	camera stopRecording! !

!QVideoCameraManager methodsFor: 'private' stamp: 'jcg 2/21/2008 00:03'!
publicationConnected
	"Script run in response to #publicationConnected; see #beginPublication."
	mutex critical: [
		state := #connected.
		self updateAvatarWithVideo; showWebcamPane.
	]
! !

!QVideoCameraManager methodsFor: 'private' stamp: 'jcg 8/10/2007 16:08'!
publicationDestroyed
	"Script run in response to #publicationDestroyed; see #beginPublication."
	self destroy.! !

!QVideoCameraManager methodsFor: 'private' stamp: 'jcg 5/5/2008 11:46'!
qualitySettingString
	^view videoSession qualitySettingString! !

!QVideoCameraManager methodsFor: 'dynamic control' stamp: 'hrs 11/18/2007 16:31'!
report: aLabel m: measuredValue e: measuredError eInt: accumulatedError eDer: deltaError p: p i: i d: d pid: pid
	^aLabel, ':', (pid roundTo: 1), 
		'/ m=', (measuredValue roundTo: 0.1),
		' p=', (p roundTo: 1), ' (', (measuredError roundTo: 0.1),
		') i=', (i roundTo: 1), ' (', (accumulatedError roundTo: 1), 
		') d=', (d roundTo: 1), ' (', (deltaError roundTo: 0.1),
		')'! !

!QVideoCameraManager methodsFor: 'actions' stamp: 'jcg 2/25/2008 14:04'!
republishVideo
	"After media-controller reconnect."
	self isChatting ifFalse: [^self "we're not chatting... there's nothing to republish"].
	QLogger log: 'Republishing video after reconnect' from: self.	
	self destroy. "Don't use #endVideoChat... that will make us upload a grayscale image."
	self startVideoChat.! !

!QVideoCameraManager methodsFor: 'actions' stamp: 'hrs 4/8/2008 16:40'!
resumeVideo
	"Resume suspended video if any (e.g., #userBackFromAway)."
	state == #suspended ifTrue: [
		state := #initial.
		self startVideoChat.
		].! !

!QVideoCameraManager methodsFor: 'private' stamp: 'jcg 10/21/2008 10:57'!
sendFrame: bytes 
	| elapsed |

	"Put a timestamp on the frame.  Would be better to get the time closer to capturing the frame from the camera instead after encoding, but this is easier."
	startTime ifNil: [startTime := Time millisecondClockValue].
	elapsed := Time millisecondsSince: startTime.
	bytes networkUnsignedLongAt: 1 put: elapsed.
	
	stream sendMedia: bytes
! !

!QVideoCameraManager methodsFor: 'private' stamp: 'bgf 10/15/2009 15:04'!
setupCamera
	"Answer true for success, and false for failure."
	[
	camera := QWebcam new.
	camera fps: videoSpec fps.
	camera deviceUID: (self desiredDeviceUID).
	camera frameExtent: videoSpec extent] 
		on: Error 
		do: [:err |
			QLogger log: 'error setting up camera: ', err description from: self.
			Transcript cr; show: err signalerContext longStack.
			^false
		].

	"No need to hold on to the process to terminate it. It will die on its own when we stop
	chatting and set camera to nil."
	self fork: #doUpdateRate at: Processor userSchedulingPriority+1.

	^true! !

!QVideoCameraManager methodsFor: 'private' stamp: 'jcg 1/24/2012 00:29'!
setupEncoder
	"Answer true for success, and false for failure."
	| encoderClass |

	videoSpec usePlatformEndianness.
	encoderClass := self videoSession ifNotNilDo: [:vs | vs encoderClassFor: videoSpec codec].
	encoderClass ifNil: [
		QLogger logWarning: 'no encoder found for codec type: ', videoSpec codec.
		^false
	].

	"Create the encoder."
	[encoder := encoderClass withArgs: videoSpec extent: videoSpec extent] 
		on: Error 
		do: [:err |
			QLogger logWarning: 'failed to instantiate encoder (', err description, ')'.
		^false
	].
	encoder headerSize: 4. "leave room for header: just timestamp for now"

	"Hook it up to the camera."
	self runScript: #encodeFrame: when: {camera. #grabbedFrame}.
	self runScript: #sendFrame: when: {encoder. #encodedFrame}.

	^true! !

!QVideoCameraManager methodsFor: 'private' stamp: 'bgf 6/8/2008 18:55'!
showWebcamPane
	"We don't expect an error, but in the worst case we do nothing but log the error."
	[self view session owner showWebcamPane]
		on: Error
		do: [:err | QLogger logError: '#showWebcamPane: ', err description from: self]! !

!QVideoCameraManager methodsFor: 'actions' stamp: 'sn 3/4/2013 21:17'!
startVideoChat
	"Starts video, going to considerable lengths to ensure that we don't try to fire up video
	while it is in the process of being started. That's not easy. For example, the mutex is
	not enough because #beginPublication forks off some of the work."

	mutex critical: [
		self checkComputerPerformance.

		"Now everyone has webcam support, but it is watermarked unless you pay."
		view owner hasWebCamSupport
			ifTrue: [watermark := nil]
			ifFalse: [watermark := QForms find: 'openqwaq-logo-clear-70.png'].

		state == #initial ifFalse: [
			"Can only start from #initial state."
			^self
		].
		view owner statusInfo: 'Starting camera at 'translateMe, self qualitySettingString, ' quality.'; waitTick.
		(self setupCamera and: [self setupEncoder]) ifFalse: [
			"unsuccessful :-("
			view owner statusAlert: 'Camera could not be started.'translateMe; waitTick.
			^ self endVideoChat.
		].
		state := #publishing.
		view owner statusInfo: ((camera cameraName) ifNil: ['Camera']), 
							 ' started (', self qualitySettingString, ')'; waitTick.
		self signal: #startedVideoChat.
		self beginPublication.
	].
! !

!QVideoCameraManager methodsFor: 'actions' stamp: 'hrs 4/8/2008 16:39'!
suspendVideo
	"See #resumeVideo"
	state == #initial ifTrue: [^self].
	self endVideoChat.
	state := #suspended.
! !

!QVideoCameraManager methodsFor: 'actions' stamp: 'jcg 1/29/2008 10:05'!
targetFrameRate
	^videoSpec ifNotNil: [videoSpec fps]! !

!QVideoCameraManager methodsFor: 'hacking' stamp: 'jcg 2/20/2008 15:19'!
tokens
	"We pretend to be a QClientVideoTexture to keep our own video stream alive when transitioning between Forums.  See also #updateAvatarWithVideo and QWebcamPane>>onSpaceChange."
	^{'keepalive'}! !

!QVideoCameraManager methodsFor: 'private' stamp: 'jcg 10/21/2008 10:55'!
unpause
	startTime := nil.
	camera startRecording.! !

!QVideoCameraManager methodsFor: 'private' stamp: 'crl 12/17/2009 16:11'!
updateAvatarWithVideo
	"Avatar needs to be updated, either because the costume has changed, or because video has just started running."
	mutex critical: [
		| avatarCostume avatarReplica tex card desc |

		"If video isn't running then there's nothing to update."
		state == #connected ifFalse: [^self].

		avatarCostume := self fetchAvatarCostume.
		avatarReplica := self fetchAvatarReplica.
		avatarCostume ifNil: [^self endVideoChat "it was all for naught; there is no avatar"].

		"Create a description of the video-stream... we'll use this in two different ways."
		desc := QStreamingVideoV1FileCardContents new.
		desc
			initializeStreamID: stream streamID
			extent: videoSpec extent
			codec: videoSpec codec
			userName: self userLoginName.
			
		"In order to not disrupt our thumbnail in the QWebcamPane, we register ourselves as a fake client of the video stream."
		self videoSession webcastManager future
									addClient: self 
									of: desc streamID 
									description: desc 
									controller: self mediaController.

		"Create a texture to display the video on."
		tex := avatarCostume island future new: QWebcamTexture.
		tex future description: desc.

		"Install the texture and register the video-stream."
		avatarReplica future registerVideoStream: desc.
		avatarCostume future setVideoFace: tex.
	]
! !

!QVideoCameraManager methodsFor: 'hacking' stamp: 'sn 3/4/2013 21:14'!
uploadPreview
	| form byteStream data hashedLogin |

	camera ifNil: [
		QLogger log: 'could not upload preview: camera is nil'translateMe from: self.
		^self
	].
	hashedLogin := self hashedUserLoginName ifNil: [
		QLogger log: 'could not upload preview: cannot obtain hashed username from: self'.
		^self
	].

	(form := camera currentForm) ifNil: [^self "There is no form to upload"].
	form := QEmbeddedApp asTonedGray: form.
	byteStream := (ByteArray new: 32768) writeStream.
	JPEGReadWriter2 putForm: form onStream: byteStream.
	data := byteStream contents.

	view session 
			updateAppPreview: form 
			data: data 
			sha: hashedLogin 
			island: view activeIsland.
! !

!QVideoCameraManager methodsFor: 'private' stamp: 'jcg 2/14/2008 17:50'!
userLoginName
	"The username that the user logged into Forums with."
	^ [view owner userLogin] on: Error do: [nil]! !

!QVideoCameraManager methodsFor: 'accessing' stamp: 'jcg 9/10/2007 11:21'!
videoSession
	^ view ifNotNil: [view videoSession]! !

!QVideoCameraManager methodsFor: 'accessing' stamp: 'jcg 9/12/2007 12:12'!
videoSpec: newVideoSpec
	videoSpec := newVideoSpec.

	self isChatting ifTrue: [
		"It's easiest to completely restart the video-chat.  We use #destroy instead of #endVideoChat so as not to update the webcam-button in the control-bar."
		mutex critical: [self destroy; startVideoChat].
	]
	! !

!QVideoCameraManager methodsFor: 'accessing' stamp: 'jcg 8/9/2007 23:52'!
view
	^view! !

!QVideoCameraManager methodsFor: 'initialize' stamp: 'jcg 9/17/2007 14:40'!
view: aCroquetView
	| avatar |

	view == aCroquetView ifTrue: [^self "no change"].
	view ifNotNil: [
		"Haven't thought through the implications of switching view (which we never do, anyway)."
		self error: 'view already assigned'.
	].
	view := aCroquetView.
	
	"Whenever the avatar costume changes, we may need to update it if video is running."
	avatar := view avatar.
	avatar ifNil: [self error: 'avatar must not be nil when setting up QVideoCameraManager'].
	self startScript: #updateAvatarWithVideo when: {avatar. #costumeChanged}.! !

TObject subclass: #QVideoDecoder
	instanceVariableNames: 'handle extent formPool frameSemIndex frameSem callbackLoop callbackFrameCount mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-LowLevel'!

!QVideoDecoder commentStamp: '<historical>' prior: 0!
Pushes encoded video into a primitive (defined in subclasses).  When an encoded frame is ready, the plugin signals a semaphore that a Process in the decoder is blocked on, and the decoder then reads the decoded frame back from the plugin.

Maintains a pool of forms to decode into.  Whoever's using the decoder is responsible for sending #returnToFormPool to the form when finished with it (if they don't, it's OK... it just causes extra pressure on the garbage collector).!

!QVideoDecoder class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QVideoDecoder class methodsFor: 'accessing' stamp: 'jcg 5/30/2011 13:12'!
isAvailable
	[self dummyPrimitiveInvocation: 0] on: Error do: [^false].
	^true
 ! !

!QVideoDecoder class methodsFor: 'instance creation' stamp: 'jcg 8/6/2007 14:37'!
new
	"Use #withArgs: instead."
	self shouldNotImplement
	! !

!QVideoDecoder class methodsFor: 'instance creation' stamp: 'jcg 9/12/2007 12:06'!
withArgs: aQVideoArgs extent: videoExtent
	^ super new initializeWithArgs: aQVideoArgs extent: videoExtent; yourself! !

!QVideoDecoder methodsFor: 'private - form pool' stamp: 'jcg 2/13/2009 17:09'!
clearFormPool
	mutex critical: [formPool := OrderedCollection new].! !

!QVideoDecoder methodsFor: 'private - form pool' stamp: 'jcg 2/13/2009 17:32'!
createFormForPool
	"No form was available to read data back from the plugin, so create a new one."
	| form |
	form := QDecodedFrame extent: extent depth: 32.
	form decoder: self.
	^form! !

!QVideoDecoder methodsFor: 'decoding' stamp: 'jcg 9/4/2007 00:45'!
decode: bytes
	"We'll be notified via callback when the frame has been decoded."
	self decode: bytes offset: 0.! !

!QVideoDecoder methodsFor: 'decoding' stamp: 'jcg 4/10/2008 03:05'!
decode: bytes offset: offset
	"We'll be notified via callback when the frame has been decoded."
	handle ifNil: [^self].
	self 
		primitiveDecoder: handle 
		decodeFrame: bytes 
		ofSize: (bytes size - offset)
		offsetBy: offset! !

!QVideoDecoder methodsFor: 'initialize' stamp: 'bgf 10/22/2009 17:09'!
destroy
	self stopCallbackLoop.
	mutex critical: [
		handle ifNotNil: [
			| h |
			h := handle.
			handle := nil.
			self primitiveDestroyDecoder: h.
		].
		frameSemIndex ifNotNil: [
			frameSem signal. "so that #runCallbackLoop doesn't hang forever"
			frameSemIndex := nil.
			Smalltalk unregisterExternalObject: frameSem.
		].
		self clearFormPool.
	].! !

!QVideoDecoder methodsFor: 'private - form pool' stamp: 'jcg 2/13/2009 17:30'!
formFromPool
	"Answer a Form from the pool, or create a new one if none is available."
	mutex critical: [
		| form |
		^formPool 
			ifEmpty: [self createFormForPool]
			ifNotEmpty: [formPool removeLast].
	]! !

!QVideoDecoder methodsFor: 'testing' stamp: 'jcg 8/16/2007 11:07'!
hasValidHandle
	handle ifNil: [^false].
	^self primitiveDecoderIsValid: handle
	! !

!QVideoDecoder methodsFor: 'accessing' stamp: 'jcg 2/13/2009 16:57'!
height
	^ extent y! !

!QVideoDecoder methodsFor: 'initialize' stamp: 'bgf 3/21/2009 21:14'!
initialize
	super initialize.
	handle ifNotNil: [self error: 'handle already set'].

	callbackFrameCount := 0.

	mutex := Mutex new.
	frameSem := Semaphore new.
	frameSemIndex := Smalltalk registerExternalObject: frameSem.

	self clearFormPool.
	self startCallbackLoop.! !

!QVideoDecoder methodsFor: 'initialize' stamp: 'jcg 2/13/2009 16:57'!
initializeWithArgs: aQVideoArgs extent: videoExtent
	handle ifNotNil: [self error: 'handle already set'].
	extent = videoExtent ifFalse: [
		extent := videoExtent.
		self clearFormPool.
	].
	handle := self 
				primitiveCreateDecoder: aQVideoArgs
				semaphoreIndex: frameSemIndex
				width: videoExtent x
				height: videoExtent y.
! !

!QVideoDecoder methodsFor: 'primitives' stamp: 'bgf 10/9/2009 10:06'!
primitiveCreateDecoder: decoderArgs semaphoreIndex: semIndex width: width height: height
	" <primitive: 'primitiveCreateDecoder' module: 'QwaqMediaPlugin'> "
	self subclassResponsibility.! !

!QVideoDecoder methodsFor: 'primitives' stamp: 'bgf 10/9/2009 10:06'!
primitiveDecoder: decoderIndex decodeFrame: bytes ofSize: byteSize offsetBy: offset
	" <primitive: 'primitiveDecode' module: 'QwaqMediaPlugin'> "
	self subclassResponsibility.! !

!QVideoDecoder methodsFor: 'primitives' stamp: 'bgf 10/9/2009 10:06'!
primitiveDecoder: decoderIndex readIntoBitmap: bits
	" <primitive: 'primitiveDecoderReadIntoBitmap' module: 'QwaqMediaPlugin'> "
	self subclassResponsibility.! !

!QVideoDecoder methodsFor: 'primitives' stamp: 'bgf 10/9/2009 10:06'!
primitiveDecoderIsValid: decoderIndex
	"Answer true if the decoder handle is valid, and false otherwise."
	" <primitive: 'primitiveDecoderIsValid' module: 'QwaqMediaPlugin'> "
	self subclassResponsibility.! !

!QVideoDecoder methodsFor: 'primitives' stamp: 'bgf 10/9/2009 10:07'!
primitiveDestroyDecoder: decoderIndex
	" <primitive: 'primitiveDestroyDecoder' module: 'QwaqMediaPlugin'> "
	self subclassResponsibility.
! !

!QVideoDecoder methodsFor: 'private' stamp: 'jcg 2/13/2009 17:01'!
readCallbackData
	"Read a decompressed frame."
	mutex critical: [
		| bytesRead form |
		handle ifNil: [^self].
		form := self formFromPool.
		bytesRead := self readIntoForm: form.
	"	'frame decoded at	', RealTime millisecondClockValue displayAt: 600@45."
		self signal: #decodedFrame with: form.
	]! !

!QVideoDecoder methodsFor: 'private' stamp: 'jcg 2/13/2009 17:00'!
readIntoForm: aForm

	self flag: #todo.  "XXXX: Check for matching resolution/depth."

	self primitiveDecoder: handle readIntoBitmap: aForm bits! !

!QVideoDecoder methodsFor: 'private - form pool' stamp: 'jcg 2/13/2009 17:32'!
returnFormToPool: aForm
	"Return the form to the pool for re-use (ensure that it has the right extent... something might have changed since it was created)."
	mutex critical: [
		aForm extent = extent ifTrue: [formPool addLast: aForm]
	]! !

!QVideoDecoder methodsFor: 'callback loop' stamp: 'jcg 2/3/2009 12:01'!
runCallbackLoop

	[
		frameSem wait.
		handle ifNil: [^self "must have been destroyed"].
		callbackFrameCount := callbackFrameCount + 1.
		"XXXX: we should probably check for dropped frames here."
		self readCallbackData.
	] doWhileTrue: [Processor activeProcess == callbackLoop].
! !

!QVideoDecoder methodsFor: 'callback loop' stamp: 'jcg 8/6/2007 14:35'!
startCallbackLoop
	self stopCallbackLoop.
	callbackLoop := self fork: #runCallbackLoop at: Processor lowIOPriority.! !

!QVideoDecoder methodsFor: 'callback loop' stamp: 'jcg 8/6/2007 14:35'!
stopCallbackLoop
	callbackLoop := nil "it will stop itself"! !

!QVideoDecoder methodsFor: 'accessing' stamp: 'jcg 2/13/2009 16:57'!
width
	^extent x! !

QVideoDecoder subclass: #QVideoDecoderFree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-LowLevel'!

!QVideoDecoderFree class methodsFor: 'plugin interface' stamp: 'jcg 5/30/2011 13:25'!
dummyPrimitiveInvocation: ignoredInteger
	"Answer true if the decoder handle is valid, and false otherwise."
	<primitive: 'primitiveDecoderIsValid' module: 'QVideoCodecPluginFree'>
	self primitiveFailed! !

!QVideoDecoderFree class methodsFor: 'plugin interface' stamp: 'jcg 7/26/2011 23:37'!
setErrorLog: fileName
	"Errors/info will be logged to the specified filename in the VM directory (or stderr if an empty filename is specified)."
	QVideoEncoderFree setErrorLog: fileName! !

!QVideoDecoderFree class methodsFor: 'accessing' stamp: 'jcg 6/16/2011 02:19'!
supportedCodecs
	^#('avc1')! !

!QVideoDecoderFree methodsFor: 'private - form pool' stamp: 'jcg 6/16/2011 02:08'!
createFormForPool
	"No form was available to read data back from the plugin, so create a new one.  Unlike the superclass, no metadata will also be read back from the plugin."
	^ super createFormForPool
					! !

!QVideoDecoderFree methodsFor: 'decoding' stamp: 'jcg 7/27/2011 01:06'!
flush
	"Flush out existing data."
	self decode: (ByteArray new: 0)! !

!QVideoDecoderFree methodsFor: 'primitives' stamp: 'jcg 6/14/2011 23:34'!
primitiveCreateDecoder: decoderArgs semaphoreIndex: semIndex width: width height: height
	<primitive: 'primitiveCreateDecoder' module: 'QVideoCodecPluginFree'>
	self primitiveFailed! !

!QVideoDecoderFree methodsFor: 'primitives' stamp: 'jcg 6/14/2011 23:34'!
primitiveDecoder: decoderIndex decodeFrame: bytes ofSize: byteSize offsetBy: offset
	<primitive: 'primitiveDecode' module: 'QVideoCodecPluginFree'>
	self primitiveFailed! !

!QVideoDecoderFree methodsFor: 'primitives' stamp: 'jcg 6/14/2011 23:34'!
primitiveDecoder: decoderIndex readIntoBitmap: bits
	<primitive: 'primitiveDecoderReadIntoBitmap' module: 'QVideoCodecPluginFree'>
	self primitiveFailed! !

!QVideoDecoderFree methodsFor: 'primitives' stamp: 'jcg 6/14/2011 23:34'!
primitiveDecoder: decoderIndex readIntoBitmap: bits metadata: bytes
	<primitive: 'primitiveDecoderReadIntoBitmapAndMetadata' module: 'QVideoCodecPluginFree'>
	self primitiveFailed! !

!QVideoDecoderFree methodsFor: 'primitives' stamp: 'jcg 6/14/2011 23:35'!
primitiveDecoderIsValid: decoderIndex
	"Answer true if the decoder handle is valid, and false otherwise."
	<primitive: 'primitiveDecoderIsValid' module: 'QVideoCodecPluginFree'>
	self primitiveFailed! !

!QVideoDecoderFree methodsFor: 'primitives' stamp: 'jcg 6/14/2011 23:35'!
primitiveDestroyDecoder: decoderIndex
	<primitive: 'primitiveDestroyDecoder' module: 'QVideoCodecPluginFree'>
	self primitiveFailed
! !

QVideoDecoder subclass: #QVideoDecoderMC
	instanceVariableNames: ''
	classVariableNames: 'LastFrameTime ThrottleMutex'
	poolDictionaries: ''
	category: 'Qwaq-Video-LowLevel'!

!QVideoDecoderMC commentStamp: '<historical>' prior: 0!
Uses QVideoCodecPluginMC instead of QwaqMediaPlugin.!

!QVideoDecoderMC class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QVideoDecoderMC class methodsFor: 'plugin interface' stamp: 'jcg 11/24/2007 15:08'!
dummyPrimitiveInvocation: ignoredInteger
	"Answer true if the decoder handle is valid, and false otherwise."
	<primitive: 'primitiveDecoderIsValid' module: 'QVideoCodecPluginMC'>
	self primitiveFailed! !

!QVideoDecoderMC class methodsFor: 'class initialization' stamp: 'bgf 10/22/2009 15:30'!
initialize
	ThrottleMutex := Mutex new! !

!QVideoDecoderMC class methodsFor: 'flow control' stamp: 'bgf 10/23/2009 17:40'!
minFrameIntervalMilliseconds
	"The minimum clock interval between successive decode-frame calls;
	 imposed to prevent flooding the main-concept layer with frames
	 after other blocking delays, so we don't overwhelm its buggy worker-thread management."

	"This is global across decoders (should be at most 3, one for cam, and for session-capture).
	 The rate allowed is much higher than any live frame rate we'd push through,
	 this just prevents back-to-back calls into MC"
	^ 3! !

!QVideoDecoderMC class methodsFor: 'plugin interface' stamp: 'jcg 1/31/2009 11:58'!
setErrorLog: fileName
	"Errors/info will be logged to the specified filename in the VM directory (or stderr if an empty filename is specified)."
	QVideoEncoderMC setErrorLog: fileName! !

!QVideoDecoderMC class methodsFor: 'accessing' stamp: 'jcg 11/24/2007 15:06'!
supportedCodecs
	^#('avc1')! !

!QVideoDecoderMC class methodsFor: 'flow control' stamp: 'bgf 5/19/2010 12:38'!
throttleForFrame

	"Blocking  call to throttle the absolute rate at which we call the encoding primitive."
	self throttleMutex critical: [
		| gap t |
		LastFrameTime ifNil: [
			LastFrameTime := Time millisecondClockValue.
			^ self 
		].

		(gap := (Time milliseconds: (t := Time millisecondClockValue) since: LastFrameTime))  
		< (self minFrameIntervalMilliseconds)
		 ifTrue: [
			QLogger logInfo: 'Throttling decoder.' every: 120000.
			(Delay forMilliseconds: (self minFrameIntervalMilliseconds)-gap) wait.
		].
		LastFrameTime := t
	].
! !

!QVideoDecoderMC class methodsFor: 'flow control' stamp: 'bgf 10/22/2009 15:42'!
throttleMutex
	"For the all-Decoders flow throttle, see allowNextFrame"
	ThrottleMutex ifNil: [ ThrottleMutex := Mutex new ].
	^ ThrottleMutex! !

!QVideoDecoderMC methodsFor: 'private - form pool' stamp: 'jcg 2/13/2009 17:33'!
createFormForPool
	"No form was available to read data back from the plugin, so create a new one.  Its metadata will also be read back from the plugin."
	^ super createFormForPool
							metadata: QDecodedFrameMetadataMC new;
							yourself! !

!QVideoDecoderMC methodsFor: 'decoding' stamp: 'bgf 10/22/2009 20:21'!
decode: bytes offset: offset
	"We'll be notified via callback when the frame has been decoded.
	 Adds global frequency throttle to the base version."
	self class throttleForFrame.
	mutex critical: [
		handle ifNil: [^self].
		self 
			primitiveDecoder: handle 
			decodeFrame: bytes 
			ofSize: (bytes size - offset)
			offsetBy: offset
	].! !

!QVideoDecoderMC methodsFor: 'decoding' stamp: 'jcg 2/3/2009 01:16'!
flush
	"Flush out existing data."
	self decode: (ByteArray new: 0)! !

!QVideoDecoderMC methodsFor: 'primitives' stamp: 'jcg 11/20/2007 13:54'!
primitiveCreateDecoder: decoderArgs semaphoreIndex: semIndex width: width height: height
	<primitive: 'primitiveCreateDecoder' module: 'QVideoCodecPluginMC'>
	self primitiveFailed! !

!QVideoDecoderMC methodsFor: 'primitives' stamp: 'jcg 11/20/2007 13:54'!
primitiveDecoder: decoderIndex decodeFrame: bytes ofSize: byteSize offsetBy: offset
	<primitive: 'primitiveDecode' module: 'QVideoCodecPluginMC'>
	self primitiveFailed! !

!QVideoDecoderMC methodsFor: 'primitives' stamp: 'jcg 11/20/2007 13:55'!
primitiveDecoder: decoderIndex readIntoBitmap: bits
	<primitive: 'primitiveDecoderReadIntoBitmap' module: 'QVideoCodecPluginMC'>
	self primitiveFailed! !

!QVideoDecoderMC methodsFor: 'primitives' stamp: 'jcg 1/31/2009 14:48'!
primitiveDecoder: decoderIndex readIntoBitmap: bits metadata: bytes
	<primitive: 'primitiveDecoderReadIntoBitmapAndMetadata' module: 'QVideoCodecPluginMC'>
	self primitiveFailed! !

!QVideoDecoderMC methodsFor: 'primitives' stamp: 'jcg 11/20/2007 13:54'!
primitiveDecoderIsValid: decoderIndex
	"Answer true if the decoder handle is valid, and false otherwise."
	<primitive: 'primitiveDecoderIsValid' module: 'QVideoCodecPluginMC'>
	self primitiveFailed! !

!QVideoDecoderMC methodsFor: 'primitives' stamp: 'jcg 11/20/2007 13:55'!
primitiveDestroyDecoder: decoderIndex
	<primitive: 'primitiveDestroyDecoder' module: 'QVideoCodecPluginMC'>
	self primitiveFailed
! !

!QVideoDecoderMC methodsFor: 'private' stamp: 'jcg 2/13/2009 17:00'!
readIntoForm: aForm

	self 
		primitiveDecoder: handle
		readIntoBitmap: aForm bits 
		metadata: aForm metadata getHandle.

	false ifTrue: [
		| x y |
		x := 500.
		y := 0.
		'FRAME METADATA' displayAt: x@y.
		QDecodedFrameMetadataMC fields do: [:pair |
			y := y + 20.
			'        ', pair first, ':  ', (aForm metadata perform: pair first), '       ' displayAt: x@y
		]
	]! !

QVideoDecoder subclass: #QVideoDecoderQT
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-LowLevel'!

!QVideoDecoderQT commentStamp: '<historical>' prior: 0!
Uses QVideoCodecPluginQT (a Quicktime implementation).
Unused, no longer part of our assembly.!

!QVideoDecoderQT class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QVideoDecoderQT class methodsFor: 'plugin interface' stamp: 'jcg 11/24/2007 14:50'!
dummyPrimitiveInvocation: ignoredInteger
	"Answer true if the decoder handle is valid, and false otherwise."
	<primitive: 'primitiveDecoderIsValid' module: 'QVideoCodecPluginQT'>
	self primitiveFailed! !

!QVideoDecoderQT class methodsFor: 'plugin interface' stamp: 'jcg 1/31/2009 11:58'!
setErrorLog: fileName
	"Errors/info will be logged to the specified filename in the VM directory (or stderr if an empty filename is specified)."
	QVideoEncoderQT setErrorLog: fileName! !

!QVideoDecoderQT class methodsFor: 'accessing' stamp: 'jcg 11/25/2007 11:59'!
supportedCodecs
	^#('jpeg' 'h261' 'h263')! !

!QVideoDecoderQT methodsFor: 'primitives' stamp: 'jcg 11/15/2007 14:56'!
primitiveCreateDecoder: decoderArgs semaphoreIndex: semIndex width: width height: height
	<primitive: 'primitiveCreateDecoder' module: 'QVideoCodecPluginQT'>
	self primitiveFailed! !

!QVideoDecoderQT methodsFor: 'primitives' stamp: 'jcg 11/15/2007 14:55'!
primitiveDecoder: decoderIndex decodeFrame: bytes ofSize: byteSize offsetBy: offset
	<primitive: 'primitiveDecode' module: 'QVideoCodecPluginQT'>
	self primitiveFailed! !

!QVideoDecoderQT methodsFor: 'primitives' stamp: 'jcg 11/15/2007 14:55'!
primitiveDecoder: decoderIndex readIntoBitmap: bits
	<primitive: 'primitiveDecoderReadIntoBitmap' module: 'QVideoCodecPluginQT'>
	self primitiveFailed! !

!QVideoDecoderQT methodsFor: 'primitives' stamp: 'jcg 11/15/2007 14:56'!
primitiveDecoderIsValid: decoderIndex
	"Answer true if the decoder handle is valid, and false otherwise."
	<primitive: 'primitiveDecoderIsValid' module: 'QVideoCodecPluginQT'>
	self primitiveFailed! !

!QVideoDecoderQT methodsFor: 'primitives' stamp: 'jcg 11/15/2007 14:55'!
primitiveDestroyDecoder: decoderIndex
	<primitive: 'primitiveDestroyDecoder' module: 'QVideoCodecPluginQT'>
	self primitiveFailed
! !

!QVideoDecoderQT methodsFor: 'primitives' stamp: 'bgf 10/9/2009 10:04'!
primitiveEncoder: encoderIndex getProperty: propertyName
	<primitive: 'primitiveEncoderGetProperty' module: 'QVideoCodecPluginQT'>
	self primitiveFailed
! !

TObject subclass: #QVideoEncoder
	instanceVariableNames: 'handle buffer extent frameSemIndex frameSem callbackLoop callbackFrameCount maxFrameSize mutex headerSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-LowLevel'!

!QVideoEncoder class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QVideoEncoder class methodsFor: 'instance creation' stamp: 'jcg 8/5/2007 17:35'!
new
	"Use #withArgs: instead."
	self shouldNotImplement
	! !

!QVideoEncoder class methodsFor: 'instance creation' stamp: 'jcg 9/12/2007 11:09'!
withArgs: aQVideoArgs extent: extent
	^ super new initializeWithArgs: aQVideoArgs extent: extent; yourself! !

!QVideoEncoder methodsFor: 'initialize' stamp: 'bgf 10/22/2009 17:03'!
destroy
	self stopCallbackLoop.
	mutex critical: [
		handle ifNotNil: [
			| h |
			h := handle.
			handle := nil.
			self primitiveDestroyEncoder: h.
		].
		frameSemIndex ifNotNil: [
			frameSem signal. "so that #runCallbackLoop doesn't hang forever"
			frameSemIndex := nil.
			Smalltalk unregisterExternalObject: frameSem.
		].
	].! !

!QVideoEncoder methodsFor: 'private' stamp: 'jcg 6/10/2008 08:49'!
determineIfKeyframe: buf bytesRead: bytesRead
	| isKeyframe |
	"Manually compute whether we think that this is a keyframe (since QuickTime's API tells us that the frame type is unknown)."
	isKeyframe := (maxFrameSize // bytesRead) > 4.
	buf at: 1 put: (isKeyframe ifTrue: [1] ifFalse: [0]).! !

!QVideoEncoder methodsFor: 'callback loop' stamp: 'jcg 12/19/2007 12:43'!
encode: aForm
	"We'll be notified via callback when the frame has been encoded."
	handle ifNil: [^self].
	self primitiveEncoder: handle encodeBitmap: aForm bits! !

!QVideoEncoder methodsFor: 'accessing' stamp: 'jcg 5/26/2009 11:20'!
getProperty: propertyName "a String"
	"Get a property from the codec-code in the plugin.  Different property names may be supported by different codecs.  Answer a ByteArray, or nil if the property isn't available."
	^ self primitiveEncoder: handle getProperty: propertyName! !

!QVideoEncoder methodsFor: 'testing' stamp: 'jcg 8/16/2007 11:09'!
hasValidHandle
	handle ifNil: [^false].
	^self primitiveEncoderIsValid: handle
	! !

!QVideoEncoder methodsFor: 'accessing' stamp: 'jcg 10/21/2008 10:27'!
headerSize
	"Specify the amount of unused space at the beginning of each encoded frame... users of QVideoEncoder can fill it with whatever information they wish before eg: sending it out on the network."
	^headerSize! !

!QVideoEncoder methodsFor: 'accessing' stamp: 'jcg 10/21/2008 10:27'!
headerSize: hdrSz
	"Specify the amount of unused space at the beginning of each encoded frame... users of QVideoEncoder can fill it with whatever information they wish before eg: sending it out on the network."
	headerSize := hdrSz! !

!QVideoEncoder methodsFor: 'initialize' stamp: 'bgf 3/21/2009 21:14'!
initialize
	super initialize.

	extent := 352@288.
	buffer := ByteArray new: (extent area * 4). "way more than enough space for encoded frames"

	mutex := Mutex new.
	frameSem := Semaphore new.
	frameSemIndex := Smalltalk registerExternalObject: frameSem.

	maxFrameSize := 0.
	callbackFrameCount := 0.
	headerSize := 0.

	self startCallbackLoop.! !

!QVideoEncoder methodsFor: 'initialize' stamp: 'jcg 5/31/2011 01:38'!
initializeWithArgs: aQVideoArgs extent: videoExtent
	handle ifNotNil: [self error: 'handle already set'].
	extent := videoExtent.
	handle := self 
				primitiveCreateEncoder: aQVideoArgs
				semaphoreIndex: frameSemIndex
				width: extent x
				height: extent y.
	handle < 0 ifTrue: [
		| errCode |
		errCode := handle.
		handle := nil.
		self error: 'encoder creation failed with code: ', errCode
	]
! !

!QVideoEncoder methodsFor: 'primitives' stamp: 'bgf 10/9/2009 10:07'!
primitiveCreateEncoder: encoderArgs semaphoreIndex: semIndex width: width height: height
	" <primitive: 'primitiveCreateEncoder' module: 'QwaqMediaPlugin'> "
	self subclassResponsibility.! !

!QVideoEncoder methodsFor: 'primitives' stamp: 'bgf 10/9/2009 10:07'!
primitiveDestroyEncoder: encoderIndex
	" <primitive: 'primitiveDestroyEncoder' module: 'QwaqMediaPlugin'> "
	self subclassResponsibility.
! !

!QVideoEncoder methodsFor: 'primitives' stamp: 'bgf 10/9/2009 10:07'!
primitiveEncoder: encoderIndex encodeBitmap: bits
	" <primitive: 'primitiveEncode' module: 'QwaqMediaPlugin'> "
	self subclassResponsibility.
! !

!QVideoEncoder methodsFor: 'primitives' stamp: 'bgf 10/9/2009 10:07'!
primitiveEncoder: encoderIndex getProperty: propertyName
	" <primitive: 'primitiveEncoderGetProperty' module: 'QwaqMediaPlugin'> "
	self subclassResponsibility.! !

!QVideoEncoder methodsFor: 'primitives' stamp: 'bgf 10/9/2009 10:05'!
primitiveEncoder: encoderIndex readIntoBytes: bytes ofSize: byteSize
	" <primitive: 'primitiveEncoderReadIntoBytes' module: 'QwaqMediaPlugin'> "
	self subclassResponsibility.
	
! !

!QVideoEncoder methodsFor: 'primitives' stamp: 'bgf 10/9/2009 10:07'!
primitiveEncoderIsValid: encoderIndex
	"Answer true if the encoder handle is valid, and false otherwise."
	" <primitive: 'primitiveEncoderIsValid' module: 'QwaqMediaPlugin'> "
	self subclassResponsibility.! !

!QVideoEncoder methodsFor: 'private' stamp: 'jcg 10/21/2008 10:36'!
readCallbackData
	"Read a compressed frame back from the plugin."
	mutex critical: [
		| bytesRead result |
		handle ifNil: [^self].
		bytesRead := self readIntoByteArray: buffer.
		bytesRead = 0 ifTrue: [^QLogger log: 'encoder read 0 byte buffer' from: self "WTF?"].

		maxFrameSize := maxFrameSize max: bytesRead.
		self determineIfKeyframe: buffer bytesRead: bytesRead.

	"	'is keyframe: ', isKeyframe, '                ' displayAt: 400@100."
	"	'frame encoded at	', RealTime millisecondClockValue displayAt: 600@30."

		"Answer only the encoded bytes, not the whole buffer (copying <= 10kB/sec is no big deal)."
		result := ByteArray new: bytesRead + headerSize.
		result replaceFrom: headerSize+1 to: result size with: buffer startingAt: 1.
		self signal: #encodedFrame with: result.
	]
! !

!QVideoEncoder methodsFor: 'private' stamp: 'jcg 8/16/2007 11:10'!
readIntoByteArray: aByteArray
	^ self 
		primitiveEncoder: handle 
		readIntoBytes: aByteArray 
		ofSize: aByteArray size! !

!QVideoEncoder methodsFor: 'callback loop' stamp: 'jcg 2/3/2009 12:03'!
runCallbackLoop

	[
		frameSem wait.
		handle ifNil: [^self "must have been destroyed"].
		callbackFrameCount := callbackFrameCount + 1.
		"XXXX: we should probably check for dropped frames here."
		self readCallbackData.
	] doWhileTrue: [Processor activeProcess == callbackLoop].
! !

!QVideoEncoder methodsFor: 'callback loop' stamp: 'jcg 8/6/2007 00:55'!
startCallbackLoop
	self stopCallbackLoop.
	callbackLoop := self fork: #runCallbackLoop at: Processor lowIOPriority.! !

!QVideoEncoder methodsFor: 'callback loop' stamp: 'jcg 8/6/2007 01:00'!
stopCallbackLoop
	callbackLoop := nil "it will stop itself"! !

QVideoEncoder subclass: #QVideoEncoderMC
	instanceVariableNames: ''
	classVariableNames: 'LastFrameTime ThrottleMutex'
	poolDictionaries: ''
	category: 'Qwaq-Video-LowLevel'!

QVideoEncoderMC subclass: #QVideoEncoderFree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-LowLevel'!

!QVideoEncoderFree class methodsFor: 'plugin interface' stamp: 'jcg 5/31/2011 01:31'!
dummyPrimitiveInvocation: ignoredInteger
	"Answer true if the decoder handle is valid, and false otherwise."
	<primitive: 'primitiveEncoderIsValid' module: 'QVideoCodecPluginFree'>
	self primitiveFailed! !

!QVideoEncoderFree class methodsFor: 'plugin interface' stamp: 'jcg 7/4/2011 21:20'!
primLogMsg: msgString
	"Allows us to log to the current plugin log-file (typically QVideoCodecPluginFree.log)."
	<primitive: 'primitiveLogMsg' module: 'QVideoCodecPluginFree'>
	^self primitiveFailed! !

!QVideoEncoderFree class methodsFor: 'plugin interface' stamp: 'jcg 5/31/2011 01:32'!
setErrorLog: fileName
	"Errors/info will be logged to the specified filename in the VM directory (or stderr if an empty filename is specified)."
	<primitive: 'primitiveSetLogFile' module: 'QVideoCodecPluginFree'>
	self primitiveFailed! !

!QVideoEncoderFree methodsFor: 'primitives' stamp: 'jcg 5/31/2011 01:20'!
primitiveCreateEncoder: encoderArgs semaphoreIndex: semIndex width: width height: height
	<primitive: 'primitiveCreateEncoder' module: 'QVideoCodecPluginFree'>
	self primitiveFailed
! !

!QVideoEncoderFree methodsFor: 'primitives' stamp: 'jcg 5/31/2011 01:20'!
primitiveDestroyEncoder: encoderIndex
	<primitive: 'primitiveDestroyEncoder' module: 'QVideoCodecPluginFree'>
	self primitiveFailed
! !

!QVideoEncoderFree methodsFor: 'primitives' stamp: 'jcg 5/31/2011 01:21'!
primitiveEncoder: encoderIndex encodeBitmap: bits
	<primitive: 'primitiveEncode' module: 'QVideoCodecPluginFree'>
	self primitiveFailed
! !

!QVideoEncoderFree methodsFor: 'primitives' stamp: 'jcg 5/31/2011 01:21'!
primitiveEncoder: encoderIndex getProperty: propertyName
	<primitive: 'primitiveEncoderGetProperty' module: 'QVideoCodecPluginFree'>
	self primitiveFailed
! !

!QVideoEncoderFree methodsFor: 'primitives' stamp: 'jcg 5/31/2011 01:21'!
primitiveEncoder: encoderIndex readIntoBytes: bytes ofSize: byteSize
	<primitive: 'primitiveEncoderReadIntoBytes' module: 'QVideoCodecPluginFree'>
	self primitiveFailed
! !

!QVideoEncoderFree methodsFor: 'primitives' stamp: 'jcg 5/31/2011 01:21'!
primitiveEncoderIsValid: encoderIndex
	"Answer true if the encoder handle is valid, and false otherwise."
	<primitive: 'primitiveEncoderIsValid' module: 'QVideoCodecPluginFree'>
	self primitiveFailed! !

!QVideoEncoderMC class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QVideoEncoderMC class methodsFor: 'plugin interface' stamp: 'jcg 11/24/2007 15:09'!
dummyPrimitiveInvocation: ignoredInteger
	"Answer true if the decoder handle is valid, and false otherwise."
	<primitive: 'primitiveEncoderIsValid' module: 'QVideoCodecPluginMC'>
	self primitiveFailed! !

!QVideoEncoderMC class methodsFor: 'class initialization' stamp: 'bgf 10/22/2009 15:30'!
initialize
	ThrottleMutex := Mutex new! !

!QVideoEncoderMC class methodsFor: 'accessing' stamp: 'jcg 11/24/2007 15:07'!
isAvailable
	[self dummyPrimitiveInvocation: 0] on: Error do: [^false].
	^true
 ! !

!QVideoEncoderMC class methodsFor: 'flow control' stamp: 'bgf 10/22/2009 20:20'!
minFrameIntervalMilliseconds
	"The minimum clock interval between successive encode-frame calls;
	 imposed to prevent flooding the main-concept layer with frames
	 after other blocking delays, so we don't overwhelm its buggy worker-thread management."

	"This is global across encoders (should be at most 3, one for cam, and for session-capture).
	 The rate allowed is much higher than any live frame rate we'd push through,
	 this just prevents back-to-back calls into MC"
	^ 5! !

!QVideoEncoderMC class methodsFor: 'plugin interface' stamp: 'jcg 7/4/2011 21:20'!
primLogMsg: msgString
	"Allows us to log to the current plugin log-file (typically QVideoCodecPluginMC.log)."
	<primitive: 'primitiveLogMsg' module: 'QVideoCodecPluginMC'>
	^self primitiveFailed! !

!QVideoEncoderMC class methodsFor: 'plugin interface' stamp: 'jcg 1/31/2009 11:57'!
setErrorLog: fileName
	"Errors/info will be logged to the specified filename in the VM directory (or stderr if an empty filename is specified)."
	<primitive: 'primitiveSetLogFile' module: 'QVideoCodecPluginMC'>
	self primitiveFailed! !

!QVideoEncoderMC class methodsFor: 'accessing' stamp: 'jcg 11/24/2007 15:07'!
supportedCodecs
	^#('avc1')! !

!QVideoEncoderMC class methodsFor: 'flow control' stamp: 'bgf 5/19/2010 12:38'!
throttleForFrame
	"Blocking  call to throttle the absolute rate at which we call the encoding primitive."
	self throttleMutex critical: [
		| gap t |
		LastFrameTime ifNil: [
			LastFrameTime := Time millisecondClockValue.
			^ self 
		].

		(gap := (Time milliseconds: (t := Time millisecondClockValue) since: LastFrameTime))  
		< (self minFrameIntervalMilliseconds)
		 ifTrue: [
			QLogger logInfo: 'Throttling encoder.' every: 120000.
			(Delay forMilliseconds: (self minFrameIntervalMilliseconds)-gap) wait.
		].
		LastFrameTime := t
	].
! !

!QVideoEncoderMC class methodsFor: 'flow control' stamp: 'bgf 10/22/2009 15:42'!
throttleMutex
	"For the all-encoders flow throttle, see allowNextFrame"
	ThrottleMutex ifNil: [ ThrottleMutex := Mutex new ].
	^ ThrottleMutex! !

!QVideoEncoderMC methodsFor: 'accessing' stamp: 'jcg 10/19/2009 08:32'!
decoderConfigurationRecord
	"Answer an AVCDecoderConfigurationRecord."
	| avc |
	avc := AVCDecoderConfigurationRecord new.
	avc initializeFromParameterSets: self parameterSets.
	avc nalUnitSize: 4.
	^avc! !

!QVideoEncoderMC methodsFor: 'private' stamp: 'jcg 6/10/2008 08:49'!
determineIfKeyframe: buf bytesRead: bytesRead
	"Do nothing; the plugin correctly detects whether a frame is a keyframe or not."! !

!QVideoEncoderMC methodsFor: 'callback loop' stamp: 'bgf 10/22/2009 20:22'!
encode: aForm
	"We'll be notified via callback when the frame has been encoded."
	self class throttleForFrame.
	mutex critical: [
		handle ifNil: [^self].
		self primitiveEncoder: handle encodeBitmap: aForm bits
	].! !

!QVideoEncoderMC methodsFor: 'accessing' stamp: 'jcg 5/26/2009 11:22'!
parameterSets
	"Answer the picture/sequence-parameter sets for this codec."
	^self getProperty: 'PARAMETER_SETS'! !

!QVideoEncoderMC methodsFor: 'primitives' stamp: 'jcg 11/20/2007 13:56'!
primitiveCreateEncoder: encoderArgs semaphoreIndex: semIndex width: width height: height
	<primitive: 'primitiveCreateEncoder' module: 'QVideoCodecPluginMC'>
	self primitiveFailed
! !

!QVideoEncoderMC methodsFor: 'primitives' stamp: 'jcg 11/20/2007 13:56'!
primitiveDestroyEncoder: encoderIndex
	<primitive: 'primitiveDestroyEncoder' module: 'QVideoCodecPluginMC'>
	self primitiveFailed
! !

!QVideoEncoderMC methodsFor: 'primitives' stamp: 'jcg 11/20/2007 13:56'!
primitiveEncoder: encoderIndex encodeBitmap: bits
	<primitive: 'primitiveEncode' module: 'QVideoCodecPluginMC'>
	self primitiveFailed
! !

!QVideoEncoderMC methodsFor: 'primitives' stamp: 'jcg 5/8/2009 16:28'!
primitiveEncoder: encoderIndex getProperty: propertyName
	<primitive: 'primitiveEncoderGetProperty' module: 'QVideoCodecPluginMC'>
	self primitiveFailed
! !

!QVideoEncoderMC methodsFor: 'primitives' stamp: 'jcg 11/20/2007 13:56'!
primitiveEncoder: encoderIndex readIntoBytes: bytes ofSize: byteSize
	<primitive: 'primitiveEncoderReadIntoBytes' module: 'QVideoCodecPluginMC'>
	self primitiveFailed
! !

!QVideoEncoderMC methodsFor: 'primitives' stamp: 'jcg 11/20/2007 13:56'!
primitiveEncoderIsValid: encoderIndex
	"Answer true if the encoder handle is valid, and false otherwise."
	<primitive: 'primitiveEncoderIsValid' module: 'QVideoCodecPluginMC'>
	self primitiveFailed! !

QVideoEncoder subclass: #QVideoEncoderQT
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-LowLevel'!

!QVideoEncoderQT commentStamp: '<historical>' prior: 0!
Uses QVideoCodecPluginQT (a Quicktime implementation).
Unused, no longer part of our assembly.!

!QVideoEncoderQT class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QVideoEncoderQT class methodsFor: 'plugin interface' stamp: 'jcg 11/24/2007 15:08'!
dummyPrimitiveInvocation: ignoredInteger
	"Answer true if the decoder handle is valid, and false otherwise."
	<primitive: 'primitiveEncoderIsValid' module: 'QVideoCodecPluginQT'>
	self primitiveFailed! !

!QVideoEncoderQT class methodsFor: 'accessing' stamp: 'jcg 11/24/2007 15:07'!
isAvailable
	[self dummyPrimitiveInvocation: 0] on: Error do: [^false].
	^true
 ! !

!QVideoEncoderQT class methodsFor: 'plugin interface' stamp: 'jcg 1/30/2009 16:10'!
setErrorLog: fileName
	"Errors/info will be logged to the specified filename in the VM directory (or stderr if an empty filename is specified)."
	<primitive: 'primitiveSetLogFile' module: 'QVideoCodecPluginQT'>
	self primitiveFailed! !

!QVideoEncoderQT class methodsFor: 'accessing' stamp: 'jcg 11/25/2007 11:59'!
supportedCodecs
	^#('jpeg' 'h261' 'h263')! !

!QVideoEncoderQT methodsFor: 'primitives' stamp: 'jcg 11/15/2007 14:53'!
primitiveCreateEncoder: encoderArgs semaphoreIndex: semIndex width: width height: height
	<primitive: 'primitiveCreateEncoder' module: 'QVideoCodecPluginQT'>
	self primitiveFailed
! !

!QVideoEncoderQT methodsFor: 'primitives' stamp: 'jcg 11/15/2007 14:53'!
primitiveDestroyEncoder: encoderIndex
	<primitive: 'primitiveDestroyEncoder' module: 'QVideoCodecPluginQT'>
	self primitiveFailed
! !

!QVideoEncoderQT methodsFor: 'primitives' stamp: 'jcg 11/15/2007 14:53'!
primitiveEncoder: encoderIndex encodeBitmap: bits
	<primitive: 'primitiveEncode' module: 'QVideoCodecPluginQT'>
	self primitiveFailed
! !

!QVideoEncoderQT methodsFor: 'primitives' stamp: 'jcg 11/15/2007 14:53'!
primitiveEncoder: encoderIndex readIntoBytes: bytes ofSize: byteSize
	<primitive: 'primitiveEncoderReadIntoBytes' module: 'QVideoCodecPluginQT'>
	self primitiveFailed
! !

!QVideoEncoderQT methodsFor: 'primitives' stamp: 'jcg 11/15/2007 14:53'!
primitiveEncoderIsValid: encoderIndex
	"Answer true if the encoder handle is valid, and false otherwise."
	<primitive: 'primitiveEncoderIsValid' module: 'QVideoCodecPluginQT'>
	self primitiveFailed! !

TObject subclass: #QVideoRegistry
	instanceVariableNames: 'dict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-Discovery'!

!QVideoRegistry commentStamp: '<historical>' prior: 0!
Used to set/access video streamIDs, and to signal changes to interested parties.!

!QVideoRegistry class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QVideoRegistry methodsFor: 'initialize' stamp: 'jcg 1/30/2008 16:51'!
initialize
	dict := Dictionary new! !

!QVideoRegistry methodsFor: 'accessing' stamp: 'jcg 2/1/2008 11:59'!
streamDescription: descOrNil forUser: userName birthTime: avatarBirthTime
	"If the registered value has changed, update the registry and signal the change to interested observers.  'descOrNil' is a QStreamingVideoDescription."
	(dict at: userName ifAbsent: [nil]) = descOrNil ifTrue: [^self "no change, so don't signal"].
	descOrNil
		ifNil: [
			(dict at: userName) second > avatarBirthTime ifTrue: [
				"A newer avatar than me set the streamID, so don't do anything.
				 this happens when an avatar times out and is obliterated."
				^self
			].
			dict removeKey: userName
		]
		ifNotNil: [dict at: userName put: {descOrNil. avatarBirthTime}].
	self signal: #streamDescriptionChanged with: userName with: descOrNil
! !

!QVideoRegistry methodsFor: 'accessing' stamp: 'jcg 1/31/2008 22:32'!
streamDescriptionForUser: userName
	^ (dict at: userName ifAbsent: [^nil]) first! !

TObject subclass: #QwaqVideoSession
	instanceVariableNames: 'view cameraManager webcastManager isQuickTimeAvailable isSuspended availableEncoders availableDecoders qualitySetting mutex devices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-Session'!

!QwaqVideoSession commentStamp: '<historical>' prior: 0!
(c) 2007 Qwaq Inc.  Responsible for capture, publish/subscribe, encoding, decoding, and display of video streams.  Actually, it delegates these responsibilities to QVideoCameraManager and QVideoDecoderManager.!

!QwaqVideoSession class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QwaqVideoSession class methodsFor: 'utility' stamp: 'eem 3/18/2010 17:48'!
hasQVideoCodecPlugin
	^self primGetPluginVerbosityOrNil ~~ nil! !

!QwaqVideoSession class methodsFor: 'primitives' stamp: 'jcg 7/26/2011 23:35'!
primGetPluginVerbosityOrNil
	"For quick determination of the plugin being present"
	<primitive: 'primitiveGetLogVerbosity' module: 'QVideoCodecPluginFree'>
	^nil! !

!QwaqVideoSession methodsFor: 'accessing' stamp: 'jcg 8/9/2007 23:54'!
cameraManager
	^cameraManager! !

!QwaqVideoSession methodsFor: 'accessing' stamp: 'bgf 10/13/2009 21:51'!
cameraName
	"The device name of the active camera, if any is known; else nil"
	^ cameraManager ifNotNil: [ 
		cameraManager camera ifNotNilDo: [ : cam | cam cameraName ]].
! !

!QwaqVideoSession methodsFor: 'accessing' stamp: 'jcg 11/24/2007 16:19'!
decoderClassFor: codecType
	^availableDecoders at: codecType ifAbsent: [nil]! !

!QwaqVideoSession methodsFor: 'initialize' stamp: 'crl 12/17/2009 16:13'!
destroy
	cameraManager ifNotNil: [
		cameraManager destroy.
		cameraManager := nil.
	].
	webcastManager ifNotNil: [
		webcastManager destroy.
		webcastManager := nil.
	].! !

!QwaqVideoSession methodsFor: 'video quality' stamp: 'bgf 10/16/2009 17:01'!
deviceMenu
	"Return a tweak CMenu with the video device choices."
	| menu curUID |
	devices ifNil: [ ^ nil ].
	
	"Decide which entry to checkmark, if any"
	curUID := (cameraManager desiredDeviceUID) ifNil: [
				cameraManager camera ifNotNilDo: [ :cam| cam deviceUID ]].

	menu := CMenu new.
	devices do: [ : pair |
		menu add: (pair first) 
			   target: cameraManager 
			   action: #desiredDeviceName:uid: 
			   arguments: pair.
		menu menuItems last checked: ( curUID = (pair second) ).
		].
	QStyles installMenuFontInMenu: menu.
	QLogger logInfo: 'Device menu ', menu menuItems size.
	^ menu! !

!QwaqVideoSession methodsFor: 'accessing' stamp: 'bgf 10/15/2009 21:08'!
devices
	"The collection of pairs (Array with: friendlyName with: uid) 
	  describing the most-recently fetched set of vid-capture devices."
	^ devices! !

!QwaqVideoSession methodsFor: 'initialize' stamp: 'jcg 12/28/2009 11:56'!
discardIsland: anIsland
	"Stale island cleanup after logout or reconnect."
	webcastManager ifNotNil: [ webcastManager discardIsland: anIsland ].! !

!QwaqVideoSession methodsFor: 'accessing' stamp: 'jcg 11/24/2007 16:19'!
encoderClassFor: codecType
	^availableEncoders at: codecType ifAbsent: [nil]! !

!QwaqVideoSession methodsFor: 'accessing' stamp: 'crl 12/17/2009 16:13'!
hasVideoPlayers
	"Answer true if we have any webcam- or streaming-video-players.  These don't have to be actively playing... they still count."
	self streamingPlayersDo: [:p | ^true "any one will do"].
	webcastManager future numWebcasts wait > 0 ifTrue: [^true].
	^false! !

!QwaqVideoSession methodsFor: 'initialize' stamp: 'jcg 12/28/2009 11:56'!
initialize
	super initialize.

	mutex := Mutex new.
	isSuspended := false.
	webcastManager := QSecureWebcastManager new.
	cameraManager := QVideoCameraManager new.
	isQuickTimeAvailable := nil. "we don't know yet"

	self initializeAvailableCodecs.
	self initializeLogFiles.

	"Seed the camera lookup table."
	devices := (QWebcam availableCamDevices).
	self qualitySetting: #Normal! !

!QwaqVideoSession methodsFor: 'initialize' stamp: 'jcg 6/16/2011 02:14'!
initializeAvailableCodecs
	"Find out which encoders and decoders we have available, and cache the results."

	availableEncoders := Dictionary new.
	availableDecoders := Dictionary new.

	"Iterate through the possible encoder classes in order of decreasing preference... we want to choose the best available encoder for each codec."
	{QVideoEncoderFree} do: [:encoder |
		"Check whether the encoder is available... eg: some customers might have access to fancier encoders."
		encoder isAvailable ifTrue: [
			encoder supportedCodecs do: [:c |
				"If we don't already have a better encoder for this codec type, use this one."
				availableEncoders at: c ifAbsentPut: [encoder].
			].
		].
	].

	"Do the same thing for the decoders."
	{QVideoDecoderFree} do: [:decoder |
		decoder isAvailable ifTrue: [
			decoder supportedCodecs do: [:c |
				availableDecoders at: c ifAbsentPut: [decoder].
			].
		].
	].! !

!QwaqVideoSession methodsFor: 'initialize' stamp: 'jcg 7/26/2011 23:35'!
initializeLogFiles
	| path |
	[
		path := (FileDirectory logDirectory fullNameFor: 'QVideoCodecPluginFree.log').
		QVideoDecoderFree setErrorLog: path
	]
		on: Error
		do: [:err | 
			QLogger logWarning: 'failed to set log-file to: ', path, '  (', err description, ')' 
		]! !

!QwaqVideoSession methodsFor: 'suspending' stamp: 'jcg 4/8/2009 14:34'!
isSuspended
	^isSuspended! !

!QwaqVideoSession methodsFor: 'video quality' stamp: 'jcg 3/30/2008 19:59'!
qualityMenu

	"Return a tweak CMenu with the video rate choices.
	Note that the control bar exploits the fact that the <argument>
 	to each item is the quality-symbol."

	| menu |
	menu := CMenu new.
	(menu add: 'Normal' target: self action: #qualitySetting: argument: #Normal) 
		checked: (qualitySetting = #Normal).
	(menu add: 'High' target: self action: #qualitySetting: argument: #High) 
		checked: (qualitySetting = #High).
	(menu add: 'Very High' target: self action: #qualitySetting: argument: #VeryHigh) 
		checked: (qualitySetting = #VeryHigh).

	QStyles installMenuFontInMenu: menu.
	^ menu! !

!QwaqVideoSession methodsFor: 'video quality' stamp: 'bgf 9/19/2007 11:38'!
qualitySetting
	"One of #Normal, #High, #VeryHigh"
	^ qualitySetting! !

!QwaqVideoSession methodsFor: 'video quality' stamp: 'bgf 11/24/2009 13:46'!
qualitySetting: aSymbol

	"Change the video quality setting, updating the active video spec.
	 Also remember the new setting in preferences.
	 One of #Normal, #High, #VeryHigh"

	"Make preferences match."
	view ifNotNil: [
		view owner preferences videoQuality = aSymbol ifFalse: [
			view owner preferences videoQuality: aSymbol.
			view owner commitPreferencesInBackground.
		]].

	"Make the camera match."
	qualitySetting = aSymbol ifFalse: [

		qualitySetting := aSymbol.
		aSymbol caseOf: {
			[#High] -> [self useHighQualityVideo].
			[#VeryHigh] -> [self useVeryHighQualityVideo].
		} otherwise: [
			self useNormalQualityVideo
		].

	].
	self signal: #qualitySettingChanged.! !

!QwaqVideoSession methodsFor: 'video quality' stamp: 'jcg 5/5/2008 11:24'!
qualitySettingString
	"Answer a string for use in the UI"
	^qualitySetting caseOf: {
		[#VeryHigh] -> ['Very High'].
	} otherwise: [qualitySetting].! !

!QwaqVideoSession methodsFor: 'suspending' stamp: 'jcg 12/28/2009 12:35'!
resumeVideo
	isSuspended ifFalse: [^self].
	isSuspended := false.

	webcastManager resumeVideo.
	cameraManager resumeVideo.
	self streamingPlayersDo: [:p | p resumeVideo].
! !

!QwaqVideoSession methodsFor: 'private' stamp: 'bgf 5/13/2010 19:14'!
streamingPlayersDo: aBlock
	"Iterate through all embedded-apps... evaluate aBlock each time we find a TweakProjectWorld with a StreamingVideoApp."
	| allApps |
	allApps := view session embeddedApps.
	allApps values do: [:embeddable |
		(embeddable isKindOf: TweakProjectWorld) ifTrue: [
			| tweakApp |
			tweakApp := embeddable project ifNotNil: [ : proj | proj  world ].
			(tweakApp isKindOf: QStreamingVideoPlayer) ifTrue: [
				"Last check to ensure that app is still in session's app-list."
				allApps at: embeddable appID ifPresent: [:e | aBlock value: tweakApp]
			].
		].
	]! !

!QwaqVideoSession methodsFor: 'suspending' stamp: 'jcg 12/28/2009 12:35'!
suspendVideo
	isSuspended ifTrue: [^self].
	isSuspended := true.

	webcastManager suspendVideo.
	cameraManager suspendVideo.
	self streamingPlayersDo: [:p | p suspendVideo].! !

!QwaqVideoSession methodsFor: 'accessing' stamp: 'sn 3/4/2013 21:10'!
tick
	"Periodic (every few seconds) work-opportunity, in tweak context, from the main UI.
	 We check for changes in the video devices known to the computer."
	| newDevices |
	newDevices := QWebcam availableCamDevices.
	newDevices ifNil: [ ^ self ].	"Disregard prim fail (only act on real lists, so empty means something."

	devices ifNotNil: [
		(devices hasEqualElements: newDevices) ifTrue: [ ^ self ].	"Agreement."
	] ifNil: [
		devices := newDevices.	"First time result."
		^ self
	].

	"We have a new device list, different from the previous list."
	QLogger logInfo: 'Webcams changed ('translateMe, (newDevices size), ')', 
					(String streamContents: [ :strm | 
						newDevices do: [ : spec | strm nextPutAll: ', '; nextPutAll: spec first ]]).

	(view notNil and: [ view owner notNil ]) ifTrue: [
		| cb |
		cb := view owner controlBar.
		cameraManager devicesUpdate: newDevices oldDevices: devices.

		cb camera enabled: (newDevices notEmpty).
		newDevices size > devices size ifTrue: [
			cb microphoneMessage:  'New video camera detected.'translateMe.
		]].

	devices := newDevices.! !

!QwaqVideoSession methodsFor: 'resources' stamp: 'crl 2/4/2010 17:12'!
updateResourceType: resourceType in: anIsland
	resourceType caseOf: {
		[QVideoTexture resourceType] -> [
			webcastManager future updateVideoTexturesInIsland: anIsland
		].
		[QVideoCamera resourceType] -> [
			webcastManager future updateVideoFeedsInIsland: anIsland
		].
	} otherwise:[].! !

!QwaqVideoSession methodsFor: 'video quality' stamp: 'jcg 1/24/2012 02:12'!
useHighQualityVideo
	"Private - use 'qualitySetting: [Normal High VeryHigh]' to change quality."
	| spec |

	spec := QVideoArgs new usePlatformEndianness.
	spec useZeroLatencyProfile.
	(availableEncoders includesKey: 'avc1')
		ifTrue: [
			spec 
				codec: 'avc1';
				extent: 320@240;
				fps: 15.0;
				bitRate: 240000  "30kbytes/sec".
		]
		ifFalse: [
			spec
				codec: 'h261';
				extent: 160@120;
				fps: 10.0;
				bitRate: 0 "ignored";
				timeScale: 3000.
		].
	cameraManager videoSpec: spec.
! !

!QwaqVideoSession methodsFor: 'video quality' stamp: 'jcg 1/24/2012 02:12'!
useNormalQualityVideo
	"Private - use 'qualitySetting: [Normal High VeryHigh]' to change quality."
	| spec |

	spec := QVideoArgs new usePlatformEndianness.
	spec useZeroLatencyProfile.
	(availableEncoders includesKey: 'avc1')
		ifTrue: [
			spec 
				codec: 'avc1';
				extent: 320@240;
				fps: 10.0;
				bitRate: 80000  "10kbytes/sec".
		]
		ifFalse: [
			spec
				codec: 'jpeg';
				extent: 160@120;
				fps: 2.0;
				bitRate: 0 "ignored";
				timeScale: 3000.
		].
	cameraManager videoSpec: spec.
! !

!QwaqVideoSession methodsFor: 'video quality' stamp: 'jcg 1/24/2012 02:12'!
useVeryHighQualityVideo
	"Private - use 'qualitySetting: [Normal High VeryHigh]' to change quality."
	| spec |

	spec := QVideoArgs new usePlatformEndianness.
	spec useZeroLatencyProfile.
	(availableEncoders includesKey: 'avc1')
		ifTrue: [
			spec 
				codec: 'avc1';
				extent: 640@480;
				fps: 15.0;
				bitRate: 320000  "40kbytes/sec".
		]
		ifFalse: [
			spec
				codec: 'h261';
				extent: 640@480;
				fps: 15.0;
				bitRate: 0 "ignored";
				timeScale: 3000.
		].
	cameraManager videoSpec: spec.
! !

!QwaqVideoSession methodsFor: 'accessing' stamp: 'jcg 8/8/2007 23:54'!
view
	^view! !

!QwaqVideoSession methodsFor: 'initialize' stamp: 'jcg 12/28/2009 11:56'!
view: aCroquetView
	view := aCroquetView.
	webcastManager view: view.
	cameraManager view: view.

	self qualitySetting: view owner preferences videoQuality.
	"Don't disable the cam-button if devices is nil - that means discovery isn't working;
	 an empty list is what tells us that there are no cameras."
	view owner controlBar camera enabled: (devices isNil or: [ devices notEmpty ]).! !

!QwaqVideoSession methodsFor: 'accessing' stamp: 'jcg 12/28/2009 11:55'!
webcastManager
	^webcastManager! !

!TObject methodsFor: '*Qwaq-Video' stamp: 'jcg 1/31/2008 18:19'!
forumVideoStreamRegistry
	^ self island at: #ForumVideoRegistry ifAbsentPut: [QVideoRegistry new]! !

SharedPool subclass: #AACAudioObjectTypes
	instanceVariableNames: ''
	classVariableNames: 'AacLC AacLTP AacMain AacSSR AacScalable CELP HVXC TTSI TwinVQ'
	poolDictionaries: ''
	category: 'Qwaq-Video-MP4'!

!AACAudioObjectTypes commentStamp: '<historical>' prior: 0!
See 14496-3 Table 1.1

Somewhat redundant with 'AudioObjectTypes' class-var in AACAudioSpecificConfig.  Sorry.!

!AACAudioObjectTypes class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!AACAudioObjectTypes class methodsFor: 'class initialization' stamp: 'jcg 8/12/2009 11:46'!
initialize
	AacMain		:= 1.
	AacLC			:= 2.
	AacSSR			:= 3.
	AacLTP			:= 4.
	"(reserved)		:= 5."
	AacScalable	:= 6.
	TwinVQ		:= 7.
	CELP			:= 8.
	HVXC			:= 9.
	"(reserved)		:= 10."
	"(reserved)		:= 11."
	TTSI			:= 12.! !

SharedPool subclass: #MP4Constants
	instanceVariableNames: ''
	classVariableNames: 'MP4StreamAUDIO MP4StreamFONT MP4StreamINTERACT MP4StreamIPMP MP4StreamIPMPTOOL MP4StreamMPEG7 MP4StreamMPEGJ MP4StreamNDSUBPIC MP4StreamOCI MP4StreamOCR MP4StreamOD MP4StreamSCENE MP4StreamTEXT MP4StreamVISUAL'
	poolDictionaries: ''
	category: 'Qwaq-Video-MP4'!

Object subclass: #MP4BoxNHMLTrack
	instanceVariableNames: 'version info maxCTS maxCTSOffset streamType objectTypeIndication baseMediaFile baseDirPath samples'
	classVariableNames: ''
	poolDictionaries: 'MP4Constants'
	category: 'Qwaq-Video-MP4'!

!MP4BoxNHMLTrack commentStamp: '<historical>' prior: 0!
Represents an audio or video track read from a .nhml file.  We use MP4Box (an external executable) to process an .mp4 file into .nhml for easier parsing.!

!MP4BoxNHMLTrack class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!MP4BoxNHMLTrack methodsFor: 'debugging' stamp: 'jcg 7/10/2011 16:53'!
asSampledSound
	| decoder buf stream file |
	self isAudio ifFalse: [self error: 'must be an audio track'].
	self isAAC ifFalse: [self error: 'must be an AAC track'].

	
	[
		decoder := QAudioDecoderAAC new.
		decoder createHandle: info decoderSpecificInfo.
		buf := SoundBuffer newMonoSampleCount: self dtsIncrement.
		file := self readStream.
		stream := WriteStream on: (SoundBuffer newMonoSampleCount: 1024).
		samples do: [:s | 
			file position: s filePosition.
			decoder decode: (file next: s dataLength) into: buf.
			stream nextPutAll: buf
		].
		^SampledSound samples: stream contents samplingRate: self sampleRate
	] ensure: [
		decoder ifNotNilDo: [:d | d destroy].
		file ifNotNilDo: [:f | f close].
	].
	^nil
	! !

!MP4BoxNHMLTrack methodsFor: 'accessing' stamp: 'jcg 8/12/2009 16:17'!
averageBitrate
	| dur |
	dur := self duration.
	dur = 0.0 ifTrue: [
		QLogger logWarning: 'track has duration of 0.0, so cannot compute bitrate'.
		^0.0
	].
	^(self byteSize * 8 "bits/byte" / dur / 1000 "from milliseconds") rounded
! !

!MP4BoxNHMLTrack methodsFor: 'accessing' stamp: 'jcg 4/4/2009 10:21'!
byteSize
	"Answer the total number of bytes in this track."
	| lastSample |
	lastSample := samples ifEmpty: [^0] ifNotEmpty: [samples last].
	^lastSample filePosition + lastSample dataLength! !

!MP4BoxNHMLTrack methodsFor: 'private' stamp: 'jcg 11/29/2009 12:07'!
computeAndCacheParameters
	| trackType codec bitrate |
	info duration: (maxCTS asFloat / self timeScale).

	"What type of stream is this?"
	trackType := 'unknown'.
	self isAudio ifTrue: [trackType := 'audio'].
	self isVideo ifTrue: [trackType := 'video'].
	info trackType: trackType.

	"What codec do we use?"
	codec := 'unknown'.
	self isAVC ifTrue: [codec := 'avc1'].
	self isAAC ifTrue: [codec := 'AAC'].
	self isQSpeex ifTrue: [codec := 'qspeex'].
	info codec: codec.

	"Compute the average bitrate."
	bitrate := (self byteSize * 8 "bits/byte") / self duration.
	info bitrate: bitrate rounded.
	! !

!MP4BoxNHMLTrack methodsFor: 'private' stamp: 'jcg 11/29/2009 14:29'!
computeDTSDeltas
	"Once we've read the samples, compute the difference between adjacent DTSes."
	| allDeltas |

	"Handle potential error conditions first."
	samples size < 2 ifTrue: [
		QLogger logWarning: 'track has < 2 samples'.
		^info dtsIncrement: nil.
	].

	"Compute the deltas."
	allDeltas := Set new.
	1 to: samples size - 1 do: [:i | 
		| samp1 samp2 delta |
		samp1 := samples at: i.
		samp2 := samples at: i+1.
		delta := samp2 dts - samp1 dts.
		samp1 dtsDelta: delta.
		allDeltas add: delta.
	].
	"There won't be a next sample, so it doesn't matter what it is (just not nil)."
	samples last dtsDelta: 0. 

	"In our experience, the DTS-delta is always uniform; we want to know if it isn't."
	allDeltas size > 1 ifTrue: [
		QLogger logWarning: 'non-uniform DTS deltas: ', allDeltas asArray.
		^info dtsIncrement: nil.
	].
	info dtsIncrement: allDeltas anyOne.
! !

!MP4BoxNHMLTrack methodsFor: 'accessing' stamp: 'jcg 7/26/2009 18:21'!
dtsIncrement
	^info dtsIncrement! !

!MP4BoxNHMLTrack methodsFor: 'accessing' stamp: 'jcg 7/26/2009 18:14'!
duration
	^info duration! !

!MP4BoxNHMLTrack methodsFor: 'accessing-video' stamp: 'jcg 7/26/2009 21:44'!
extent
	^info extent! !

!MP4BoxNHMLTrack methodsFor: 'accessing' stamp: 'jcg 7/29/2009 14:54'!
generateDecoderSpecificInfo
	| avcConfig |
	self isAVC ifFalse: [self error: 'this track is not AVC video'].
	info decoderSpecificInfo ifNil: [^nil "nothing to work with"].
	avcConfig := AVCDecoderConfigurationRecord new.
	avcConfig initializeFromDecoderSpecificInfo: info decoderSpecificInfo.
	^avcConfig
! !

!MP4BoxNHMLTrack methodsFor: 'accessing' stamp: 'jcg 7/26/2009 21:46'!
generateVideoArgs
	| args |
	self isVideo ifFalse: [self error: 'not a video track'].
	args := QVideoArgs new usePlatformEndianness.
	args 
		codecType: (self isAVC ifTrue: ['avc1'] ifFalse: ['unknown']);
		timeScale: self timeScale;
		width: self width;
		height: self height;
		bitRate: 0;  "don't know how to obtain this; anyway, irrelevant for decoder"
		fps: (1.0 / self timeScale).
	^args
		! !

!MP4BoxNHMLTrack methodsFor: 'accessing-video' stamp: 'jcg 7/26/2009 21:44'!
height
	^info height! !

!MP4BoxNHMLTrack methodsFor: 'accessing' stamp: 'jcg 3/26/2009 16:29'!
indexOfPreviousRAP: startIndex
	"Answer the index of the first Random Access Point  at or before the specified index.  Answer 0 if no such index exists."
	startIndex to: 1 by: -1 do: [:i | (samples at: i) isRAP ifTrue: [^i]].
	QLogger logWarning: 'there is no RAP before index: ', startIndex.
	^0
! !

!MP4BoxNHMLTrack methodsFor: 'accessing' stamp: 'jcg 7/27/2009 10:45'!
info
	^info! !

!MP4BoxNHMLTrack methodsFor: 'initialize' stamp: 'jcg 7/26/2009 18:14'!
initialize
	super initialize.
	info := QNetVidTrackInfo new.! !

!MP4BoxNHMLTrack methodsFor: 'private' stamp: 'jcg 7/27/2009 08:12'!
initializeFromBinaryStream: binaryStream
	| dataSize buf timeScale trackID width height sampleRate numChannels |
	
	binaryStream binary.
	buf := ByteArray new: 8.
	
	"Read version 0 header."
	version := binaryStream next.
	version = 0 ifFalse: [self error: 'expected version 0, not ', version].
	timeScale := (binaryStream next: 4 into: buf) networkUnsignedLongAt: 1.
	info timeScale: timeScale.
	maxCTS := (binaryStream next: 8 into: buf) networkUnsignedLongLongAt: 1.
	maxCTSOffset := (binaryStream next: 4 into: buf) networkLongAt: 1.
	streamType := binaryStream next.
	objectTypeIndication := (binaryStream next: 4 into: buf) networkLongAt: 1.
	trackID := (binaryStream next: 4 into: buf) networkUnsignedLongAt: 1.
	info trackID: trackID.
	dataSize := (binaryStream next: 4 into: buf) networkUnsignedLongAt: 1.
	dataSize > 0 ifTrue: [info decoderSpecificInfo: (binaryStream next: dataSize)].
	width := (binaryStream next: 4 into: buf) networkUnsignedLongAt: 1.
	width == 0 ifTrue: [width := nil].
	info width: width.
	height := (binaryStream next: 4 into: buf) networkUnsignedLongAt: 1.
	height == 0 ifTrue: [height := nil].
	info height: height.
	sampleRate := (binaryStream next: 4 into: buf) networkUnsignedLongAt: 1.
	sampleRate == 0 ifTrue: [sampleRate := nil].
	info sampleRate: sampleRate.
	numChannels := (binaryStream next: 4 into: buf) networkUnsignedLongAt: 1.
	numChannels == 0 ifTrue: [numChannels := nil].
	info numChannels: numChannels.
	dataSize := (binaryStream next: 4 into: buf) networkUnsignedLongAt: 1.
	baseMediaFile := (binaryStream next: dataSize) asString.
	dataSize := (binaryStream next: 4 into: buf) networkUnsignedLongAt: 1.
	baseDirPath := (binaryStream next: dataSize) asString.

	"Test for supported track types"
	(self isAVC or: [self isAAC] or:[self isQSpeex]) ifFalse: [
		self error: 
			'Unsupported track (streamType: ', streamType, 
			' objectType: ', objectTypeIndication,')'
	].

	"Read version 0 samples."
	samples := OrderedCollection new.
	[binaryStream atEnd] whileFalse: [
		| dts ctsOffset dataStart dataLength isRAP samp |
		dts := (binaryStream next: 8 into: buf) networkUnsignedLongLongAt: 1.
		ctsOffset := (binaryStream next: 4 into: buf) networkLongAt: 1.
		dataStart := (binaryStream next: 8 into: buf) networkUnsignedLongLongAt: 1.
		dataLength := (binaryStream next: 4 into: buf) networkUnsignedLongAt: 1.
		isRAP := (binaryStream next) = 1.
		samp := MP4BoxNHNTSample new.
		samp 
			initializeFromFilePos: dataStart 
			length: dataLength 
			dts: dts
			ctsOffset: ctsOffset
			isRAP: isRAP.
		samples add: samp.
	].

	"Once we've read the samples, compute the difference between adjacent DTSes."
	self computeDTSDeltas.

	"Compute and store some values based on the parameters that we just read."
	self computeAndCacheParameters.! !

!MP4BoxNHMLTrack methodsFor: 'private' stamp: 'jcg 7/27/2009 08:12'!
initializeFromXmlElement: xml baseDirectoryPath: directoryPath
	| decoderSpecificInfoFilename filePos |

	maxCTS := maxCTSOffset := 0.

	xml name == #NHNTStream ifFalse: [self error: 'expected <NHNTStream> element'].
	baseDirPath := directoryPath.
	samples := OrderedCollection new.

	"Read track attributes from XML element."
	xml attributes keysAndValuesDo: [:key :value |
		key caseOf: {
			['version']			->		[version := Number readFrom: value].
			['timeScale']			->		[info timeScale: (Number readFrom: value)].
			['streamType']		->		[streamType := Number readFrom: value].
			['objectTypeIndication']	->	[objectTypeIndication := Number readFrom: value].
			['width']			->		[info width: (Number readFrom: value)].
			['height']			->		[info height: (Number readFrom: value)].
			['trackID']			->		[info trackID: (Number readFrom: value)].
			['specificInfoFile']	->		[decoderSpecificInfoFilename := value].
			['baseMediaFile']	->		[baseMediaFile := value].
			['sampleRate']		->		[info sampleRate: (Number readFrom: value)].
			['numChannels']	->		[info numChannels: (Number readFrom: value)].
			['inRootOD']			->		[
				"This doesn't seem to apply to elementary AAC/AVC tracks."
				QLogger logWarning: 'ignoring MP4Box attribute: ', key
			].
		} otherwise: [self error: 'unexpected attribute: ', (key->value)].
	].

	"Test for supported track types"
	(self isAVC or: [self isAAC] or:[self isQSpeex]) 
		ifFalse: [self error: 'Unsupported track (streamType: ', streamType, ' objectType: ', objectTypeIndication,')'].

	"If there is decoder-specific information associated with the track, read it now."
	decoderSpecificInfoFilename ifNotNil: [
		| dir file |
		dir := FileDirectory on: baseDirPath.
		file := dir readOnlyFileNamed: decoderSpecificInfoFilename.
		[info decoderSpecificInfo: (file binary contents)] ensure: [file close].
	].
	
	"Read the samples!!"
	filePos := 0.
	xml elementsDo: [:elem |
		| samp |
		samp := MP4BoxNHNTSample new.
		samp initializeFromXmlElement: elem filePosition: filePos.
		filePos := filePos + samp dataLength.
		maxCTS := maxCTS max: samp cts.
		maxCTSOffset := maxCTSOffset max: samp ctsOffset.
		samples addLast: samp.
	].

	"Once we've read the samples, compute the difference between adjacent DTSes."
	self computeDTSDeltas.

	"Finally, cache a binary version for quicker reading."
	self writeBinaryFile.

	"Compute and store some values based on the parameters that we just read."
	self computeAndCacheParameters.! !

!MP4BoxNHMLTrack methodsFor: 'testing' stamp: 'jcg 1/6/2009 09:12'!
isAAC
	"Does this track contain AAC-encoded audio?"
	^self isAudio and: [objectTypeIndication == 64]! !

!MP4BoxNHMLTrack methodsFor: 'testing' stamp: 'jcg 1/6/2009 09:13'!
isAVC
	"Does this track contain H.264/AVC-encoded audio?"
	^self isVideo and: [objectTypeIndication == 33]! !

!MP4BoxNHMLTrack methodsFor: 'testing' stamp: 'jcg 1/6/2009 09:11'!
isAudio
	^streamType == MP4StreamAUDIO! !

!MP4BoxNHMLTrack methodsFor: 'testing' stamp: 'ar 3/18/2009 15:17'!
isQSpeex
	"Does this track contain Qwaq-Speex-encoded audio?"
	^self isAudio and: [objectTypeIndication == -17]! !

!MP4BoxNHMLTrack methodsFor: 'testing' stamp: 'jcg 1/6/2009 09:11'!
isVideo
	^streamType == MP4StreamVISUAL! !

!MP4BoxNHMLTrack methodsFor: 'accessing' stamp: 'jcg 1/27/2009 17:46'!
maxCTSOffset
	"Answer the largest CTS-offset of any sample in the track."
	^maxCTSOffset! !

!MP4BoxNHMLTrack methodsFor: 'accessing' stamp: 'jcg 2/20/2009 16:57'!
mediaFilePath
	^(FileDirectory on: baseDirPath) fullPathFor: baseMediaFile! !

!MP4BoxNHMLTrack methodsFor: 'accessing-audio' stamp: 'jcg 7/26/2009 22:08'!
numChannels
	^info numChannels! !

!MP4BoxNHMLTrack methodsFor: 'accessing' stamp: 'jcg 7/27/2009 08:11'!
rawDecoderSpecificInfo
	^info decoderSpecificInfo
! !

!MP4BoxNHMLTrack methodsFor: 'debugging' stamp: 'jcg 7/10/2011 16:52'!
readStream
	"Answer a read-only stream on the track's media data."
	| file |
	file := (FileDirectory on: baseDirPath) readOnlyFileNamed: baseMediaFile.
	file binary.
	^ file
! !

!MP4BoxNHMLTrack methodsFor: 'accessing-audio' stamp: 'jcg 7/26/2009 22:07'!
sampleRate
	^info sampleRate! !

!MP4BoxNHMLTrack methodsFor: 'accessing' stamp: 'jcg 1/23/2009 15:55'!
samples
	^samples! !

!MP4BoxNHMLTrack methodsFor: 'accessing' stamp: 'jcg 7/26/2009 18:15'!
timeOfSample: sample "or integer index"
	"Answer the time (in seconds) that the specified sample will be played."
	sample isInteger ifTrue: [^self timeOfSample: (samples at: sample)].
	^sample cts / self timeScale asFloat! !

!MP4BoxNHMLTrack methodsFor: 'accessing' stamp: 'jcg 7/26/2009 18:15'!
timeScale
	^info timeScale! !

!MP4BoxNHMLTrack methodsFor: 'accessing' stamp: 'jcg 7/27/2009 08:09'!
trackID
	^info trackID! !

!MP4BoxNHMLTrack methodsFor: 'accessing-video' stamp: 'jcg 7/26/2009 21:44'!
width
	^info width! !

!MP4BoxNHMLTrack methodsFor: 'private' stamp: 'jcg 7/27/2009 08:22'!
writeBinaryFile
	"Write a binary file, so that we can read it faster next time."
	| fileName fullPath binaryStream fileStream |

	"Generate the data before writing it to a file."
	binaryStream := WriteStream on: (ByteArray new: 100000).
	[self writeOnBinaryStream: binaryStream] 
		on: Error 
		do: [:err | 
			QLogger logError: 'error while generating .qtrack data:  ', err description.
			QLogger logError: err.
			^self
		].

	fileName := (baseMediaFile copyUpToLast: $.), '.qtrack'.
	fullPath := (FileDirectory on: baseDirPath) fullPathFor: fileName.
	[fileStream := FileStream forceNewFileNamed: fullPath]
		on: Error
		do: [:err | 
			^QLogger logWarning: 'failed to create .qtrack file because: ', err description
		].
	[fileStream nextPutAll: binaryStream contents] ensure: [fileStream close].

QLogger logInfo: 'wrote binary .qtrack file'.
! !

!MP4BoxNHMLTrack methodsFor: 'private' stamp: 'jcg 7/27/2009 08:11'!
writeOnBinaryStream: binaryStream
	| uint32 uint64 |
	
	uint32 := ByteArray new: 4.
	uint64 := ByteArray new: 8.

	"Write version 0 header."
	"Version #"
	binaryStream nextPut: 0.
	"Time scale"
	uint32 networkUnsignedLongAt: 1 put: self timeScale.
	binaryStream nextPutAll: uint32.
	"Max CTS"
	uint64 networkUnsignedLongLongAt: 1 put: maxCTS.
	binaryStream nextPutAll: uint64.
	"Max CTS Offset"
	uint32 networkLongAt: 1 put: maxCTSOffset.
	binaryStream nextPutAll: uint32.
	"Stream Type"
	binaryStream nextPut: streamType.
	"Object Type Indication"
	uint32 networkLongAt: 1 put: objectTypeIndication.
	binaryStream nextPutAll: uint32.
	"Track ID"
	uint32 networkUnsignedLongAt: 1 put: self trackID.
	binaryStream nextPutAll: uint32.

	"Decoder Specific Info"
	info decoderSpecificInfo
		ifNil: [
			uint32 networkUnsignedLongAt: 1 put: 0.
			binaryStream nextPutAll: uint32.
		]
		ifNotNilDo: [:decInfo |
			uint32 networkUnsignedLongAt: 1 put: decInfo size.
			binaryStream nextPutAll: uint32.
			binaryStream nextPutAll: decInfo.
		].
	"Width"
	uint32 networkUnsignedLongAt: 1 put: (self width ifNil: [0]).
	binaryStream nextPutAll: uint32.	
	"Height"
	uint32 networkUnsignedLongAt: 1 put: (self height ifNil: [0]).
	binaryStream nextPutAll: uint32.	
	"Sample Rate"
	uint32 networkUnsignedLongAt: 1 put: (self sampleRate ifNil: [0]).
	binaryStream nextPutAll: uint32.	
	"Number of Channels"
	uint32 networkUnsignedLongAt: 1 put: (self numChannels ifNil: [0]).
	binaryStream nextPutAll: uint32.	

	"Media file name"
	uint32 networkUnsignedLongAt: 1 put: baseMediaFile size.
	binaryStream nextPutAll: uint32.	
	binaryStream nextPutAll: baseMediaFile asByteArray.
	"Base directory path"
	uint32 networkUnsignedLongAt: 1 put: baseDirPath size.
	binaryStream nextPutAll: uint32.	
	binaryStream nextPutAll: baseDirPath asByteArray.

	"Write version 0 samples"
	samples do: [:samp |
		uint64 networkUnsignedLongLongAt: 1 put: samp dts.
		binaryStream nextPutAll: uint64.
		uint32 networkLongAt: 1 put: samp ctsOffset.
		binaryStream nextPutAll: uint32.
		uint64 networkUnsignedLongLongAt: 1 put: samp filePosition.
		binaryStream nextPutAll: uint64.
		uint32 networkUnsignedLongAt: 1 put: samp dataLength.
		binaryStream nextPutAll: uint32.
		binaryStream nextPut: (samp isRAP ifTrue: [1] ifFalse: [0]).
	].

! !

!MP4Constants class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!MP4Constants class methodsFor: 'class initialization' stamp: 'jcg 1/5/2009 23:57'!
initialize
	self initializeStreamTypes.! !

!MP4Constants class methodsFor: 'class initialization' stamp: 'jcg 1/6/2009 00:10'!
initializeStreamTypes
	MP4StreamOD			:= 1.		"Object Descriptor stream"
	MP4StreamOCR			:= 2.		"Object Clock Reference stream"
	MP4StreamSCENE		:= 3.		"MPEG-4 Scene Description stream"
	MP4StreamVISUAL		:= 4.		"Visual stream (Video, Image or MPEG-4 SNHC Tools)"
	MP4StreamAUDIO		:= 5.		"Audio stream (Audio, MPEG-4 Structured-Audio Tools)"
	MP4StreamMPEG7		:= 6.		"MPEG-7 Description stream"
	MP4StreamIPMP			:= 7.		"MPEG-4 IP Management and Protection Stream"
	MP4StreamOCI			:= 8.		"MPEG-4 Object Content Information Stream"
	MP4StreamMPEGJ		:= 9.		"MPEG-4 MPEGlet Stream"
	MP4StreamINTERACT	:= 16rA.	"MPEG-4 User Interaction Stream"
	MP4StreamIPMPTOOL	:= 16rB.	"MPEG-4 IPMP Tool Stream"
	MP4StreamFONT		:= 16rC.	"MPEG-4 Font Data Stream"
	MP4StreamTEXT			:= 16rD.	"MPEG-4 Streaming Text Stream"
	MP4StreamNDSUBPIC	:= 16r38.	"Nero Digital Subpicture Stream"
! !

SharedPool subclass: #QWebcamConstants
	instanceVariableNames: ''
	classVariableNames: 'FrameWasRead'
	poolDictionaries: ''
	category: 'Qwaq-Video-Webcam'!

!QWebcamConstants commentStamp: '<historical>' prior: 0!
Constants used by QWebcam.!

QBaseVideoCamera subclass: #QWebcam
	instanceVariableNames: 'handle feedbackChannel watchdog lastFrameTime'
	classVariableNames: 'SerialDiscoveryMutex'
	poolDictionaries: 'QWebcamConstants'
	category: 'Qwaq-Video-Webcam'!

!QWebcam commentStamp: '<historical>' prior: 0!
The latest greatest webcam.

Declares the primitives from the QWebcamPlugin.
The class-side provides enumeration of available camera devices.!

!QWebcam class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QWebcam class methodsFor: 'discovery' stamp: 'bgf 10/15/2009 20:30'!
availableCamDevices
	"Returns a collections of Array[2] of strings.
	 Each entry is  (friendlyName, uid),
	 enumerating the video capture devices known on this machine right now;
	 or returns NIL if there was a primitive-failure in performing the lookup.
	 The friendlyName is the platform-supplied user-friend name for the camera.
 	 The uid is the platform-supplied persistent (we hope) identifier 
	 by which this camera can be chosen via the camera-creation primitive. "
	[
		"The prim contract is that each call to get NumCamDevices caches the result
		 at that time, so we serialize the gathering of the table."
		self serialDiscoveryMutex critical:[ 
			| result n |
			result := OrderedCollection new.
			n := (self primNumCamDevices).
			0 to: n-1 do: [ : i |
				| nm uid |
				nm := self primCamDeviceName: i.
				uid := self primCamDeviceUID: i.
				(nm notNil and: [ uid notNil ])  ifTrue: [
					result addLast: {
						(self primCamDeviceName: i) .
						(self primCamDeviceUID: i) }.
				]].
			^ result ].

	] on: Error do: [ :ex |
		QLogger logWarning: 'Cannot enumerate webcams: ', ex description 
				 every: (300*1000).
		^ nil
	].
	! !

!QWebcam class methodsFor: 'private' stamp: 'bgf 10/8/2009 19:04'!
errorStringFor: errorCode
	"Somewhat legacy, transferred from old QVideoCamera.
 	Loosely correspond to the results coming back from create-camera when it fails."
	^errorCode caseOf: {
		[0]		->		['no error'].
		[-1]		->		['invalid handle value'].
		[-2]		->		['insufficient memory (allocation failed)'].
		[-3]		->		['invalid data source / no data to read'].
		[-4]		->		['no free object slots'].
		[-5]		->		['QuickTime error'].
	} otherwise: ['unknown error (', errorCode, ')']
! !

!QWebcam class methodsFor: 'private' stamp: 'bgf 10/13/2009 21:05'!
exerciseMe
	" QWebcam exerciseMe "

	" A simple stress test... mostly to expose c-side allocation difficulties."
	100 timesRepeat:[ 
	  | n |
	  n := QWebcam primNumCamDevices.
	  0 to: n-1 do: [ :  i| 
	     Transcript cr; show: (QWebcam primCamDeviceName: i ).
	]]! !

!QWebcam class methodsFor: 'class initialization' stamp: 'bgf 10/15/2009 14:35'!
initialize
	"QWebcam initialize"
	SerialDiscoveryMutex := Mutex new.! !

!QWebcam class methodsFor: 'primitives' stamp: 'bgf 10/13/2009 20:33'!
primCamDeviceIsBusy: devIndex
	"Boolean, true if the given camera is in use by another application (if known).
	 This will be used to disable the option of choosing the camera for web cam input.
	The devIndex is 0-based, allowable values 0..(primtiveGetNumCameras-1),
	 where the most recent call to primitiveGetNumCameras prevails (and, c-side, caches the dev-info)."

	<primitive: 'primitiveGetCamDeviceIsBusy' module: 'QWebcamPlugin'>
	self primitiveFailed! !

!QWebcam class methodsFor: 'primitives' stamp: 'bgf 10/13/2009 20:34'!
primCamDeviceName: devIndex
	"Answer the UTF-8 string identifying this camera to the user,
	 or nil if the camera is no longer known or usable.
	The devIndex is 0-based, allowable values 0..(primtiveGetNumCameras-1),
	 where the most recent call to primitiveGetNumCameras prevails (and, c-side, caches the dev-info)."

	<primitive: 'primitiveGetCamDeviceName' module: 'QWebcamPlugin'>
	self primitiveFailed! !

!QWebcam class methodsFor: 'primitives' stamp: 'bgf 10/13/2009 20:35'!
primCamDeviceUID: devIndex
	"Answer the string to use to identify this camera for use across application sessions;
	 this string should be stable for the same device across distinct enumerations of cameras,
	 and ideally be stable across application and computer restarts for use in preferences.
	The devIndex is 0-based, allowable values 0..(primtiveGetNumCameras-1),
	 where the most recent call to primitiveGetNumCameras prevails (and, c-side, caches the dev-info)."

	<primitive: 'primitiveGetCamDeviceUID' module: 'QWebcamPlugin'>
	self primitiveFailed! !

!QWebcam class methodsFor: 'primitives' stamp: 'bgf 10/13/2009 20:35'!
primNumCamDevices
	"Answer the number of web cam input devices known to the system, or negative on error.
	 The plugin should cache a stable table of such devices at each call to this method."

	<primitive: 'primitiveGetNumCamDevices' module: 'QWebcamPlugin'>
	self primitiveFailed! !

!QWebcam class methodsFor: 'private' stamp: 'bgf 10/15/2009 14:43'!
serialDiscoveryMutex
	"See availableCamDevices"
	SerialDiscoveryMutex ifNil: [
		SerialDiscoveryMutex := Mutex new.
	].
	^ SerialDiscoveryMutex! !

!QWebcam methodsFor: 'accessing' stamp: 'bgf 11/14/2009 10:39'!
cameraName
	"If available, the user-friendly device name of this camera."
	friendlyName ifNotNil: [ ^ friendlyName ].	"Cached"
	handle ifNil: [ ^ nil  ].
	^ friendlyName := ([ self primitiveCameraName: handle ] on: Error do: [nil]).
! !

!QWebcam methodsFor: 'subclass responsibilities' stamp: 'bgf 10/15/2009 15:09'!
createHandle
	"Activate the system default web camera"
	| params |
	feedbackChannel := QWebcamFeedbackChannel new.
	feedbackChannel camera: self.

	params := QWebcamParams new.
	params
		width: frameExtent x;
		height: frameExtent y;
		fps: fps.
	
	[
		handle := self 
				primitiveCreateCamera: (self deviceUID)
				args: params getHandle
				argsSize: params class byteSize
				feedbackChannel: feedbackChannel getHandle.
	] on: Error do: [ :ex|
		QLogger logInfo: 'Falling back to default webcam activation (', (ex description), ')'.
		handle := self 
				primitiveCreateCamera: params getHandle
				argsSize: params class byteSize
				feedbackChannel: feedbackChannel getHandle.
	].

	handle < 0 ifTrue: [
		| errString |
		errString := (self class errorStringFor: handle).
		handle := nil.
		self error: self class name, ' : error during creation: ', errString.
	].

	
! !

!QWebcam methodsFor: 'subclass responsibilities' stamp: 'jcg 1/12/2008 17:02'!
destroyHandle
	handle ifNotNil: [
		self primitiveDestroyCamera: handle.
		handle := nil.
	].
	feedbackChannel ifNotNil: [
		feedbackChannel destroy.
		feedbackChannel := nil.
	].! !

!QWebcam methodsFor: 'accessing' stamp: 'bgf 10/15/2009 14:53'!
deviceUID
	"If available, the persistent device identifier in use (or desired) of this camera."
	handle ifNil: [ ^ super deviceUID ].
	^ [ self primitiveCameraUID: handle ] on: Error do: [nil].
! !

!QWebcam methodsFor: 'accessing' stamp: 'bgf 10/16/2009 13:17'!
deviceUID: aDeviceUIDString
	"Nil arg indicates choosing the platform current default device."
	mutex critical: [
		deviceUID := aDeviceUIDString.
	]! !

!QWebcam methodsFor: 'primitives' stamp: 'jcg 1/15/2008 15:11'!
primitiveCameraAdjust: cameraIndex args: cameraArgs argsSize: argsSize
	<primitive: 'primitiveCameraAdjust' module: 'QWebcamPlugin'>
	self primitiveFailed! !

!QWebcam methodsFor: 'primitives' stamp: 'jcg 12/29/2007 01:00'!
primitiveCameraIsValid: cameraIndex
	"Answer true if the camera handle is valid, and false otherwise."
	<primitive: 'primitiveCameraIsValid' module: 'QWebcamPlugin'>
	self primitiveFailed! !

!QWebcam methodsFor: 'primitives' stamp: 'bgf 10/13/2009 21:53'!
primitiveCameraName: cameraIndex
	"The user-friendly utf-8 string name of this web camera device, if known"
	<primitive: 'primitiveCameraName' module: 'QWebcamPlugin'>
	self primitiveFailed! !

!QWebcam methodsFor: 'primitives' stamp: 'jcg 1/4/2008 00:29'!
primitiveCameraPause: cameraIndex
	<primitive: 'primitiveCameraPause' module: 'QWebcamPlugin'>
	self primitiveFailed! !

!QWebcam methodsFor: 'primitives' stamp: 'jcg 1/13/2008 00:15'!
primitiveCameraReadFrame: bufferAddress size: bufferSize into: bitmap
	<primitive: 'primitiveCameraReadFrame' module: 'QWebcamPlugin'>
	self primitiveFailed! !

!QWebcam methodsFor: 'primitives' stamp: 'jcg 1/4/2008 00:29'!
primitiveCameraRun: cameraIndex
	<primitive: 'primitiveCameraRun' module: 'QWebcamPlugin'>
	self primitiveFailed! !

!QWebcam methodsFor: 'primitives' stamp: 'jcg 1/4/2008 00:29'!
primitiveCameraStop: cameraIndex
	<primitive: 'primitiveCameraStop' module: 'QWebcamPlugin'>
	self primitiveFailed! !

!QWebcam methodsFor: 'primitives' stamp: 'bgf 10/13/2009 21:55'!
primitiveCameraUID: cameraIndex
	"The persistent UID string which can be used to identify this camera device
	 across application-sessions; should match the device UID string 
	 returned by the listing primitives (i.e. primCamDeviceUID: devIndex)."

	<primitive: 'primitiveCameraUID' module: 'QWebcamPlugin'>
	self primitiveFailed! !

!QWebcam methodsFor: 'primitives' stamp: 'bgf 10/13/2009 21:31'!
primitiveCreateCamera: uid args: cameraArgs argsSize: argsSize feedbackChannel: channelHandle 
	"Activate the given camera device (identified by the UID).
   	 This is the newer device-specific extended form;
  	 the simpler original method primitiveCreateCamera:argSize:feedbackChannel
	 opens the system default video capture device.
	 (Passing uid nil to this primitive also opens the default device.)"

	<primitive: 'primitiveCreateCameraByUID' module: 'QWebcamPlugin'>
	self primitiveFailed! !

!QWebcam methodsFor: 'primitives' stamp: 'jcg 1/12/2008 16:41'!
primitiveCreateCamera: cameraArgs argsSize: argsSize feedbackChannel: channelHandle 
	<primitive: 'primitiveCreateCamera' module: 'QWebcamPlugin'>
	self primitiveFailed! !

!QWebcam methodsFor: 'primitives' stamp: 'jcg 1/3/2008 23:11'!
primitiveDestroyCamera: cameraIndex
	<primitive: 'primitiveDestroyCamera' module: 'QWebcamPlugin'>
	self primitiveFailed! !

!QWebcam methodsFor: 'primitives' stamp: 'jcg 1/13/2008 00:28'!
primitiveUtilRead: bufferAddress into: bitmap size: bufferSize
	<primitive: 'primitiveUtilReadIntoBitmap' module: 'QWebcamPlugin'>
	self primitiveFailed! !

!QWebcam methodsFor: 'primitives' stamp: 'jcg 1/13/2008 00:28'!
primitiveUtilRead: bufferAddress intoBitmap: bitmap size: bufferSize
	<primitive: 'primitiveUtilReadIntoBitmap' module: 'QWebcamPlugin'>
	self primitiveFailed! !

!QWebcam methodsFor: 'subclass responsibilities' stamp: 'jcg 1/12/2008 20:21'!
privateDestroy
	"Nothing to do."! !

!QWebcam methodsFor: 'subclass responsibilities' stamp: 'bgf 10/15/2009 15:09'!
privateSetCameraFrameRate
	| params paramsHandle |
	handle ifNil: [^self].
	params := QWebcamParams new.
	paramsHandle := params getHandle.
	params
		width: frameExtent x;
		height: frameExtent y;
		fps: fps.
	self primitiveCameraAdjust: handle args: paramsHandle argsSize: paramsHandle byteSize.
! !

!QWebcam methodsFor: 'subclass responsibilities' stamp: 'bgf 10/16/2009 12:56'!
privateStartRecording
	self startWatchdog.
	handle ifNotNil:[ self  primitiveCameraRun: handle ].! !

!QWebcam methodsFor: 'subclass responsibilities' stamp: 'bgf 10/16/2009 12:56'!
privateStopRecording
	self stopWatchdog.
	handle ifNotNil: [ self primitiveCameraPause: handle ].
! !

!QWebcam methodsFor: 'double-dispatch' stamp: 'bgf 10/8/2009 17:35'!
readFrameFrom: event "a QVideoFrameEvent"
	| form buf bufSize bits |

	"Keep watchdog happy."
	lastFrameTime := Time coarseClockValue.

	form := self nextForm.
	buf := event buffer.
	bufSize := event bufferSize.
	bits := form bits.
	bits byteSize = bufSize ifFalse: [self error: 'form size does not match buffer size'].
	self primitiveUtilRead: buf getHandle intoBitmap: bits size: bufSize.
	
	Smalltalk platformName = 'Win32' ifTrue: [
		"I would love do to this within DirectShow, 
		but not every capture device supports the IAMVideoControl interface 
		(for example, my Firewire iSight doesn't).  Bollocks."
		form flipVertically. 
	].

	"(FormCanvas on: form) 
		drawString: 'time: ', event sampleTime 
		at: 10@10 
		font: ((TTCFont family: 'BitstreamVeraSans' size: 14) emphasis: 1)
		color: Color green."
	
	self signalGrabbedFrame: form.! !

!QWebcam methodsFor: 'watchdog' stamp: 'jcg 5/18/2009 11:58'!
runWatchdog
	"Make sure that, if we're recording, we're actually seeing frames coming it.  Otherwise, give the camera a quick 'reboot' to get it going again (we are on Windows, after all)."
	| watchPeriod |
	watchPeriod := 4000.
	lastFrameTime := Time coarseClockValue.
	[true] whileTrue: [
		(Delay forMilliseconds: watchPeriod*2) wait.
		(Time coarseMillisecondsSince: lastFrameTime) > watchPeriod ifTrue: [
			mutex critical: [
				"Exit early if we're no longer responsible for watching this camera."
				Processor activeProcess == watchdog ifFalse: [^self].
				isRecording ifFalse: [^watchdog := nil].

				"If we reach here, give the camera a quick pause/unpause."
				QLogger logWarning: 'restarting camera: no frame for ', watchPeriod, 'ms'.
				self privateStopRecording.
				(Delay forMilliseconds: 200) wait.  "not sure if necessary"
				self privateStartRecording.
			].
		].
	].! !

!QWebcam methodsFor: 'watchdog' stamp: 'jcg 5/8/2009 20:20'!
startWatchdog
	mutex critical: [
		watchdog := self 
						forkSuspended: #runWatchdog 
						at: Processor userSchedulingPriority.
		watchdog resume.
	]! !

!QWebcam methodsFor: 'watchdog' stamp: 'jcg 5/8/2009 20:18'!
stopWatchdog
	mutex critical: [watchdog := nil "it will kill itself"].! !

!QWebcamConstants class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QWebcamConstants class methodsFor: 'initialize' stamp: 'jcg 1/9/2008 15:38'!
initialize
	"QWebcamConstants initialize"
	
	FrameWasRead := 1.! !

QPluginFeedbackChannel subclass: #QWebcamFeedbackChannel
	instanceVariableNames: 'camera'
	classVariableNames: ''
	poolDictionaries: 'QWebcamConstants'
	category: 'Qwaq-Video-PluginFeedback'!

!QWebcamFeedbackChannel commentStamp: 'jcg 3/7/2008 11:18' prior: 0!
Concrete subclass of QPluginFeedbackChannel.

!

!QWebcamFeedbackChannel class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QWebcamFeedbackChannel methodsFor: 'initialize' stamp: 'jcg 1/13/2008 00:09'!
camera: aQWebcam
	camera := aQWebcam! !

!QWebcamFeedbackChannel methodsFor: 'subclass responsibilities' stamp: 'jcg 1/13/2008 11:37'!
initializeTypeMap
	typeMap := {
		FrameWasRead -> QVideoFrameEvent.
	}.
! !

!QWebcamFeedbackChannel methodsFor: 'subclass responsibilities' stamp: 'jcg 1/12/2008 21:11'!
primitiveCreateFeedbackChannel: bytes semaphoreIndex: semaphoreIndex
	"Fill 'bytes' with a pointer to a feedback channel."
	<primitive: 'primitiveCreateFeedbackChannel' module: 'QWebcamPlugin'>
	self primitiveFailed! !

!QWebcamFeedbackChannel methodsFor: 'subclass responsibilities' stamp: 'jcg 7/22/2008 01:37'!
primitiveDestroyFeedbackChannel: hndl
	"Destroy the feedback channel (implement interface specified by superclass)."
	<primitive: 'primitiveDestroyFeedbackChannel' module: 'QWebcamPlugin'>
	self primitiveFailed! !

!QWebcamFeedbackChannel methodsFor: 'subclass responsibilities' stamp: 'jcg 1/12/2008 21:21'!
primitiveGetEvent: hndl
	<primitive: 'primitiveFeedbackChannelReadEvent' module: 'QWebcamPlugin'>
	^self primitiveFailed! !

!QWebcamFeedbackChannel methodsFor: 'subclass responsibilities' stamp: 'jcg 1/12/2008 21:34'!
primitivePopEvent: hndl
	<primitive: 'primitiveFeedbackChannelPopEvent' module: 'QWebcamPlugin'>
	^self primitiveFailed ! !

!QWebcamFeedbackChannel methodsFor: 'subclass responsibilities' stamp: 'jcg 1/13/2008 00:11'!
processEvent: event
	event processIn: camera
! !

QEventLoop subclass: #QSecureWebcastManager
	instanceVariableNames: 'view webcasts feeds textures videoDisabled errorCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-Session'!

!QSecureWebcastManager commentStamp: '<historical>' prior: 0!
(c) 2007 Qwaq Inc.  QSecureWebcastManager is responsible for keeping track of all of the incoming video streams to be decoded and displayed.  It keeps track of two types of entities: QClientVideoTextures and "webcasts".  The former have a 1-1 relationship with QVideoTextures, and each of the latter may reference multiple QClientVideoTextures (this relationship is not bi-directional).   In other words, multiple textures can use the same video stream.

There are several classes that can act as "webcasts".  They include QSecureWebcast and QStreamingVideoDecoder.
!

!QSecureWebcastManager class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QSecureWebcastManager methodsFor: 'decoder access' stamp: 'jcg 12/30/2009 14:30'!
addClient: aQClientVideoTexture of: sessionID description: desc controller: aController
	| webcast |

	self currentlyInEventLoop ifFalse: [
		^self future 
				addClient: aQClientVideoTexture 
				of: sessionID 
				description: desc 
				controller: aController
	].

	webcast := webcasts at: sessionID ifAbsentPut: [self 
													createWebcastFor: sessionID
													description: desc
													controller: aController].
	webcast addClientTexture: aQClientVideoTexture.! !

!QSecureWebcastManager methodsFor: 'private' stamp: 'crl 2/4/2010 17:12'!
createClientVideoCameraFor: videoCameraRef controller: aController
	^QClientVideoCamera for: videoCameraRef manager: self controller: aController! !

!QSecureWebcastManager methodsFor: 'private' stamp: 'ar 10/22/2007 12:22'!
createClientVideoTextureFor: videoTextureRef controller: aController
	^QClientVideoTexture for: videoTextureRef manager: self controller: aController! !

!QSecureWebcastManager methodsFor: 'private' stamp: 'jcg 1/31/2008 18:39'!
createDecoderFor: streamID description: desc controller: aController
	| decoder | 
	decoder := QStreamingVideoDecoder 
								forStreamID: streamID 
								manager: self 
								description: desc
								controller: aController.
	self signal: #addedDecoder with: decoder.
	^decoder
	! !

!QSecureWebcastManager methodsFor: 'private' stamp: 'jcg 5/20/2010 16:42'!
createWebcastFor: sessionID description: desc controller: aController
	^desc class caseOf: {
		[QWebcastRecord]->[
			| webcast |
			webcast := QSecureWebcast 
							description: desc 
							manager: self 
							controller: aController.
			self signal: #addedWebcast with: webcast.
			self runScript: #onWebcastDestroyed: when: {webcast. #destroyed}.
			webcast
		].
		[QStreamingVideoV1FileCardContents]->[
			| decoder |
			decoder := QStreamingVideoDecoder 
										forStreamID: sessionID 
										manager: self 
										description: desc
										controller: aController.
			self signal: #addedDecoder with: decoder.
			self runScript: #onWebcastDestroyed: when: {decoder. #destroyed}.
			decoder
		]
	} otherwise: [QLogger logWarning: 'unexpected video-description class: ', desc class].
	
	! !

!QSecureWebcastManager methodsFor: 'private' stamp: 'crl 12/17/2009 15:32'!
critical: aBlock
	self shouldNotImplement.  "we're an event-loop now!!"
! !

!QSecureWebcastManager methodsFor: 'actions' stamp: 'crl 12/17/2009 15:34'!
destroyAllTexturesAndDecoders
	
	self currentlyInEventLoop ifFalse: [^self future destroyAllTexturesAndDecoders].

	textures copy do: [:tex | tex destroy].
	
	"Paranoid."
	textures ifNotEmpty: [
		QLogger logWarning:  textures size printString, ' destroyed textures still in dict'
	].
	webcasts ifNotEmpty: [
		QLogger logWarning:  webcasts size printString, ' destroyed webcasts still in dict'
	].! !

!QSecureWebcastManager methodsFor: 'initialize' stamp: 'crl 12/17/2009 15:31'!
discardIsland: aStaleIslandRef
	"Cleanup for selective island logout."

	self currentlyInEventLoop ifFalse: [^self future discardIsland: aStaleIslandRef].

	textures clone keysAndValuesDo: [ : oid : txtr |
		txtr ref island value = aStaleIslandRef value ifTrue: [
			txtr destroy.
			textures removeKey: oid ifAbsent: [].
		]].! !

!QSecureWebcastManager methodsFor: 'private' stamp: 'jcg 5/20/2010 17:32'!
handleEventLoopError: err
	"Email a bug-report if we're a sealed app, or pop open a debugger if not."
	| ui |

	eventLoop avoidDeath.  "Let's try to struggle on."

	"Ensure that we can properly report the error."
	ui := view ifNotNil: [:v | v owner].
	ui ifNil: [
		QLogger logWarning: 'no UI available to report error'.
		QLogger logError: err.
		^self
	].

	ui isSealedApplication 
		ifFalse: [err pass "handy for debugging"]
		ifTrue: [
			| stack |
			errorCount := errorCount + 1.
			errorCount > 5 ifTrue: [
				"Don't spam too many emails."
				^QLogger logWarning: 'only reporting 5 errors, this is number ', errorCount
			].
			stack := [err signalerContext stackOfSize: 200] on: Error do: [
				QLogger logWarning: 'failed to get stack in #handleError'.
				OrderedCollection new
			].
			ui 
				reportIncident: 'QSecureWebcastManager event-loop error number: ', errorCount 
				error: err 
				stack: stack
		]
! !

!QSecureWebcastManager methodsFor: 'initialize' stamp: 'jcg 5/20/2010 17:22'!
initialize
	super initialize.
	"isDebugging := true."
	textures := Dictionary new.
	feeds := Dictionary new.
	webcasts := Dictionary new.
	videoDisabled := false.
	errorCount := 0.
! !

!QSecureWebcastManager methodsFor: 'accessing' stamp: 'crl 12/17/2009 15:56'!
numWebcasts
	self currentlyInEventLoop ifFalse: [^self future numWebcasts].
	^webcasts size! !

!QSecureWebcastManager methodsFor: 'events' stamp: 'crl 1/4/2010 17:46'!
onWebcastDestroyed: aSecureWebcast
	self currentlyInEventLoop ifFalse: [^self future onWebcastDestroyed: aSecureWebcast].
	QLogger logInfo: 'YYYYY: attempting to remove a webcast.'.
	webcasts removeKey: aSecureWebcast sessionID ifAbsent: [QLogger logWarning: 'attempt to remove non-existent webcast']! !

!QSecureWebcastManager methodsFor: 'initialize' stamp: 'crl 12/17/2009 15:14'!
privateDestroy
	super privateDestroy.
	self destroyAllTexturesAndDecoders! !

!QSecureWebcastManager methodsFor: 'private' stamp: 'jcg 12/30/2009 17:28'!
randomizeWebcastColors
	"for debuggin'... remove me soon"
	"webcasts do: [:wcast |
		(wcast respondsTo: #changeColor:) ifTrue: [wcast future changeColor: Color random]
	]"! !

!QSecureWebcastManager methodsFor: 'decoder access' stamp: 'crl 5/19/2010 12:18'!
removeClient: aQClientVideoTexture of: sessionID
	| webcast |
	self currentlyInEventLoop ifFalse: [^self future removeClient: aQClientVideoTexture of: sessionID].

	webcast := webcasts 
					at: sessionID 
					ifAbsent: [ ^QLogger logWarning: 'no webcast with sessionID: ', sessionID].	

	"Remove the specified client, and check if anyone is still using the webcast.  If not, destroy it."							
	webcast removeClientTexture: aQClientVideoTexture.
	webcast hasClients ifFalse: [webcast future destroy]! !

!QSecureWebcastManager methodsFor: 'private' stamp: 'crl 12/18/2009 14:43'!
removeClientTexture: tex " a QClientVideoTexture"
	self currentlyInEventLoop ifFalse: [^self future removeClientTexture: tex].
	textures 
		removeKey: tex objectID 
		ifAbsent: [QLogger logInfo: 'asked to remove absent texture: ', tex objectID hex]! !

!QSecureWebcastManager methodsFor: 'actions' stamp: 'crl 4/22/2010 18:08'!
resetSpeakers
	webcasts do: [:webcast | webcast resetSpeakerInputs]! !

!QSecureWebcastManager methodsFor: 'actions' stamp: 'jcg 12/28/2009 12:34'!
resumeVideo
	self videoDisabled: false
! !

!QSecureWebcastManager methodsFor: 'accessing' stamp: 'crl 1/11/2010 14:23'!
speakerManager
	^view audioSession speakerManager! !

!QSecureWebcastManager methodsFor: 'actions' stamp: 'jcg 12/28/2009 12:34'!
suspendVideo
	self videoDisabled: true
! !

!QSecureWebcastManager methodsFor: 'actions' stamp: 'jcg 8/8/2007 14:44'!
updateDecodersInIsland: anIsland
	self error: '#updateDecodersInIsland: ...  not yet implemented'! !

!QSecureWebcastManager methodsFor: 'actions' stamp: 'crl 2/4/2010 17:12'!
updateVideoFeedsInIsland: anIsland
	"Keep replicated video cameras in sync with non-replicated video feeds (at the moment, a feed is a combination of viewpoint/quality/netvidserver)."
	"This replaces the list, rather than editing it."

	self currentlyInEventLoop ifFalse: [^self future updateVideoFeedsInIsland: anIsland].

	feeds := TClientObject
					matchupWithResources: QVideoCamera resourceType
					in: anIsland
					existing: feeds
					createWith: [:ref | 
						| cc |
						cc := ref controller.
						cc isMediaController ifFalse:[cc := view session mediaController].
						self createClientVideoCameraFor: ref controller: cc.
					]

! !

!QSecureWebcastManager methodsFor: 'actions' stamp: 'crl 12/18/2009 14:23'!
updateVideoTexturesInIsland: anIsland
	"Keep replicated video-textures in sync with non-replicated video-decoders.
	 This replaces the list, rather than editing it."
	self currentlyInEventLoop ifFalse: [^self future updateVideoTexturesInIsland: anIsland].

	textures := TClientObject
					matchupWithResources: QWebcamTexture resourceType
					in: anIsland
					existing: textures
					createWith: [:ref | 
						| cc |
						cc := ref controller.
						cc isMediaController ifFalse:[cc := view session mediaController].
						self createClientVideoTextureFor: ref controller: cc.
					]

! !

!QSecureWebcastManager methodsFor: 'accessing' stamp: 'jcg 5/14/2008 17:57'!
videoDisabled
	"Is video decoding globally disabled?"
	^videoDisabled! !

!QSecureWebcastManager methodsFor: 'private' stamp: 'crl 12/17/2009 17:19'!
videoDisabled: trueOrFalse
	"Is video decoding globally disabled?"
	self currentlyInEventLoop ifFalse: [^self future videoDisabled: trueOrFalse].
	videoDisabled = trueOrFalse ifTrue: [^self "no change"].
	videoDisabled := trueOrFalse.
	self signal: #videoGloballyDisabled with: videoDisabled.
! !

!QSecureWebcastManager methodsFor: 'accessing' stamp: 'jcg 8/9/2007 17:43'!
view
	^view! !

!QSecureWebcastManager methodsFor: 'initialize' stamp: 'crl 12/17/2009 15:54'!
view: aCroquetView
	self currentlyInEventLoop ifFalse: [^self future view: aCroquetView].
	view == aCroquetView ifTrue: [^self "no change"].
	view ifNotNil: [
		"We do this for symmetry with QSpeakerManager>>view: .  What does it mean to change views?"
		self error: 'view already assigned'.
	].
	view := aCroquetView.
	self videoDisabled: view owner preferences videoDisabled.! !

QEventLoop subclass: #QSessionRecorder
	instanceVariableNames: 'sessionID netVidClient netVidServices sessionName finalizer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Recorder'!

!QSessionRecorder commentStamp: '<historical>' prior: 0!
Server-side component that subscribes to a QNetVidServer and records the data received from its tracks.!

!QSessionRecorder class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QSessionRecorder methodsFor: 'accessing' stamp: 'jcg 4/15/2010 11:29'!
cacheDir
	^finalizer cacheDir! !

!QSessionRecorder methodsFor: 'initialize' stamp: 'jcg 8/16/2010 12:33'!
connectNetVidControlStream: controlStreamID netVidServices: services
	self currentlyInEventLoop ifFalse: [
		self future 
			connectNetVidControlStream: controlStreamID 
			netVidServices: services.
		^self "so compiler generates #futureDo:, not #futureSend:"
	].

	"Do it this way (instead of using #newWithControlStream:streamManager)
	 for several reasons: 
		- we can block until 'netVidClient' connects or times out.
		- we can set up"
	netVidClient := QSessionRecorderNetVidClient new.
	netVidClient recorder: self.
	netVidClient streamManager: services streamManager.
	netVidClient updateTrackBlock: [self onTracksChanged].
	self 
		runScript: #finalizeRecordingAndDestroy 
		when: {netVidClient. #controlStreamDestroyed}.
	[(netVidClient future subscribeToControlStream: controlStreamID) wait]
		on: TPromiseWasBroken
		do:	[QLogger logWarning: 'subscription to control-stream failed'.
			 self destroy].
							! !

!QSessionRecorder methodsFor: 'private' stamp: 'ar 4/16/2011 17:45'!
finalizeRecordingAndDestroy
	"WARNING!!  This is being run from within the NetVidClient's event-loop (so it's OK to futz with the client's players)."
	| playerCount |

	"Sanity check... we should always have tracks."
	playerCount := netVidClient videoPlayers size + netVidClient audioPlayers size.
	playerCount = 0 
		ifTrue: [QLogger logWarning: 'finalizing, but there are no tracks']
		ifFalse: [
			QLogger logInfo: 'finalizing session with ', 
									playerCount, ' tracks: ', sessionName.
		].

	"Catch server misconfigurations."
	MP4Box smokeTest.

	"For some reason, we need to add video before audio (nothing in MP4Box
	 docs about this).  Can't use #allPlayers, because the result is result is an
	 IdentitySet, and hence iteration order is 'undefined'."
	netVidClient videoPlayers do: [:player | player output finalizeRecording: finalizer].
	netVidClient audioPlayers do: [:player | player output finalizeRecording: finalizer].

	"Rename/move the recorded file to it's final destination, and rename the cache-dir so
	 it's just as if the MP4 were dropped into OpenQwaq from the user's file-system."
	[	
		finalizer renameNewMP4.
		finalizer renameCacheDirUsingSHA.
	] on: Error do: [:err |
		| msg |
		msg := String streamContents: [:s |
			s nextPutAll: 'Failed to convert recorded session into MP4 file (', err description, ')'.
			s cr; tab; nextPutAll: ' video-players: ', netVidClient videoPlayers size.
			s cr; tab; nextPutAll: ' audio-players: ', netVidClient audioPlayers size.
			s cr; tab; nextPutAll: ' doc-path: ', finalizer docPath.
			s cr; tab; nextPutAll: ' cache-dir: ', finalizer cacheDir.
		].
		QLogger logError: msg.
	].
	self future destroy.! !

!QSessionRecorder methodsFor: 'initialize' stamp: 'ar 4/16/2011 18:57'!
handleRequest: xmlNode fromConnection: connection
	| slash |
	self currentlyInEventLoop ifFalse: [
		self future 
			handleRequest: xmlNode 
			fromConnection: connection.
		^self "so compiler generates #futureDo:, not #futureSend:"
	].

	[
		| xmlReq service realmPath originatorName cacheDir docPath |

		xmlReq := xmlNode elements first.
		xmlReq name = #record ifFalse: [
			| msg |
			msg := 'unknown request #', xmlReq name, 
					' (#record is the only valid request type)'.
			QLogger logError: msg.
			^connection sendFailureResponse: msg request: xmlNode
		].
		sessionName := xmlReq contentStringAt: 'sessionName'.
		service := xmlReq contentStringAt: 'service'.
		realmPath := xmlReq contentStringAt: 'path'.
		originatorName := xmlReq contentStringAt: 'originator'.

		"Avoid race condition by setting up finalizer before connecting the netvid-client."
		slash := FileDirectory slash.
		cacheDir := netVidServices cacheDir fullName, slash, sessionName, '--', TObjectID new hex.
		docPath := netVidServices realmsPath, slash, realmPath, slash, 'services', slash, service, slash, 'sharedDocuments', slash, originatorName, slash, sessionName, '.mp4'.
		QLogger logInfo: 'using cache-dir:  ', cacheDir.
		QLogger logInfo: 'final destination: ', docPath.
		finalizer := QSessionRecorderFinalizer new.
		finalizer cacheDir: cacheDir.
		finalizer docPath: docPath.
		
		"Create and connect NetVid client, so that we can communicate with the
		 OpenQwaq-client that is doing the recording."
		self connectNetVidControlStream: sessionID netVidServices: netVidServices.
		netVidClient isConnected ifFalse: [
			| msg |
			msg := 'failed to connect to audio/video feed'.
			QLogger logError: msg.
			^connection sendFailureResponse: msg request: xmlNode
		].
			
		"Write some metadata so that we can recover the recording if it is interrupted
		 (at least the part recorded so far)."
		finalizer writeMetadata.  
		
		connection sendXMLResponse: 'ok' contents: [:ignore | ] request: xmlNode.
	] on: Error do: [:err |
		| msg |
		msg := 'Unexpected error while starting session-recording'.
		QLogger logError: msg.
		QLogger logError: err.
		connection
			sendFailureResponse: msg, ': ', err description
			request: xmlNode
	].! !

!QSessionRecorder methodsFor: 'initialize' stamp: 'jcg 8/16/2010 12:27'!
netVidServices: aQNetVidServices
	netVidServices := aQNetVidServices
! !

!QSessionRecorder methodsFor: 'services' stamp: 'jcg 4/22/2010 15:21'!
notifyServicesOfDestruction: aQNetVidServices
	"So that the script is attached to us, instead of the much longer-lived services (where repeated destruction of recorders would end up bloating the scripts dictionary)."
	aQNetVidServices recorderDestroyed: self sessionID! !

!QSessionRecorder methodsFor: 'private' stamp: 'jcg 8/11/2009 23:38'!
onTracksChanged
	"Make track-players active."
	netVidClient audioPlayers do: [:pl | netVidClient addAudioPlayer: pl].
	netVidClient videoPlayers do: [:pl | netVidClient addVideoPlayer: pl].
! !

!QSessionRecorder methodsFor: 'initialize' stamp: 'jcg 8/23/2009 15:40'!
privateDestroy
	netVidClient future destroy.
	! !

!QSessionRecorder methodsFor: 'accessing' stamp: 'jcg 8/6/2009 19:12'!
sessionID
	^sessionID! !

!QSessionRecorder methodsFor: 'initialize' stamp: 'jcg 8/16/2010 12:25'!
sessionID: controlStreamID
	"Reuse NetVid control-stream ID as the recording-session ID."
	sessionID ifNotNil: [self error: 'attempting to set up session-recorder twice'].
	sessionID := controlStreamID.
	! !

!QSessionRecorder methodsFor: 'accessing' stamp: 'jcg 8/6/2009 15:06'!
sessionName
	^sessionName! !

QNetworkClient subclass: #QNetVidClient
	instanceVariableNames: 'playState assetState assetErrorDescription stopwatch videoPlayers audioPlayers activePlayers videoRenderBlock audioRenderBlock updateTrackBlock videoPaused audioPaused seekPromise nextSeekTime duration isLooping supportsPlayAfterSeek'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Client'!

!QNetVidClient commentStamp: '<historical>' prior: 0!
A QNetVidClient is responsible for playing video streamed by a QNetVidServer.  The server may publish multiple audio and video streams, each one providing a different quality/bitrate tradeoff.  The QNetVidClient is responsible for managing subscriptions to these streams, including unpausing only the ones corresponding to the currently-desired quality level.

Final rendering of the decoded audio/video frames is Somebody Else's Problem.  See #audioRenderBlock: and #videoRenderBlock:  !

!QNetVidClient class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QNetVidClient methodsFor: 'private' stamp: 'ar 3/20/2009 15:55'!
addAudioPlayer: player "a QNetVidAudioTrackPlayer"
	(activePlayers includes: player) ifFalse:[
		activePlayers add: player.
		audioPaused 
			ifTrue: [player pause]
			ifFalse: [player unpause]
	].
! !

!QNetVidClient methodsFor: 'private' stamp: 'ar 3/20/2009 15:52'!
addVideoPlayer: player "a QNetVidVideoTrackPlayer"
	(activePlayers includes: player) ifFalse:[
		activePlayers add: player.
		videoPaused 
			ifTrue: [player pause]
			ifFalse: [player unpause]
	].
! !

!QNetVidClient methodsFor: 'initialize' stamp: 'jcg 8/7/2009 16:03'!
allPlayers
	^audioPlayers, videoPlayers! !

!QNetVidClient methodsFor: 'accessing' stamp: 'jcg 3/31/2009 00:13'!
assetErrorDescription
	"If there was an error with the initial, server-side processing of our current video-asset, it is propagated to the client to be displayed to the user."
	^assetErrorDescription! !

!QNetVidClient methodsFor: 'accessing' stamp: 'jcg 3/30/2009 15:03'!
assetState
	^assetState! !

!QNetVidClient methodsFor: 'private' stamp: 'jcg 3/30/2009 15:03'!
assetState: newState
	"Handle stuff that must be taken care of when leaving a state, no matter which new state we're entering.  Finally, notify listeners that state has changed."
	assetState == newState ifTrue: [^self "state didn't change"].
	assetState := newState.
	self signal: #assetStateChanged with: newState.
! !

!QNetVidClient methodsFor: 'accessing' stamp: 'jcg 2/11/2009 23:53'!
audioPlayers
	^audioPlayers! !

!QNetVidClient methodsFor: 'initialize' stamp: 'jcg 2/1/2009 18:49'!
audioRenderBlock: aBlock
	"When a decoded SoundBuffer (or whatever... we're focusing on video right now) is obtained from the decoder, invoke the specified block with the Form as the argument."
	audioRenderBlock := aBlock.! !

!QNetVidClient methodsFor: 'accessing' stamp: 'jcg 8/27/2009 23:54'!
bandwidth
	"Not yet implemented... here as a placeholder that can be used by #sdp."
	^nil! !

!QNetVidClient methodsFor: 'defaults' stamp: 'jcg 3/31/2010 11:33'!
createAudioPlayerOutput
	"Subclasses may override."
	^QAudioSession hasQAudioPlugin
		ifTrue: [QNetVidAudioTrackDecoder new]
		ifFalse: [QNetVidNullPlayerOutput new]! !

!QNetVidClient methodsFor: 'defaults' stamp: 'eem 3/18/2010 17:50'!
createVideoPlayerOutput
	"Subclasses may override."
	^QwaqVideoSession hasQVideoCodecPlugin
		ifTrue: [QNetVidVideoTrackDecoder new]
		ifFalse: [QNetVidNullPlayerOutput new]! !

!QNetVidClient methodsFor: 'accessing' stamp: 'jcg 2/11/2009 18:58'!
currentTime "in seconds"
	^stopwatch elapsed / 1000.0! !

!QNetVidClient methodsFor: 'private' stamp: 'jcg 2/11/2009 18:58'!
currentTime: newTime "in seconds"
	| elapsed |
	elapsed := stopwatch elapsed.
	stopwatch elapsed: (newTime * 1000) rounded "convert to msecs".
	stopwatch elapsed = elapsed ifFalse: [self signal: #currentTimeChanged]! !

!QNetVidClient methodsFor: 'private' stamp: 'ar 8/12/2009 13:53'!
decodedAudioFrame: aSoundBuffer sampleRate: sampleRate from: decoder
	audioRenderBlock ifNotNil:[audioRenderBlock value: aSoundBuffer value: sampleRate value: decoder].
! !

!QNetVidClient methodsFor: 'private' stamp: 'ar 3/20/2009 16:59'!
decodedVideoFrame: aForm from: player
	videoRenderBlock ifNotNil: [videoRenderBlock value: aForm value: player].
	aForm returnToFormPool.! !

!QNetVidClient methodsFor: 'initialize' stamp: 'jcg 6/25/2010 01:00'!
defaultProcessPriority
	"We're playing media, including audio... priority must be high."
	^Processor lowIOPriority - 1! !

!QNetVidClient methodsFor: 'accessing' stamp: 'jcg 2/3/2009 02:38'!
duration "in seconds"
	^duration! !

!QNetVidClient methodsFor: 'private' stamp: 'jcg 2/3/2009 02:38'!
duration: newDuration "in seconds"
	duration = newDuration ifFalse: [
		duration := newDuration.
		self signal: #durationChanged with: newDuration.
	]! !

!QNetVidClient methodsFor: 'ui hooks' stamp: 'jcg 4/22/2010 02:43'!
endSeek
	"Send a message upstream to resume playing for everyone."
	self currentlyInEventLoop ifFalse: [self future endSeek. ^self].
	supportsPlayAfterSeek ifFalse: [^self "no server support for this command"].
	nextSeekTime := nil.  "so that #sendNextSeek doesn't do anything"
	self sendCommand: 'endSeek' xmlBlock: [:empty | ].
	! !

!QNetVidClient methodsFor: 'private' stamp: 'jcg 4/22/2010 16:25'!
handleFeatureList: node "anXMLNode"
	"Let superclass verify it's sane."
	super handleFeatureList: node.
	features ifNil: [^self "superclass already logged the warning"].

	"Determine whether server understands the 'endSeek' command, which is used
	 to resume playing if we were playing when seeking started."
	supportsPlayAfterSeek := (features elementAt: 'resumePlayAfterSeek') notNil.! !

!QNetVidClient methodsFor: 'private' stamp: 'jcg 3/27/2009 15:16'!
handleIsLoopingCommand: node
	"The server has told whether it is looping."
	self isLooping: (self xmlBoolean: node for: 'isLooping').
! !

!QNetVidClient methodsFor: 'subclass responsibilities' stamp: 'jcg 3/27/2009 15:15'!
handleParsedCommand: node "an XMLNode"
	"Implements responsibility specified by superclass."
	[
		^(node attributeAt: 'type') caseOf: {
			['trackListing'] -> [self updateTrackListing: node].
			['play'] -> [self handlePlayCommand: node].
			['pause'] -> [self handlePauseCommand: node].
			['seek'] -> [self handleSeekCommand: node].
			['looping'] -> [self handleIsLoopingCommand: node].
		}.
	] on: Error do: [:err |
		QLogger logError: 'error while handling command: ', String crlf, node.
		QLogger logError: err.
		^nil
	].! !

!QNetVidClient methodsFor: 'private' stamp: 'jcg 3/30/2009 13:42'!
handlePauseCommand: node
	"The server has told us that we are paused (no longer playing).  React accordingly."
	| mediaTime |

	"NOTE: we don't actually pause/play any of the player's streams in response to pause/play commands from the server.  If we did, we'd likely miss the first sample after the server starts playing again (because the #unpause messages from the clients would need time to propagate up to the server); this would hurt extra for video, where we'd have to wait for the next key-frame.  Go, now, into a Forum, and pause and restart a video.  Notice how it restarts almost instantly, and think of the love and care that it took to make it happen.  That's what this is all about."

	mediaTime := Number readFrom: (node contentStringAt: 'mediaTime').
	self currentTime: mediaTime / 1000.0. "convert to seconds"
	self playState: #paused.
! !

!QNetVidClient methodsFor: 'private' stamp: 'jcg 3/30/2009 13:42'!
handlePlayCommand: node
	"The server has told us to start playing.  React accordingly."
	| mediaTime |

	"NOTE: we don't actually pause/play any of the player's streams in response to pause/play commands from the server.  If we did, we'd likely miss the first sample after the server starts playing again (because the #unpause messages from the clients would need time to propagate up to the server); this would hurt extra for video, where we'd have to wait for the next key-frame.  Go, now, into a Forum, and pause and restart a video.  Notice how it restarts almost instantly, and think of the love and care that it took to make it happen.  That's what this is all about."

	mediaTime := Number readFrom: (node contentStringAt: 'mediaTime').
	self currentTime: mediaTime / 1000.0. "convert to seconds"
	self playState: #playing.! !

!QNetVidClient methodsFor: 'private' stamp: 'jcg 2/3/2009 02:22'!
handleSeekCommand: node "an XML node"
	| time | 
	time := (node firstTagNamed: #time) characterData asNumber.
	self currentTime: time.
! !

!QNetVidClient methodsFor: 'initialize' stamp: 'jcg 4/22/2010 01:45'!
initialize
	super initialize.
	videoPlayers := IdentitySet new.
	audioPlayers := IdentitySet new.
	activePlayers := IdentitySet new.
	stopwatch := QStopwatch new.
	videoPaused := audioPaused := false.
	playState := #paused.
	assetState := #noMedia.
	duration := 0.0.
	isLooping := false.

	"We don't automatically resume playing after seeking unless the server
	 has informed us that it supports this feature."
	supportsPlayAfterSeek := false.! !

!QNetVidClient methodsFor: 'testing' stamp: 'jcg 2/28/2009 19:00'!
isAudioPaused
	^audioPaused! !

!QNetVidClient methodsFor: 'accessing' stamp: 'jcg 3/27/2009 15:08'!
isLooping
	"Answer whether the video-stream will loop to the beginning after finishing playing.  You can also listen for #isLoopingChanged."
	^isLooping! !

!QNetVidClient methodsFor: 'private' stamp: 'jcg 3/27/2009 15:06'!
isLooping: newValue
	isLooping = newValue ifTrue: [^self].
	isLooping := newValue.
	self signal: #isLoopingChanged with: isLooping.! !

!QNetVidClient methodsFor: 'testing' stamp: 'jcg 3/30/2009 13:37'!
isPlaying
	^playState == #playing! !

!QNetVidClient methodsFor: 'testing' stamp: 'jcg 2/28/2009 19:01'!
isVideoPaused
	^videoPaused! !

!QNetVidClient methodsFor: 'ui hooks' stamp: 'jcg 3/30/2009 13:37'!
pause
	"Send a message upstream to pause playing for everyone."
	self currentlyInEventLoop ifFalse: [self future pause. ^self].
	playState == #paused ifTrue: [^self].
	self sendCommand: 'pause' xmlBlock: [:empty | ].
	! !

!QNetVidClient methodsFor: 'ui hooks' stamp: 'ar 3/20/2009 15:56'!
pauseAudio
	"Pause audio for only this client."
	audioPaused ifTrue: [^self "already paused"].
	audioPaused := true.
	activePlayers do:[:p| p isAudio ifTrue:[p pause]].! !

!QNetVidClient methodsFor: 'ui hooks' stamp: 'ar 10/19/2009 19:07'!
pauseLocally
	"Pause all the streams in this player"
	self currentlyInEventLoop ifFalse: [self future pauseLocally. ^self].
	self allPlayers do:[:trackPlayer| trackPlayer pause].! !

!QNetVidClient methodsFor: 'ui hooks' stamp: 'jcg 7/28/2010 14:01'!
pauseVideo
	"Pause video for only this client."
	
	QJoshHacks receiveButIgnoreVideo ifTrue: [^self unpauseVideo].
	
	videoPaused ifTrue: [^self "already paused"].
	videoPaused := true.
	activePlayers do:[:p| p isVideo ifTrue:[p pause]].

! !

!QNetVidClient methodsFor: 'ui hooks' stamp: 'jcg 3/30/2009 13:37'!
play
	"Send a message upstream to resume playing for everyone."
	self currentlyInEventLoop ifFalse: [self future play. ^self].
	playState == #playing ifTrue: [^self].
	self sendCommand: 'play' xmlBlock: [:empty | ].
	! !

!QNetVidClient methodsFor: 'accessing' stamp: 'jcg 3/30/2009 13:45'!
playState
	^playState! !

!QNetVidClient methodsFor: 'private' stamp: 'jcg 3/30/2009 13:44'!
playState: newState
	playState == newState ifFalse: [
		newState == #playing
			ifTrue: [self startTicker]
			ifFalse: [self stopTicker].

		playState := newState.
		self signal: #playStateChanged with: newState.
	]! !

!QNetVidClient methodsFor: 'private' stamp: 'jcg 9/28/2009 22:08'!
playerDestroyed: trackPlayer
	"The player was destroyed... release any references to it."	

	"Andreas was right... things would be cleaner if we had a single collection of players."
	trackPlayer isAudio ifTrue: [audioPlayers remove: trackPlayer].
	trackPlayer isVideo ifTrue: [videoPlayers remove: trackPlayer].
	activePlayers remove: trackPlayer ifAbsent: [].

	QLogger logInfo: 'track-player was just destroyed: ', trackPlayer

	! !

!QNetVidClient methodsFor: 'private' stamp: 'jcg 3/26/2009 12:02'!
playerIDs
	"Answer the streamIDs of all players."
	^audioPlayers, videoPlayers collect: [:p | p streamID]! !

!QNetVidClient methodsFor: 'private' stamp: 'jcg 3/26/2009 12:20'!
playersWithIDs: listOfStreamIDs
	"Answer the streamIDs of all players."
	^audioPlayers, videoPlayers select: [:p | listOfStreamIDs includes: p streamID]! !

!QNetVidClient methodsFor: 'initialize' stamp: 'jcg 12/14/2009 08:11'!
privateDestroy
	self stopTicker.
	playState := #destroyed.
	videoPlayers do: [:p | p destroy].
	audioPlayers do: [:p | p destroy].

	"The blocks are closures with connection to island far-refs,
	 clearing them aids GC."
	videoRenderBlock := nil.
	audioRenderBlock := nil.
	updateTrackBlock := nil.

	super privateDestroy.
! !

!QNetVidClient methodsFor: 'ui hooks' stamp: 'jcg 6/16/2010 18:53'!
requestTrackListing
	| result |
	self currentlyInEventLoop ifFalse: [self future requestTrackListing. ^self].
	result := self sendRequest: 'trackListing' xmlBlock: [:empty | ].
	result whenFulfilled: [:node "an XMLNode" | 
		node 
			ifNil: [self error: 'failed request for track listing']
			ifNotNil: [
				[self updateTrackListing: node] on: Error do: [:err |
					QLogger logWarning: 'failed to process track listing: ', node.
					err pass.
				].
			]
	]
	! !

!QNetVidClient methodsFor: 'accessing' stamp: 'ar 10/19/2009 18:28'!
sdp
	"Construct an SDPSessionDescription from our currently-known tracks."
	"NOTE: if you change this, also check the similar version in QNetVidServer."
	| sdpSession range payloadType |

	[
		sdpSession := SDPSessionDescription new.
		sdpSession protocolVersion: 0.
		
		"Some placeholders."
		sdpSession 
			origin: 'PLACEHOLDER' 
			sessionID: 0 
			sessionVersion: 0 
			ipAddress: '127.0.0.1'.
		sdpSession sessionName: 'PLACEHOLDER.mp4'.

		"skip session-name, friendly-info, uri, email, and phone."
		"XXXXX: need to update for IPv6"
		sdpSession connectionData: #('IN' 'IP4' '0.0.0.0').
		sdpSession bandwidth: self bandwidth.
		sdpSession timing: #('0' '0').

		"If we know a finite duration, set it."
		range := '0- '.
		(duration isNumber and: [duration isInfinite not]) ifTrue: [range := range, duration].
		sdpSession attributes at: 'range' put: range.

		"Create the SDP descriptions for each media track."
		payloadType := 95. "One less than the first dynamic payload type."
		self allPlayers do: [:track |
			| sdpTrack |
			sdpTrack := SDPMediaDescription 
										newFromTrackInfo: track trackInfo
										payloadType: (payloadType := payloadType+1).
			sdpSession addMediaDescription: sdpTrack.
		].
	] on: Error do: [:err |
		QLogger logWarning: 'failed to create SDP because: ', err messageText.
		sdpSession := nil.
	].
	^sdpSession! !

!QNetVidClient methodsFor: 'ui hooks' stamp: 'jcg 6/16/2010 18:53'!
seekTo: seconds
	self currentlyInEventLoop ifFalse: [self future seekTo: seconds. ^self].
	
	"XXXX: what states are acceptable for seeking?  Eg: can we seek while #playing, or do we need to pause first?  Does the client manage this, or is it implicit in how the server responds to the seek-request?"

	"To avoid saturating our pipes, we limit the rate of seek requests.  We only make one request at a time, waiting until we hear back from the server (and perhaps a bit longer) before seeking again.  If we are told (by the UI controlling us) to make other seeks in the interim, we make a note of the desired seek time.  Then, when the previous request is completed, we issue another request with the most-recently recorded time." 
	seekPromise
		ifNotNil: [nextSeekTime := seconds "already seeking; wait until finished"]
		ifNil: [
			nextSeekTime := nil.  	
			seekPromise := self sendRequest: 'seek' xmlBlock: [:xml |
				xml tag: #time pcData: seconds printString.
			].
			seekPromise whenFulfilled: [:xml |
				"Limit the frequency of seek requests to < 5/second."
				[(Delay forMilliseconds: 200) wait. self future sendPendingSeek] 
					forkAt: Processor lowIOPriority.
			].
		]
! !

!QNetVidClient methodsFor: 'private' stamp: 'jcg 4/22/2010 16:23'!
sendPendingSeek
	"Finish seek after receiving confirmation from server.  If another seek request has been made in the interim, now is the time to tell the server."
	seekPromise := nil.
	nextSeekTime ifNotNil: [self seekTo: nextSeekTime].! !

!QNetVidClient methodsFor: 'ui hooks' stamp: 'jcg 3/1/2009 14:28'!
serverIsLooping: trueOrFalse
	"Send a command upstream to tell the server whether it should loop to the beginning when it finishes playing."
	self currentlyInEventLoop ifFalse: [self future serverIsLooping: trueOrFalse. ^self].

	self sendCommand: 'setProperties' xmlBlock: [:xml |
		| attr |
		attr := Dictionary new
					at: 'propName' put: 'isLooping';
					at: 'propType' put: 'Boolean';
					yourself.
		xml tag: #property attributes: attr value: trueOrFalse printString
	]! !

!QNetVidClient methodsFor: 'ticking' stamp: 'jcg 6/22/2010 18:56'!
startTicker
	"Schedule a #tick that will continue scheduling more #tick messages until stopped."
	stopwatch isRunning ifTrue: [^self "already ticking"].
	stopwatch start.
	self future tick: 0.
	! !

!QNetVidClient methodsFor: 'ticking' stamp: 'jcg 6/22/2010 19:16'!
stopTicker
	"See #tick:... if the stopwatch isn't running, then no more ticks will be scheduled."
	stopwatch stop.
	! !

!QNetVidClient methodsFor: 'initialize' stamp: 'jcg 2/1/2009 22:42'!
subscribeToControlStream: streamID
	"XXXX: a bit of a hack... we know that the superclass implementation blocks until the control-stream is established (or not)."
	super subscribeToControlStream: streamID.
	controlStream ifNotNil: [self requestTrackListing].! !

!QNetVidClient methodsFor: 'ticking' stamp: 'jcg 6/22/2010 19:02'!
tick: tickCount
	| elapsed bufferDuration nextTickCount |

	stopwatch isRunning ifFalse: [^self "we've stopped ticking"].

	elapsed := stopwatch elapsed / 1000.0.

	"XXXX: I don't like this approach to buffering.  For one thing, I don't like the fixed 0.5 second size (this should definitely change (it can add up to a lot of memory).  I also don't like lying to the players about what the time is (but I don't know exactly why, and don't have a better alternative)."
	bufferDuration := 0.5.
	videoPlayers do: [:p | p playTo: elapsed-bufferDuration].
	audioPlayers do: [:p | p playTo: elapsed-bufferDuration].
	
	"Every 20 ticks, let everyone know what time it is."
	tickCount \\ 20 = 0 
		ifFalse: [nextTickCount := tickCount + 1]
		ifTrue:
			[nextTickCount := 0.
			 self signal: #currentTimeChanged].
	
	"Schedule the next tick."
	stopwatch isRunning ifTrue: [(self future: 10) tick: nextTickCount].
! !

!QNetVidClient methodsFor: 'ui hooks' stamp: 'ar 3/20/2009 15:56'!
unpauseAudio
	"Unpause audio for only this client."
	audioPaused ifFalse: [^self "already unpaused"].
	audioPaused := false.
	activePlayers do:[:p| p isAudio ifTrue:[p unpause]].! !

!QNetVidClient methodsFor: 'ui hooks' stamp: 'ar 10/19/2009 19:07'!
unpauseLocally
	"Unpause all the streams in this player"
	self currentlyInEventLoop ifFalse: [self future unpauseLocally. ^self].
	self allPlayers do:[:trackPlayer| trackPlayer unpause].! !

!QNetVidClient methodsFor: 'ui hooks' stamp: 'ar 3/20/2009 15:53'!
unpauseVideo
	"Unpause video for only this client."
	videoPaused ifFalse: [^self "already unpaused"].
	videoPaused := false.
	activePlayers do:[:p| p isVideo ifTrue:[p unpause]].
! !

!QNetVidClient methodsFor: 'initialize' stamp: 'ar 3/20/2009 17:20'!
updateTrackBlock: aBlock
	"Hook to inform interested parties that the netvid client has received its track listing."
	updateTrackBlock := aBlock.! !

!QNetVidClient methodsFor: 'private' stamp: 'crl 5/3/2010 10:50'!
updateTrackListing: node "an XMLNode"
	"Set up the client to play the audio/video specified in the new track listing."
	| listedIDs currentIDs newIDs missingIDs newPlayers |

	"Sanity check"
	node name == #command ifFalse: [self error: 'expected a <command> element'].
	(node attributeAt: 'type' ifAbsent: [nil]) = 'trackListing' 
		ifFalse: [self error: 'expected a <command> element with type=trackListing'].

	"First thing, check for errors."
	(node elementAt: #assetState) ifNotNilDo: [:elem |
		elem contentString = 'error' ifTrue: [
			assetState := #error.
			assetErrorDescription := elem contentStringAt: 'description'.
			updateTrackBlock ifNotNil:[updateTrackBlock value].
			^QLogger logWarning: 'track-listing failed: ', assetErrorDescription.
		].
	].

	"Get information like current state, total duration, etc."
	self duration: (node firstTagNamed: #duration) characterData asNumber.
	self currentTime: 
			(node firstTagNamed: #currentTime) characterData asNumber / 1000.

	"XXXX: if we don't see a #playState node, we're dealing with an old server, so just look for a #state node.   Otherwise, we should find both a #playState and an #assetState node."
	(node firstTagNamed: #playState)
		ifNil: [ "old"
			| state |
			state := (node firstTagNamed: #state) characterData asSymbol.
			state == #noMedia 
				ifTrue: [
					self assetState: #noMedia.
					self playState: #paused.
				]
				ifFalse: [
					self assetState: #ready. "XXXX: should read actual state"
					self playState: state.
				]
		]
		ifNotNil: [ "new"
			self assetState: (node firstTagNamed: #assetState) characterData asSymbol.
			self playState: (node firstTagNamed: #playState) characterData asSymbol
		].

	"Determine which tracks are new to us, and which existing tracks are missing (i.e. destroyed).  We don't do anything with tracks that we already know."
	listedIDs := node 
					tagsNamed: #track 
					collect: [:elem | self xmlOID: elem for: 'streamID'].
	currentIDs := self playerIDs.
	newIDs := listedIDs difference: currentIDs.
	missingIDs := currentIDs difference: listedIDs.

	"Destroy players that no longer appear in the track-listing."
	(self playersWithIDs: missingIDs) do: [:player | player destroy].

	"Create a new player for each new track in the listing."
	newPlayers := OrderedCollection new.
	node tagsNamed: #track do: [:elem |
		(newIDs includes: (self xmlOID: elem for: 'streamID')) ifTrue: [
			| player |
			player := QNetVidTrackPlayer newForClient: self fromXmlElement: elem.
			self runScript: [:pl | self playerDestroyed: pl] when: {player. #destroyed}.
			player isAudio ifTrue: [audioPlayers add: player].
			player isVideo ifTrue: [videoPlayers add: player].
			newPlayers add: player.
			QLogger logInfo: 'added new track-player: ', player.
		].
	].

	"Inform interested parties about the track update"
	((newIDs asArray), (missingIDs asArray)) ifNotEmpty: [
		"This is now also available as a signal, but we still support 'updateTrackBlock'."
		updateTrackBlock ifNotNil:[updateTrackBlock value].
		self signal: #tracksChanged with: self with: self allPlayers with: node.
	].
	! !

!QNetVidClient methodsFor: 'accessing' stamp: 'jcg 2/11/2009 23:53'!
videoPlayers
	^videoPlayers! !

!QNetVidClient methodsFor: 'initialize' stamp: 'jcg 2/1/2009 18:48'!
videoRenderBlock: aBlock
	"When a decoded Form is obtained from the decoder, invoke the specified block with the Form as the argument."
	videoRenderBlock := aBlock.! !

!QNetVidClient methodsFor: 'private' stamp: 'jcg 12/10/2009 14:45'!
videoStreamConnected: trackPlayer
	"A video track player's stream just connected successfully. 
	Request an initial frame if this is the current video player and the client is paused."
	self isPlaying ifTrue: [^self "we're playing, so we'll have a frame soon enough"].
	(activePlayers includes: trackPlayer) ifFalse: [
		"XXXXX: We used to exit early here, but this triggered a race condition... 
		 sometimes a video would start all-white, but be OK when you pressed play.  
		 The motivation was to not waste bandwidth on inactive video-tracks.  This 
		 is not a concern, since for current use-cases there is only a single 
		 video-track which is always active."
		QLogger logInfo: 'requesting initial frame even though track is inactive'.
	].
	trackPlayer requestInitialFrame.
! !

QNetVidClient subclass: #QRtspBroadcastNetVidClient
	instanceVariableNames: 'webcast playerOutputClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-RTSP'!

!QRtspBroadcastNetVidClient class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QRtspBroadcastNetVidClient methodsFor: 'defaults' stamp: 'jcg 12/8/2009 13:36'!
createAudioPlayerOutput
	^(playerOutputClass new)
					eventLoopOwner: webcast; 
					yourself! !

!QRtspBroadcastNetVidClient methodsFor: 'defaults' stamp: 'jcg 12/8/2009 13:36'!
createVideoPlayerOutput
	^(playerOutputClass new)
					eventLoopOwner: webcast; 
					yourself! !

!QRtspBroadcastNetVidClient methodsFor: 'initialize' stamp: 'jcg 9/16/2009 00:25'!
playerOutputClass: cls
	"Specify the class to use to instantiate track-player outputs."
	playerOutputClass := cls.! !

!QRtspBroadcastNetVidClient methodsFor: 'initialize' stamp: 'jcg 12/8/2009 14:12'!
webcast: wcast
	webcast := wcast! !

QNetVidClient subclass: #QSecureWebcast
	instanceVariableNames: 'manager texture description clientIDs webcastMutex persistentSpeakerInputs lastTextureUse'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-Session'!

!QSecureWebcast class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QSecureWebcast class methodsFor: 'instance creation' stamp: 'jcg 12/30/2009 12:39'!
description: desc "a QWebcastRecord" manager: mgr "a QSecureWebcastManager" controller: controller
	^self new
		streamManager: controller;
		manager: mgr;
		description: desc; "triggers connection to the specified NetVid session."
		yourself! !

!QSecureWebcast methodsFor: 'accessing' stamp: 'crl 4/30/2010 11:27'!
addClientTexture: client "a QClientVideoTexture"
	webcastMutex critical: [
		| speaker |

		clientIDs add: client objectID.
		persistentSpeakerInputs
			at: client objectID
			put: (
				QPersistentClientSpeakerInput
					on: (client ref get: #speaker)
					for: self)]! !

!QSecureWebcast methodsFor: 'private' stamp: 'crl 12/31/2009 14:17'!
changeColor: newColor
	texture form fillColor: newColor.
	texture updateAll. 
! !

!QSecureWebcast methodsFor: 'private' stamp: 'crl 5/10/2010 12:37'!
createTexture
	| texForm |
	texForm := Form extent: description videoExtent asLargerPowerOfTwo depth: 32.
	texture := TTexture fromForm: texForm mipmap: false shrinkFit: false extension: nil.
	texture textureScale: (description videoExtent / texForm extent asFloatPoint).
	texture sha: description sessionID.
	lastTextureUse := RealTime millisecondClockValue.
	self 
		runScript: #noteUseOfTextureIn:isMainView: 
		when: {texture. #installedTexture}.
	TContentManager default substituteForm: texture! !

!QSecureWebcast methodsFor: 'initialize' stamp: 'crl 4/9/2010 18:07'!
description: desc "a QWebcamRecord"
	self currentlyInEventLoop ifFalse: [^self future description: desc].
	description ifNotNil: [self error: 'description already set'].
	description := desc.
	description streamID ifNil: [^QLogger logInfo: 'webcast description has nil streamID'].
	self createTexture.
	self videoRenderBlock: [:form :p | self updateTextureFromForm: form].
	self audioRenderBlock: [:buf :samplingRate :decoder | 
		self
			handleDecodedAudio: buf
			samplingRate: samplingRate
			from: decoder].

	self updateTrackBlock: [
		audioPlayers do: [:pl | self addAudioPlayer: pl].
		videoPlayers do: [:pl | self addVideoPlayer: pl].
	].
	self subscribeToControlStream: (TObjectID readHexFrom: description streamID).
	self runScript: #destroy when: {self. #controlStreamDestroyed}! !

!QSecureWebcast methodsFor: 'accessing' stamp: 'crl 1/4/2010 15:24'!
extent
	^texture form extent! !

!QSecureWebcast methodsFor: 'private' stamp: 'crl 4/29/2010 18:47'!
handleDecodedAudio: buf samplingRate: samplingRate from: decoder
	"QLogger logInfo: 'webcast received audio data from decoder: ', buf printString."

	persistentSpeakerInputs do: [:persistentSpeakerInput | persistentSpeakerInput handleDecodedAudio: buf samplingRate: samplingRate]! !

!QSecureWebcast methodsFor: 'testing' stamp: 'jcg 12/29/2009 18:00'!
hasClients
	^webcastMutex critical: [clientIDs isEmpty not]! !

!QSecureWebcast methodsFor: 'initialize' stamp: 'crl 4/30/2010 11:26'!
initialize
	webcastMutex := Mutex new.
	clientIDs := Set new.
	self resetSpeakerInputs.
	super initialize.! !

!QSecureWebcast methodsFor: 'testing' stamp: 'crl 2/10/2010 16:39'!
isLive
	^true! !

!QSecureWebcast methodsFor: 'accessing' stamp: 'crl 12/31/2009 14:17'!
lastForm
	^texture form! !

!QSecureWebcast methodsFor: 'initialize' stamp: 'crl 12/24/2009 12:13'!
manager: mgr "a QSecureWebcastManager"
	manager := mgr! !

!QSecureWebcast methodsFor: 'private' stamp: 'crl 1/4/2010 15:31'!
noteUseOfTexture
	"For compatibility with QStreamingVideoDecoder as used by the QVideoFeedPaneItem hierarchy. Not sure if anything actually need be done here yet."! !

!QSecureWebcast methodsFor: 'private' stamp: 'crl 5/13/2010 14:46'!
noteUseOfTextureIn: ogl isMainView: isMainView
	"The texture was just rendered... ensure that the stream is unpaused;
	 but only for the main scene, and only for my live-view."
	isMainView ifTrue: [self noteUseOfTexture]! !

!QSecureWebcast methodsFor: 'accessing' stamp: 'crl 4/30/2010 11:26'!
removeClientTexture: client "a QClientVideoTexture"
	webcastMutex critical: [
		clientIDs remove: client objectID.
		persistentSpeakerInputs removeKey: client objectID ifAbsent: []]! !

!QSecureWebcast methodsFor: 'initialize' stamp: 'crl 4/30/2010 11:26'!
resetSpeakerInputs
	persistentSpeakerInputs := Dictionary new! !

!QSecureWebcast methodsFor: 'accessing' stamp: 'crl 12/24/2009 11:45'!
sessionID
	^description sessionID! !

!QSecureWebcast methodsFor: 'accessing' stamp: 'crl 1/11/2010 14:25'!
speakerManager
	^manager speakerManager! !

!QSecureWebcast methodsFor: 'initialize' stamp: 'crl 1/4/2010 15:10'!
updateTextureFromForm: aForm
	texture form copy: aForm boundingBox from: 0@0 in: aForm rule: Form over.
	texture invalidate: aForm boundingBox.
	self signal: #newFrame with: aForm! !

!QSecureWebcast methodsFor: 'accessing' stamp: 'crl 1/11/2010 14:27'!
videoClient
	"So that I can act like a QStreamingVideoPlayer as far as QClientSpeakerNetVidInputs are concerned."

	^self! !

QNetVidClient subclass: #QSessionRecorderNetVidClient
	instanceVariableNames: 'recorder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-NetVid-Recorder'!

!QSessionRecorderNetVidClient commentStamp: 'jcg 8/11/2009 22:59' prior: 0!
Small changes to make a QNetVidClient suitable for session-recording.!

!QSessionRecorderNetVidClient class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QSessionRecorderNetVidClient methodsFor: 'defaults' stamp: 'jcg 8/11/2009 23:15'!
createAudioPlayerOutput
	| trackRecorder |
	trackRecorder := QNetVidTrackNhmlRecorder new.
	trackRecorder recorder: recorder.
	^trackRecorder! !

!QSessionRecorderNetVidClient methodsFor: 'defaults' stamp: 'jcg 8/11/2009 23:15'!
createVideoPlayerOutput
	| trackRecorder |
	trackRecorder := QNetVidTrackNhmlRecorder new.
	trackRecorder recorder: recorder.
	^trackRecorder! !

!QSessionRecorderNetVidClient methodsFor: 'initialize' stamp: 'jcg 8/11/2009 23:16'!
recorder: aQSessionRecorder
	recorder := aQSessionRecorder! !

!Bag methodsFor: '*Qwaq-Video' stamp: 'jcg 2/19/2008 21:50'!
sizeAsSet
	"Equivalent to 'self asSet size', but without creating a Set."
	^contents size! !

ByteArray variableByteSubclass: #QVideoArgs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-LowLevel'!

!QVideoArgs commentStamp: 'jcg 1/24/2012 01:02' prior: 0!
version 0 fields:
	isBigEndian	(1 byte - padded to 4)
	codecType	(4 bytes)
	timeScale	(4 bytes)
	width		(4 bytes - int)
	height		(4 bytes - int)
	bits/sec		(4 bytes - int)
	frames/sec	(8 bytes - double)
	flags0			(1 byte)
	flags1			(1 byte)
	flags2			(1 byte)
		bit 1&2		0 - 	use zero-latency
					1 -	use H.264 baseline profile
					2 -	use H.264 main profile
					3 -  use H.264 high profile    
	flags3			(1 byte)
		bit 1		-	use reordering
		bit 2		-	use muxer
		bit 3-6		-	version number (uint)
		bit 7-8		-	reserved
version 1 fields:
!

!QVideoArgs class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QVideoArgs class methodsFor: 'instance creation' stamp: 'jcg 2/13/2009 00:09'!
new
	^ self new: 36! !

!QVideoArgs methodsFor: 'endianness' stamp: 'jcg 8/6/2007 08:39'!
beBigEndian
	self isBigEndian ifFalse: [self swapEndianness]
! !

!QVideoArgs methodsFor: 'endianness' stamp: 'jcg 8/6/2007 08:39'!
beLittleEndian
	self isLittleEndian ifFalse: [self swapEndianness]
! !

!QVideoArgs methodsFor: 'accessing' stamp: 'jcg 11/24/2007 12:16'!
bitRate
	^ self longAt: 21 bigEndian: self isBigEndian ! !

!QVideoArgs methodsFor: 'accessing' stamp: 'jcg 11/24/2007 12:17'!
bitRate: newBitRate
	^ self longAt: 21 put: newBitRate bigEndian: self isBigEndian ! !

!QVideoArgs methodsFor: 'accessing' stamp: 'jcg 11/25/2007 09:59'!
codec
	"Compatibility."
	^self codecType! !

!QVideoArgs methodsFor: 'accessing' stamp: 'jcg 11/25/2007 09:59'!
codec: fourCharString
	"Compatibility."
	self codecType: fourCharString! !

!QVideoArgs methodsFor: 'accessing' stamp: 'jcg 9/19/2007 15:21'!
codecType
	| result |
	result := (self copyFrom: 5 to: 8) asString.
	self isLittleEndian ifTrue: [result := result reversed].
	^ result
! !

!QVideoArgs methodsFor: 'accessing' stamp: 'jcg 9/19/2007 15:20'!
codecType: fourCharString
	"Codec type is specified as a '4-char-code'."
	| stringToUse |
	fourCharString isString ifFalse: [self error: 'argument must be a string'].
	stringToUse := self isBigEndian ifTrue: [fourCharString] ifFalse: [fourCharString reversed].
	self replaceFrom: 5 to: 8 with: stringToUse! !

!QVideoArgs methodsFor: 'accessing' stamp: 'jcg 11/24/2007 10:56'!
extent
	^self width@self height! !

!QVideoArgs methodsFor: 'accessing' stamp: 'jcg 11/24/2007 10:56'!
extent: newExtent
	self width: newExtent x.
	self height: newExtent y.! !

!QVideoArgs methodsFor: 'flags' stamp: 'jcg 11/5/2009 02:18'!
flags0
	^self at: 33! !

!QVideoArgs methodsFor: 'flags' stamp: 'jcg 11/5/2009 02:19'!
flags0: bits "anInteger"
	^self at: 33 put: bits! !

!QVideoArgs methodsFor: 'flags' stamp: 'jcg 11/5/2009 02:18'!
flags1
	^self at: 34! !

!QVideoArgs methodsFor: 'flags' stamp: 'jcg 11/5/2009 02:19'!
flags1: bits "anInteger"
	^self at: 34 put: bits! !

!QVideoArgs methodsFor: 'flags' stamp: 'jcg 11/5/2009 02:18'!
flags2
	^self at: 35! !

!QVideoArgs methodsFor: 'flags' stamp: 'jcg 11/5/2009 02:19'!
flags2: bits "anInteger"
	^self at: 35 put: bits! !

!QVideoArgs methodsFor: 'flags' stamp: 'jcg 11/5/2009 02:18'!
flags3
	^self at: 36! !

!QVideoArgs methodsFor: 'flags' stamp: 'jcg 11/5/2009 02:19'!
flags3: bits "anInteger"
	^self at: 36 put: bits! !

!QVideoArgs methodsFor: 'accessing' stamp: 'jcg 11/24/2007 15:18'!
fps
	"Get the frame rate (frames/second)."
	^ self doubleAt: 25 bigEndian: self isBigEndian ! !

!QVideoArgs methodsFor: 'accessing' stamp: 'jcg 12/30/2009 14:57'!
fps: newFrameRate
	"Set the frame rate (frames/second)."
	^ self doubleAt: 25 put: newFrameRate asFloat bigEndian: self isBigEndian ! !

!QVideoArgs methodsFor: 'flags' stamp: 'jcg 11/5/2009 02:20'!
getFrameReorderingFlag
	"Flags are in bytes 33-36"
	^self flags3 anyMask: 1! !

!QVideoArgs methodsFor: 'flags' stamp: 'jcg 11/5/2009 02:20'!
getMuxerFlag
	"Flags are in bytes 33-36"
	^self flags3 anyMask: 2! !

!QVideoArgs methodsFor: 'flags' stamp: 'jcg 11/5/2009 02:25'!
getVersionNumber
	"Flags are in bytes 33-36"
	^(self flags3 bitShift: -2) bitAnd: 15
	! !

!QVideoArgs methodsFor: 'flags' stamp: 'jcg 11/14/2007 08:17'!
height
	^ self longAt: 17 bigEndian: self isBigEndian ! !

!QVideoArgs methodsFor: 'accessing' stamp: 'jcg 11/14/2007 08:18'!
height: newHeight
	^ self longAt: 17 put: newHeight bigEndian: self isBigEndian ! !

!QVideoArgs methodsFor: 'flags' stamp: 'jcg 1/24/2012 01:08'!
isBaselineProfile
	"The first two bits of flag2 encode a number from 0-3:
		0	- zero latency setting (i.e. for videoconferencing)
		1	- H.264 baseline profile
		2	- H.264 main profile
		3	- H.264 high profile"
	| byte |
	byte := self flags2 bitAnd: 3.
	^byte == 1
	
! !

!QVideoArgs methodsFor: 'endianness' stamp: 'jcg 8/6/2007 08:37'!
isBigEndian
	^ (self at: 1) ~~ 0! !

!QVideoArgs methodsFor: 'flags' stamp: 'jcg 1/24/2012 01:08'!
isHighProfile
	"The first two bits of flag2 encode a number from 0-3:
		0	- zero latency setting (i.e. for videoconferencing)
		1	- H.264 baseline profile
		2	- H.264 main profile
		3	- H.264 high profile"
	| byte |
	byte := self flags2 bitAnd: 3.
	^byte == 3
	
! !

!QVideoArgs methodsFor: 'endianness' stamp: 'jcg 8/6/2007 08:37'!
isLittleEndian
	^ (self at: 1) == 0! !

!QVideoArgs methodsFor: 'flags' stamp: 'jcg 1/24/2012 01:08'!
isMainProfile
	"The first two bits of flag2 encode a number from 0-3:
		0	- zero latency setting (i.e. for videoconferencing)
		1	- H.264 baseline profile
		2	- H.264 main profile
		3	- H.264 high profile"
	| byte |
	byte := self flags2 bitAnd: 3.
	^byte == 2
	
! !

!QVideoArgs methodsFor: 'flags' stamp: 'jcg 1/24/2012 01:08'!
isZeroLatencyProfile
	"The first two bits of flag2 encode a number from 0-3:
		0	- zero latency setting (i.e. for videoconferencing)
		1	- H.264 baseline profile
		2	- H.264 main profile
		3	- H.264 high profile"
	| byte |
	byte := self flags2 bitAnd: 3.
	^byte == 0
	
! !

!QVideoArgs methodsFor: 'flags' stamp: 'jcg 11/5/2009 02:21'!
setFrameReorderingFlag: bool
	"Flags are in bytes 33-36"
	| byte |
	byte := self flags3.
	bool 
		ifTrue: [byte := byte bitOr: 1]
		ifFalse: [byte := byte bitClear: 1].
	self flags3: byte! !

!QVideoArgs methodsFor: 'flags' stamp: 'jcg 11/5/2009 02:21'!
setMuxerFlag: bool
	"Flags are in bytes 33-36"
	| byte |
	byte := self flags3.
	bool 
		ifTrue: [byte := byte bitOr: 2]
		ifFalse: [byte := byte bitClear: 2].
	self flags3: byte! !

!QVideoArgs methodsFor: 'flags' stamp: 'jcg 11/5/2009 02:24'!
setVersionNumber: zeroToFifteen
	"Flags are in bytes 33-36"
	| byte |
	(zeroToFifteen between: 0 and: 15) ifFalse: [self error: 'acceptable range is 0-15'].
	byte := (self flags3 bitClear: (15 bitShift: 2)) bitOr: (zeroToFifteen bitShift: 2).
	self flags3: byte.
! !

!QVideoArgs methodsFor: 'endianness' stamp: 'jcg 11/5/2009 02:15'!
swapEndianness

	self isBigEndian 
		ifTrue: [self at: 1 put: 0 "now little-endian"]
		ifFalse: [self at: 1 put: 1 "now big-endian"].
	
	"Swap endianness of 'codecType'"
	self swapEndiannessOfWordAt: 5.

	"Swap endianness of 'time scale'"
	self swapEndiannessOfWordAt: 9.

	"Swap endianness of width and height"
	self swapEndiannessOfWordAt: 13.
	self swapEndiannessOfWordAt: 17.

	"Swap endianness of bit-rate"
	self swapEndiannessOfWordAt: 21.

	"Swap endianness of frame-rate"
	self swapEndiannessOfFloatAt: 25.! !

!QVideoArgs methodsFor: 'endianness' stamp: 'jcg 12/2/2007 22:12'!
swapEndiannessOfFloatAt: index
	"Swap endianness of Float (double-precision floating-point)"
	| word |
	self swapEndiannessOfWordAt: index.
	self swapEndiannessOfWordAt: index + 4.
	word := self networkUnsignedLongAt: index.
	self networkUnsignedLongAt: index put: (self networkUnsignedLongAt: index+4).
	self networkUnsignedLongAt: index+4 put: word.
! !

!QVideoArgs methodsFor: 'endianness' stamp: 'jcg 11/14/2007 08:22'!
swapEndiannessOfWordAt: index
	| tmp |
	tmp := self at: index.
	self at: index put: (self at: index+3).
	self at: index+3 put: tmp.
	tmp := self at: index+1.
	self at: index+1 put: (self at: index+2).
	self at: index+2 put: tmp.
! !

!QVideoArgs methodsFor: 'accessing' stamp: 'jcg 8/6/2007 10:24'!
timeScale
	^ self longAt: 9 bigEndian: self isBigEndian! !

!QVideoArgs methodsFor: 'accessing' stamp: 'jcg 8/6/2007 10:25'!
timeScale: anInteger
	^ self longAt: 9 put: anInteger bigEndian: self isBigEndian! !

!QVideoArgs methodsFor: 'flags' stamp: 'jcg 1/24/2012 01:09'!
useBaselineProfile
	"The first two bits of flag2 encode a number from 0-3:
		0	- zero latency setting (i.e. for videoconferencing)
		1	- H.264 baseline profile
		2	- H.264 main profile
		3	- H.264 high profile"
	| byte |
	byte := self flags2 bitClear: 3.
	self flags2: byte+1
! !

!QVideoArgs methodsFor: 'flags' stamp: 'jcg 1/24/2012 01:09'!
useHighProfile
	"The first two bits of flag2 encode a number from 0-3:
		0	- zero latency setting (i.e. for videoconferencing)
		1	- H.264 baseline profile
		2	- H.264 main profile
		3	- H.264 high profile"
	| byte |
	byte := self flags2 bitClear: 3.
	self flags2: byte+3
! !

!QVideoArgs methodsFor: 'flags' stamp: 'jcg 1/24/2012 01:09'!
useMainProfile
	"The first two bits of flag2 encode a number from 0-3:
		0	- zero latency setting (i.e. for videoconferencing)
		1	- H.264 baseline profile
		2	- H.264 main profile
		3	- H.264 high profile"
	| byte |
	byte := self flags2 bitClear: 3.
	self flags2: byte+2
! !

!QVideoArgs methodsFor: 'endianness' stamp: 'jcg 8/6/2007 08:51'!
usePlatformEndianness
	Smalltalk isBigEndian
		ifTrue: [self beBigEndian]
		ifFalse: [self beLittleEndian]
! !

!QVideoArgs methodsFor: 'flags' stamp: 'jcg 1/24/2012 01:07'!
useZeroLatencyProfile
	"The first two bits of flag2 encode a number from 0-3:
		0	- zero latency setting (i.e. for videoconferencing)
		1	- H.264 baseline profile
		2	- H.264 main profile
		3	- H.264 high profile"
	| byte |
	byte := self flags2 bitClear: 3.
	self flags2: byte
! !

!QVideoArgs methodsFor: 'accessing' stamp: 'jcg 11/14/2007 08:17'!
width
	^ self longAt: 13 bigEndian: self isBigEndian ! !

!QVideoArgs methodsFor: 'accessing' stamp: 'jcg 11/14/2007 08:18'!
width: newWidth
	^ self longAt: 13 put: newWidth bigEndian: self isBigEndian ! !

TMaterial subclass: #QVideoMaterial
	instanceVariableNames: 'previewTexture'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-Texture'!

!QVideoMaterial commentStamp: '<historical>' prior: 0!
Chooses at render-time whether to use the live video image or the preview image.  To do this, we check whether the thumbnail-SHA of 'texture' is nil... if so, we use 'previewTexture' instead.  This is a TFileTexture that uses Brad's magical preview mechanism to ensure that the preview file is available (check cache, and download from server if not in cache).!

!QVideoMaterial class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QVideoMaterial methodsFor: 'render' stamp: 'jcg 3/30/2009 11:57'!
enableTexture: ogl
	| textureToUse |
	textureToUse := texture sha ifNotNil: [texture] ifNil: [previewTexture].
	textureToUse ifNil: [
		QLogger logWarning: '#enableTexture: no preview texture' every: 10000.
		^self
	].
	self enableTexture: textureToUse in: ogl! !

!QVideoMaterial methodsFor: 'initialize' stamp: 'jcg 2/3/2008 09:55'!
hashedName: hashedName
	previewTexture ifNotNil: [
		previewTexture destroy.
		previewTexture := nil
	].
	previewTexture := QEmbeddedApp makePreviewTexture: hashedName.
	! !

Form subclass: #QDecodedFrame
	instanceVariableNames: 'metadata decoder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Video-LowLevel'!

!QDecodedFrame commentStamp: '<historical>' prior: 0!
The simplest possible way to return metadata attached to a decoded video frame: add a metadata slot to the Form.
!

!QDecodedFrame class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QDecodedFrame methodsFor: 'initialize' stamp: 'jcg 2/13/2009 17:17'!
decoder: aQVideoDecoder
	decoder := aQVideoDecoder.! !

!QDecodedFrame methodsFor: 'copying' stamp: 'jcg 2/12/2009 15:42'!
deepCopy
	^super deepCopy postCopy! !

!QDecodedFrame methodsFor: 'initialize' stamp: 'jcg 2/1/2009 10:19'!
initialize
	super initialize.
	metadata := nil.  "allow different decoders to attach different metadata"
! !

!QDecodedFrame methodsFor: 'accessing' stamp: 'jcg 2/1/2009 10:15'!
metadata
	^metadata! !

!QDecodedFrame methodsFor: 'initialize' stamp: 'jcg 2/1/2009 10:20'!
metadata: newMetadata
	"Allow different decoders to attach different metadata."
	metadata := newMetadata! !

!QDecodedFrame methodsFor: 'copying' stamp: 'jcg 2/12/2009 15:54'!
postCopy
	metadata := metadata deepCopy! !

!QDecodedFrame methodsFor: 'other' stamp: 'jcg 2/14/2009 22:17'!
returnToFormPool
	metadata ifNotNil: [metadata getHandle atAllPut: 0].
	decoder returnFormToPool: self.
	! !

!CPrimitiveCostume methodsFor: '*Qwaq-Video' stamp: 'jcg 3/19/2009 09:43'!
clearMatrixFlag
	"Once matrix flag has been set, it is never cleared.  This hack allows us to clear it manually (otherwise a costume that has been scaled will never be translucent again, even if you set the scale back to 1)."
	flags := flags bitClear: FlagHasMatrix! !
AACAudioSpecificConfig initialize!
QVideoDecoderMC initialize!
QVideoEncoderMC initialize!
AACAudioObjectTypes initialize!
MP4Constants initialize!
QWebcam initialize!
QWebcamConstants initialize!
